/*
 * truc.java
 *
 * Created on 04 January 2005, 14:19
 */

package MiscTests;
import java.util.*;
import java.text.MessageFormat;
/**
 *
 * @author  Jean-Alain Grunchec
 */
/**
* Measures the approximate size of an object in memory, given a Class which
* has a no-argument constructor.
*/
public final class ObjectSizer {
    final static int nb_tests=100;

  /**
  * First and only argument is the package-qualified name of a class
  * which has a no-argument constructor.
  */
  public static void main(String[] aArguments){
    
     long result = 0;

    //if the class does not have a no-argument constructor, then
    //inform the user and return 0.
    

    //this array will simply hold a bunch of references, such that
    //the objects cannot be garbage-collected
    Object[] objects = new Object[fSAMPLE_SIZE];
    
    //build a bunch of identical objects
     Object throwAway = createObject();

      long startMemoryUse = getMemoryUse();
      for (int idx=0; idx < objects.length ; ++idx) {
        objects[idx] = createObject();
      }
      try{
        Thread.currentThread().sleep(5000);
      }
      catch(Exception exc){}
      long endMemoryUse = getMemoryUse();

      float approximateSize = ( endMemoryUse - startMemoryUse ) /objects.length;
      result = Math.round( approximateSize );
      System.out.println("Approximate size of objects :" + result);
      
      
  /*  long start,end;
    start=System.currentTimeMillis();
    List ints = new ArrayList();
    for (int i=0; i<nb_tests; i++) {
       ints.add(new Integer(i));
    }
    end=System.currentTimeMillis();
    System.out.println("Time Integer "+(end - start)+" ms");
    start=System.currentTimeMillis();
    int ints_[] = new int[nb_tests];
    for (int i=0; i<nb_tests; i++) {
        ints_[i] = i;
    }
    end=System.currentTimeMillis();
    System.out.println("Time int "+(end - start)+" ms");*/
  }
  static neosim.implementation.EntityImpl myEntity=new neosim.implementation.EntityImpl();
  static private Object createObject(){
     /* Hashtable inConnections=new Hashtable();
      for(int i=0;i<100;i++){
          Vector v=new Vector();
          for(int j=0;j<100;j++){
              v.add(new neosim.implementation.ConnectionImpl(1000,(short)1,myEntity,(short)2,0.7d));
          }
          inConnections.put(new Integer(i),v);
      }
      return inConnections;*/
      /*Hashtable hsh;
      Object o=new neosim.implementation.ConnectionImpl(1000,(short)1,myEntity,(short)2,700000000);
      hsh=new Hashtable();
      for(int j=0;j<1000;j++){
          Vector v=new Vector();
          hsh.put(new Integer(j),v);
        for(int i=0;i<50;i++){
            v.add(o);
        }  
      }
      return hsh;*/
      //return new neosim.implementation.ConnectionImpl(1000,(short)1,myEntity,(short)2,700000000);
/*      neosim.kernel.InPortsTable ips=new neosim.kernel.InPortsTable(0);
      for(int j=0;j<100;j++){
          neosim.kernel.InPortTable Current=new neosim.kernel.InPortTable(j,(short)0,0);
          for(int i=0;i<100;i++){
            Current.addConnection(new neosim.implementation.ConnectionImpl(1000,(short)1,myEntity,(short)2,700000000));
          }
          ips.add(Current);
      }
      return ips;*/
      return null;
      //return new OriginalConnectionImpl(); 
  }
 

  /// PRIVATE ////
  private static int fSAMPLE_SIZE = 100;
  private static long fSLEEP_INTERVAL = 100;

  public static long getMemoryUse(){
    putOutTheGarbage();
    long totalMemory = Runtime.getRuntime().totalMemory();

    putOutTheGarbage();
    long freeMemory = Runtime.getRuntime().freeMemory();

    return (totalMemory - freeMemory);
  }

  private static void putOutTheGarbage() {
    collectGarbage();
    collectGarbage();
  }
/*
  System.gc();
      Thread.currentThread().sleep(fSLEEP_INTERVAL);
      System.runFinalization();
      Thread.currentThread().sleep(fSLEEP_INTERVAL);
  System.gc();
      Thread.currentThread().sleep(fSLEEP_INTERVAL);
      System.runFinalization();
      Thread.currentThread().sleep(fSLEEP_INTERVAL);
    long totalMemory = Runtime.getRuntime().totalMemory();
 *
 */
  private static void collectGarbage() {
    try {
      System.gc();
      Thread.currentThread().sleep(fSLEEP_INTERVAL);
      System.runFinalization();
      Thread.currentThread().sleep(fSLEEP_INTERVAL);
    }
    catch (InterruptedException ex){
      ex.printStackTrace();
    }
  }
} 

     class EntityID implements java.io.Serializable {
        public int id;
        public EntityID(int id ) { this.id = id; }
        public final int getValue() { return id; }
        public static EntityID SYSTEM_ENTITY = new EntityID(0);
        public final String toString() { return ""+id;}
    }

     class OriginalConnectionImpl{
         
        EntityID srce=EntityID.SYSTEM_ENTITY;
        PortID srcport=PortID.SYSTEM_PORT, destport=PortID.SYSTEM_PORT;
        neosim.iface.Time delay=new neosim.iface.Time(0.7);    
        ConnectionID cid=ConnectionID.SYSTEM_CONNECTION;
        neosim.implementation.EntityImpl destent=ObjectSizer.myEntity;
        public OriginalConnectionImpl( ){
        }        
    }
    
    class ConnectionID implements java.io.Serializable {
        public int id;
        public ConnectionID(int id ) { this.id = id; }
        public int getValue() { return id; }
        public static ConnectionID SYSTEM_CONNECTION = new ConnectionID(0);
        public String toString() { return ""+id; }
    }
   
     class PortID implements java.io.Serializable {
        public int id;
        public PortID(int id ) { this.id = id; }
        public int getValue() { return id; }
        public static PortID SYSTEM_PORT = new PortID(0);
        public String toString() { return ""+id; }
    }   
