/*
 * Reshaper.java
 *
 * Created on 23 February 2004, 16:18
 */

package ReshapeNetwork;
import java.util.*;
import java.awt.*;
import neuroml.model.network.*;
import java.io.*;
import java.io.File.*;
//import jarinspector.*;
import neuroml.util.*;
import org.jdom.*;
import org.jdom.input.*;
import java.lang.*;
import guikit.*;
import guikit.GridReshaper;
import guikit.RGBColour;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class JarInspectorReshaper implements GridReshaper {
    Hashtable<String,NodePopulation> Nodes=new Hashtable<String,NodePopulation>();
    Hashtable<String,Vector<Object>> Links=new Hashtable<String,Vector<Object>>();

    org.jdom.Element root;
    /** Creates a new instance of Reshaper */
    
    public JarInspectorReshaper()
    {
    }
    
    public void Reshape(Network net, NetEditPanel parent) {
        for(int i=0;i<net.elements.size();i++){
            Population truc=(Population)(net.elements.elementAt(i));
            Nodes.put(truc.getName(),new NodePopulation(truc.getName(),truc)); 
        }
        for(int i=0;i<net.probes.size();i++){
            Probe truc=(Probe)(net.probes.elementAt(i));
            Nodes.put(truc.getName(),new NodePopulation(truc.getName(),truc)); 
        }
        for(int i=0;i<net.projections.size();i++)
        {
            String srcPop=null,dstPop=null;
            NodePopulation src=null,dest=null;
            int dotindex;
            Projection truc=(Projection)(net.projections.elementAt(i));
            if(truc.source!=null){
                srcPop=truc.source.getTargetName();
                dotindex = srcPop.lastIndexOf("elements.");
                if (dotindex!=-1)
                    srcPop = srcPop.substring(dotindex+9);
                dotindex = srcPop.indexOf('.');
                if (dotindex!=-1)
                    srcPop=srcPop.substring(0,dotindex);
                src=(Nodes.get(srcPop));
            }
            if(truc.dest!=null){
                dstPop=truc.dest.getTargetName();
                dotindex = dstPop.lastIndexOf("elements.");
                if (dotindex!=-1)
                    dstPop = dstPop.substring(dotindex+9);
                dotindex = dstPop.indexOf('.');
                if (dotindex!=-1)
                    dstPop=dstPop.substring(0,dotindex);
                dest=(Nodes.get(dstPop));
            }
            Vector<Object> machin=Links.get(new String("Temp."+srcPop+"+Temp."+dstPop));
            if(machin==null)
            {
                machin=new Vector<Object>(1,1);
                Integer Counter=new Integer(1);
                machin.add(Counter);
                machin.add(new LinkProjection(truc,src,dest));
                Links.put(new String("Temp."+srcPop+"+Temp."+dstPop),machin);
            }
            else
            {
                Integer Counter=(Integer)machin.get(0);
                Counter = new Integer(Counter.intValue()+1);
                machin.add(new LinkProjection(truc,src,dest));
            }
            
            if(src!=null){
 //               if(!src.Neighbours.contains(dest))
                    src.Neighbours.add(dest);
            }
        }
        for(int i=0;i<net.attachments.size();i++)
        {
            String srcPop=null,dstPop=null;
            NodePopulation src=null,dest=null;
            int dotindex;
            Attachment truc=(Attachment)(net.attachments.elementAt(i));
            if(truc.source!=null){
                srcPop=truc.source.getTargetName();
                dotindex = srcPop.lastIndexOf("elements.");
                if (dotindex!=-1)
                    srcPop = srcPop.substring(dotindex+9);
                dotindex = srcPop.indexOf('.');
                if (dotindex!=-1)
                    srcPop=srcPop.substring(0,dotindex);
                src=(Nodes.get(srcPop));
            }
            if(truc.dest!=null){
                dstPop=truc.dest.getTargetName();
                dotindex = dstPop.lastIndexOf("probes.");
                if (dotindex!=-1)
                    dstPop = dstPop.substring(dotindex+7);
                dotindex = dstPop.indexOf('.');
                if (dotindex!=-1)
                    dstPop=dstPop.substring(0,dotindex);
                dest=(Nodes.get(dstPop));
            }
            Vector<Object> machin=Links.get(new String("Temp."+srcPop+"+Temp."+dstPop));
            if(machin==null)
            {
                machin=new Vector<Object>(1,1);
                Integer Counter=new Integer(1);
                machin.add(Counter);
                machin.add(new LinkProjection(truc,src,dest));
                Links.put(new String("Temp."+srcPop+"+Temp."+dstPop),machin);
            }
            else
            {
                Integer Counter=(Integer)machin.get(0);
                machin.setElementAt(new Integer(Counter.intValue()+1),0);
                machin.add(new LinkProjection(truc,src,dest));
            }
            
            if(src!=null){
 //               if(!src.Neighbours.contains(dest))
                    src.Neighbours.add(dest);
            }
        }
        
        
        File dir = new File("Temp");
        dir.mkdir();
        
        Enumeration enum_=Nodes.elements();
        while(enum_.hasMoreElements()) {
	    NodePopulation truc = (NodePopulation)enum_.nextElement();
            truc.Output();
        }
        for (long count=0; count<=250000000; count++) {

        }

        try{
            //EXPORT java path to environment variables so that it works
            Process p = Runtime.getRuntime().exec("javac ./Temp/*.java");
            p.waitFor();
            p = Runtime.getRuntime().exec("jar cf Netdesc.jar ./Temp/*.class");
            p.waitFor();
            String[] stuff = new String[1];
            stuff[0]=new String("Netdesc.jar");
            //EXPORT jarinspector to environment variables so that it works //C:\\Zip_Dec03\\JarInspector.jar
            System.out.println("java -jar jarinspector.jar  Netdesc.jar");
            
            p = Runtime.getRuntime().exec("java -jar jarinspector.jar  Netdesc.jar"); //%JARINSPECTOR_HOME%
            p.waitFor();
        }
        catch(Exception e){
            System.out.println("could not compile");
        }
	try{	    	    
	    // Try and get an input stream from the xmlfilename.
	    InputStream is;
	    is = new FileInputStream( new File( "Netdesc.prj" ) );
            if(is==null) 
                return;
	    // read XML from an input stream
            SAXBuilder parser = new SAXBuilder();
	    Document jdomDocumentt = parser.build(is);
            root = jdomDocumentt.getRootElement();

            java.util.List list = root.getChildren();
            
            org.jdom.Element subElement=null;
	
            for (int i=0; i<list.size(); i++) {
                subElement = (org.jdom.Element)list.get(i);
                if(subElement.getName().compareTo("Diagrams")==0)
                    break;
                else 
                    subElement=null;
            }
            if(subElement!=null)
            {
                list = subElement.getChildren();
                for (int i=0; i<list.size(); i++) {
                    subElement = (org.jdom.Element)list.get(i);
                    if(subElement.getName().compareTo("graphml")==0)
                        break;
                    else 
                        subElement=null;
                }                
            }
            if(subElement!=null)
            {
                list = subElement.getChildren();
                for (int i=0; i<list.size(); i++) {
                    subElement = (org.jdom.Element)list.get(i);
                    if(subElement.getName().compareTo("graph")==0)
                        break;
                    else 
                        subElement=null;
                }                
            }
            if(subElement!=null)
            {
                list = subElement.getChildren();
             //   int j=0;
                for (int i=0; i<list.size(); i++) {
                    subElement = (org.jdom.Element)list.get(i);
                    if(subElement.getName().compareTo("node")==0)
                        TreatNode(subElement);
                    else if(subElement.getName().compareTo("edge")==0)
                        TreatLink(subElement);
                }                
            }
           System.out.println("stuff"); 
           is.close();

        } catch (Throwable t) {
            t.printStackTrace ();
        }       
        GregorianCalendar stuff=new GregorianCalendar();
        RGBColour.InitSeed(stuff.getTimeInMillis());
        
	for (enum_ = Nodes.keys() ; enum_.hasMoreElements() ;) {
	    String key = (String)enum_.nextElement();
	    NodePopulation v = (Nodes.get(key));
	
	    if (v!=null) {
		v.display();
	    }
        }
        for (enum_ = Links.keys() ; enum_.hasMoreElements() ;) {
	    String key = (String)enum_.nextElement();
	    Vector<Object> v = (Links.get(key));	    
	    if (v!=null) {
                for(int i=1;i<v.size();i++)
                    ((LinkProjection)(v.elementAt(i))).display();
	    }
        }
         
        String[] children = dir.list();
        boolean success=true;
        for(int i = 0; i < children.length; i++){
            File truc=new File(dir, children[i]);
            truc.delete();
            if (!success)
                break;
        }
        if(success){
            dir.delete();
            File truc=new File("Netdesc.jar");
            truc.delete();
            parent.rerender();
            parent.repaint();
        }
        else{
            System.out.println("Can't remove the files");
        }
        
        
    }
    
    private void TreatNode(org.jdom.Element subElement){
        Attribute a =subElement.getAttribute("uml.uid");
        String Name=a.getValue();
        int dotindex;

        dotindex=Name.indexOf('.');
        if(dotindex==-1)
            return;
        else
            Name=Name.substring(dotindex+1);
        NodePopulation myNode=(Nodes.get(Name));
        if(myNode==null)
            return;
        java.util.List list = subElement.getChildren();
        for(int i=0; i<list.size(); i++) {
            subElement = (org.jdom.Element)list.get(i);
            if(subElement.getName().compareTo("data")==0)
                break;
            else 
                subElement=null;
        }                
        if(subElement!=null)
        {
            list = subElement.getChildren();
            for (int i=0; i<list.size(); i++) {
               subElement = (org.jdom.Element)list.get(i);
               if(subElement.getName().compareTo("NodeLayout")==0){
                   break; 
               }
               else 
                   subElement=null;
             }                
         }
        if(subElement!=null)
        {
            list = subElement.getChildren();
            for (int i=0; i<list.size(); i++) {
               double chose;
               String stuff;
               java.util.List list2,list3;
               org.jdom.Element tmpElement;
               //org.jdom.Element deepElement;
               org.jdom.Text tempValue;
               
               subElement = (org.jdom.Element)list.get(i);
               if(subElement.getName().compareTo("Location")==0){
                   //list2=subElement.getChildren();
                   list2=subElement.getContent();
                   tmpElement=(org.jdom.Element)(list2.get(1));//0X    
                   tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                   myNode.setX(Double.parseDouble(tempValue.getValue()));
                   tmpElement=(org.jdom.Element)(list2.get(3));//1Y
                   tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                   myNode.setY(Double.parseDouble(tempValue.getValue()));
               }
               else if(subElement.getName().compareTo("Size")==0){
                   //list2=subElement.getChildren();
                  /* list2=subElement.getContent();
                   tmpElement=(org.jdom.Element)(list2.get(0));//X                  
                   myNode.setWidth(Double.parseDouble(tmpElement.getContent().get(0).toString()));
                   tmpElement=(org.jdom.Element)(list2.get(1));//Y
                   myNode.setHeight(Double.parseDouble(tmpElement.getContent().get(0).toString()));*/
                    list2=subElement.getContent();
                   tmpElement=(org.jdom.Element)(list2.get(1));//0X    
                   tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                   myNode.setWidth(Double.parseDouble(tempValue.getValue()));
                   tmpElement=(org.jdom.Element)(list2.get(3));//1Y
                   tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                   myNode.setHeight(Double.parseDouble(tempValue.getValue()));                   
               }
               else{
                   subElement=null;
               }
             }                
         }
    }

    private void TreatLink(org.jdom.Element subElement){
        double X,Y;
        Attribute a =subElement.getAttribute("uml.uid");
        String Name=a.getValue();
        
         Vector<Object> machin=Links.get(Name);
         if(machin==null) return;
         Integer Counter=(Integer)(machin.get(0));
         
         LinkProjection myLink=(LinkProjection)(machin.elementAt(Counter.intValue()));
         machin.setElementAt(new Integer(Counter.intValue()-1),0);
        
        if(myLink==null)
            return;
        java.util.List list2,list3,list = subElement.getChildren();
        for(int i=0; i<list.size(); i++) {
            subElement = (org.jdom.Element)list.get(i);
            if(subElement.getName().compareTo("data")==0)
                break;
            else 
                subElement=null;
        }                
        if(subElement!=null)
        {
            list = subElement.getChildren();
            for (int i=0; i<list.size(); i++) {
               subElement = (org.jdom.Element)list.get(i);
               if(subElement.getName().compareTo("CompositeLayout")==0){
                   break; 
               }
               else 
                   subElement=null;
             }                
         }
        if(subElement!=null)
        {
            list = subElement.getChildren();
            for (int i=0; i<list.size(); i++) {
               subElement = (org.jdom.Element)list.get(i);
               if(subElement.getName().compareTo("EdgeLayout")==0){
                   break; 
               }
               else 
                   subElement=null;
             }                
         }
        if(subElement!=null)
        {
            list = subElement.getChildren();
            org.jdom.Element tmpElement;
            for (int i=0; i<list.size(); i++) {
               subElement = (org.jdom.Element)list.get(i);
               org.jdom.Text tempValue;
               if(subElement.getName().compareTo("SourcePort")==0){                   
                   subElement = (org.jdom.Element)(subElement.getChildren().get(0));                   
                   if(subElement.getName().compareTo("Location")==0){
                      tmpElement=(org.jdom.Element)(subElement.getChildren().get(0));//Location
                      tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                      X=Double.parseDouble(tempValue.getValue());
                      tmpElement=(org.jdom.Element)(subElement.getChildren().get(1));
                      tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                      Y=Double.parseDouble(tempValue.getValue());
                      myLink.addPath(new Dimension((int)X,(int)Y));
                   }
               }
               else if(subElement.getName().compareTo("TargetPort")==0){
                   subElement = (org.jdom.Element)(subElement.getChildren().get(0));                   
                   if(subElement.getName().compareTo("Location")==0){
                      tmpElement=(org.jdom.Element)(subElement.getChildren().get(0));//Location
                      tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                      X=Double.parseDouble(tempValue.getValue());
                      tmpElement=(org.jdom.Element)(subElement.getChildren().get(1));
                      tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                      Y=Double.parseDouble(tempValue.getValue());
                      myLink.addPath(new Dimension((int)X,(int)Y));
                   }
               }
               else if(subElement.getName().compareTo("Path")==0){
                   list2=subElement.getChildren();
                   for (int k=0; k<list2.size(); k++) {
                      subElement = (org.jdom.Element)(list2.get(k));                   
                      if(subElement.getName().compareTo("Location")==0){
                      tmpElement=(org.jdom.Element)(subElement.getChildren().get(0));//Location
                      tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                      X=Double.parseDouble(tempValue.getValue());
                      tmpElement=(org.jdom.Element)(subElement.getChildren().get(1));
                      tempValue=(org.jdom.Text)(tmpElement.getContent().get(0));
                      Y=Double.parseDouble(tempValue.getValue());
                          myLink.addPath(new Dimension((int)X,(int)Y));
                      }
                   }
               }
               else
                   subElement=null;
             }                
         }
    }
}

/*list3=;
Object deepElement=list3.get(0);
stuff=deepElement.toString();*/
