package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
import guikit.*;  

/** A clickable point on a graph panel
 */  
public interface ClickablePoint {  
    boolean queryClick( double x, double y );
    boolean intersect( double x, double y, double w, double h );
    void mouseMoved( double x, double y );
    void mouseDragged( double x, double y );
    void move( double dx, double dy );
    String toString();


    /** Link information
     */
    void notifyTargetChanged(ClickablePoint child);
    ClickablePoint getSource();
    ClickablePoint getTarget();

    /** Get user data for this point
     */
    Object getData();
    void setData(Object o);

    /** Initialise user data for this point
     * e.g. makes a new network, link etc & adds it to parent set
     */
    void initUserData( Environment env, neuroml.core.Set parentset, String path );

    // Parent is a Set for notifications
    Object getParentSet();
    void setParentSet(Object p);

    String getBaseClass();
    // Set local state
    void setState(int state);    
    void setHighlighted();
    void clearHighlighted();
    boolean isHighlighted();
    void toggleHighlight();
    // Notify state change from relative
    void notifyStateChange(int state);    
    int getState();

    // display depth
    int getDepth();
    void setDepth(int i);
}

