package guikit;
 
import java.util.*;
import neuroml.sim.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
 
/** Lookup table for which editor to use for which class
 */
class ColourEditor implements Editor, ActionListener {  

    public ColourEditor() {
    }
    public void editObject( Object o, String path, ElementChangedListener ecl ) {
	editObject(o,ecl);
    }
    public void editObject( Object o  ) {
	editObject(o,null);
    }
    public void editObject( Object o, ElementChangedListener cl ) {
	if (o instanceof RGBColour) {	    
	    final RGBColour c = (RGBColour)o; 
	    final JColorChooser jc = new JColorChooser( c.getColor() );
	    final ElementChangedListener ecl = cl;
	    jc.getSelectionModel().addChangeListener( 
						     new ChangeListener() {
							     public void stateChanged(ChangeEvent e) {
								 Color newColor = jc.getColor();
								 c.setColor(newColor);
								 ecl.elementChanged(c,c);
							     }
							 }
						     );
	    JDialog d = JColorChooser.createDialog( null, "Change colour",
						    false, jc,
						    this,this);
	    d.setVisible(true);
	}
    }    
  
    public void startMain() {
    }

    public void actionPerformed( ActionEvent e ) {
	// do nothing
    }
}
