package guikit;

import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.NumberFormat;

import neuroml.core.*;
import neuroml.util.*;
 
/** Edit a reference
 */
public class EditModuleRefPanel extends EditObjectPanel  implements ActionListener {

    ModuleRef mr;
    boolean init=true;
 
    /** Build the panel
     */
    public EditModuleRefPanel(Namespace ns, ObjectNode node) {
	super(ns,node,null, true); 
	updateParameters();
        init=false;
    }       

    /** Update the parameters window when the reference changes
     */
    public void updateParameters() {
	try {
	    mr = (ModuleRef)node.getContent();
            String[] str;
//MODULE--JAG	    Object module = ns.deRef(mr.module);
            Vector vec;
            JPanel Pan=null;
            Class myClass=null;
                      
            vec=ns.getModuleClasses(mr.getName());
            if(vec==null) 
            {
                //System.out.println("ERROR: The ModuleRef should specify its class name: edit "+mr.getName()+"!");
                return;
            }
                        
            if(vec.size()>0)
            {                 
                 int j;
                 str=new String[j=vec.size()];
                 for(int i=0;i<j;i++)
                     str[i]=((Class)vec.elementAt(i)).getName();
                 Pan=new JPanel();
                 Pan.setBorder( BorderFactory.createTitledBorder("Classes for Parameter") ); 
                 JComboBox ParameterCombo=addComboBox(str,str.length,this);
                 Pan.add(ParameterCombo);
                 if(init&&vec.size()!=1)
                    ParameterCombo.setSelectedIndex(0); 
                 if(mr.parameters==null)
                 {
                    
                    if(ParameterCombo.getSelectedIndex()>0)
                    {
                        myClass=NeuromlSys.classLoader.loadClassFromJar(ParameterCombo.getSelectedItem().toString());
                        if(myClass!=null)  
                            try{
                                mr.parameters=myClass.newInstance();
                                node.setContent(mr);
                            }
                            catch(Exception e)
                            {
                            }
                    }
                 }
                 else{
                     int i=0;
                     boolean found=false;
                     while(i<str.length&&!found)
                     {
                         if(str[i].compareTo(mr.parameters.getClass().getName())==0)
                            found=true;
                         else
                             i++;
                     }
                     ParameterCombo.setSelectedIndex(i+1);
                 }
            } else vec=null;
            
/*MODULE--JAG	    if (module instanceof Module) {
		// Get a copy of the module's object...
		System.out.println("updateParameters got module "+module);
		Object params = ((Module)module).getModuleObject();
		ns.removeRef(node.getPath(), value);    
	    }MODULE--JAG*/
            
            topPanel.removeAll();
            if(Pan!=null)topPanel.add(Pan);
            addFields( topPanel, baseClass, inline, inlist );
            
            
            
	    topPanel.validate();
            revalidate();
	} catch (Exception e) {
	    System.out.println("EditModuleRefPanel update Params error "+e);
	}
    }

    /** Listen to text field changes
     */
    public void elementChanged(Object oldn, Object newn) {
	//System.out.println("EditModuleRefPanel - something's changed");
/*MODULE--JAG	if (newn instanceof Ref) {
	    ModuleRef mr = (ModuleRef)node.getContent();
	    mr.module = (Ref)newn;
//	    updateParameters();
	}MODULE--JAG*/
    }

    public void actionPerformed(java.awt.event.ActionEvent e) {
        
	if (e.getActionCommand().equals("Edit")) {
	} else {
            if(init) 
                return;
	    JComboBox cb = (JComboBox)e.getSource();
	    String selectName = (String)cb.getSelectedItem();
            Class myClass=null;
            if(cb.getSelectedIndex()>0)
            {
                myClass=NeuromlSys.classLoader.loadClassFromJar(selectName);
                if(myClass!=null)
                try{
                    mr.parameters=myClass.newInstance();
                    Container cont=cb.getParent();
                    topPanel.removeAll();
                    topPanel.add(cont);
                    addFields( topPanel, baseClass, inline, inlist );
                    updateSize(topPanel);
                    topPanel.validate();
                    revalidate();
                }
                catch(Exception exc)
                {
                }
            }
            else{
                mr.parameters=null;
                try{
                    Container cont=cb.getParent();
                    topPanel.removeAll();
                    topPanel.add(cont);
                    addFields( topPanel, baseClass, inline, inlist );
                    topPanel.validate();
                    revalidate();
                }
                catch(Exception exc)
                {
                }
            }
            
	  /* reference.setTargetName(selectName);
	    System.out.println("You chose "+selectName);
	    if (notifyParent != null) {
		notifyParent.elementChanged( node.getContent(), reference );
	    }*/
	}
    }
}
