package guikit;

import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.NumberFormat;


/** Super class for panel editors
 */
public class EditPanel extends JPanel implements FieldPanel {
    protected ObjectNode node; 
   /* protected static java.util.List ListListeners=Collections.synchronizedList( new LinkedList()) ;
    static public void clearListener(){
        while(!ListListeners.isEmpty()){
            ((EditPanel)ListListeners.remove(0)).clear(); 
        }
    }*/
    
    /** Build the panel
     */
    public EditPanel(ObjectNode node) {
	super();
	this.node = node;
    }

    public EditPanel() {
	super();	
    }

    /** Return info about the field */
    public ObjectNode getNode() { return node; }

    /** Useful functions... */
    public static JButton makeButton(String msg, String action, ActionListener l) {
	JButton b = new JButton(msg);
        b.setPreferredSize(new Dimension(msg.length()*12+50, 32));
	b.addActionListener(l);
	b.setActionCommand(action);
	return b;
    }

    public static JButton makeButton( ImageIcon image, String text, ActionListener al ) {
	JButton  button = new JButton(image);
        //button.setToolTipText(text);
       	button.addActionListener(al);
	button.setFocusPainted(false);
	return button;
    }

    /** Make a selection box 
     */
    public static JComboBox makeComboBox( Hashtable list, String def, ActionListener l) {
    	String[] possibilities;
	String elemDef = new String("");
	int index = -1;	
	if(def!=null){
	    int dotindex = def.lastIndexOf('.');
	    if (dotindex!=-1)
		elemDef = def.substring(dotindex+1);
	}
       // System.out.println("def "+def+" elemDef "+elemDef);
	if (list!=null) {
	    possibilities = new String[list.size()+1];
	    possibilities[0] = "<not set>";
	    int i = 1;
	    boolean NotSet=(elemDef.compareTo("")!=0);
	    for (Enumeration enum_ = list.keys(); enum_.hasMoreElements();i++) {
		String elem = (String)enum_.nextElement();
		possibilities[i] = new String(elem);
                if(NotSet)
                    if(elem.endsWith(elemDef) )
                        index=i;
	    }   
	} else {
	    possibilities = new String[1];
	    possibilities[0] = "<no objects of this type to reference>";
	}
	if (index==-1) {
	    System.out.println("Warning - couldn't find reference to "+def+" in list of possibilities nor to "+elemDef);
	    index = 0;
	}

	// Make a combo box
        JComboBox comboBox = new JComboBox(possibilities);
        comboBox.setSelectedIndex(index);
        comboBox.addActionListener(l);
	return comboBox;
    }
    
    public void confirm() {
	// update node
    }
    public void cancel() {
	// do nowt.
    }
    // Update display from values...
    public void updateDisplay(Object newob) {
	// do nowt.
    }
}
