package guikit;

import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.NumberFormat;


import neuroml.sim.ElementChangedListener;

/** String field editor
 */
public class EditStringPanel extends EditPanel implements DocumentListener  {

    String value;
    JLabel paramLabel;
    JTextField paramValueField;
    ElementChangedListener ecl = null;

    /** Build the panel
     */
    public EditStringPanel(ObjectNode node) {
	super(node);
	value = (String)node.getContent();
	paramLabel = new JLabel(node.getName());
	paramLabel.setPreferredSize( new Dimension(80, 32));
	paramLabel.setMinimumSize( new Dimension(10, 16));// For resizing
	//paramLabel.setMaximumSize( new Dimension(10000, 32));// For resizing
	paramLabel.setFont(GuiKit.getDefaultFont());
	paramValueField = new JTextField(value);
	paramValueField.setPreferredSize( new Dimension(200, 32));
	paramValueField.setMinimumSize( new Dimension(10, 16));// For resizing
	//paramValueField.setMaximumSize( new Dimension(10000, 32));// For resizing

	paramValueField.getDocument().addDocumentListener( this ); 
	paramValueField.setFont(GuiKit.getDefaultFont());
	GridBagLayout gb = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	setLayout(gb);
	//c.fill = GridBagConstraints.BOTH;
	c.fill = GridBagConstraints.HORIZONTAL;

	c.gridwidth = 10;
	c.weightx = 10.0;
	c.weighty = 5.0;
	add(paramLabel);      gb.setConstraints(paramLabel,c); 
	c.weightx = 20.0;
	c.gridwidth = GridBagConstraints.REMAINDER;
 	add(paramValueField); gb.setConstraints(paramValueField,c);
    }      

    public void insertUpdate(DocumentEvent e) {
	updateDisplayValue(e);
    }
    public void removeUpdate(DocumentEvent e) {
	updateDisplayValue(e);
    }
    public void changedUpdate(DocumentEvent e) {
    }
    public void setElementChangedListener( ElementChangedListener ecl ) { this.ecl = ecl; }
    public void updateDisplayValue(DocumentEvent e) {
	String oldvalue=value;
 	value = paramValueField.getText();
	confirm();
	if (ecl!=null) {
	    ecl.elementChanged( oldvalue,value );
	}
    }
    public JTextField getTextField() { return paramValueField; }
    public void confirm() {
	node.setContent(paramValueField.getText());
    }
    public void setPreferredSize(Dimension dim1, Dimension dim2){
        paramLabel.setPreferredSize(dim1);
        paramValueField.setPreferredSize(dim2);
        this.validate();
    }
    
}
