package guikit;

import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.NumberFormat;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.sim.*;


/** Object editor firing termination event
 */
public class FiringEditObjectPanel extends EditObjectPanel{

  
    ActionListener listener;

    /** Build the panel
     * 
     * @param listener The listener to which notify the end of use of this panel
     * @param ns The namespace for references
     * @param node The object node (field of parent)
     * @param baseClass The expected class of this object
     * @param inline Display contents in parent's JPanel
     * @param inlist A member of a list
     * @param subinline Display subobjects as popups or inline
     */
 
    public FiringEditObjectPanel(ActionListener listener, Namespace ns, Object node, String baseClass, boolean inline) {
	super(ns, new ObjectNode( node ),baseClass, inline, false, true );
	this.listener = listener;
    }
  
      public void confirm() {
	super.confirm();
	ActionEvent e = new ActionEvent(this,1,"Termination");
	listener.actionPerformed(e);

    }

    public void cancel() {
	super.cancel();
	ActionEvent e = new ActionEvent(this,2,"Termination");
	listener.actionPerformed(e);
    }
}
