package guikit;

import java.io.*;
import java.io.IOException;
import javax.swing.*; 
import javax.swing.text.JTextComponent;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import java.math.BigInteger;

import java.net.URL;
import java.util.*;

import neuroml.util.*;

/** Test GUI for Gui Kit
 *
 * @author Paul Rogister and Fred Howell
 * @date March 2001
 */

public class GuiKit extends JFrame {

    public static Font font = null;

    public static Font getDefaultFont() { return font; }
    public static void setDefaultFont(Font f) { font=f; }

    /** fwh added bundled resources
     */
    private static ResourceBundle resources;
    static {
        try {
            resources = ResourceBundle.getBundle("guikit.resources/GuiKit", Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("guikit.resources/JDOMGui.properties not found");
        }
    }
    protected static String getResourceString(String nm) {
	String str;
	try {
	    str = resources.getString(nm);
	    System.out.println("getResourceString asking for "+nm+" got "+str);
	} catch (MissingResourceException mre) {
	    str = null;
	}
	return str;
    }
    protected URL getResource(String key) {
	String name = getResourceString(key);
	if (name != null) {
	    URL url = GuiKit.class.getResource(name);
	    return url;
	} else {
	    System.out.println("Couldn't get resource "+key);
	}
	return null;
    }
    protected URL getURLResource(String name) {
	URL url = this.getClass().getResource(name);
	return url;
    }
 
    
   /* public static void main(String[] args) {
	System.out.println("Starting test");
        JFrame frame = new TestKit();
	frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) { System.exit(0);  }
	    });  	
        frame.pack();
        frame.setVisible(true);
    } */
}
