package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;


/** Menu of node / link types
 */
public class MenuPanel extends NetPanel implements ComponentListener{

    NetEditPanel nep=null; 
    int CurrentY=0;
    double MaxSize=0.0,MinSize=0.0;

    public MenuPanel() {
	super();	
        setBackground(Color.lightGray.darker());
        addComponentListener(this);
    }

    public void setNetPanel( NetEditPanel nep ) {
	this.nep = nep;
    }

    protected void setInitialScale() {
	super.setInitialScale();
	ysz  = 80;
//	pysz = 80;
	platonicYPixelSize = ysz / (double)pysz;  // Size for placing images    
	//System.out.println("Menu Panel Set Initial Scale");
    }

    // Press -> Select Node/Link to place
    public void mousePressed(MouseEvent e) {  
	int modif = e.getModifiers();
	double rx = realX( e.getX() );
	double ry = realY( e.getY() );
	if ((modif & InputEvent.BUTTON1_MASK) != 0) {
	    clickedPoint = cp.queryClick( rx,ry );
	    // System.out.println("Clicked at Real:-"+rx+" "+ry+","+e.getX()+" "+e.getY());

	    if (clickedPoint != null) {
		// System.out.println("Clicked on "+clickedPoint);
		if (nep!=null) {
                    if(((NetEditPanel)nep).ToBeAdded!=null) nep.removeMenuNode(((NetEditPanel)nep).ToBeAdded);
                    ((NetEditPanel)nep).ToBeAdded=clickedPoint;                   
		    nep.addMenuNode( clickedPoint );
                    
		} else {
		    System.out.println("Error: MenuiPanel needs to have setNetPanel called");
		}
	    }
	}
        else if ((modif & InputEvent.BUTTON3_MASK) != 0) {
	    dragY = e.getY();
	    realDragY = realY( dragY );
	    navigating  = true;
	    System.out.println("navigating!");     
	}            
    }
    public void mouseDragged(MouseEvent e) {   
	if (navigating) {
	    double py = (e.getY() - dragY)/zoomFactor;
            dragY=e.getY();
            
            hasMoved=true;
            ty+=py;
            if(ty<MinSize) {
                ty=MinSize;
                return;
            }

            if(ty>MaxSize) {
                ty=MaxSize;
                return;
            }
            t.translate(0.0,py);
            
	    rerender();
	    repaint();
	} else super.mouseDragged(e);
    }    

    public void mouseReleased(MouseEvent e) {  
        navigating = false;
        hasMoved = false;
    }    
    
    void SetNbComponents(int nb, int perline)
    {
        pysz=10+70*((nb-1)/perline+1);
        pxsz=125*perline;
    }
    
    public void componentHidden(ComponentEvent e) {
    }
    
    public void componentMoved(ComponentEvent e) {
    }

    public void organize()
    {
        int i;
        int Lines=1;
        CurrentY=50;
        int CurrentX=50;
        
        Dimension d = getSize();

        int Width=(int)realX(d.width);
        Node n; 
        Link l;
        boolean DoingNode=true;
        i=0;
        while(true)
        {    
            if(DoingNode)
            {
                
                
                if(i<net.nodes.size())
                {
                    if(CurrentX+50>Width)
                    {
                        CurrentX=50;
                        CurrentY+=70;
                        Lines++;
                    }
                    n = (Node) net.nodes.elementAt(i++);
                    n.setPos(CurrentX,CurrentY);
                    CurrentX+=100;
                }
                else
                {
                    i=0;
                    DoingNode=false;

                }
            }
            else
            {
                if(i<net.links.size())
                {
                     if(CurrentX+50>Width)
                    {
                        CurrentX=50;
                        CurrentY+=70;
                        Lines++;
                    }
                    l=(Link) net.links.elementAt(i++);
                    l.setPos(CurrentX,CurrentY);
                    CurrentX+=100;
                   
                }
                else
                {
                    break;
                }
            }//if DoingNode
        }//While
        MaxSize=getSize().height-(CurrentY+30.0);
        MinSize=MaxSize;
        if(MaxSize<0.0) MaxSize=0.0;
        if(MinSize>0.0) MinSize=0.0; 
        if(t!=null) 
            t.translate(0.0,-ty);
        ty=0.0;
    }
    
    
    public void componentResized(ComponentEvent e) {
        organize();
        rerender();
        repaint();  
        
    }
   
    public void componentShown(ComponentEvent e) {
    }
    public boolean ContainProjectionType(Connector pr){
        boolean equivalent=false;
        ProjectionLink stuff;
        int size=net.links.size();
        for(int i=0;i<size&&equivalent==false;i++){
            stuff=(ProjectionLink)(net.links.elementAt(i));
            equivalent=equivalent||pr.IsEquivalent((Connector)(stuff.getData()));
        }
        return equivalent;
    }    
   public void mouseMoved(MouseEvent e) { 
        double rx,ry;
        
	if (dragging) {
	    mouseDragged(e);
	}
        else{
            int modif = e.getModifiers();
            try
            {
                rx = realX(e.getX());
                ry = realY(e.getY());
            }
            catch(java.lang.Throwable throwable)
            {
                return;
            }
            clickedPoint = cp.queryClick( rx,ry );
            if(BasicClickablePoint.EmphasizedPoint==clickedPoint) return;
            if(clickedPoint==null) 
                System.out.println("Out!");
            else
                System.out.println("Found "+clickedPoint+"!");
            BasicClickablePoint.EmphasizedPoint=clickedPoint;       
            rerender();
            repaint();    
        }
    }   

//Organize()
}
 
