/*
 * ModuleEditor.java
 *
 * Created on 17 February 2004, 10:56
 */

package guikit;
import java.util.*;
import java.io.*;
import javax.swing.filechooser.*;
import java.net.*;
import neuroml.core.*;
import neuroml.sim.*;
import neuroml.util.*;
import javax.swing.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class ModuleEditor implements Editor, ElementChangedListener {
    
    /** Creates a new instance of ModuleEditor */
    
    ElementChangedListener notifyParent = null;
    String ModuleDir=null;
    
    
    public ModuleEditor() {
    }
    
    public void confirmElementChanged(Object oldobject, Object newobject) {
    }
    
    public void editObject(Object o) {
        editObject(o,null);
    }
    
    public void editObject(Object o, ElementChangedListener ecl) {
        editObject( o, "modules", ecl );
  
    }
    
    public void editObject(Object o, String path, ElementChangedListener ecl) {
        notifyParent = ecl;
        Module value=null;
        //Should be nodes instead
        
        Namespace ns = NeuromlSys.getNewestNamespace();
        URL newModule=null;

        try{
            File machin=fileChooser("jar","NeuroML modules");
            newModule=(machin!=null)?machin.toURL():null;
        }
        catch(Exception e){
            return;
        }
        
        if(newModule==null) return;
	if (newModule!=null) {
            System.out.println("Loading jar file "+newModule);
	// *** Try to get the module ***
	// *** Just the default one... ***
            Object m = ModuleLoader.getObject( newModule.toString(),"");
            String beanName = ModuleLoader.getObjectName();
            String imgName  = ModuleLoader.getManifestValue("Icon");
            String docName  = ModuleLoader.getManifestValue("Doc");
            String modClass = ModuleLoader.getManifestValue("ModuleClass");
            //Module NewModule=new Module(beanName);
            //NewModule.location=newModule.toString();
            String location=newModule.toString();

            URL imgUrl = null;
            
            if (imgName!=null){
                imgUrl = ModuleLoader.getResource(location, imgName);
		System.out.println("imgUrl "+imgUrl);
                System.out.println("Got resource "+imgName+" url "+imgUrl+" object "+m);
            }
            URL docUrl = null;
            if (docName!=null)
                docUrl = ModuleLoader.getResource(location, docName);
            
            //NewModule.setModuleObject(m);//like Fred
            
            //NewModule.className=modClass;
            //NewModule.imageUrl=(imgUrl==null)?new String(""):imgUrl.toString();
            //NewModule.docUrl=(docName==null)?new String(""):docName.toString();
            
            if (beanName==null) 
                beanName = location;
           
        
//need to say to the parent that we have a new module.
            

//            if(topObject instanceof NeuromlPkg)
//            {
//                NeuromlPkg o=(NeuromlPkg)topObject;
//                o.modules.addElement(NewModule);
                
                JarClassLoader truc=NeuromlSys.classLoader;
                if(truc!=null)
                {
                    String[] strings=null;
                    try{
                        strings=truc.readJar(location);
                    }
                    catch(Exception e){
                        System.out.println("Can not read "+ beanName +"?...");
                    }
                    if(strings!=null){
                        Namespace truv=NeuromlSys.getNewestNamespace();
                        Ref myRef=new Ref();
                        myRef.setTargetName(((Module) o).getName());
                        myRef.setContentClassName("Module");
                        
                        value=(Module)(truv.deRef(myRef));
                        if(value!=null){
                            truv.removeRef(myRef.getTargetName(),o);
                            truv.removeRef("modules."+myRef.getTargetName(),o);
                        }
                        else
                            value=new Module(beanName);
                        
                        value.setName( beanName );
                        truv.addRef(value.getName(),value);
                        value.location=location;
                        value.className=modClass;
                        value.imageUrl=(imgUrl==null)?new String(""):imgUrl.toString();
                        value.docUrl=(docName==null)?new String(""):docName.toString();  
                        truv.initialiseDerivedFrom(strings);
                        
                    }else{
                        System.out.println("Hmmmm... no classes for module "+ beanName +"?...");
                    }
                }
                else System.out.println("NeuromlSys.classLoader is null!");
                
                notifyParent.elementChanged(o, value);
            }
        
    }
    
    public File fileChooser(String ext,String hint) {
        JDialog Dialog;
	try {
	    if(ModuleDir==null) ModuleDir = System.getProperty("user.dir");
            if(ModuleDir==null) ModuleDir = "./";
	} catch (java.security.AccessControlException ae){
	    ModuleDir = "./";
	}
	JFileChooser chooser = new JFileChooser(ModuleDir);  
        ExampleFileFilter filter = new ExampleFileFilter(ext,hint);
	chooser.addChoosableFileFilter(filter);	
        Dialog=new JDialog();
        Dialog.setVisible(true);
	int returnVal = chooser.showOpenDialog(Dialog); 
	if (returnVal == JFileChooser.APPROVE_OPTION){
            ModuleDir=chooser.getSelectedFile().getParent();
            Dialog.setVisible(false);	
            return chooser.getSelectedFile();
	} 
        Dialog.setVisible(false);	
        return null;
    }
    
    public void elementChanged(Object oldobject, Object newobject) {
    }
    
    public void startMain() {
    }
    
}
