package guikit;
 
import neuroml.*;
import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.network.*;
 
import javax.swing.*; 
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

/** Example extension of the Basic Editor Application
 * -- Adds some extra menus items
 *
 * @author  Fred Howell
 * @date July 2001
 */
public class MyApp extends BasicApp {
 
    /** Initialise application
     */
    public MyApp(String frameName) {
        super(frameName);    
    }

    public void createMenu() {
        menuBar = new JMenuBar();
        setJMenuBar(menuBar);

	fileMenu = addMenu( menuBar, "File", "File", KeyEvent.VK_F);
	addMenuItem(fileMenu, "Open", "Open NeuroML Model", -1);
	addMenuItem(fileMenu, "Edit Model", "Edit model", -1);
	addMenuItem(fileMenu, "Save", "Save Model", -1); 
	fileMenu.addSeparator();
	addMenuItem(fileMenu, "Exit", "Exit", -1);
	
	editMenu = addMenu( menuBar, "Edit", "Edit", KeyEvent.VK_E);
	addMenuItem(editMenu, "Browse Objects", "Object browser", -1);
	addMenuItem(editMenu, "Modules", "Module browser", -1);

 	JMenu myMenu = addMenu( menuBar, "My Menu", "MyMenu", KeyEvent.VK_E);
	addMenuItem(myMenu, "Do this", "This", -1);
	addMenuItem(myMenu, "Do that", "That", -1);
  
	menuBar.add(Box.createHorizontalGlue());
	JMenu helpMenu = addMenu(menuBar,"Help", "Help about Basic Application", KeyEvent.VK_H);
	JMenuItem about = addMenuItem(helpMenu, "About", "About this program", -1);

    }     
    
    /** Deal with the new menu items...
     */
    public void actionPerformed(ActionEvent e) {
	if (e.getActionCommand().equals("Do This")) {
	    System.out.println("Do This");
        } else if (e.getActionCommand().equals("Do That")) {
	    System.out.println("Do That");
	} else {
	    super.actionPerformed(e);
	}
    }

    /** Sample main program
     */
    public static void main(String[] args) {
	System.out.println("Starting My Customized Applet");
        JFrame frame = new MyApp("My Customized Applet");
	frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) { System.exit(0);  }
	    });  	
        frame.pack();
        frame.setVisible(true);
    } 
}
