package guikit; 

import neuroml.core.*;
import java.lang.reflect.*;



/** Represents the name field 
 */
public class NameNode extends ObjectNode {  
    
    /** Example use:
     * new NameNode( testObject, "myname" );
     */
    public NameNode(Object parent, String name) {
	super(name);
	this.parent = parent;
    }
    
    public String getName() { return "name"; }
    public Object getContent() { return content; }
    public void setContent(Object c) {  
	if (parent!=null) {
	    try {
		((Nameable)parent).setName((String)c); 
	    } catch (Exception e ) {
	    } 
	}
	// What if parent is a list???
    }

    public String toString(){
	String title = getName()+" : "+content; 
	return title;
    }
}
