package guikit; 
import java.io.*;
import javax.swing.*;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;
import java.net.URL;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.*;

public class Navigator extends EditPanel  {
    
   
    HTMLPanel panel;
    JPanel navbar = new JPanel();
  
    String comment = new String();
    JButton backButton = null;
    JButton forwardButton = null;
    JButton homeButton = null;

    // images urls
    public URL imgBackUrl;
    public URL imgForwardUrl; 
    public URL imgHomeUrl;
    // dimensions
    public int x = 250;
    public int y = 250;

    public Navigator() {
	panel = new HTMLPanel();
	panel.setNavigator(this);
	initURLs();
	buildPanel();
    }
    public Navigator(String url) {
	panel = new HTMLPanel(url);
	panel.setNavigator(this);
	initURLs();
	buildPanel();
    }
    public Navigator(String url,String comment) {
	this.comment = comment;
	panel = new HTMLPanel(url);
	panel.setNavigator(this);
	initURLs();
	buildPanel();
    }
    public Dimension getPreferredSize() {
	return new Dimension(x,y);
    }
    protected void initURLs(){
	try {
	    imgBackUrl = new URL("http://www.anc.ed.ac.uk/~paulro/images/back.gif");
	    imgForwardUrl = new URL("http://www.anc.ed.ac.uk/~paulro/images/forward.gif"); 
	    imgHomeUrl = new URL("http://www.anc.ed.ac.uk/~paulro/images/home.gif"); 
	} catch (Throwable t) {
	    t.printStackTrace();
	}
    }
    private void buildPanel(){

	navbar.setLayout(new FlowLayout(FlowLayout.LEFT )); 
	ImageIcon icon;
	// back button
	icon = new ImageIcon(imgBackUrl);
	if (icon==null) {	    
	    //System.out.println("Couldn't get icon");
	    backButton = makeButton( "<<", "Back", new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    //System.out.println("back");
		    backURL();		    
		}});
	} else {
	    
	    backButton = makeButton( icon, "Back", new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    //System.out.println("back");
		    backURL();		    
		}});
	}
	backButton.setPreferredSize(new Dimension(30,30));			     
	backButton.setEnabled(false);
	navbar.add(backButton);

	// forward button
	icon = new ImageIcon(imgForwardUrl);
	if (icon==null) {
	    forwardButton = makeButton( ">>", "Forward", new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    //System.out.println("forward");
		    forwardURL();		    
		}});
	} else {
	    
	    forwardButton = makeButton( icon, "Forward", new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    //System.out.println("back");
		    forwardURL();		    
		}});
	}
	forwardButton.setPreferredSize(new Dimension(30,30));
	forwardButton.setEnabled(false);
	navbar.add(forwardButton);

	// home button
	icon = new ImageIcon(imgHomeUrl);
	if (icon==null) {
	    homeButton = makeButton( "home", "Home", new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    //System.out.println("home");
		    homeURL();		    
		}});
	} else {
	    
	    homeButton = makeButton( icon, "Home", new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    //System.out.println("back");
		    homeURL();		    
		}});
	}
	homeButton.setPreferredSize(new Dimension(30,30));
	homeButton.setEnabled(true);	     
	navbar.add(homeButton);
	
	if(!comment.equals("")){
	    JLabel commentLabel = new JLabel(comment);
	    add(commentLabel);
	}
	
	setLayout(new BorderLayout( )); 
	add(navbar,BorderLayout.NORTH);
	add(panel,BorderLayout.CENTER);

    }
    
    public void setHome(String url){
	panel.setHome(url);
    }
    public void enableBack(boolean b){
	backButton.setEnabled(b);
    }
    public void enableForward(boolean b){
	forwardButton.setEnabled(b);
    }
    public Dimension getMinimumSize() {
	return getPreferredSize(); 
    }
  
    public Dimension getMaximumSize() {
	return getPreferredSize();
	
    }
    
 /** use of back button
     */
    public void backURL(){

	boolean back = panel.backURL();
	refreshPanel();

	enableBack(back);
	enableForward(true);
	
    }

    /** use of foward button
     */
    public void forwardURL(){
	
	boolean forward = panel.forwardURL();
	refreshPanel();

	enableForward(forward);
	enableBack(true);
    }


    
    public void homeURL(){

	boolean home = panel.homeURL();
	refreshPanel();


	panel.revalidate();
	enableForward(home);
	enableBack(false);
    }
	
    public void openURL(String url){
	panel.openURL(url);
	refreshPanel();
    }

    public void refreshPanel(){
	removeAll();
	add(navbar,BorderLayout.NORTH);
	add(panel,BorderLayout.CENTER);
	this.revalidate();
    }

  
	
}
