package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;
import java.lang.reflect.*;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
import neuroml.util.NeuromlSys;

import neuroml.sim.*;
//First update with WinCVS under NetBeans
 
/** A network editor - superclass for user network editors.
 */
public class NetEditPanel_GuiKit extends NetEditPanel implements ActionListener {
    SubnetsEditor_GuiKit superParent;  
    protected static NetEditPanel_GuiKit LastGuiKit=null;
    public static ClickablePoint getLastClick(){
        if(LastGuiKit!=null)
            return LastGuiKit.clickedPoint;
        return null;
    }
    
    Object LastObj;
    public NetEditPanel_GuiKit(Environment env, Network n, String path, SubnetsEditor_GuiKit ttt) {
        super(env,n,path);
        LastGuiKit=this;
        superParent=ttt;    
    }

    
    public void popupEditor(Namespace ns, ObjectNode ne, String base) {
	Editor specialEditor = SpecialEditors.get( ne.getContent().getClass().getName() );
	if (specialEditor==null) {
            LastObj=ne.getContent();
	    eop = new EditObjectPanel( ns, ne, base , true,true,this);                                                       
	    eop.addElementChangedListener(this);
            JPanel PanelEdit=new JPanel(new BorderLayout()); 
            int v=ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED;
            int h=ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED;     
            JScrollPane jsp = new JScrollPane(eop,v,h);
            PanelEdit.add(jsp,BorderLayout.CENTER);
            JPanel buttons = new JPanel();
            buttons.setLayout( new BoxLayout(buttons, BoxLayout.X_AXIS) );
            String stuff=new String();
            buttons.add(eop.makeButton("Remove", "remove", this));
            buttons.add(eop.makeButton("Save "+ns.getShortClassName(ne.getName()), "save", eop));
            buttons.add(eop.makeButton("Close", "close", this));
            PanelEdit.add(buttons,BorderLayout.SOUTH);
            superParent.DisplaySide(PanelEdit);
           } else {
	    specialEditor.editObject( ne.getContent(), this ); 
	}  
    }
    

    protected void PopupClickedPoint(ClickablePoint clickedPoint){                      
	ObjectNode on =  new ObjectNode(clickedPoint.getParentSet(), clickedPoint.getData(), this);
        //on.setPath(path+"."+((neuroml.core.Set)clickedPoint.getParentSet()).getName()+"."+((NamedObject)clickedPoint.getData()).getName());
        on.setPath(path+"."+((neuroml.core.Set)clickedPoint.getParentSet()).getName(),((NamedObject)clickedPoint.getData()).getName());
	popupEditor(env.getNamespace(),on,clickedPoint.getBaseClass());
    }   
 
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("remove")) {          	    
	    eop.remove();  
            superParent.HideSide();
        }
        else if (e.getActionCommand().equals("close")){
            superParent.HideSide();
            if(LastObj!=null&&LastObj instanceof Connector)
            superParent.addProjection((Connector)LastObj);
        }      
    }
    public void elementChanged( Object oldobject, Object newobject ) {
        if(oldobject instanceof Connector && newobject instanceof Connector)
            LastObj=newobject;
        super.elementChanged(oldobject, newobject);
    }

    protected void RightClick(MouseEvent e){
        final int X=e.getX();
        final int Y=e.getY();
        final NetEditPanel_GuiKit PanelGuikit=this;
        double rx = realX(X);
	double ry = realY(Y);
        final Point pt=PanelGuikit.getLocationOnScreen();
        clickedPoint = cp.queryClick( rx,ry );
	if (clickedPoint != null&&!this.dragging) {
            final Object o=clickedPoint.getData();
            final Namespace ns=env.getNamespace();
	    if (o!=null) {	
                menu.removeAll();
                JMenuItem item = new JMenuItem("Cancel");
                item.addActionListener(new ActionListener() {
                     public void actionPerformed(ActionEvent event) {
                          //menu.setVisible(false);
                          MenuPopupVisible=false;    
                     }
                });    
                menu.add(item);                
                try{
                    menu.add(JPopupMenu.Separator.class.newInstance());
                }
                catch(Exception ecp){
                    
                }                


//Popup Class                
                Class expClass_ =  NeuromlSys.getClassFromJar( clickedPoint.getBaseClass() );
                if (expClass_ == null) {
	//if ((baseClass != null)&&(expClass == null)) {

                    expClass_ =  NeuromlSys.getClassFromShortName( clickedPoint.getBaseClass() );
                }
                final  Class expClass=expClass_;
                final String thisClassName = expClass.getName();
                
                if (expClass != null) { // we know what we're expecting...
                    final Vector derivedFrom = ns.getDerivedFrom( expClass.getName() );
                    /*for (int i=0; i<derivedFrom.size(); i++) {
                        System.out.println("  or a "+derivedFrom.elementAt(i));
                    }*/	    
	    // OK, make a "change Class" selection box...
                    if (derivedFrom.size() > 0) {
			item = new JMenuItem("Class");
                        final ObjectNode on_ = new ObjectNode( clickedPoint.getParentSet(), o,new ElementChangedListener(){
                            public void elementChanged(Object oldobject, Object newobject){                                        
                                PanelGuikit.elementChanged(o,newobject);
                            }
                            public void confirmElementChanged(Object oldobject, Object newobject){
                            }
                        });
                        on_.setPath(path+"."+((neuroml.core.Set)clickedPoint.getParentSet()).getName(),((NamedObject)clickedPoint.getData()).getName());
                        

                        final ObjectNode on=on_;
                                 
			item.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
                                    MenuPopupVisible=false;  
                                    int currIdx = derivedFrom.indexOf(on.getContent().getClass().getName()) + 1;
                                    int sz = derivedFrom.size()+1;
                                    String[] choices = new String[sz];
                                    choices[0] = expClass.getName(); // first choice is base class
                                    for (int j=1; j<sz; j++) choices[j]=(String)(derivedFrom.elementAt(j-1)); 
                                    JComboBox classComboBox = new JComboBox( choices );
                                    classComboBox.setSelectedIndex(currIdx);
                                    classComboBox.addActionListener(new ActionListener() {
                                        public void actionPerformed(ActionEvent event) {
                                            JComboBox cb = (JComboBox)event.getSource();	    
                                            String selectName = (String)cb.getSelectedItem();	    
                                            //objName=getObjectName();                                            
                                            String str=on.getPath();
                                            String truc=str.substring(0,str.lastIndexOf("."));
                                            Object value=on.getContent();
                                            ns.removeRef(on.getPath(),value);

                                        // make a new object of this class
                                        // rebuild the panel...
                                            Object newo = NeuromlSys.makeNeuromlObject( selectName );

                                        // if object is parameter and so not a neuroml object :
                                            if (newo==null)
                                                newo = NeuromlSys.makeObjectFromJar( selectName );

                                        // set name...
                                            if (newo instanceof Nameable) ((Nameable)newo).setName(on.getName());
                                            Field[] flds_old=value.getClass().getFields();
                                            Field[] flds_new=newo.getClass().getFields();
                                            Object fob;
                                            Object CurrenField;
                                            for (int i=0; i<flds_new.length; i++) {
                                                try {
                                                    fob  = flds_new[i].get(value);
                                                    int mod  = flds_new[i].getModifiers();
                                                    if (Modifier.isStatic(mod)) {
                                                    } else  {
                                                        if (fob!=null) {
                                                            flds_new[i].set(newo,fob);                            
                                                        }//fobnull
                                                    }//if Modifier
                                                }
                                                catch ( Exception e) {
                                                    System.out.println(" EditObjectPanel : "+e);
                                                }
                                            }                                            
                                            
                                            Object Obj=on.getParent();
                                            if(Obj!=null)
                                            {
                                                if(Obj instanceof neuroml.core.Set)
                                                {
                                                    ((neuroml.core.Set)Obj).removeElement(value);
                                                    ((neuroml.core.Set)Obj).addElement(newo);
                                                }
                                            }          
                                       //     on.setContent(newo); //useful ???
                                       //     on.setPath(); 
                                            ns.addRef(truc+"."+on.getName(), newo);
                                            
                                            PanelGuikit.elementChanged(value,newo);// notifyParent.elementChanged( value,value );               
                                            value=newo;  
                                        }
                                    });
                                    JFrame myFrame=new JFrame( ((Nameable)o).getName()+ " : class selection");
                                    myFrame.add(classComboBox);
                                    try{
                                        java.net.URL truc=NetEditPanel_GuiKit.class.getResource(NetworkDesigner.resources.getString("EditingPopup"));
                                        ImageIcon chose=new ImageIcon(truc);
                                        myFrame.setIconImage(chose.getImage());
                                    }
                                    catch(Exception except){
                                        System.out.println("No icon for the editing window");
                                    }                                        
                                    myFrame.pack();
                                        
                                    myFrame.setLocation(X+pt.x, Y+pt.y);
                                    myFrame.addWindowListener(new WindowAdapter(){
                                        public void windowClosing(WindowEvent e){ 
                                            PanelGuikit.rerender();
                                            PanelGuikit.repaint();
                                        }
                                    });
                                    myFrame.setVisible(true);                                    
                                }
                        });
                        menu.add(item); 
                        try{
                            menu.add(JPopupMenu.Separator.class.newInstance());
                        }
                        catch(Exception ecp){
                        }
                        
                    /*    
                    
                    fieldPan.add(classComboBox);*/
                    }
                }                
                
//Popup Name                 
                if (o instanceof Nameable) {
                    item = new JMenuItem("Name");
                    item.addActionListener(new ActionListener() {
                           public void actionPerformed(ActionEvent event) {
                                 MenuPopupVisible=false;                                   
                                 //Point pt=PanelGuikit.getLocationOnScreen();
                                 JFrame myFrame=new JFrame( new String(((Nameable)o).getName()+ ".Name"));
                                 final NameNode on_ = new NameNode(o,((Nameable)o).getName());
                                 on_.setPath(path+"."+((neuroml.core.Set)clickedPoint.getParentSet()).getName(),((NamedObject)clickedPoint.getData()).getName()+".Name");
                                 final NameNode on=on_;
                                 EditStringPanel namep = new EditStringPanel( on );
                                 namep.setElementChangedListener(new ElementChangedListener(){
                                       public void elementChanged(Object oldobject, Object newobject){
                                            if (newobject instanceof String) {
                                		ns.rename( on.getParentPath()+"."+oldobject, on.getParentPath()+"."+newobject);
                                                on.changeFieldName((String)newobject);
                                            }                                           
                                            on.setContent(newobject);                                                    
                                            PanelGuikit.elementChanged(o,o);
                                       }
                                       public void confirmElementChanged(Object oldobject, Object newobject){         
                                       }
                                 });                                       
                                 myFrame.add(namep);
                                 try{
                                      String str=NetworkDesigner.resources.getString("EditingPopup");
                                      java.net.URL truc=NetEditPanel_GuiKit.class.getResource(str);
                                      ImageIcon chose=new ImageIcon(truc);
                                      myFrame.setIconImage(chose.getImage());
                                 }
                                 catch(Exception except){
                                       System.out.println("No icon for the diting window");
                                 }                                  
                                 myFrame.pack();
                                        
                                 myFrame.setLocation(X+pt.x, Y+pt.y);
                                 myFrame.addWindowListener(new WindowAdapter() {
                                      public void windowClosing(WindowEvent e) { 
                                            PanelGuikit.rerender();
                                            PanelGuikit.repaint();
                                      }
                                 });
                                 myFrame.setVisible(true);
                           }
                    });
                    menu.add(item); 
                }                
                
                Class c = o.getClass();
                final Field[] flds = c.getFields();
                for (int i=0; i<flds.length; i++) {
                    try {
            		Object fob = flds[i].get(o);
                	int mod  = flds[i].getModifiers();
                        if (Modifier.isStatic(mod)) {
                        } else if (Modifier.isPublic(mod)) {	
                            final int k=i;
                            item = new JMenuItem(flds[i].getName());
                            item.addActionListener(new ActionListener() {
                                public void actionPerformed(ActionEvent event) {
                                    
                                    MenuPopupVisible=false;    
                                    try{
                                        final Object fob=flds[k].get(o);
                                        //EditObjectPanel eop = new EditObjectPanel( ns,myField,myField.getClass().getName(),false );
                                        //eop.popup();   
                                         final JFrame myFrame=new JFrame( new String(((Nameable)o).getName()+ "." +flds[k].getName()));                                        
                                         ObjectNode on_ = new ObjectNode( o, flds[k].getName(),new ElementChangedListener(){
                                                public void elementChanged(Object oldobject, Object newobject){                                        
                                                    PanelGuikit.elementChanged(o,fob);
                                                    //on.setContent(newobject);
                                                }
                                                public void confirmElementChanged(Object oldobject, Object newobject){
                                                }
                                        });
                                        on_.setPath(path+"."+((neuroml.core.Set)clickedPoint.getParentSet()).getName()+"."+((NamedObject)clickedPoint.getData()).getName(),flds[k].getName());
                                        final ObjectNode on=on_;
                                        JPanel innerPannel=new JPanel();
                                       
                                        if (fob instanceof Integer ) {
                                             innerPannel=new EditIntegerPanel( on ) ;
                                        } else if (fob instanceof Short ) {
                                             innerPannel=new EditShortPanel( on ) ;
                                        } else if (fob instanceof Double ) {
			                     innerPannel=new EditDoublePanel( on ) ;
                                        } else if (fob instanceof DValue ) {
                                            innerPannel=new EditDValuePanel( ns,on ) ;
                                        } else if (fob instanceof Boolean ) {
                                            innerPannel=new EditBooleanPanel( on ) ;                            
                                        } else if (fob instanceof String ) {
                                            innerPannel=new EditStringPanel( on ) ;
                                        } else if (fob instanceof URL ) {
                                            innerPannel=new EditURLPanel( on ) ;
                                        } else if (fob instanceof neuroml.core.NeuromlArray ) {
                                            innerPannel=new EditArrayPanel(ns, on ) ;
                                        } else if (fob instanceof neuroml.core.Set ) {
                                             innerPannel=new EditSetPanel(ns, on ) ;
                                        } else if (fob instanceof neuroml.core.List ) {
                                            innerPannel=new EditListPanel(ns, on ) ;
                                        } else if (fob instanceof neuroml.core.TreeRef ) {
                                            innerPannel= new EditTreeRefPanel(ns, on );
                                           ((EditTreeRefPanel)innerPannel).addElementChangedListener(new ElementChangedListener(){
                                                public void elementChanged(Object oldobject, Object newobject){
                                                    on.setContent(newobject);                                                    
                                                    PanelGuikit.elementChanged(o,fob);
                                                    revalidate();
                                                }
                                                public void confirmElementChanged(Object oldobject, Object newobject){
                                                 
                                                }
                                            });
                                        } else if (fob instanceof neuroml.core.Ref ) {
                                            innerPannel= new EditRefPanel(ns, on );
                                           ((EditRefPanel)innerPannel).addElementChangedListener(new ElementChangedListener(){
                                                public void elementChanged(Object oldobject, Object newobject){
                                                    on.setContent(newobject);                                                    
                                                   // PanelGuikit.elementChanged(o,fob);
                                                    PanelGuikit.elementChanged(o,o);
                                                    revalidate();
                                                  }
                                                public void confirmElementChanged(Object oldobject, Object newobject){
                                                 
                                                }
                                            });// Listen to changes
                                        } else if (fob instanceof neuroml.core.ModuleRef ) {
                                            innerPannel=new EditModuleRefPanel(ns, on ) ;
                                        } else if (fob instanceof neuroml.core.Enum ) {
                                            innerPannel=new EditEnumPanel(ns, on ) ;
                                        } else if (fob != null) {
                                            innerPannel= new EditObjectPanel(ns, on, flds[k].getType().getName(),true);	
                                            ((EditObjectPanel)innerPannel).addElementChangedListener( new ElementChangedListener(){
                                                public void elementChanged(Object oldobject, Object newobject){
                                                    on.setContent(newobject);                                                    
                                                    PanelGuikit.elementChanged(o,fob); 
                                                    revalidate();
                                                }
                                                public void confirmElementChanged(Object oldobject, Object newobject){
                                                 
                                                }
                                            });// Listen to changes
                                        }	
                                        //Point pt=PanelGuikit.getLocationOnScreen();

                                        myFrame.add(innerPannel);
                                        try{
                                            java.net.URL truc=NetEditPanel_GuiKit.class.getResource(NetworkDesigner.resources.getString("EditingPopup"));
                                            ImageIcon chose=new ImageIcon(truc);
                                            myFrame.setIconImage(chose.getImage());
                                        }
                                        catch(Exception except){
                                            System.out.println("No icon for the editing window");
                                        }                                        
                                        myFrame.pack();
                                        
                                        myFrame.setLocation(X+pt.x, Y+pt.y);
                                        myFrame.addWindowListener(new WindowAdapter() {
                                            public void windowClosing(WindowEvent e) { 
                                                PanelGuikit.rerender();
                                                PanelGuikit.repaint();
                                            }
                                        });
                                        myFrame.setVisible(true);
                                    }
                                    catch(Exception Excep){
                                        System.out.println("Should have edited "+flds[k].getName()+ " but I got an exception->JAG");
                                    }
                                }
                            });    
                            menu.add(item);
                        }
                    }
                    catch(Exception exc){
                        
                    }
                }//for
                try{
                    menu.add(JPopupMenu.Separator.class.newInstance());
                }
                catch(Exception ecp){
                    
                }
                item = new JMenuItem("Remove");
                final NetPanel stuff=this;
                final ObjectNode on_ = new ObjectNode( clickedPoint.getParentSet(), o,new ElementChangedListener(){
                    public void elementChanged(Object oldobject, Object newobject){                                        
                        PanelGuikit.elementChanged(o,newobject);
                    }
                    public void confirmElementChanged(Object oldobject, Object newobject){
                    }
                });
                on_.setPath(path+"."+((neuroml.core.Set)clickedPoint.getParentSet()).getName(),((NamedObject)clickedPoint.getData()).getName());
                        

                final ObjectNode on=on_;                
                item.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        MenuPopupVisible=false;  
                        stuff.RemoveElement(on);
                    }
                });

                menu.add(item);
                MenuPopupVisible=true;                
                menu.show(e.getComponent(), X, Y);
            }
        }
        else{
            if(!this.dragging){
                dragX = X; dragY = Y;
                realDragX = realX( dragX );
                realDragY = realY( dragY );
                navigating  = true;
                System.out.println("navigating!");            
            }
        }
    }
}


