package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.sim.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
import guikit.*;

/** A Panel with a number of nodes + links
 */
public class NetPanel extends GraphPanel {
    
    SubnetsEditor superParent;   
    Net net;
    protected ClickablePoints cp = new ClickablePoints();
    protected int dragY;
    protected double realDragY;
    protected boolean navigating = false;
    protected boolean hasMoved=false;  
    
    protected boolean dragging = false;
    protected ClickablePoint clickedPoint = null;
    ClickablePoint highlightedPoint = null;
    
    public NetPanel() {
	super();
        setBackground(Color.LIGHT_GRAY);
	net = new Net();
    }

    public void addNode(Node n) {
	net.addNode(n);
	cp.add(n);
    }

    /** Add a link
     */
    public void addLink(Link l) {
	net.addLink( l );
	cp.add( l );
    }
    
    public void mousePressed(MouseEvent e) {  
    }

    public void mouseReleased(MouseEvent e) {  
    }    

    // Special for selection from menu...
    public void mouseMoved(MouseEvent e) {  
        double rx,ry;
        
	if (dragging) {
	    mouseDragged(e);
	}
        else {
            try{
                Thread.sleep(10);//sleep 1cs
            }
            catch(Exception ecp){
            
            }
        }
    }

    // hook for sub classes...
    public void zoomed() {
    }
    
    public void mouseDragged(MouseEvent e) {
	double rx=realX(e.getX());
	double ry=realY(e.getY());
        if (dragging) {
	    clickedPoint.mouseDragged(rx,ry);
	    // If a control point...
	    if (clickedPoint instanceof Node) {
	    } else if (clickedPoint instanceof Link) {
	    } else if (clickedPoint instanceof ControlPoint) {
		ControlPoint ctrl = (ControlPoint)clickedPoint;
		// Check for intersection with nodes...
		if (highlightedPoint!=null) {
		    highlightedPoint.clearHighlighted();
		    highlightedPoint=null;
		}
		highlightedPoint = cp.intersectNode( rx, ry, ctrl.getWidth(), ctrl.getHeight() );
		if (highlightedPoint!=null) {
		    highlightedPoint.setHighlighted();
		}
	    }
            rerender();
	    repaint();
	}
    }
 

    /** Draw a link - one link
     */
    public void drawLink( Link l, Graphics2D g ) {
	l.draw(g);
    }
 

    // Draw a highlighted node
    public void drawHighlightedNode( Node n, Graphics2D g ) {
	AlphaComposite ac = AlphaComposite.getInstance( AlphaComposite.SRC_OVER, 0.5f );
	Composite oc = g.getComposite();
	g.setComposite(ac);
	g.setColor(Color.white);
        g.fill( new RoundRectangle2D.Double( n.getX0(), n.getY0(), n.getWidth(), n.getHeight(), n.getWidth()*0.2, n.getHeight()*0.2 ));
	g.setComposite(oc);
    }

    // Draw a node
    public void drawNode( Node n, Graphics2D g ) {
	n.draw(g);
    }
    public boolean imageUpdate(Image img, int f, int x, int y, int w, int h ) {
	if ((f & ImageObserver.ALLBITS) !=0) {
	    System.out.println("Image: done it all!"+f);
	    rerender();
	    repaint();
	    return false;
	} else {
	    return true;
	}
    }

    // Redraw the network
    public void render( int w, int h, Graphics2D g2) {
        int i;   
        g2.setColor(Color.black);

	// Paint the nodes
	for (i=0; i<net.nodes.size(); i++) {
	    Node n = (Node) net.nodes.elementAt(i);
	    if (n.getState() == Constants.NORMAL) drawNode( n,g2 );
	}
	// Paint the links
	for (i=0; i<net.links.size(); i++) {
	    Link l = (Link) net.links.elementAt(i);
	    if (l.getState() == Constants.NORMAL) drawLink( l, g2 );
	}
    }

    public void renderDragged( int w, int h, Graphics2D g2) {
	// Paint the nodes
	for (int i=0; i<net.nodes.size(); i++) {
	    Node n = (Node) net.nodes.elementAt(i);
	    if (n.getState() == Constants.DRAGGING) drawNode( n,g2 );
	    if (n.isHighlighted()) {
		drawHighlightedNode( n,g2 );
	    }
	}
	// Paint the links
	for (int i=0; i<net.links.size(); i++) {
	    Link l = (Link) net.links.elementAt(i);
	    if (l.getState() == Constants.DRAGGING) drawLink( l, g2 );
	}
    }
   
    public void setEditorPanel(SubnetsEditor ttt){
        superParent=ttt;
    } 
 }
