/*
 * NetworkDesigner.java
 *
 * Created on 03 May 2004, 15:34
 */

package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;
import javax.swing.*;
import neuroml.*;
import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class NetworkDesigner extends JFrame implements ActionListener {
    public Environment env;
    public Object topObject = null;
    public Namespace ns = null;    
    protected String ModuleDir=null;
    public JMenuBar menuBar;    
    public JMenu fileMenu;   
    
    protected SubnetsEditor stuff;
    //new ImageIcon(this.getClass().getResource(resources.getString("new")))
    public static ResourceBundle resources;
    public static void init()  {
        try {
            //resources = ResourceBundle.getBundle("NetTool.resources/NetworkDesigner",  Locale.getDefault());
            resources = ResourceBundle.getBundle("guikit.resources/NetworkDesigner",  Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("guikit.resources/NetworkDesigner.properties not found");
        }
    }
    public NetworkDesigner(){
         super("");
    }
    
    public NetworkDesigner(String frameName) {
        super(frameName);  
        init();
        
        java.net.URL truc=NetworkDesigner.class.getResource(resources.getString("Neuron"));
        ImageIcon chose=new ImageIcon(truc);
        this.setIconImage(chose.getImage());
        createMenu();
	getContentPane().setLayout(new BorderLayout());
               
        String BasicModel=System.getProperty("user.dir")+"/BasicModel.xml";
        Object o = NeuromlSys.loadXML(BasicModel);
	System.out.println("Loaded "+o);
	if (o!=null) {
		if (o instanceof NeuromlPkg){
                    Namespace truv=NeuromlSys.getNamespace(BasicModel);
                    truv.setModuleRef(((NeuromlPkg)o).ImplementionModules.getElements());
                    ((NeuromlPkg)o).ImplementionModules.setElements(truv.getModuleRef());
                    Environment env = new Environment(truv , (NeuromlPkg)o, null );
                    SpecialEditors.setEnvironment(env);
		}				    
		editObject( NeuromlSys.getNamespace(BasicModel), o );
	}
    }
    
    public static void main(String[] args) {
	System.out.println("Starting Basic Applet");

        System.out.println("Starting Network Editor Applet");
        SpecialEditors.put("neuroml.model.network.NetworkPkg","guikit.SubnetsEditor_GuiKit");
        SpecialEditors.put("neuroml.util.RefInterfaces","guikit.EditRefInterfaces");
        SpecialEditors.put("neuroml.core.Module","guikit.ModuleEditor");
        SpecialEditors.put("guikit.RGBColour", "guikit.ColourEditor" );
        EditTreeRefPanel.put("SubNetwork", "guikit.SubNetNode");
        JFrame frame = new NetworkDesigner("Basic neuroml editor applet");

	frame.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }
	});
    }     
    public File fileChooser(String ext,String hint) {
	try {
	    if(ModuleDir==null) ModuleDir = System.getProperty("user.dir");
            if(ModuleDir==null) ModuleDir = "./";
	} catch (java.security.AccessControlException ae){
	    ModuleDir = "./";
	}
	JFileChooser chooser = new JFileChooser(ModuleDir);  
        ExampleFileFilter filter = new ExampleFileFilter(ext,hint);
	chooser.addChoosableFileFilter(filter);	
	int returnVal = chooser.showOpenDialog(this); 
	if (returnVal == JFileChooser.APPROVE_OPTION){
            ModuleDir=chooser.getSelectedFile().getParent();
            return chooser.getSelectedFile();
	} 
	return null;
    }
    
    public void createMenu() {
        menuBar = new JMenuBar();
        setJMenuBar(menuBar);
	fileMenu = addMenu( menuBar, "File", "File", KeyEvent.VK_F);
	addMenuItem(fileMenu, "Open", "Open", "Open NeuroML Model", -1);
	addMenuItem(fileMenu, "Save", "Save", "Save Model", -1);

	fileMenu.addSeparator();
	addMenuItem(fileMenu, "Exit", null, "Exit", -1);
	
	menuBar.add(Box.createHorizontalGlue());
	JMenu helpMenu = addMenu(menuBar,"Help",  "Help about Basic Application", KeyEvent.VK_H);
	JMenuItem about = addMenuItem(helpMenu, "About", null, "About this program", -1);

    }    
    
    public JMenu addMenu( JMenuBar parent, String name, String desc, int m) {
	JMenu menu = new JMenu(name);
	if (m!=-1)  menu.setMnemonic(m);
        menu.getAccessibleContext().setAccessibleDescription(desc); 
	parent.add(menu);
	menu.addActionListener(this);
	return menu;
    }

    public JMenuItem addMenuItem( JMenu parent, String name, String IconName, String desc, int m) {
        JMenuItem mi;
        if(IconName==null)
            mi = new JMenuItem(name);
        else{
            java.net.URL myURL=NetworkDesigner.class.getResource(resources.getString(IconName));
            ImageIcon myIcon=new ImageIcon(myURL);
            mi = new JMenuItem(name,myIcon);
        }
	if (m!=-1) 
	    mi.setAccelerator(KeyStroke.getKeyStroke(m, ActionEvent.ALT_MASK)); 
        mi.getAccessibleContext().setAccessibleDescription(desc); 
	mi.addActionListener(this);
	parent.add(mi);
	return mi;
    }
    
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("Save")) {
            File machin=fileChooser("xml","NeuroML file");
            String fname=(machin!=null)?machin.getPath():null;
	    if (fname!=null) {
                System.out.println("Saving "+fname);
                NeuromlSys.toFile(topObject,fname);//filename
                System.out.println("Writen model to "+fname);//filename
            }
        } else if (e.getActionCommand().equals("Exit")) {
            System.exit(0);
        } else if (e.getActionCommand().equals("Open")) { 
	    File machin=fileChooser("xml","NeuroML file");
            String fname=(machin!=null)?machin.getPath():null;
	    if (fname!=null) {
		System.out.println("Opening "+fname);
		Object o = NeuromlSys.loadXML(fname);
		System.out.println("Loaded "+o);
                this.setName(o.toString());
		if (o!=null) {
		    if (o instanceof NeuromlPkg){
                        Namespace truv=NeuromlSys.getNamespace(fname);
                        truv.setModuleRef(((NeuromlPkg)o).ImplementionModules.getElements());
                        ((NeuromlPkg)o).ImplementionModules.setElements(truv.getModuleRef());
			Environment env = new Environment(truv , (NeuromlPkg)o, null );
			SpecialEditors.setEnvironment(env);		
		    }				    
		   editObject( NeuromlSys.getNamespace(fname), o );
		   //filename = fname;
		}
	    }	  	   
	} else  if (e.getActionCommand().equals("About")) { 
            System.out.println("");
 	    System.out.println("Network Designer Tool");
            System.out.println("---------------------");
            System.out.println("University of Edinburgh");
            System.out.println("Jean-Alain Grunchec, 2004");
            System.out.println("");
	} else { 
            System.out.println("Unknown command");
        }        
    }
    
    public void editObject( Namespace ns, Object o ) { 
         if(o instanceof NeuromlPkg){
            topObject = o;
            this.ns = ns;
            NeuromlPkg np=(NeuromlPkg)o;
            Object obj=null;
            for(int i=0;i<np.models.size()&&obj==null;i++){
                obj=np.models.elementAt(i);
                if(!(obj instanceof NetworkPkg))
                    obj=null;
            }
            NetworkPkg netPkg;
            if(obj==null){
                netPkg = new NetworkPkg("pkg1");
                np.models.addElement( netPkg );
                ns.addRef("models.pkg1", netPkg); 
            }
            else
               netPkg=(NetworkPkg) obj;
            ObjectNode on = new ObjectNode(netPkg);
            on.setPath( "models."+netPkg.getName() );
    
            stuff=new SubnetsEditor_StandAlone(netPkg,(NeuromlPkg)o,on.getPath(),null);//GuiKit
            getContentPane().removeAll();
            getContentPane().add(stuff,BorderLayout.CENTER);
            //((SubnetsEditor_StandAlone)stuff).BuildOthers((NeuromlPkg)o);

            pack();
            setVisible(true);
            obj=null;
            String str=netPkg.MainNetwork.getTargetName();
            if(str==null){
                for(int i=0;i<netPkg.networks.size()&&obj==null;i++){
                    obj=netPkg.networks.elementAt(i);
                    if(!(obj instanceof Network))
                        obj=null;
                }
            }
            else{
                Hashtable chose=(Hashtable)ns.getReferences().get("Network");
                if(chose!=null){
                    obj=chose.get(str);
                }
            }
            if(obj!=null)
               ((SubnetsEditor_StandAlone)stuff).ChangeCurrentNetwork((Network)obj);
            stuff.validate();   
         }
    }
}
