package guikit;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;
import guikit.*;     
/** Top class for node
 */
public class Node extends ControlPoint {
  
    public RGBColour colour = new RGBColour("ffff00"); 
    Font font = new Font("serif", Font.PLAIN, 14);

    public Node() { 
	this(10,10,10,10);
    }
    public Node(double x, double y) { 
	this(x,y,0.1,0.1);
    }   
    public Node(double x, double y, double xsize, double ysize) {
	super(x,y,xsize,ysize); 
	setDepth(1);
    }
    public Node(double x, double y, double xsize, double ysize, RGBColour rc) { 
	super(x,y,xsize,ysize); 
	colour = rc;
	setDepth(1);
    }   
    public Node duplicate(double xpix, double ypix) { 
	return new Node(cx,cy, xsize, ysize,colour );
    }
    /** Move this node
     */
    public void mouseDragged( double xp, double yp ) {
	double dx = xp - clickXOffset - getX();
	double dy = yp - clickYOffset - getY();
	this.cx = xp - clickXOffset;
	this.cy = yp - clickYOffset;
	for (int i=0; i<notifyPoints.size(); i++) {
	    ((ClickablePoint)(notifyPoints.elementAt(i))).move( dx, dy );
	}
    }      

    /** Draw this node 
     */
    public void draw( Graphics2D g ) {
	Font f = font;
	String msg=getName();
	int sw = g.getFontMetrics(f).stringWidth(msg);
	g.setFont(f);
	int shadow = 8; 
	g.setColor(colour.getColor().darker());
	g.fill( new Ellipse2D.Double( getX0()+shadow, getY0()+shadow, getWidth(), getHeight()) );
	g.setColor(colour.getColor()); 
	g.fill( new Ellipse2D.Double( getX0(), getY0(), getWidth(), getHeight()) );
	g.setColor(Color.black);
	g.drawString(msg, (float)getX() - sw/2, (float)getY());
    }
 
    public String toString() { return "Node "+getName()+" at "+cx+" "+cy; }
    public String getName() {
	if (data instanceof Nameable) {
	    return ((Nameable)data).getName(); 
	} else return "NewNode";
    }
    public void setName(String n) {
	if (data instanceof Nameable) {
	    ((Nameable)data).setName(n); 
	} 
    }
  
}
