package guikit;
 
import neuroml.model.network.*;
import neuroml.core.*;
import neuroml.sim.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import neuroml.util.*;

/** Subnet editor - popup an editor for a sub network
 */
class SubnetDisplayer extends EditPanel implements Editor, ElementChangedListener {

    NameNode name;
    Object value;
    //   Namespace ns; // Don't include a namespace in special editors yet...

    String path="models.pkg1.networks";

    ElementChangedListener notifyParent = null;

    /** Add notification of parent */
    public void addElementChangedListener( ElementChangedListener p ) {
	notifyParent = p;
    }

    public SubnetDisplayer() {
    }

    public void setPath( String p ) { path = p; }

    public void editObject( Object o ) {
	editObject(o,null);
    }

    public void editObject( Object o, ElementChangedListener ecl ) {
	editObject( o, "models", ecl );
    }
    public void editObject( Object o, String path, ElementChangedListener ecl ) {
	System.out.println("SubnetDisplayer path="+path);
	notifyParent = ecl;
	setPath(path);
	value = o;
	if (o instanceof Network) {
	    Network n = (Network)o;
	    
	    Environment env = SpecialEditors.getEnvironment();
	    Namespace ns = NeuromlSys.getNewestNamespace();
	    env.setNamespace(ns);
	    JFrame ed = new JFrame("Display subnetwork "+path);

	    ed.getContentPane().setLayout( new BorderLayout());

	    JPanel contents = new JPanel();
	    contents.setLayout(new BorderLayout());
	    ed.getContentPane().add(contents);
	    // At top, enter name...
	    name = new NameNode( n, n.getName() );
	    EditStringPanel namep = new EditStringPanel( name );
	    namep.setElementChangedListener(this);
	    contents.add(namep, "North");

		 
	    NetEditPanel panel = new NetEditPanel(env,
						  n, 
						  path );
	 
	    contents.add(panel,"Center");
	    ed.pack();
	    ed.setVisible(true);
	}
    }

    public void startMain() {
    }

    /** Listen to text field changes
     */
    public void elementChanged(Object oldn, Object newn) {
	if (newn instanceof String) {
	    System.out.println("SubnetDisplayer update name tbd "+newn);	 
	    notifyParent.elementChanged( value,value );
	}
   }
    /** Listen to text field changes
     */
    public void confirmElementChanged(Object oldn, Object newn) {
	// confirmation of changes, could be nice to implement it
    }
}
