package guikit;
 
import neuroml.model.network.*;
import neuroml.model.cell.AbstractNeuron;
import neuroml.core.*;
import neuroml.sim.*;
import neuroml.util.*;
import neuroml.*;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

//import guikit.*;
import neuroml.model.cell.CellPkg;
import guikit.ObjectNode;
import guikit.Environment;
import guikit.SpecialEditors;
import guikit.EditSetPanel;
import guikit.EditStringPanel;
import guikit.EditRefPanel;



/*
 * Subnet editor - popup an editor for a sub network
 */
public class SubnetsEditor_StandAlone extends SubnetsEditor_GuiKit {
     
     
     public SubnetsEditor_StandAlone() {
        super();
    }
     public SubnetsEditor_StandAlone(Object o) {
        super(o);
    } 
     
    public SubnetsEditor_StandAlone(Object o, NeuromlPkg NMLPack, String path, ElementChangedListener ecl) {
       super(o,path,ecl);
        this.BuildOthers(NMLPack);
    }
    
    protected JPanel BuildTop(){
        Top=new JPanel(new BorderLayout());             
        if(BuildJTP()!=null)
            Top.add(jtp,BorderLayout.CENTER );
        return Top;
    }
    
    protected JPanel BuildBottom(){
        Bottom=new JPanel(new BorderLayout());
        if(BuildMenuPanel()!=null){
            Bottom.add(menuPanel,BorderLayout.WEST);  
        }
        if(BuildNetEditPanel()!=null){
           Bottom.add(panel,BorderLayout.CENTER);   
        }
        if(menuPanel!=null&&menuPanel instanceof MenuPanel&&panel!=null&&panel instanceof NetEditPanel){
            ((MenuPanel)menuPanel).setNetPanel((NetEditPanel)panel);
            ((MenuPanel)menuPanel).organize();
            ((MenuPanel)menuPanel).rerender();
            ((NetEditPanel)panel).rerender();
            Bottom.validate();
        }
        Bottom.validate();  
        return Bottom;
    }   
    protected JPanel BuildMenuPanel(){
        super.BuildMenuPanel();
        if(menuPanel!=null){
            menuPanel.setPreferredSize(new Dimension(128,350));
            ((MenuPanel)menuPanel).organize();
            ((MenuPanel)menuPanel).rerender();
            ((MenuPanel)menuPanel).repaint();    
        }
        return menuPanel;
    }    
    public void ChangeCurrentNetwork(Network Net){
        if(n!=null){
            NetworksPanel.getParent().remove(namep);
        }
        n=Net;
        BuildNetworkName();
        if(this.MainNetPanel!=null)
            ((EditRefPanel)MainNetPanel).refresh();
        if(Net!=null) 
            NetworksPanel.getParent().add(namep,BorderLayout.NORTH);
        NetworksPanel.getParent().repaint();            
        NetworksPanel.getParent().getParent().repaint();
        jtp.validate();
        Bottom.remove(panel);
        BuildNetEditPanel();
        Bottom.add(panel,BorderLayout.CENTER);
        panel.rerender();
        Bottom.validate();
        
        Bottom.remove(menuPanel);
        BuildMenuPanel();
        Bottom.add(menuPanel,BorderLayout.WEST);
        panel.rerender();
        Bottom.validate();  
        HideSide();
        
    }
    public void DisplaySide(JPanel stuff){
        if(SidePanel!=null)
            Bottom.remove(SidePanel);
        int wdt=stuff.getPreferredSize().width;
        Rectangle rect=Bottom.getBounds();
        Bottom.setPreferredSize(new Dimension(rect.width,rect.height));
        panel.setPreferredSize(new Dimension(rect.width-wdt-menuPanel.getPreferredSize().width,rect.height)); 
        stuff.setPreferredSize(new Dimension(wdt,rect.height)); 
 
        rect=Top.getBounds();
        
        SidePanel=stuff;
        Bottom.add(SidePanel,BorderLayout.EAST);
        if(panel!=null && panel instanceof NetPanel) 
            ((NetPanel)panel).rerender();
        if(menuPanel!=null && menuPanel instanceof NetPanel) 
            ((NetPanel)menuPanel).rerender();
        Top.validate();
        Bottom.validate();
    }
      
    
    public void BuildOthers(NeuromlPkg o){
        ObjectNode on;
        Environment env=SpecialEditors.getEnvironment();
        Namespace ns=env.getNamespace();
        //Find the cell package
        int size=o.models.size(),i;
        Object obj=null;
        
      
        
        /* ADD THE MODULE PANEL*/
        SpecialEditors.put("neuroml.core.Module","guikit.ModuleEditor");
        
        on = new ObjectNode(o,"modules"); //new ObjectNode(NeuronSet);  
        String str="models."+netPkg.getName();
        on.setPath(str+".MainNetwork");
        EditSetPanel ModulePanel=new EditSetPanel(ns, on);    
        
        JPanel Second=new JPanel(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();        
        c.fill = GridBagConstraints.BOTH;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.gridy = 0;  
        c.gridx = 0;
        c.weightx = 5;
        Second.add(ModulePanel,c);
        
        /*Text document*/
        
        JPanel Descriptif=new JPanel(new GridBagLayout());
        GridBagConstraints c_desc = new GridBagConstraints();        
        c_desc.fill = GridBagConstraints.BOTH;
        on = new ObjectNode(o,"author");    
        on.setPath("",".author");
        c_desc.gridy = 0;  
        c_desc.gridx = 0;
        c_desc.weightx = 1;
        c_desc.weighty = 1;
        Descriptif.add(new EditStringPanel(on),c_desc);
        on = new ObjectNode(o,"description");    
        on.setPath("",".description");
        c_desc.gridy = 1;  
        c_desc.gridx = 0;
       
        Descriptif.add(new EditStringPanel(on),c_desc);
        c_desc.gridy = 2;  
        c_desc.gridx = 0;

        on = new ObjectNode(o,"keywords");    
        on.setPath("",".keywords");
        Descriptif.add(new EditStringPanel(on),c_desc);
        Descriptif.setBorder( BorderFactory.createTitledBorder("Reference") );
        
        c.gridy = 0;  
        c.gridx = 5;
        c.weightx = 3;
        Second.add(Descriptif,c);
        
         CellPkg cellpack;
        for(i=0;i<size&&obj==null;i++){
            obj=o.models.elementAt(i);
            if(!(obj instanceof CellPkg)) 
                obj=null;
        }
        if(obj==null){
            obj=new CellPkg("cell_pkg");
            o.models.add(obj);
            ns.addRef("models.cell_pkg", obj);
        }
        cellpack=(CellPkg)obj;
        on = new ObjectNode(cellpack,"neurons"); //new ObjectNode(NeuronSet);
        String parent=new String("models."+cellpack.getName());
        on.setPath(parent,"neurons");//parent+

       // c = new GridBagConstraints();        

        c.gridy = 0;  
        c.gridx = 8;
        c.weightx = 5;
        EditSetPanel machin=new NotifyingSet(ns, on,this);//this
            
        Second.add(machin,c);
        
        ((JTabbedPane)jtp).add("Environment",Second);
    }
     public void elementChanged(Object oldn, Object newn) {
        if(oldn instanceof AbstractNeuron&&newn instanceof AbstractNeuron){ 
            if(newn instanceof AbstractNeuron){
                //System.out.println("TARATATA!!!");
                if(n!=null)
                    ChangeCurrentNetwork(n);
            }
        }
        else 
            super.elementChanged(oldn,newn);
     }
    
}
