/*
 * TreeNodeEditor.java
 *
 * Created on 14 January 2004, 15:06
 */

package guikit;
import javax.swing.tree.*;
import neuroml.core.*;
import neuroml.util.*;
import javax.swing.*;
import java.util.*;

/**
 *
 * @author  Jean-Alain Grunchec
 * Added by JAG
 * From TreeNodeEditor at http://www.apl.jhu.edu/~hall/java/Swing-Tutorial/Swing-Tutorial-JTree.html
 */

/** Simple TreeNode that builds children on the fly.
 *  The key idea is that getChildCount is always called before
 *  any actual children are requested. So getChildCount builds
 *  the children if they don't already exist.
 *  <P>
 *  In this case, it just builds an "outline" tree. Ie
 *  if the root is current node is "x", the children are
 *  "x.0", "x.1", "x.2", and "x.3".
 * <P>
 *  1999 Marty Hall, http://www.apl.jhu.edu/~hall/java/
 */

public class TreeNodeEditor extends DefaultMutableTreeNode {
  private boolean areChildrenDefined = false;
  private int numChildren;
  private String Name;
  protected static  Namespace ns;
       
    /** Creates a new instance of TreeNodeEditor */
  public TreeNodeEditor() {
      super();
    }

  public boolean isLeaf() {
    return(false);
  }

  public int getChildCount() {
    if (!areChildrenDefined)
      defineChildNodes();
    return(super.getChildCount());
  }

  protected void defineChildNodes() {
    // You must set the flag before defining children if you
    // use "add" for the new children. Otherwise you get an infinite
    // recursive loop, since add results in a call to getChildCount.
    // However, you could use "insert" in such a case.
    areChildrenDefined = true;
   }
  public void setParameter(Object Element,String Name) {
    setUserObject(Element);
    this.Name=Name;
  }
  
  public String toString() {
        return Name;
  }
  
  public static void setNameSpace(Namespace ns)
  {
      TreeNodeEditor.ns=ns;
  }
  
  public DefaultMutableTreeNode SelectNode(Vector StackName, JTree myTree)
  {
      return null;
  }
}
