/*
 * LeakChannel.java
 *
 * Created on 24 August 2004, 13:54
 */

package Holger_modules.module.channels;
import neuroml.model.ions_channel.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class LeakChannel implements Channel {
   public double Conductance=3.0; //120 mS/cm2
    public double RestingPotential=0.0106; 
    /** Creates a new instance of LeakChannel */
    public LeakChannel() {
    }
    
    public Channel Clone() {
        LeakChannel stuff=new LeakChannel();
        stuff.Conductance=Conductance;
        stuff.RestingPotential=RestingPotential;
        return stuff;        
    }
    
    public boolean advance(double VoltageSoma, double dt) {
        return true;
    }
    
    public double getChannelCurrent(double VoltageSoma) {
        return Conductance*(VoltageSoma-RestingPotential);
    }
    
    public double get_h() {
        return -1d; //irrelevant
    }
    
    public double get_mORn() {
        return -1d; //irrelevant
    }
    
}
