package Holger_modules.module.destmethod;

import neosim.iface.*;
import neosim.kernel.*;
import neosim.implementation.*;
import java.util.Hashtable;
/** The part of a 3D Sphere projection which runs on
 * a destination entity and decides to fulfil/deny
 * connection requests.
 *
 * differences from a general dest method : use of ParamConnectionSpec instead of ConnectionSpec. It supposes tht entity has a setDstParam method. if not there will be a problem. to fix
 */
public class DestMethodTotal extends DestMethodImpl {
    //PortID destPort;
    //Time delay;
    Hashtable params;
    public DestMethodTotal( short destPort, Time delay, Hashtable params ) {//PortID destPort
	super(destPort,delay);
	    //this.destPort = destPort; 
	    //this.delay    = delay;
	this.params = params;
    }

    //public PortID getDestPort() { return destPort; }
    //public Time getDelay() { return delay; }

    /** The considerRequest method checks the source entity's details 
     * against the dest entity's details, and returns True or False
     * depending on whether or not the connection will be made. 
     * @param deste the destination entity
     * @param cr the connection request from the source entity
     * @return connection if a connection made, null otherwise.
     */
    public Connection considerRequest( Entity deste, ConnectionRequest cr ) {
	
	params.remove("ProjNeededParamPopSource");
	params.remove("ProjNeededParamPopDest");
	params.remove("ProjNeededParamOutPort");
	params.remove("ProjNeededParamInPort");
	params.remove("ProjNeededParamDelay");

	ParamConnectionSpec c = new ParamConnectionSpec( cr.getSrcEntityID(), cr.getSrcPortID(), 
							 deste.getID(), getDestPort(), getDelay().t, params);
	int cid = makeConnection(deste, c,true );//ConnectionID cid
	c.setDstParams(deste,cid);
	//	deste.setDstConnectionParams( c, c.getID(), params );

	return c;
	// else return null
    }
 
    /** 
     * This method is called by the considerRequest method to 
     * create a connection.
     * @param c the connection to make
     * @return the id of the connection
     */
    /*public final ConnectionID makeConnection( Entity deste, Connection c ) {	
	ConnectionImpl ci = new ConnectionImpl( c.getSrcEntityID(), 
						c.getSrcPortID() ,
						(EntityImpl)deste, 
						c.getDstPortID() , 
						c.getDelay() );
	
	// This method of adding connections seems clumsy...
	BasicKernel bk    = (BasicKernel) SimSystem.getKernel();
			       
	int srcproc  = bk.getEntityProcessor(c.getSrcEntityID());	
	bk.addInConnection( srcproc, ci ); 
	// c.setDstParams(deste, ci.getConnectionID());	

	return ci.getConnectionID();
    }
    */
}
