/*
 * LearningNeuronFactory.java
 *
 * Created on 19 October 2004, 17:52
 */

package Holger_modules.module.shmemneuron;
import Holger_modules.module.RealNeuron.*;
import neuroml.util.module.*;
import neuroml.sim.run.SpikeSender;
import neuroml.sim.state.PopulationState;
import neuroml.sim.run.RunnableCell;
import neuroml.model.MeasurementTool.*;
import Holger_modules.module.channels.*;
import java.awt.*;
import java.awt.geom.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class LearningNeuronFactory extends RealNeuronFactory{
    
    /** Creates a new instance of LearningNeuronFactory */
    public LearningNeuronFactory() {
        super();
    }
    public RunnableCell makeRunnableCell(PopulationState populationstate, int id,int index, SpikeSender spikesender)
    {
        return new LearningNeuron(this, populationstate, id,index, spikesender, InitialV);
    }

    public Color getColorSoma(){
        return new Color(0.9f,0.6f,0.0f);
    }     
public void DrawExtra(Graphics2D g, Object pop, double x, double y, double width, double height, String msg, boolean selected, Font f){
        double SIZE=height;
        if(SIZE>width) SIZE=width;        
        g.setStroke(new BasicStroke(4.0f));
        g.setColor(Color.PINK);
//draw 3 channels        
        g.draw(new Line2D.Double(x ,y-height*0.25,x,y-height*0.45));
        g.draw(new Line2D.Double(x-0.17*0.25*width,y-height*0.25*0.984,x-0.17*0.45*width,y-height*0.45*0.984));
        g.draw(new Line2D.Double(x+0.17*0.25*width,y-height*0.25*0.984,x+0.17*0.45*width,y-height*0.45*0.984));
//draw HH graph
        g.setColor(Color.CYAN);
        g.fill(new Rectangle2D.Double(x-16-width*0.4,y-12, 20, 24));
        g.setStroke(new java.awt.BasicStroke(1));
        g.setColor(Color.blue.darker().darker());
        g.draw(new Line2D.Double(x-16-width*0.4,y+8,x-12-width*0.4,y+8));
        g.draw(new Line2D.Double(x-12-width*0.4,y+8,x-6-width*0.4,y));
        g.draw(new Line2D.Double(x-6-width*0.4,y-10,x-6-width*0.4,y+10));
        g.draw(new Line2D.Double(x-6-width*0.4,y+10,x+2-width*0.4,y+8)); 
        
        g.draw(new Line2D.Double(x-width*0.4-16,y-12,x-width*0.4+4,y-12));
        g.draw(new Line2D.Double(x-width*0.4-16,y-12,x-width*0.4-16,y+12));
        g.draw(new Line2D.Double(x-width*0.4+4,y+12,x-width*0.4+4,y-12));
        g.draw(new Line2D.Double(x-width*0.4+4,y+12,x-width*0.4-16,y+12)); 
        
//draw synapses        
        g.setColor(Color.YELLOW.darker());
        g.fill(new Ellipse2D.Double(x+SIZE*0.5-0.05*SIZE,y-0.05*SIZE,0.1*SIZE,0.1*SIZE));        
        g.fill(new Ellipse2D.Double(x+SIZE*0.5/1.4142-0.05*SIZE,y+SIZE*0.5/1.4142-0.05*SIZE,0.1*SIZE,0.1*SIZE));        
        g.fill(new Ellipse2D.Double(x-0.05*SIZE,y+SIZE*0.5-0.05*SIZE,0.1*SIZE,0.1*SIZE));                     
   }    
   public void setFactory(MeasurementSet MeasurementList, String str) {
        super.setFactory(MeasurementList,str);
        
        ModuleMeasurement mdlmr=new ModuleMeasurement();
        MeasurementTool msTool = new LearningFactor(); 
        ((LearningFactor)msTool).IndexChannel=0;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);
        
        mdlmr=new ModuleMeasurement();
        msTool = new X_Concentration(); 
        ((X_Concentration)msTool).IndexChannel=0;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);        
        
        mdlmr=new ModuleMeasurement();
        msTool = new Y_Concentration(); 
        ((Y_Concentration)msTool).IndexChannel=0;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);  
        
        mdlmr=new ModuleMeasurement();
        msTool = new Z_Concentration(); 
        ((Z_Concentration)msTool).IndexChannel=0;
        mdlmr.module.parameters=msTool;
        MeasurementList.add(mdlmr);          
    }    
}
