/*
 * XConcentration.java
 *
 * Created on 19 October 2004, 17:21
 */

package Holger_modules.module.shmemneuron;
import neuroml.model.MeasurementTool.*;
import neuroml.model.Synapse_nml.*;
import neuroml.sim.run.*;
import neuroml.core.*;
import neuroml.util.*;
import neuroml.model.cell.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class X_Concentration extends MeasurementTool {
    
    /** Creates a new instance of XConcentration */
    public int IndexChannel=0;    
    /** Creates a new instance of LearningFactor */
    public X_Concentration() {
        super();          
    }

    public double getValue(RunnableCell obj, double t){
       SynapticCell bscc=((SynapticCell)obj);
       LearningSynapse mySynapse=(LearningSynapse)bscc.getSynapse(IndexChannel,LearningSynapse.class);
       if(mySynapse!=null)
           return mySynapse.get_X_Concentration();
       else 
           return -1e35;
    }
    public String toString(){
        String toAdd=new String();
        if(this.ToBeSent)
            toAdd=new String("");
        else
            toAdd=new String("NOT_");
            
        String str=this.getClass().getName();
        int i=str.lastIndexOf('.');
        if(i>0) 
            str=str.substring(i+1);
        return toAdd+str+"_"+IndexChannel;               
    }
    public String getXUnit(){
        return "Time(s)";
    }
    public String getYUnit(){
        return "";
    }    
    
    public Object Clone() {
        X_Concentration truc=new X_Concentration();
        truc.IndexChannel=this.IndexChannel;
        return truc;
    }   
    
}
