/*
 * MatrixConnection.java
 *
 * Created on 28 July 2004, 14:45
 */

package Holger_modules.module.sourcemethod;
import neuroml.sim.state.*;
import neuroml.sim.run.*;

import neuroml.util.module.*;

import java.util.Hashtable;
import java.awt.*;
import java.awt.geom.*;

import java.util.*;
import java.awt.image.*;
import javax.swing.*;    
/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class MatrixConnection implements SourceMethod {
    public short srcPort;
    public NeuromlArrayConnectivity connectivity=new NeuromlArrayConnectivity();

      
    
    /** Creates a new instance of MatrixConnection */
    public MatrixConnection()  {
    }
    
    public void Draw(Graphics2D g, double x, double y) {
        g.setColor(Color.WHITE);
        g.fill(new Rectangle2D.Double(x-15,  y-15, 30,30));
        g.setColor(Color.BLACK);
        g.setStroke(new BasicStroke(2.0f));
        
        g.draw(new Line2D.Double(x-15,y-15,x+15,y-15));
        g.draw(new Line2D.Double(x-15,y-5,x+15,y-5));
        g.draw(new Line2D.Double(x-15,y+5,x+15,y+5));
        g.draw(new Line2D.Double(x-15,y+15,x+15,y+15));

        
        g.draw(new Line2D.Double(x-15,y-15,x-15,y+15));
        g.draw(new Line2D.Double(x-5,y-15,x-5,y+15));
        g.draw(new Line2D.Double(x+5,y-15,x+5,y+15));
        g.draw(new Line2D.Double(x+15,y-15,x+15,y+15));
        
    }
    
    public void sendRequests(ConnectionRequestSender crs, ElementState srcState, PopulationState dstState, DestMethod dm, boolean BuildingConnection) {
        if(srcState instanceof BasicRunnableCell){
            int srcIndex=((BasicRunnableCell)srcState).getIndex();
            
        //srcState.getID()
            for (int i=0; i<dstState.getNumElements(); i++) {
                if(((Boolean)connectivity.getValue(i, srcIndex)).booleanValue()){
                    ConnectionRequest cr = new ConnectionRequest(srcState.getID(), srcPort, dm);
                    crs.sendRequest(cr, dstState.getElementID(i),BuildingConnection);	    
                }
            }
        }
    }
    
    public short getSrcId() {
         return srcPort;
    }
    
}
