package Holger_modules.module.sourcemethod;

import neosim.iface.*;
import java.util.Vector;
import java.lang.Math;
import java.util.Hashtable;
import neosim.implementation.*; 
import neosim.kernel.*; 
import neosim.util.*;
 
 
/**
 * ConnectToAll connects the cell to a all dest cells
 * @version 2 : fwh fixed a number of bugs Nov 2000
 * @version 3 : fwh changed pop specs to strings
 */
class SourceMethodTotal extends SourceMethodImpl {
    
    /**
     * ConnectToAll
     * @param srcPort outpout port of the source cell
     *
     */
    SourceMethodTotal(short srcPort) { //PortID
	super( srcPort );	
    }    
	    
    /**
     * sendRequests to the dest cells
     */
    public void sendRequests( Entity srce, Population dPop, DestMethod dm, boolean BuildingConnection ) {   
	int destIndex;	
	for (destIndex=0;destIndex<dPop.getNumEnts();destIndex++) {
	    sendRequest( srce, dPop.getEntityID(destIndex),
			 new ConnectionRequestImpl( srce.getID(), srcPort, dm ),BuildingConnection );
	}
    }
}


/** A general projection defines a set of connections between
 * two populations. The projection is specified with a 
 * SourceMethod, which runs on each member of the source
 * population and issues connection requests to the 
 * destination population.  The destination method decides
 * to fulfill/deny these requests.
 */
/*
class ProjToAllImpl extends GeneralProjectionImpl {

    public ProjToAllImpl( String srcPop, PortID outPort, String destPop, PortID inPort, 
			  Time delay, Hashtable extraparams) {
	super(srcPop, destPop, new ConnectToAll(outPort), new ProjDestMethod(inPort,delay,extraparams));	
    }
}*/
 /**
  * ProjToAll is a class used to get and init the ProjToAllImpl class from a jar file
  * the main aim is to pass the hashtable of parameters to the constructor method of the ProjToAllImpl class
  *   
  */
/*
public class ProjToAll implements ProjectionJar{
    ProjToAllImpl projection;
    
    public ProjToAll(){}

 

     // init the ProjToAllImpl class

    public void init(String name, String srcPop, PortID outPort, 
		     String destPop, PortID inPort, 
		     Time delay, Hashtable params) {
	projection = new ProjToAllImpl(srcPop, outPort, destPop, inPort, delay,params);
    }

    public ProjectionImpl getProjection(){
	return projection;
    }
 
}
*/