package neosim.iface;

import java.util.Vector;


/** Interface for sorted event lists
 */
public interface EventList extends java.io.Serializable {
    /** Return the vector of events */
    public Vector getEvents();

    /** Remove and return the event at the top of the queue.
     * @return           The next event.
     */
    public Event pop();

    /**
     * Return the event at the top of the queue, without removing it.
     * @return    The next event.
     */
    public Event top();

    /**
     * Add a new event to the queue, preserving the temporal order of the
     * events in the queue.
     * @param new_event   The event to be put on the queue.
     */
    public void add(Event new_event);

    /**
     * Removes all events from the list
     */
    public void clear();


    /**
     * Returns true if there are any more events in the list
     * @return true if any more events
     */
    public boolean hasMoreElements();

}
