package neosim.iface;

/** An object event.
 */
public class ObjectEvent extends Event {

    Object payload = null;

    public ObjectEvent( Time t ) { super(t); }
    public ObjectEvent( Time t, Object o ) { super(t); payload = o; }
    public ObjectEvent( Time t, Object o, boolean IsDelayed ){
        super(t); payload=o; this.DelayedEvent=IsDelayed;
    }
    public ObjectEvent( Time t, int iType, Object o ) { super(t); this.iType = iType; payload=o; }
    public ObjectEvent( Time t, int srce, short srcport ) {  super(t,srce,srcport); }//Time t, EntityID srce, PortID srcport 
    public ObjectEvent( Time t, int srce, short srcport, int iType, Object o ) {  //Time t, EntityID srce, PortID srcport 
	super(t,srce,srcport,iType); payload=o; 
    }

    public final ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("ObjectEvent", "Event", "neosim.kernel"); return cid;     
    }
    public final Object clone() { 
	ObjectEvent e = new ObjectEvent( t, srce, srcport,iType, payload); 
	e.cid = cid; 
	return e; 
    } 
    public final Object getObject() { return payload; }

    /** Test of new event delivery mechanism 
     * Derived types try to cast recipient to appropriate target,
     * e.g. (ObjectHandler)e.handle(dt,this,i)
     */
    public final void deliverToEntity( Time dt, Entity e, Input i ) {
	try {
	    // System.out.println("Trying to deliver spike event to entity "+e);	    
	    ((ObjectHandler)e).handle(dt,this,i);
	} catch (Exception ex) { 
	    System.out.println("Failed to deliver a spike to entity "+e);
	}
    }
    
    public ObjectEvent(){
        srce=-1;//new EntityID(-1);
        t=new Time();
        srcport=-1;//new PortID
        cid=new ClassID(-1);
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
       // System.out.println(this.getClass().getName()+"In ObjectEvent: readObject  ");
        srce=objectInput.readInt();
        t.t=objectInput.readLong();
        srcport=objectInput.readShort();
        cid.id=objectInput.readInt();
        iType=objectInput.readInt();
        c=(Connection)objectInput.readObject();
        payload=objectInput.readObject();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(srce);
        objectOutput.writeLong(t.t);
        objectOutput.writeShort(srcport);
        objectOutput.writeInt(cid.id);
        objectOutput.writeInt(iType);
        objectOutput.writeObject(c);
        objectOutput.writeObject(payload);
    }
    
    public int getSize(){
        return 500;// object can be small but can be really big too
    }     
}
