package neosim.iface;

//import neuroml.sim.state.*;
import java.util.Vector;

/**  A population is a collection of one or more entity handles.
 * It can contain extra methods for initialising the elements of
 * the population, or for indexing them rapidly.
 */
public interface Population extends PopulationNode {
  
    /** Returns unique population id */
    int getID();

    /** Sets unique population id */
    void setID(int i);

    /** Returns number of entities */
    int getNumEnts();

    /** Returns index of a given entity ID
     * @param eid handle of entity
     * @return index of entity in population if present, or -1 otherwise.
     */
    int getIndex( int eid );//EntityID eid


    /** Returns entityID of a given index
     * @param index index in population
     * @return entityID of given index
     */
    int getEntityID( int index );//EntityID reutrn
    
    /** Returns whether a given entity is a member
     * @param eid handle of entity
     * @return true if entity is a member of this population
     */
    boolean isMember( int eid );////EntityID eid

    /** Returns a list of all members */
    Vector getMemberList();

    /** Add a member to this population
     * @param eid handle of entity
     */
    void addMember( int eid );//EntityID


}
