package neosim.implementation;
import neosim.iface.*;

/**  A connection links a source entity/port to a destination entity/port,
 * and has a delay. It is possible to check the connection details for events 
 * arriving on a port to get the delay, and source entity/port.
 * ConnectionIDs are assigned when the addInConnection() method of the
 * destination entity is called.
 */
public final class ConnectionImpl implements Connection, java.io.Externalizable  {
    /*EntityID srce;
    PortID srcport, destport;
    Time delay;    
    ConnectionID cid;
    transient EntityImpl destent;




    public ConnectionImpl( EntityID srce, PortID srcport, EntityImpl destent, PortID destport, Time delay ){
	this.srce = srce; this.srcport = srcport; this.destent = destent; this.destport = destport;
	this.delay = delay;
    }

    public final EntityID     getDstEntityID() { return destent.getID(); }
    public final PortID       getDstPortID() { return destport; }
    public final Time         getDelay() { return delay; }
    public final EntityID     getSrcEntityID() { return srce; }
    public final PortID       getSrcPortID() { return srcport; }
    public final ConnectionID getConnectionID() { return cid; }

    public final void sendEvent( Event e ) {
	//	System.out.println("Sending event to "+destent.getName()+" connection "+cid.id);
	Event newe = (Event)e.clone();
	Time arrivalTime = new Time(); 
	arrivalTime.t =  e.getTime().t + delay.t;
	newe.setTime( arrivalTime );
	newe.setConnection(this);
	destent.postEvent(newe);
    }

    public final void setConnectionID(ConnectionID cid ) { this.cid = cid; }
    public final void setDest(EntityImpl destent){
        this.destent = destent;
    }
    
    public ConnectionImpl(){
        srce=new EntityID(-1);
        delay=new Time();
        srcport=new PortID(-1);
        destport=new PortID(-1);
        cid=new ConnectionID(-1);
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        srce.id=objectInput.readInt();
        delay.t=objectInput.readLong();
        srcport.id=objectInput.readInt();
        destport.id=objectInput.readInt();
        cid.id=objectInput.readInt();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(srce.id);
        objectOutput.writeLong(delay.t);
        objectOutput.writeInt(srcport.id);
        objectOutput.writeInt(destport.id);
        objectOutput.writeInt(cid.id);
    }     */
    byte[] data;//srcpid.id //destpid.id //srce.id //delay.t 
    int destcid;    
    transient EntityImpl destent;
  
    
    
    void setData(int srce, short srcpid, short destpid, long delay){
        int i=0;
        byte[] array=new byte[30];
        
        //srcpid
        while ((srcpid & ~0x7F) != 0) {
	    array[i++] = (byte)((srcpid & 0x7f) | 0x80);
	    srcpid >>>= 7;
	}
	array[i++] =(byte)srcpid;  
        //destpid
        while ((destpid & ~0x7F) != 0) {
	    array[i++] = (byte)((destpid & 0x7f) | 0x80);
	    destpid >>>= 7;
	}
	array[i++] =(byte)destpid;          

        //srce
        while ((srce & ~0x7F) != 0) {
	    array[i++] = (byte)((srce & 0x7f) | 0x80);
	    srce >>>= 7;
	}
	array[i++] =(byte)srce;               
        //delay
        while ((delay & ~0x7F) != 0) {
	    array[i++] = (byte)((delay & 0x7f) | 0x80);
	    delay >>>= 7;
	}
	array[i++] =(byte)delay; 
        data=new byte[i];
        for(i=0;i<data.length;i++)
            data[i]=array[i];        
    }
    public final short       getSrcPortID() { 
        byte i=-1,shift;
        int temp;
        
	//srce.id
	temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	} 
        return (short)temp;
    } 
    public final short       getDstPortID() { 
        byte i=-1,shift;
        int temp;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        return (short)temp; 
    }
    public final int     getSrcEntityID() { 
        byte i=-1,shift;
        int temp;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        return temp; 
    }
    public final int     getDstEntityID() { 
          return destent.getID();
    }   
    public final long         getDelay() { 
        byte i=-1,shift;
        int temp;
        long temp2;
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp |= (data[++i] & 0x7F) << shift;
	}        
        temp2 = data[++i] & 0x7F;
	for (shift = 7; (data[i] & 0x80) != 0; shift += 7) {
	    temp2 |= (data[++i] & 0x7F) << shift;
	}        
        return temp2;          
    }    
    public final int getConnectionID() { return destcid; }    
     public final void sendEvent( Event e ) {
	//	System.out.println("Sending event to "+destent.getName()+" connection "+cid.id);
	Event newe = (Event)e.clone();
	Time arrivalTime = new Time(); 
	arrivalTime.t =  e.getTime().t + getDelay();
	newe.setTime( arrivalTime );
	newe.setConnection(this);
	destent.postEvent(newe);
    }

    public final void setConnectionID(int cid ) { destcid = cid; }
    public final void setDest(EntityImpl destent){
        this.destent = destent;
    }
    
    public ConnectionImpl(){
       
    }   
    public ConnectionImpl( int srce, short srcport, EntityImpl destent, short destport, long delay ){
        this.destent = destent;
        setData(srce,srcport,destport,delay);
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        data=new byte[objectInput.readByte()];
        objectInput.read(data);
        destcid=objectInput.readInt();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeByte(data.length);
        objectOutput.write(data);
        objectOutput.writeInt(destcid);
    }    
    public final void addSpike(long time) {
        destent.addSpike(destcid,time+getDelay());
    }
}
