

package neosim.implementation;

import neosim.iface.*;

/** A connection request is the message which a source entity sends to a dest entity
 * it wants to connect to. By default it contains the source entity
 * ID and port no, as well as the DestMethod.
 */
public class ConnectionRequestImpl implements ConnectionRequest, java.io.Externalizable {
    int srce;//EntityID srce
    short srcp;//PortID
    DestMethod dm;
    int srceindex;
    boolean BuildingConnection;

    public ConnectionRequestImpl(){
        srce=-1;//new EntityID(-1);
        srcp=-1;//new PortID(-1);
    }
    

    public  ConnectionRequestImpl( int srce, short srcp, DestMethod dm ) {//EntityID srce// PortID srcp
	this.srce = srce;
	this.srcp = srcp;
	this.dm   = dm;
       
    }
    public  ConnectionRequestImpl( int srceindex, int srce, short srcp, DestMethod dm) {//EntityID srce//PortID srcp
	this.srce = srce;
	this.srcp = srcp;
	this.dm   = dm;
	this.srceindex   = srceindex;

    }
    /** Return the entity originating this request */
    public final int     getSrcEntityID() { return srce; }//EntityID return
    /** Return the entity index in its population, originating this request */
    public final int          getSrcEntityIndex() { return srceindex; }

    /** Return the output port of the entity to connect from */
    public final  short      getSrcPortID() { return srcp; }//PortID

    /** Return the method to run at the dest entity */
    public final DestMethod   getDestMethod() { return dm; }
    
    public final void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException { 
        srce=objectInput.readInt();
        srcp=objectInput.readShort();
        srceindex=objectInput.readInt();
        BuildingConnection=objectInput.readBoolean();
        dm=(DestMethod)objectInput.readObject();
    }
    
    public final void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(srce);
        objectOutput.writeShort(srcp);
        objectOutput.writeInt(srceindex);
        objectOutput.writeBoolean(BuildingConnection);
        objectOutput.writeObject(dm);
    }    
}
