
package neosim.implementation;
import neosim.iface.*;
import neosim.kernel.*;
import java.util.Vector;
import java.util.Hashtable;

/** A neosim entity with a 3D position
 */
public class Entity3D extends EntityImpl {
    double x,y,z;

    Shape s;

    /** Make an entity of population p, class ec
     * @param ec the entity class
     * @param p the population
     * @param index the index within the population
     */
    public Entity3D( EntityClass ec, Population p, int index ) { 
	super( ec,p,index );
	x = 0.0; y = 0.0; z = 0.0;
    }

    /** Set the Shape of this entity
     * @param s the shape object
     */
    public final void setShape( Shape s ) { this.s = s; }

    /** Return the Shape of this entity
     * @returns the Shape of this entity
     */
    public final Shape getShape() { return s; }

    public final void setPos(double x, double y, double z) {
	this.x = x; this.y = y; this.z = z;
    }
    public final double getXPos() { return x; }
    public final double getYPos() { return y; }
    public final double getZPos() { return z; }
    public final Pos getPos() { return new Pos( x,y,z ); }
}

