package neosim.implementation;
import java.util.*;

import neosim.iface.*;

/** This class should be extended for user entity
 * class definitions, by providing a makeEntity
 * method.
 */
public class EntityClassImpl extends NeosimClassImpl implements EntityClass {

    Vector outPorts = new Vector();
    Vector inPorts  = new Vector();

    Hashtable inPortNames = new Hashtable();
    Hashtable outPortNames = new Hashtable();

    static boolean debug = false;

    public EntityClassImpl( String name ) { 
	super(null, name,"neosim.kernel", ClassID.ENTITY_CLASS);
    }

    public EntityClassImpl(   ) { 
	super(null, "noname","neosim.kernel", ClassID.ENTITY_CLASS);
    }

    /** Initialise from a bean 
     * @deprecated - use hashtable args instead
     */
    public void init(  String name, String args ) {
	this.name = name;
	//        System.out.println("Entity Class init "+name+" "+args);
    }

    /** Initialise from a bean */
    public void init(  String name, Hashtable args ) {
	this.name = name;
	//        System.out.println("Entity Class init "+name+" "+args);
    }

    public Entity makeEntity(Population p, int index) {	
	return new EntityImpl( this, p, index );
    }

    public final short  addOutPort(EventClass ec) {//PortID
	return addOutPort(ec,"");
    }
    public final short  addOutPort(EventClass ec, String name) {//PortID
	outPorts.addElement(ec);
	short ret =  (short)outPorts.size();	//PortID

	// If no name given, use "out1", "out2" etc
	String newname;
	if (name.length() == 0) { newname = "out"+ret; } else {newname=new String(name);}
	outPortNames.put( newname, ret );
	if (debug) System.out.println(getName()+"  adding output port "+newname);

	return ret;
    }

    public final short  addInPort(EventClass ec) {//PortID
	return addInPort(ec,"");
    }
    public final short  addInPort (EventClass ec, String name) {//PortID
	inPorts.addElement(ec);
	short ret = (short) inPorts.size();	//PortID


	// If no name given, use "in1", "in2" etc
	String newname;
	if (name.length() == 0) { newname = "in"+ret; } else {newname=new String(name);}
	inPortNames.put( newname, ret );
	if (debug) System.out.println(getName()+"  adding input port "+newname);

	return ret;
    }

    public final short getOutPort( String name ) {//PortID
	Short ret = (Short)outPortNames.get(name);//PortID
	if (ret==null) { 
	    ret = new Short((short)1);//new PortID(
	    System.out.println(getName()+" warning = output port "+name+" not found");
	}
	System.out.println(getName()+" returning output port "+ret.intValue());
	return (short)ret.intValue();
    }

    public final short getInPort( String name ) {//PortID
	Short ret = (Short)inPortNames.get(name);//PortID
	if (ret==null) {
	    System.out.println(getName()+"  didn't find input port "+name);
	    ret = new Short((short)1);//new PortID(
	} else {
	    System.out.println(getName()+" returning input port "+ret.intValue());
	}
	return (short)ret.intValue();
    }

    public final Vector getOutPorts() { return outPorts; }
    public final Vector getInPorts() { return inPorts; }
    
    public void initModule( ScriptReader sr ) {
    }
    
    public boolean IsInParent() {
        return false;
    }
    
}

