/*
 * GUI_Maker_Population.java
 *
 * Created on 01 June 2004, 17:03
 */

package neosim.implementation;
import neosim.iface.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import neosim.neuroml.*;
import neuroml.sim.run.*;
import neuroml.sim.state.*;
import neuroml.util.module.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class GUI_Maker_Population extends GUI_Maker implements javax.swing.event.ChangeListener {
    // Variables declaration - do not modify
    private javax.swing.JLabel jLabelCell;
    private javax.swing.JPanel jPanelCells;
    private javax.swing.JPanel jPanelMain;
    private javax.swing.JSpinner jSpinnerCell;
    PopulationBuilderImpl myPopToDisplay=null;
    // End of variables declaration    
    /** Creates a new instance of GUI_Maker_Population */
     public GUI_Maker_Population(Simulator sim,String str) {
        super(sim);
        if(myPopTree==null) return;
        myPopToDisplay=getPopulation(str);
        if(myPopToDisplay==null) return;
        
        java.awt.GridBagConstraints gridBagConstraints;

        jPanelMain = new javax.swing.JPanel();
        jPanelCells = new javax.swing.JPanel();
        jLabelCell = new javax.swing.JLabel();
        jSpinnerCell = new javax.swing.JSpinner();
        jSpinnerCell.setModel(new SpinnerNumberModel(new Integer(0),new Integer(0),new Integer(myPopToDisplay.size-1),new Integer(1)));
        
        jSpinnerCell.getModel().addChangeListener(this);
        
        setLayout(new java.awt.BorderLayout());

        setBorder(new javax.swing.border.TitledBorder(null, str, javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 12)));
        add(jPanelMain, java.awt.BorderLayout.CENTER);

        jPanelCells.setLayout(new java.awt.GridBagLayout());

        jLabelCell.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelCell.setLabelFor(jSpinnerCell);
        jLabelCell.setText("Cell Index");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanelCells.add(jLabelCell, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 3.0;
        jPanelCells.add(jSpinnerCell, gridBagConstraints);

        add(jPanelCells, java.awt.BorderLayout.SOUTH);
        ValueChanged(0);
        last=this;
    }
    
    protected final void ValueChanged(int value){
        EntityImpl main=(EntityImpl)neosim.kernel.SimSystem.getEntity(1);//first non system entity //this.kernel.getLocalEntity(1);
        System.out.println(main.getName());
        CallBackGUIMaker.pop = this;
        main.queryEntity(main.getLocalTime(),myPopToDisplay.getEntityID(value), new GetDesc(), new CallBackGUIMaker());//new NullCallBack(main.getID().id));
        
        /*NeosimEntityImpl myEntity=(NeosimEntityImpl)(myPopToDisplay.locals.elementAt(value));
        RunnableCell myCell= (RunnableCell)myEntity.getRunnableCell().getState();
        if(myCell instanceof BasicRunnableCell){
            JPanel returnedPanel=(JPanel)((BasicRunnableCell)myCell).query(new DrawQuery());
            this.remove(jPanelMain);
            jPanelMain=returnedPanel;
            this.add(jPanelMain,BorderLayout.CENTER);
            this.validate();
        }*/
    }
     
    public final void stateChanged(javax.swing.event.ChangeEvent e) {
        int value=((SpinnerNumberModel)(jSpinnerCell.getModel())).getNumber().intValue();
        ValueChanged(value);
    }
    
    public final void Close() {
        if(jPanelMain instanceof PlusMinusPanel)
            ((PlusMinusPanel)jPanelMain).Close();
    }
    
    public final void Expand() {
        if(jPanelMain instanceof PlusMinusPanel)
            ((PlusMinusPanel)jPanelMain).Expand();
    }
    
    public final void Open() {
        if(jPanelMain instanceof PlusMinusPanel)
            ((PlusMinusPanel)jPanelMain).Open();
    }
    
    public final void Reduce() {
        if(jPanelMain instanceof PlusMinusPanel)
            ((PlusMinusPanel)jPanelMain).Reduce();    
    }
    
    public final void Refresh() {
        if(jPanelMain instanceof PlusMinusPanel){
            ((PlusMinusPanel)jPanelMain).Refresh();            
        }
        int value=((SpinnerNumberModel)(jSpinnerCell.getModel())).getNumber().intValue();
        ValueChanged(value);    
    }
    
    public final void setPanel_(JPanel returnedPanel){
        this.remove(jPanelMain);
        jPanelMain=returnedPanel;
        this.add(jPanelMain,BorderLayout.CENTER);
        this.validate();
    }
    
}
/*
class NullCallBack implements Callback {    
    int id;
    public NullCallBack(int id){
        this.id=id;
    }
    public void callback(Entity e, Object o) {
        e.queryEntity(e.getLocalTime(), new EntityID(id), new GetDescServer((JPanel)o),new CallBackGUIMaker());
    }   
}

class GetDescServer extends EntityQuery {    
    JPanel panel;
    public GetDescServer(JPanel panel){
        this.panel=panel;
    }
    public Object query( Entity e ) {
        return panel;
    }
}*/

class CallBackGUIMaker implements Callback {
   public static GUI_Maker_Population pop;
   public CallBackGUIMaker(){
       
   }
    
    public final void callback( Entity e, Object o ) {
	try {
	    System.out.println(e.getName()+" CallBackGUIMaker Callback called ");
	    pop.setPanel_((JPanel)o);
	} catch ( ClassCastException ex) { 
	    System.out.println("CallBackGUIMaker - exception "+ex);
	}
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException { 
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
    }      
}
 
/** Get entity position...
 */
class GetDesc extends EntityQuery {
    public final Object query( Entity e ) {
	try {
            JPanel stuff=new JPanel();
            NeosimEntityImpl myEntity=(NeosimEntityImpl)e;
            RunnableCell myCell= (RunnableCell)myEntity.getRunnableCell().getState();
            JPanel returnedPanel=(JPanel)((BasicRunnableCell)myCell).query(new DrawQuery());            
	    return returnedPanel;
	} catch (ClassCastException ex) { 
	    System.out.println("GetPos: Not an entity3D but a "+e.getClass().getName() + " name: "+e.getName()+" id: "+e.getID() ); 
	}
	return new JPanel();
    }
}
