package neosim.implementation;
import neosim.iface.*;
import java.util.Vector;

/** A projection stores a specification of a set
 *    of connections from one population onto another,
 * and can be specified as an array of connections
 * to make from output ports of source entities
 * to input ports of destination entities.
 * If the connections to make depend on the
 * state of the source and/or destination entities,
 * a GeneralProjection should be used instead. 
 */
public class ProjectionImpl implements Projection {
    Vector connections;
    public ProjectionImpl() {
	connections = new Vector();
    }
    public ProjectionImpl( Connection c ) {
	connections = new Vector();
	connections.addElement(c);
    }
    public ProjectionImpl( Vector connections ) {
	this.connections = connections;
    }
    public final Vector getConnections() { return connections; }
    public boolean isGeneralProjection() { return false; }


}
