
package neosim.implementation;
import neuroml.sim.state.*;
/** An object shape - usable by visualisation tools,
 * included as a field in Entity3D, 
 * maybe should be included in a future EntityCLass3D?
 * This is an experimental version.
 * @author Fred Howell
 * @date Nov 2000
 */

public class Shape implements java.io.Serializable, neuroml.sim.state.Shape {
    String colour;
    String shapeName;
    double scale;

    /** Make a shape - colour = "red", "blue" etc
     * shapeName="cube", "sphere", "http://www.neosim.org/golgi.xml"
     * scale = diameter in microns
     */
    public Shape( String colour, String shapeName, double scale) { 
	this.colour = colour; 
	this.shapeName = shapeName;
	this.scale = scale;
    }

    /** Set the colour of this shape
     * @param s the shape object
     */
    public final void setColour( String s ) { this.colour = s; }

    /** Set the "name" of this shape, "cube", "sphere" etc
     * @param s the shape object name
     */
    public final void setShapeName( String s ) { this.shapeName  = s; }

    /** Set the scale
     * @param s diameter in microns
     */
    public final void setScale( double s ) { this.scale = s; }
    public final String getColour() { return colour; }
    public final String getShapeName() { return shapeName; }
    public final double getScale() { return scale; }
    
    public final void draw() {
    }
    
}

