package neosim.kernel;

import neosim.iface.*;
import neosim.implementation.*;
import java.util.Vector;

/** Class which collects responses from ConnectionQueryEvents
 * and delivers them as one event back to the originating entity.
 * @see CallbackHandler, PopulationCallbackHandler
 */
public class ConnectionCallbackHandler extends CallbackHandler {
 
    int popsz;

    public ConnectionCallbackHandler( int qid, int proc, Time t, int popsz,
				      BasicKernel bk, 
				      int srce, short srcp, Callback c ) {//EntityID srce, PortID srcp,
	super(  qid,  proc,   t,  bk,    srce,  srcp,   c );
	this.popsz = popsz;
    }

    /** Just wait for answers, then post them as an event to the originating entity */
    public final void run() { 
	//	System.out.println("ConnectionCallbackHandler started up");
	Vector retv = new Vector();

	for (int i=0; i<popsz; i++) {	    
	    //	    System.out.println("ConnectionCallbackHandler got response "+i);
	    retv.addElement( bk.waitForAnswer(qid, proc) );
	}

	//	System.out.println("ConnectionCallbackHandler got answers, sending callback event to entity");
	bk.eventRmt(proc, EntityID.SYSTEM_ENTITY, PortID.SYSTEM_PORT, srce, srcp, 
		    new EntityCallbackEvent(t, EntityID.SYSTEM_ENTITY, PortID.SYSTEM_PORT, c, retv )
		    );
	bk.callbackDone(qid);
	//	System.out.println("ConnectionCallbackHandler done");
    }
}
