package neosim.kernel;
import neosim.iface.*;

/** The event which executes an EntityUpdate
 */
public class EntityUpdateEvent extends EntityEvent {
    static boolean debug=false;
    EntityUpdate eu;
    Callback cb;
    public EntityUpdateEvent(Time t, int srce, short srcport, EntityUpdate eu, Callback cb ) { //Time t, EntityID srce, PortID srcport,
	super( t, srce, srcport );
	this.eu = eu; 
	this.cb = cb;
    }
    public final void doOnEntity( Entity e ) {
	eu.update(e);
	if (debug) { System.out.println("Entity Update Event done update, sending callback"); }
	e.sendEvent( getSrcEntityID(), PortID.SYSTEM_PORT, 
		     new EntityCallbackEvent( getTime(), 
					      e.getID(), PortID.SYSTEM_PORT, cb, new Integer(42) ) );  
	if (debug) { 
	    System.out.println("Entity Update Event sent callback"); 
	    System.out.flush();
	}

    }
    public final ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("EntityUpdateEvent", "EntityEvent", "neosim.kernel"); 
	return cid;
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        super.readExternal(objectInput);
        eu=(EntityUpdate)objectInput.readObject();
        cb=(Callback)objectInput.readObject();
    }
    
    public EntityUpdateEvent(){
        super();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        super.writeExternal(objectOutput);
        objectOutput.writeObject(eu);
        objectOutput.writeObject(cb);
    }      
    
    public int getSize(){
        return 100;
    }    
}
