package neosim.kernel;
import neosim.iface.*;

/** A special kind of PopulationQuery which doesn't require a response.
 * Executes an EntityUpdate on all members of a population
 */
public class PopulationUpdateEvent extends PopulationQueryEvent {
    EntityUpdate eu;
 
    public PopulationUpdateEvent(Time t, int srce, short srcport, Population p, EntityUpdate eu, Callback cb ) { //Time t, EntityID srce, PortID srcport, 
	super( t, srce, srcport, p, null, cb );
	this.eu = eu; 
    }

    public final void doOnEntity( Entity e ) {
	eu.update(e);
	int idx = e.getPopulation().getIndex( e.getID() );
	PopCBObject pco = new PopCBObject(new Integer(0), idx );
	sendCallback( pco ); 
    }

    public final ClassID registerClass(NeosimClasses nc) { 
	cid = nc.registerClass("PopulationUpdateEvent", "EntityEvent", "neosim.kernel"); 
	return cid;
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        super.readExternal(objectInput);
        eu=(EntityUpdate)objectInput.readObject();
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        super.writeExternal(objectOutput);
        objectOutput.writeObject(eu);
    }      
    
    public int getSize(){
        return 80;// object can be small but can be really big too
    }     
}
