package neosim.kernel;


/** Send results of query
 */
public class QueryResponse extends CommandObj implements java.io.Externalizable { 
  
  Object res;
  int qid;
   static boolean debug = false;
   public  QueryResponse(){
         super(-1);
     }
   
  public QueryResponse(int id, int qid, Object res) {  
      super(id); 
      this.res = res;
      this.qid = qid;
  }
  public String getType() { return "Query Response"; }
  public void doit(SimKernel sp) {  
      //   System.out.println("Query response: sk="+sp);
      try {
          if(res!=null)
              res=res;
	  sp.qresponseRmt(id,qid,res);
      } catch (Exception e ) {
	  if (debug) {
	      System.err.println(e);
	      e.printStackTrace();
	  }
      }
  }
 
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        id=objectInput.readInt();
        qid=objectInput.readInt();
        
        byte silly=objectInput.readByte();
        blocking=((silly&0x01)!=0);
        if((silly&0x2)!=0){         
            
        }
        else if((silly&0x4)!=0){
            int truc=objectInput.readInt();
            res=new Integer(truc);            
        }
        else if((silly&0x8)!=0){
            neosim.iface.Time res=new neosim.iface.Time();
            res.t=objectInput.readLong();
            this.res=res;
        }  
        else{
           res=objectInput.readObject();
        }    
    }
    
  
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeInt(id);
        objectOutput.writeInt(qid);

        byte silly=0;
        if(blocking)
            silly|=0x01;
        if(res==null){
            silly|=0x02;
            objectOutput.write(silly);  
        }
        else if(res.getClass()==Integer.class){
            silly|=0x04;
            objectOutput.writeByte(silly);  
            objectOutput.writeInt(((Integer)res).intValue());
        }
        else if(res.getClass() == neosim.iface.Time.class){//don't go through the instanceof
            silly|=0x08;
            objectOutput.writeByte(silly);  
            objectOutput.writeLong(((neosim.iface.Time)res).t);
        }
        else{
            objectOutput.writeByte(silly);  
            objectOutput.writeObject(res);
        }
    }  
    
    public int getSize(){
        return 100;
    }      
}
