package neosim.kernel;

import neosim.iface.Time;

/** Start a simulation 
 */
public class RunCommand extends QueryCommand {
    Time t;
    boolean debug = false;
    public RunCommand(int id,  Time t) { 
	super(id);	
	this.t = t;
	setBlocking(true);
    }
    public final String getType() { return "Run Command"; }
    public final void doit(SimKernel sk, Collective comms)  throws ResetException { 
	if (debug)	System.out.println("Runcommand: running\n");
	sk.runRmt(sk.getID(),t);
	if (debug)	System.out.println("Runcommand: finished running\n");
        //JAG DANGEROUS OPTIMIZATION 
	//if (needResponse()) sk.sendCommand(id, new QueryResponse(sk.getID(), qid, new Integer(0)));
        if (needResponse()) sk.sendCommand(id, new QueryResponseInteger(sk.getID(), qid, new Integer(0)));
    }
    public final String toString() { return getType()+" to "+t; }
}
