/* SimOutput.java
 */

package neosim.kernel;

/**
 * This defines the interface that a trace output class must provide.
 * @see         SimSystem
 * @version     1.0, 4 September 1996
 * @author      Ross McNab
 */

public interface SimOutput {
  /** Called by the SimSystem before the start of the simulation. */
  public void initialise();
  /** Called by the SimSystem to output a trace line.
   * @param msg The trace message
   */
  public void println(String msg);
  /** Called by the SimSystem at the end of the simulation. */
  public void close();
  public void flush();
}
