package neosim.neuroml;

import neosim.util.*;
import neuroml.sim.state.*;
import neosim.iface.*;

import java.util.Vector;

/** A Neosim representation of a NeuroML connection request.
 */
public final class NeosimConnectionRequest implements neosim.iface.ConnectionRequest {
  
    neuroml.sim.run.ConnectionRequest cr;

    public NeosimConnectionRequest( neuroml.sim.run.ConnectionRequest c ) { 	cr = c;    }
    
    /** Return the entity originating this request */
    public int     getSrcEntityID() { return cr.getSrcID(); }
//public EntityID     getSrcEntityID() { return new EntityID(cr.getSrcID()); }
    /** Return the entity index originating this request 
     * @deprecated
     */
    public int     getSrcEntityIndex() { 
	//	return cr.sourceIndex; 
	System.out.println("Error: NeosimConnectionRequest.getSrcEntityIndex called");
	return 0; 
    }
	
    /** Return the output port of the entity to connect from */
    public short       getSrcPortID() { return cr.getSrcPortID(); }//PortID //new PortID
    
    /** Return the method to run at the dest entity */
    public neosim.iface.DestMethod   getDestMethod() { return new NeosimDestMethodImpl(cr.getDestMethod()); }   

    /** Return the neuroml connection request
     */
    public neuroml.sim.run.ConnectionRequest getNeuromlConnectionRequest() { return cr; }
}

