package neosim.neuroml;

import neosim.implementation.*;
import neosim.iface.*;
import java.util.Vector;
import java.util.Hashtable;
import neuroml.sim.run.*;
import neuroml.sim.state.*;

/**
 * Neosim version of NeuroML DestMethod.
 * @author Paul Rogister
 * @date Aug 2001
 */
public final class NeosimDestMethodImpl extends DestMethodImpl {

    neuroml.sim.run.DestMethod dm;
   // static public int nbconns=0;
    static boolean debug = false;
   
    public NeosimDestMethodImpl(neuroml.sim.run.DestMethod dm) {
	this.dm = dm;
    }

    /** Return the actual dest method.
     */
    public neuroml.sim.run.DestMethod getNeuromlDestMethod() { return dm; }
    
    /** Neosim consider request... pass through to 
     * Neuroml version
     */
    public Connection considerRequest( Entity deste, neosim.iface.ConnectionRequest cr, boolean BuildingConnection) {
	ElementState cState = null;

	if (debug) System.out.println("NeosimDestMethodImpl considerRequest called");

	if (deste instanceof NeosimEntityImpl) {
	    NeosimEntityImpl ndeste = (NeosimEntityImpl)deste;
	    cState = ndeste.getRunnableCell().getState();
	} else {
	    System.out.println("NeosimDestMethodImpl considerRequest error : "+
			       "deste not a NeosimEntityImpl");
	}
	
	// Make neuroml version of neosim connection request...
	NeuromlConnectionRequest ncr = new NeuromlConnectionRequest(cr);

	// NeuromlCellState cState = new NeuromlCellState(deste);
	NeuromlConnectionMaker cMaker = new NeuromlConnectionMaker(deste, ncr, dm);
	//nbconns++;	
	// Call actual considerRequest method...
	boolean made = dm.considerRequest( cMaker, cState, ncr, BuildingConnection );

	NeosimConnectionImpl nci = null;

	// Tell origin that it should make its end of the connection
	if (made) {
	    nci = new NeosimConnectionImpl(ncr.getSrcID(), ncr.getSrcPortID(),deste.getID(),dm.getDstPortID(),-1,new Time(cMaker.getDelay()).t);
	}
	return nci;
    }
    
    /** @deprecated
     */
    public void init(String name, Hashtable params) {
	// dm.init(name,params);
    }
}
