package neosim.neuroml;

import neosim.implementation.*;
import neosim.iface.*; 
import neuroml.sim.run.*;
import neuroml.sim.state.*;

/**
 * An entity query version of neuroml.sim.run.Query
 * @author Fred Howell
 * @date Feb 2002
 */
public final class NeosimEntityQuery extends EntityQuery {
    Query q;
    
    public NeosimEntityQuery(Query q) {
	this.q = q;
    }

    /** Run generic neuroml query on neosim
     */
    public Object query(Entity e) { 
	RunnableCell rc = ((NeosimEntityImpl)e).getRunnableCell();
	return q.query( rc.getState() );
    }
}
