package neosim.neuroml;

import neosim.implementation.*;
import neosim.iface.*;
import java.util.Vector;
import java.util.Hashtable;
import neuroml.sim.run.*;
import neuroml.sim.state.*; //JAG

/**
 * Neosim implementation of neuroml source method
 * @author Paul Rogister
 * @date Aug 2001
 */
public final class NeosimSourceMethodImpl extends SourceMethodImpl {

    neuroml.sim.run.SourceMethod sm;

    public NeosimSourceMethodImpl(neuroml.sim.run.SourceMethod sm) {
	this.sm = sm;
    }

    /** Send requests to target population
     */
    public void sendRequests(Entity srce, Population destPop, neosim.iface.DestMethod dm, boolean BuildingConnection) {
       //neosim.kernel.Deadlock_Message ecp1=new neosim.kernel.Deadlock_Message();
       //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp1);            
       NeuromlPopulationState ps = new NeuromlPopulationState(destPop);
       
//JAG       NeuromlElementState cs = new NeuromlElementState(srce); 
//JAG **************************************
       //Fred's idea: 	SourceMethodImpl builds a NeuromlElementState for the srce (the source element state). 
       //		SourceMethodImpl builds a NeuromlPopulationState for the dest (the destination element state). 
       //		DestMethodImpl assumes that deste instanceof NeosimEntityImpl
       //		and THEN gets cleverly the runnable cell state, which is definitely an element State, but which might also be "something" else
       //Fred's other idea: VolConnectSource and VolConnectDest treats classes which must be ElementState AND PositionState.
       //Note from JAG: NeuromlElementState is not used as a class at all... It just prevents access to the entity.
       //
       //Conclusion: The user should define its own class which would be both ElementState AND PositionState. For SourceMethodImpl,  srce should be assumed to be a NeosimEntityImpl and gets its  own state in the same way as DestMethodImpl.
       
     
        ElementState cs = null;
	if (srce instanceof NeosimEntityImpl) {
	    NeosimEntityImpl nsrce = (NeosimEntityImpl)srce;
	    cs = nsrce.getRunnableCell().getState();
	} else {
	    System.out.println("BOUM!!! srce is not NeosimEntityImpl");
	}       
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp1);       
        //neosim.kernel.Deadlock_Message ecp2=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp2);         
//    NeuromlElementState cs = new NeuromlElementState(srce); 
//JAG **************************************
       neuroml.sim.run.DestMethod ndm;
       if (dm instanceof NeosimDestMethodImpl) {
	   ndm = ((NeosimDestMethodImpl)dm).getNeuromlDestMethod();
       } else {
	   System.out.println("Error in NeosimSourceMethodImpl.sendRequests - not a NeuromlDestMethod"); 
	   ndm = null; // Make some junk...
       }
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp2);       
        //neosim.kernel.Deadlock_Message ecp3=new neosim.kernel.Deadlock_Message();
        //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp3);                
       NeuromlConnectionRequestSender ns = new NeuromlConnectionRequestSender(srce); 

       sm.sendRequests(ns, cs, ps, ndm, BuildingConnection); 
        //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp3);
    }

    /** @deprecated
     */
    public void init(String name, Hashtable params) {
	//	sMethod.init(name,params);
    }
}
