package neosim.perf;
import java.util.*;
import neosim.util.*;

/**
 * This class represents a state data type.
 * @version     1.0, Mar 1999
 * @author      Fred Howell
 */
public final class TypeParam {
    String typename;
    protected StringVector labels;
    public TypeParam(String typename, String buff) {  
	labels = new StringVector();
	StringTokenizer st = new StringTokenizer(buff, " ");
	this.typename = typename;
	while (st.hasMoreTokens())
	    labels.add(st.nextToken());  
    }
    
    public int getNumLabels() { return labels.size(); }
    public String getLabel(int i) { return labels.get(i); }
    public String getTypename() { return typename; }
    public int getIndex(String l) { return labels.find(l); }
}
