package neosim.renderer;

import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.behaviors.mouse.MouseRotate;
import com.sun.j3d.utils.behaviors.mouse.MouseZoom;
import com.sun.j3d.utils.behaviors.mouse.MouseTranslate;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.geometry.Box;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.event.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.picking.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.picking.behaviors.*;
import javax.media.j3d.*;
import javax.vecmath.*;

import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neosim.iface.*;
import neosim.implementation.Shape;
import neosim.kernel.Pos;

import neosim.stats.*;
import neuroml.sim.state.PositionState;

/** Useful string vector class 
 * splits a string onto a vector
 */
final class StringVector {
    protected Vector v;
    public StringVector() { v = new Vector(); }
    /* version of perl's split */
    public StringVector(String s) { 
        v = new Vector(); 
        StringTokenizer st = new StringTokenizer(s);
        while (st.hasMoreTokens())  { add(st.nextToken()); }  
    }
    public int size() { return v.size(); }
    public Vector getV() { return v; }
    public String[] getA() { 
        return getA(0,size()-1);
    }
    public String[] getA(int start) { 
        return getA(start,size()-1);
    }
    public String[] getA(int start, int end) { 
        String[] ret = new String[end-start+1]; 
        for (int i=start; i<=end; i++) { ret[i-start] = (String)v.elementAt(i); }
        return ret; 
    }
    public void add(String s) { v.addElement(s); }
    public String get( int i ) { return (String)v.elementAt(i); }
    public int find( String s ) {
        String found = null, curr;
        int foundi = 0, i=0;
        Enumeration e;  for (e = v.elements(); e.hasMoreElements();i++) {
            curr = (String)e.nextElement();
            if(s.compareTo(curr) == 0) {  found = curr; foundi = i; }
        }
        return foundi;
    }
}


final class MyCanvas3D extends Canvas3D {
    Pausable p=null;
    boolean continuous = false;
    Vector a = new Vector(); // Vector of AnimThing
    AnimApp app;
    public AnimApp getApp() { return app; }
    boolean animation = false;
    public MyCanvas3D(Pausable p, AnimApp app) {
	super(SimpleUniverse.getPreferredConfiguration());
	this.p = p;
	this.app = app;
	stopRenderer(); // Initialise as silent.
    }

    public void setMode( boolean b ) { continuous = b; if (b) {startRenderer();}}
    public boolean getMode(  ) { return continuous; }

    public void setAnimation( boolean b ) { animation = b; }
    public boolean getAnimation(  ) { return animation; }


    public void add( AnimThing am ) {
	a.addElement( am );
    }
    public void Clean(){
        a=new Vector();
    }
   
    public void preRender() {
	if (!continuous) {
	    System.out.println("About to render the scene");
	}
	
	// Update all materials with values from files.
	if (animation) {
	    //  System.out.println("Plotting a frame...");  
	    for (int i=0; i<a.size(); i++) {
		((AnimThing) (a.elementAt(i))).step();
	    }
	}
    }
    
    public void postSwap() {
	if (!continuous) {
	    System.out.println("Done swapping the scene");
	    if (p!=null) p.restart();
	    stopRenderer();
	}
    }
}


// User Picking behaviour
final class MyPick extends PickMouseBehavior implements PickingCallback {
    public MyPick( BranchGroup root,
                             Canvas3D canvas,
		  Bounds bounds) { 
	super( canvas,root,bounds );
	setMode( PickTool.BOUNDS );
	//	setupCallback(this);
    }
    public void transformChanged(int type,
				 Transform3D transform) {
	System.out.println("MyPick got msg "+type);
    }
    public void transformChanged(int type,
				 TransformGroup transform) {
	System.out.println("MyPick tg2 got msg "+type);
    }

    public void updateScene(int x, int y ) {
	System.out.println("updateScane "+x+" "+y);
    }
}

final class Buttons extends JPanel implements ActionListener{
    JFrame frame;
    AnimApp app;
    static double runt = 10.0;
    public Buttons(AnimApp app) {
	this.app = app;
        JButton button = new JButton("Run Simulation");
        button.setActionCommand("run");
        button.addActionListener(this);
        button.setToolTipText("This button runs the simulation.");
        add(button);


        JButton animbutton = new JButton("Animation Demo");
        animbutton.setActionCommand("anim");
        animbutton.addActionListener(this);
        animbutton.setToolTipText("Start demo of activity.");
        add(animbutton);
	/*
        JButton openbutton = new JButton("Open XML file");
        openbutton.setActionCommand("open");
        openbutton.addActionListener(this);
        openbutton.setToolTipText("This button opens an XML model file.");
        add(openbutton);
	*/
        JButton stopbutton = new JButton("Exit");
        stopbutton.setActionCommand("stop");
        stopbutton.addActionListener(this);
        stopbutton.setToolTipText("This button exits.");
        add(stopbutton);
    }
 
    public void actionPerformed(java.awt.event.ActionEvent e) {
        if (e.getActionCommand().equals("run")) {
            System.out.println("Run simulation");
	    // Tortuous method to run simulation - 
	    // should the window stuff be built from
	    // Netvis Ctrl instead?   Yes!
	    Netvis nv = app.nv;
	    NetvisClass nvc =  (NetvisClass)nv.getEntityClass();
	    ScriptReader sr = nvc.getScriptReader();
	    runt += 10.0;
	    sr.runSim(new Time(runt));
	    
        } else if (e.getActionCommand().equals("stop")) {
            System.out.println("Stop simulation");
            System.exit(0);
        } else if (e.getActionCommand().equals("anim")) {
	    app.toggleAnim();
        } else if (e.getActionCommand().equals("open")) {          
            JFileChooser chooser = new JFileChooser(); 
            //      ExtensionFileFilter filter = new ExtensionFileFilter(); 
            //      filter.addExtension("xml");
            //      filter.setDescription("XML files"); 
            //      chooser.setFileFilter(filter); 
            int returnVal = chooser.showOpenDialog(this); 
            if (returnVal == JFileChooser.APPROVE_OPTION) { 
                System.out.println("You chose to open this file: " + chooser.getSelectedFile().getName()); 
            } 
        } else { 
            System.out.println("Unknown command");
        }
    }
}



/** Animation of colours &c.
 */
interface AnimThing {
    void step();
}

/** Single animated material 
 */
final class AnimMat implements AnimThing {
    public Material mat;
    Vector vals;
    double max, min;
    float r1,g1,b1,r2,g2,b2;
    int stepi = 0;
    int skip = 1;
    ColoringAttributes myColour;
    
    public AnimMat( Material mat, Vector vals, double min, double max,
		    float r1, float g1,float b1, float r2, float g2, float b2,
		    int skip, ColoringAttributes myColour ) {
	this.mat = mat; this.vals = vals; 
	this.min = min; this.max = max;
	this.r1 = r1;	this.g1 = g1;	this.b1 = b1;
	this.r2 = r2;	this.g2 = g2;	this.b2 = b2;
        this.myColour=myColour;
	this.skip = skip; // data skip
    }
    // Step the colour
    public void step() {
	// Get Max of waveform if rate2>0
	double val = -100;
	for (int si = stepi; si < stepi+skip && si < vals.size(); si++) {
	    double valt = ((Double)(vals.elementAt(si))).doubleValue();
	    if (valt > val) val = valt;
	}	
	double sval = (val - min) / (max-min);  if (sval > 1) { sval = 1; }
	float rval = (r2-r1) * (float) sval  + r1;
	float gval = (g2-g1) * (float) sval  + g1;
	float bval = (b2-b1) * (float) sval  + b1;
	// Set colour to rval,gval,bval
	mat.setAmbientColor( rval,gval,bval);
        myColour.setColor(rval,gval, bval);
	mat.setDiffuseColor( rval,gval,bval);
	stepi += skip;
	if (stepi >= vals.size()) stepi = 0;
    }
}

/** A simple Event animated material
 */
final class AnimEvent implements AnimThing {
    Material mat;
    Vector times; // Vector of integer step indices.
    float r1,g1,b1,r2,g2,b2;
    int stepi = 0;
    int ustep = 0;
    int numsteps = 1;
    int hold = 1;
    int skip = 1;
    int timei = 0;
    int nextEvent = -1;
    int oncount = -1;
    public AnimEvent( Material mat, Vector times,  
		      float r1, float g1,float b1, float r2, float g2, float b2,
		      int numsteps, int hold, int skip ) {
	this.mat = mat; this.times = times;  
	this.r1 = r1;	this.g1 = g1;	this.b1 = b1; // Off colour
	this.r2 = r2;	this.g2 = g2;	this.b2 = b2; // On colour
	this.hold = hold; // frames for ON
	this.skip = skip; // data skip
	this.numsteps = numsteps;
	timei = 0;
	nextEvent = nextTime();
    }    
    int nextTime() {
	int ret = -1;
	if (times.size() > timei) { 
	    ret = ((Integer)times.elementAt(timei)).intValue();
	    timei ++;
	}
	return ret;
    }
    public void step() {
   	if (oncount>0) {
	    oncount--;
	    if (oncount==0) {
		// Switch OFF
		mat.setAmbientColor( r1,g1,b1);
		mat.setDiffuseColor( r1,g1,b1); 
	    }
	}	    
	// stepi is current time step
	while (nextEvent >=stepi && (nextEvent < stepi+skip)) {
	    // Switch ON
	    mat.setAmbientColor( r2,g2,b2);
	    mat.setDiffuseColor( r2,g2,b2);
	    oncount   = hold;
	    nextEvent = nextTime();
	    //	    System.out.println("Switching ON at "+stepi+"  next event "+nextEvent);
	}	
	stepi += skip;	
	if (stepi >= numsteps)  {

	    stepi = 0;
	    timei = 0;
	    nextEvent = nextTime();
	    System.out.println("Anim event clocked...  next event "+nextEvent);
	}
    }
}

/** A thread to call render loop...
 */
final class AnimThread extends Thread  {
    boolean finished = false;
    long frate;
    MyCanvas3D mc;
    public AnimThread(int frate, MyCanvas3D mc) { 
	this.frate = frate; // frame rate millisecs
	this.mc = mc;
        setName(getName()+" "+this.getClass().getName()+ " "+frate);
    }
    public void finish() { finished = true; }
    public void run() {
	while (!finished) {
	    long last = System.currentTimeMillis();
	    //	    mc.getApp().mouseZoom.setFactor(mc.getApp().mouseZoom.getFactor()+1.01);
	    mc.preRender();
	    long now = System.currentTimeMillis();
	    //  System.out.println("Plotting a frame, took "+(now-last)+"ms");

	    long delay = frate - ( now-last );
	    if (delay < 1) delay = 1;
	    try { Thread.sleep( delay ); } catch (Exception e) {}
	}

    }
}

final public class AnimApp extends JPanel implements MouseListener {
    Pausable p;
    Netvis nv;
    Vector Branches=new Vector();
    static boolean debug = false;

    MyCanvas3D theCanvas;
    public void stopRenderer() { theCanvas.stopRenderer(); }
    public void startRenderer() { theCanvas.startRenderer(); }
    public void continuousRender() { theCanvas.setMode(true); }


    int rseed = 123237;
    SimUniformObj randomloc = new SimUniformObj("", 0.3, 1.0, rseed+2);
    SimNormalObj  randomwgt = new SimNormalObj("", 2.5,0.5,rseed+3);
    Random gen = new Random();


    Alpha inputPortOn, inputPortOff;
    boolean onoff = false;
    AnimThread athread = null;
   public void highlightDest( int dest ) {//EntityID dest
	if (debug) { System.out.println("AnimApp Highlighting entity ID "+dest); }

	NodeData nd = (NodeData) entityData.get( new Integer(dest) );
	
	if (nd!=null) {
	    nd.toggleHighlight(); // no longer needed...
	    AnimMat am = nd.am;
	    if (am!=null) { 		am.step();  }
	} else {
	    System.out.println("NodeData not found for entity "+dest); 
	}
    }

    /** Add connection to the scene 
     * What should happen when you click a connection?
     */
    public void addConnToVis( Pos p1, Pos p2 ) {
	System.out.println("AnimApp Adding conn to vis "+p1+" "+p2);
	/*	bg.addChild( createCuboid( greenMat, 1f, 
		(float)p1.x,(float)p1.y,(float)p1.z,
		(float)p2.x,(float)p2.y,(float)p2.z, 
		new NodeData(null,"connection"))); 
	*/

 	/*objTrans.addChild( createCuboid( yellowMat, 0.05f, 
					 (float)p1.x,(float)p1.y,(float)p1.z,
					 (float)p2.x,(float)p2.y,(float)p2.z, 
					 new NodeData(new EntityID(123),"connection")   ));*/
	
    }
    
    public void toggleAnim() {
	theCanvas.setAnimation( !theCanvas.getAnimation() );
	if (theCanvas.getAnimation()) {
	    athread = new AnimThread( 50, theCanvas );
	    athread.start();
	} else if (athread!=null) {
	    athread.finish();
	}
    }

 /*   public void sendEvents(EventList el) {
	System.out.println("J3D NW2 got "+el.getEvents().size()+" events");
	if (onoff == false) { // switch on
	    inputPortOn.setLoopCount(1);
	    inputPortOn.setTriggerTime( 0 );
	}
    }*/

    /** Create a basic box with given colour, scale, position
     */
    public TransformGroup createObject( Material m,
			       float size,
			       double x, double y, double z) {
	Transform3D t = new Transform3D();
	t.set( 1.0, new Vector3d(x,y,z));
	TransformGroup objTrans = new TransformGroup(t);
	Appearance app = new Appearance(); 
	app.setMaterial(m);
	Box obj = new Box(size,size,size,
			  Box.GENERATE_NORMALS,
			  app);
	objTrans.addChild( obj );
	return objTrans;
    }


    Hashtable nodes = new Hashtable();

    // Hashtable of entity data
    Hashtable entityData = new Hashtable(); 

    // Data stored along with each entity
    final class NodeData {
	String name;
	int eid;//EntityID eid
	Switch sw;
	public boolean highlight = false;
	public boolean detailed  = false;
	public AnimMat am;
	public double x,y,z;
	public Shape s;
	NodeData(int eid, String n ) { this.eid = eid; this.name = n; sw = null; am = null; }//EntityID eid
	NodeData(int eid, String n, double x,double y,double z,Shape s, AnimMat am ) { //EntityID eid
	    this.eid = eid; this.name = n; sw = null;
	    this.x=x;this.y=y;this.z=z;this.s=s; this.am = am;
	}
	public int getEntityID() { return eid; }//EntityID return
	public String getName() { return name; }
	public Switch getSwitch() { return sw; }
	public void setSwitch(Switch sw) { this.sw=sw; }
	public void updateSwitch() {
	    if (sw!=null) {
		if (detailed) sw.setWhichChild(1); 
		else  sw.setWhichChild(0);
	    }
	}
	// 0 = low detail, 1= highdetail   (Used to be: 2 = highlight version., now deprecated)
	public void setHighlight() {
	    if (!highlight) {
		highlight = true;
		updateSwitch();
	    }
	}
	public void clearHighlight() {
	    if (highlight) {
		highlight = false;
		updateSwitch();
	    }
	}
	public void toggleHighlight() {
	    if (highlight) clearHighlight(); else setHighlight();
	}
	public void toggleDetail() {
	    detailed = !detailed;
	    //	    highlight= false;
	    updateSwitch();
	}
    }

    /** Create a basic sphere
     */
    public TransformGroup createSphere( Material m,
					float size,
					double x, double y, double z,
					NodeData nd) {
	Transform3D t = new Transform3D();
	t.set( 1.0, new Vector3d(x,y,z));
	TransformGroup objTrans = new TransformGroup(t);
	Appearance app = new Appearance(); 
	app.setMaterial(m);


	if (false) {
	    Sphere obj = new Sphere(size,
				    Sphere.GENERATE_NORMALS | 
				    Sphere.ENABLE_GEOMETRY_PICKING |
				    Sphere.ENABLE_PICK_REPORTING,
				    app);
	    objTrans.addChild( obj );
	    objTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	    PickTool.setCapabilities(obj.getShape(), PickTool.INTERSECT_FULL);
	    
	    

	} else {	    
	    Shape3D shape;
	    Geometry geom;	    
	    geom = new CubeQA();
	    shape = new Shape3D( geom, app );
	    objTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	    objTrans.addChild( shape );
	    shape.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
	    shape.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
	    shape.setCapability(Shape3D.ENABLE_PICK_REPORTING);

	    PickTool.setCapabilities(shape, PickTool.INTERSECT_FULL);
	    nodes.put( objTrans, nd);
	    
	}
	return objTrans;
    }

    /** Create a basic box with given colour, scale, position
     */
    public BranchGroup createBranchObject( Material m,
			       float size,
			       double x, double y, double z) {
	Transform3D t = new Transform3D();
	t.set( 1.0, new Vector3d(x,y,z));
	BranchGroup objTrans = new BranchGroup();
	TransformGroup tg = new TransformGroup( t );
	objTrans.addChild( tg );
	Appearance app = new Appearance(); 
	app.setMaterial(m);
	Box obj = new Box(size,size,size,
			  Box.GENERATE_NORMALS,
			  app);
	tg.addChild( obj );
	objTrans.compile();
	return objTrans;
    }
  
    /** Create a granule cell with axon
     */
    public TransformGroup createGranule( Material m,
					 float size,
					 double x, double y, double z) {
	Transform3D t = new Transform3D();
	t.set( 1.0, new Vector3d(x,y,z));
	TransformGroup objTrans = new TransformGroup(t);
	Appearance app = new Appearance(); 
	app.setMaterial(m);

	Box soma = new Box(size,size,size,
			   Box.GENERATE_NORMALS |
			   Box.GENERATE_TEXTURE_COORDS,
			   app); 

	// Ascending part of pf
	Transform3D asct = new Transform3D();
	asct.set( 1.0, new Vector3d(0,3,0));
	TransformGroup asctg = new TransformGroup(asct);
	Box asc  = new Box(0.05f,3f,0.05f,
			   Box.GENERATE_NORMALS |
			   Box.GENERATE_TEXTURE_COORDS,
			   app);
	asctg.addChild(asc);

	// Parallel fiber
	Transform3D pft = new Transform3D();
	pft.set( 1.0, new Vector3d(0,6,0));
	TransformGroup pftg = new TransformGroup(pft);
	Box pf  = new Box(10f,0.05f,0.05f,
			   Box.GENERATE_NORMALS |
			   Box.GENERATE_TEXTURE_COORDS,
			   app);
	pftg.addChild(pf);

	objTrans.addChild( soma );
	objTrans.addChild( asctg );
	objTrans.addChild( pftg );

	return objTrans;
    }


    /** Create a pickable sphere (the default one won't allow mouse clicking)
     */
    public Node createMySphere(Appearance app, Color3f col, NodeData nd) {
	/*
	  Geometry geom = new IcosahedronITSA(col); 
	  Shape3D shape = new Shape3D(geom,app);
	*/
	Sphere sph = new Sphere( 0.3f, 
				 Primitive.ENABLE_GEOMETRY_PICKING | 
				 Primitive.GEOMETRY_NOT_SHARED | 
				 Geometry.ALLOW_INTERSECT | 
				 Shape3D.ALLOW_GEOMETRY_READ |
				 Shape3D.ALLOW_COLLISION_BOUNDS_READ |
				 Shape3D.ALLOW_APPEARANCE_READ |
				 Shape3D.ALLOW_APPEARANCE_WRITE |
				 Shape3D.ENABLE_PICK_REPORTING, 
				 5, app);
	sph.setPickable(true);
	Shape3D shape = sph.getShape();
	//	shape.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
	//	shape.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
	//	shape.setCapability(Shape3D.ENABLE_PICK_REPORTING);
	// Too late... PickTool.setCapabilities(shape, PickTool.INTERSECT_FULL);
	
	nodes.put(shape, nd);

	return sph;
    }
    
    public Node createAxonDendrite(Appearance app, Color3f col, NodeData nd, Vector v, double x, double y, double z){
        int v_realsize=v.size();
        Vector v2=new Vector();
        for(int i=0;i<v_realsize;i++){
            if(v.elementAt(i)!=null)
                v2.add(v.elementAt(i));
        }
        int vsize=v2.size();
        if(vsize==0) 
            return null;
        int vsize_2=2*vsize;
        
        Point3d pts[]=new Point3d[vsize_2];
        Color3f couls[]=new Color3f[vsize_2];
        for(int ik=0;ik<vsize;ik++){
           // pts[2*ik]= new Point3d( x , y , z);
            pts[2*ik]= new Point3d( 0 , 0 , 0);
            //18/04/05
            //PositionState e2=(PositionState)(v2.elementAt(ik));
            //pts[2*ik+1]= new Point3d( e2.getXPos()-x , e2.getYPos()-y , e2.getZPos()-z);
            //<-18/04/05
            Pos e2=(Pos)(v2.elementAt(ik));
            pts[2*ik+1]= new Point3d( e2.x-x , e2.y-y , e2.z-z);            
            couls[2*ik]=col;
            couls[2*ik+1]=col;
        }
        /*double pts[]=new double[vsize_2*3];
        for(int ik=0;ik<vsize;ik++){
            pts[6*ik]=0;
            pts[6*ik+1]=0;
            pts[6*ik+2]=0;
            PositionState e2=(PositionState)(v2.elementAt(ik));
            pts[6*ik+3]=e2.getXPos()-x;
            pts[6*ik+4]=e2.getYPos()-y;
            pts[6*ik+5]=e2.getZPos()-z;
        }*/
            LineArray la = new LineArray(pts.length,LineArray.COORDINATES);
            la.setCoordinates(0,pts);
            /*la.setColors(0,couls);
            for(int ik=0;ik<vsize;ik++){
           // pts[2*ik]= new Point3d( x , y , z);
          
                couls[2*ik]=new Color3f(1.0f,1.0f,0.0f);
                couls[2*ik+1]=new Color3f(1.0f,1.0f,0.0f);
            }
            la.setColors(0,couls);*/
            Shape3D shape = new Shape3D(la,app);
            shape.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE|
                                 Shape3D.ALLOW_GEOMETRY_READ |
				 Shape3D.ALLOW_COLLISION_BOUNDS_READ |
				 Shape3D.ALLOW_APPEARANCE_READ |
				 Shape3D.ALLOW_APPEARANCE_WRITE |
				 Shape3D.ENABLE_PICK_REPORTING);
            nodes.put(shape, nd);
          //  System.out.println("Neuron "+x+" "+y+" "+z+" has "+pts.length/6+" output connections");
            return shape;

        /*
      objTr2.addChild(shape);*/
    }

    /** Create a simple subthalamic nucleus cell
     */
    public BranchGroup createSThCell( Appearance app, 
				      float somasize,
				      float dend1len,
				      float dend1diam,
				      float dend2len,
				      float dend2diam,
				      double x, double y, double z,
				      NodeData nd,Vector v) {
	BranchGroup objTrans = new BranchGroup();
        objTrans.setCapability(BranchGroup.ALLOW_DETACH);
        objTrans.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    
	Transform3D t = new Transform3D();
	t.set( 1.0, new Vector3d(x,y,z));
	TransformGroup tg = new TransformGroup( t );
        tg.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
        tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        tg.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	objTrans.addChild( tg );
        
	Switch sw= new Switch(0);
        
	sw.setCapability(javax.media.j3d.Switch.ALLOW_SWITCH_READ);
	sw.setCapability(javax.media.j3d.Switch.ALLOW_SWITCH_WRITE);
	sw.setCapability(javax.media.j3d.Switch.ALLOW_CHILDREN_EXTEND);
	sw.setCapability(javax.media.j3d.Switch.ALLOW_CHILDREN_READ);
	sw.setCapability(javax.media.j3d.Switch.ALLOW_CHILDREN_WRITE);
	
	
	//tg.addChild( sw );
	nd.setSwitch( sw );
        if(v!=null){
            Node axon = createAxonDendrite( app ,new Color3f(0.0f,1.0f,0.0f) , nd,v,x,y,z);
            tg.addChild(axon);
        }
	Node simplesoma = createMySphere( app , new Color3f(1,0,0), nd);
        tg.addChild(simplesoma);


	//	Node simplesoma2 = createMySphere( app , new Color3f(0,0.7f,0), nd);
	//	sw.addChild(simplesoma2);

	// 	nodes.put(simplesoma, nd);
	// 	nodes.put(simplesoma2, nd);
	objTrans.compile();

	return objTrans;
    }


    Vector3f getNorm( Point3f p1, Point3f p2, Point3f p3 ) {
	Vector3f n1 = new Vector3f(p2); n1.sub(p1);
	Vector3f n2 = new Vector3f(p2); n2.sub(p3);
	Vector3f n3 = new Vector3f(); n3.cross(n1,n2); n3.normalize();
	return n3;
    }
    

    /** Global variables 
     */
    TransformGroup objTrans;

    // Make some colours
    Color3f redCol     = new Color3f(1,0,0);
    Color3f blueCol    = new Color3f(0,0,1);
    Color3f greenCol   = new Color3f(0,1,0);
    Color3f cyanCol   = new Color3f(0,1,1);
    Color3f yellowCol  = new Color3f(1,1,0);
    Color3f black      = new Color3f(0.0f,0.0f, 0.0f);
    Color3f grey      = new Color3f(0.5f,0.5f, 0.5f);
    Color3f white      = new Color3f(1.0f,1.0f, 1.0f);
    Material redMat    = new Material(redCol,    black, redCol,    white, 80.0f);
    Material granMat   = new Material(redCol,    black, redCol,    white, 80.0f);
    Material blueMat   = new Material(blueCol,   black, blueCol,   white, 80.0f);
    Material greenMat  = new Material(greenCol,  black, greenCol,  white, 80.0f);    
    Material excMat    = new Material(yellowCol,  grey, yellowCol,  white, 40.0f);    
    Material inhMat    = new Material(cyanCol,  grey, cyanCol,  white, 40.0f);    
    Material somaMat    = new Material(cyanCol,  grey, cyanCol,  white, 40.0f);    
    Material yellowMat = new Material(yellowCol, grey, yellowCol, white, 40.0f);
    

    boolean fastMode = false;
    MouseRotate mouseRotate;
    public MouseZoom mouseZoom;
    MouseTranslate mouseTranslate;

    public BranchGroup createSceneGraph(String[] args) {
	// Create the root of the branch graph
	BranchGroup objRoot = new BranchGroup();
	
	// Create a Transformgroup to scale all objects so they
	// appear in the scene.
	TransformGroup objScale = new TransformGroup();
	objScale.setCapability(TransformGroup.ENABLE_PICK_REPORTING);

	Transform3D t3d = new Transform3D();
	//	t3d.setScale(0.4);	
	t3d.set( 0.2, new Vector3d(0,0,-10));

	objScale.setTransform(t3d);
	objRoot.addChild(objScale);
    
    // Create the transform group node and initialize it to the
    // identity.  Enable the TRANSFORM_WRITE capability so that
    // our behavior code can modify it at runtime.  Add it to the
    // root of the subgraph.
    objTrans = new TransformGroup();
    //read/write-enable for behaviors
    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
    objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    // Allow adding nodes
    objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
    objTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
    objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);//JAG
    
    objScale.addChild(objTrans);



    redMat.setCapability( Material.ALLOW_COMPONENT_READ );
    redMat.setCapability( Material.ALLOW_COMPONENT_WRITE );
 
    BoundingSphere bounds =
      new BoundingSphere(new Point3d(0.0,0.0,0.0), 100000.0);

 

    // Set up the background
    Color3f bgColor = new Color3f(0.1f, 0.1f, 0.3f);
    Background bg = new Background(bgColor);
    bg.setApplicationBounds(bounds);
    objRoot.addChild(bg);
    
 
	
    // Create the rotate mouseRotate node
    mouseRotate = new MouseRotate(objTrans);
    mouseRotate.setFactor(0.01);
    objTrans.addChild(mouseRotate);
    mouseRotate.setSchedulingBounds(bounds);

    // Create the zoom behavior node
    mouseZoom = new MouseZoom(objTrans);
    mouseZoom.setFactor(0.04);
    objTrans.addChild(mouseZoom);
    mouseZoom.setSchedulingBounds(bounds);

    // Create the translate behavior node
    mouseTranslate = new MouseTranslate(objTrans);
    mouseTranslate.setFactor(0.01);
    objTrans.addChild(mouseTranslate);
    mouseTranslate.setSchedulingBounds(bounds);

    // A select behaviour ....
    MyPick mp = new MyPick(objRoot,theCanvas ,bounds);
    objRoot.addChild(mp);

    //Shine it with two lights.
    Color3f lColor1 = new Color3f(0.8f, 0.8f, 0.8f);
    Color3f lColor2 = new Color3f(0.3f, 0.3f, 0.2f);
    Vector3f lDir1  = new Vector3f(-1.0f, -1.0f, -1.0f);
    Vector3f lDir2  = new Vector3f(0.0f, 0.0f, -1.0f);
    DirectionalLight lgt1 = new DirectionalLight(lColor1, lDir1);
    DirectionalLight lgt2 = new DirectionalLight(lColor2, lDir2);
    lgt1.setInfluencingBounds(bounds);
    lgt2.setInfluencingBounds(bounds);
    objScale.addChild(lgt1);
    objScale.addChild(lgt2);

    // Let Java 3D perform optimizations on this scene graph.
    objRoot.compile();
 
    return objRoot;
    }




    double isirand = 100.0;
    double isireg = 100.0;
    SimNegexpObj rand = new SimNegexpObj( "", isirand, 1234);

    int maxEntityID =0;
    /** Add an entity to the scene 
     */
    
    public void addEntityToVis( int eid, String name, double x, double y, double z, Shape s, Vector v ) {//EntityID eid
	BranchGroup bg= new BranchGroup();
	
	if (s == null) {
	    bg= createBranchObject( blueMat, 0.5f, x,y,z);
	} else {
	    // Interpret the shape :
	    String col = s.getColour();
	    Material m;
	    if (col.equals("red")) m = redMat;
	    else if (col.equals("blue")) m = blueMat;
	    else if (col.equals("green")) m = greenMat;
	    else m = yellowMat;
	   
	    String sh = s.getShapeName();
	    if (sh.equals("sphere")) {
		//System.out.println("Making a STh cell for now");
		Material newMat   = new Material(greenCol,   black, greenCol,   white, 80.0f);
		Appearance newApp = new Appearance(); 
                newApp.setMaterial(newMat);
                newMat.setCapability( Material.ALLOW_COMPONENT_WRITE );
                
                
                //JAG-> for colouring the wires
                ColoringAttributes coloring_attributes =
                new ColoringAttributes(greenCol, ColoringAttributes.SHADE_FLAT);
                coloring_attributes.setCapability(ColoringAttributes.ALLOW_COLOR_READ);
                coloring_attributes.setCapability(ColoringAttributes.ALLOW_COLOR_WRITE);
                newApp.setCapability(Appearance.ALLOW_COLORING_ATTRIBUTES_READ);
                newApp.setColoringAttributes(coloring_attributes);

                
		

		if (col.equals("red")) {
		    Vector vals = new Vector(); vals.add(new Double(0.0)); vals.add(new Double(1.0)); 
		    AnimMat am = new AnimMat( newMat, vals, 0.0, 1.0, 1.0f, 0f,0f, 0f,1f,0f,1, coloring_attributes);
		    NodeData nd = new NodeData(eid,name,x,y,z,s,am);
		    entityData.put( new Integer(eid), nd );	
                    
                    BranchGroup muche=createSThCell( newApp,  
						      (float)(s.getScale() * 100 * 0.0188),
						      (float)(s.getScale() * 100 * 0.7019),
						      (float)(s.getScale() * 100 * 0.00318),
						      (float)(s.getScale() * 100 * 0.549),
						      (float)(s.getScale() * 100 * 0.002),
						      (float)x,(float)y,(float)z,
						      nd,v);
                    Branches.add(muche);
		    objTrans.addChild(muche);
 
		    // if (eid.id == 15) {
			Vector events = new Vector(); 	
			int max = 1000;
			int lastT=0;
			while (lastT < max) {
			    int nextT = lastT + (int)isireg + (int) (rand.sample());
			    events.addElement(new Integer(nextT));
			    lastT = nextT;
			}
			AnimEvent cfAnim = new AnimEvent( newMat,  events,
							  0,1,0,  1,0,0,
							  max, 5, 1 );
			theCanvas.add( cfAnim ); 

			if (maxEntityID < eid) maxEntityID = eid; 
		} 
	    } else {
		bg.addChild( createObject( m, (float)s.getScale(), x,y,z)); 
	    } 
	    
	}
	//	bg.compile();
	//objTrans.addChild( bg );
    }

    PickCanvas pc;


    /** Mouse Listener */
    public void mousePressed( MouseEvent e) {    
	if (e.isShiftDown()) {
	    if (!fastMode) {
		try {
		    mouseRotate.setFactor( mouseRotate.getXFactor() * 5);
		    mouseTranslate.setFactor( mouseTranslate.getXFactor() * 5);
		    mouseZoom.setFactor( mouseZoom.getFactor() * 5);
		    fastMode = true;
		} catch (Exception ex) {}
	    }
	} else {
	    if (fastMode) {
		fastMode = false;
		try {
		    mouseRotate.setFactor( mouseRotate.getXFactor() / 5);
		    mouseTranslate.setFactor( mouseTranslate.getXFactor() / 5);
		    mouseZoom.setFactor( mouseZoom.getFactor() / 5);
		} catch (Exception ex) {}
	    }
	}


	/** Do connections here too.... */
	pc.setShapeLocation(e);
	doneToggle = false;
	results = pc.pickAll();
	if (results!=null) {
	    for (int i=0; i<results.length; i++) {
		Node n = results[i].getNode(PickResult.SHAPE3D);
		NodeData nd = (NodeData)nodes.get(n );
		if (nd!=null) {
		    //System.out.println("NODE DATA:"+nd.getName()+" eid "+nd.getEntityID());
		    if (!e.isShiftDown()) { 
			if (!doneCons) {
			    //System.out.println("Getting connections from NetVis now !!!");
			    nv.clickConnections( nd.getEntityID() );
			    doneCons = true;
			    consNode = nd;
			}
		    }
		} else {
		    System.out.println("NODE DATA not found:");
		}				
	    }
	}
    }
    public void mouseReleased(MouseEvent e) {  
	if (doneCons) {
	    // *** Unhighlight them now... ***
	    nv.clickConnections( consNode.getEntityID() );
	    doneCons = false;
	}
    }    
    public void mouseEntered(MouseEvent e) {    }
    public void mouseExited(MouseEvent e) {    }  

    NodeData consNode;
    boolean doneCons;
    boolean doneToggle;
    PickResult[] results;

    /** CALLBACK when mouse clicked 
     */
    public void mouseClicked(MouseEvent e) {	
	// pc.setShapeLocation(e);
	if (results!=null) {
	    for (int i=0; i<results.length; i++) {
		Node n = results[i].getNode(PickResult.SHAPE3D);
		NodeData nd = (NodeData)nodes.get(n );
		if (nd!=null) {

		    //System.out.println("NODE DATA:"+nd.getName()+" eid "+nd.getEntityID());

		    if (e.isShiftDown()) {
			if (!doneToggle) {
			    System.out.println("Toggling LOD !!!");
			    Switch sw = nd.getSwitch();
			    // if only one ... add a detailed version ...
			    if (sw!=null) {			    
				if (sw.numChildren()==2) {
				    nd.toggleDetail();
				    //				    sw.setWhichChild( 1- sw.getWhichChild() );
				    doneToggle = true;
				} else if ( sw.numChildren()==1) {
				    System.out.println("Making a detailed version....");
				   /* createDetailedSThCell(nd.am.mat, 
							  sw,
							  (float)(nd.s.getScale() *100* 0.0188),
							  (float)(nd.s.getScale() *100* 0.7019),
							  (float)(nd.s.getScale() *100* 0.00318),
							  (float)(nd.s.getScale() *100* 0.549),
							  (float)(nd.s.getScale()*100 * 0.002),
							  (float)nd.x,(float)nd.y,(float)nd.z,
							  nd);*/

				    doneToggle = true;
				    //				    sw.setWhichChild( 1 );
				    nd.toggleDetail();
				}
				  
			    } else {
				System.out.println("Switch null :(");
			    }
			}
		    } else {
			// OK, go fetch the connections from this one...
			/** if (!doneCons) {
			    System.out.println("Getting connections from NetVis now !!!");
			    nv.clickConnections( nd.getEntityID() );
			    doneCons = true;
			    }
			*/
		    }
		    
		    

		} else {
		    System.out.println("NODE DATA not found:");
		}				
	    }
	}
    }

    public SimpleUniverse u;

    public AnimApp(String[] args, Pausable p, Netvis nv) {
      this.p = p;
      this.nv = nv;
      removeAll();
      /*setLayout(new GridBagLayout());
      GridBagConstraints c = new GridBagConstraints();        
      c.fill = GridBagConstraints.BOTH;
      c.gridwidth = 1;
      c.gridheight = 1;
      c.gridx = 0;        

      //      theCanvas = new MyCanvas3D(p);
      theCanvas = new MyCanvas3D( null ,this);  // *** Not using pausable... ***
      //theCanvas.setSize(150,150);
      c.gridy = 0;
      c.weighty = 9;  
      add(theCanvas,c);
      c.gridy = 9;
      c.weighty = 1; 
      Buttons panel = new Buttons(this);     
      add(panel,c);*/
      setLayout(new BorderLayout());
      theCanvas = new MyCanvas3D( null ,this);
      add(theCanvas,BorderLayout.CENTER);
      Buttons panel = new Buttons(this);     
      add(panel,BorderLayout.SOUTH);
      
      // Create a simple scene and attach it to the virtual universe
      BranchGroup scene = createSceneGraph(args);
      u = new SimpleUniverse(theCanvas);

      pc = new PickCanvas( theCanvas, scene );
      // *** Geometry picking only works with self-constructed objects, not builtins!!! ***
      //      pc.setMode(PickTool.GEOMETRY_INTERSECT_INFO); 
      pc.setTolerance(1.0f);      
      theCanvas.addMouseListener( this );
                 
      // This will move the ViewPlatform back a bit so the
      // objects in the scene can be viewed.
      u.getViewingPlatform().setNominalViewingTransform();
      u.addBranchGraph(scene);

      theCanvas.setMode( true ); // Continuous render now!
      this.validate();
  }
  public void clean()
  {   
      theCanvas.Clean();
      for(int i=0;i<Branches.size();i++){
          BranchGroup o=(BranchGroup)(Branches.elementAt(i));
          o.detach();
      }
      Branches=new Vector();
      
      
  }
  
  
}

