package neosim.renderer;

import neosim.iface.*;
import java.util.Vector;
import java.lang.Math;
import java.util.Hashtable;
import neosim.implementation.*; 
import neosim.kernel.*; 
import neosim.util.*; 

 
/** This simple projection performs an all-all
 */
final class SimpleProjImpl extends GeneralProjectionImpl {
    public SimpleProjImpl( String srcPop, short outPort, String destPop, short inPort, //PortID outPort//PortID inPort
			   Time delay) {
	super(srcPop, destPop, new SourceMethodImpl(outPort), new DestMethodImpl(inPort,delay)); 
    }
}

/**
 * SimpleProjection is a class used to get and init the SimpleProjImpl class from a jar file
 * the main aim is to pass the hashtable of parameters to the constructor method of the  SimpleProjImpl class
 *   
 */
public class SimpleProjection implements neosim.util.ProjectionJar {
    SimpleProjImpl p;
    public SimpleProjection(){}
    public void init(String name, String srcPop, short outPort, //PortID outPort
		     String destPop, short inPort, //PortID inPort
		     Time delay, Hashtable params){
	try {
	    p = new SimpleProjImpl( srcPop, outPort, destPop, inPort, delay );
	} catch (Exception e ) {
	    System.out.println(e);
	    e.printStackTrace();
	}
    }
    public ProjectionImpl getProjection(){
	return p;
    }
}
