package neosim.rmikernel;

import neosim.kernel.*;

/** The interface to a remote server
 */
public interface RmtServer extends java.rmi.Remote, Commandable, RmtProcMgr {
  int  add(RmtApp obj, String name, int IPAddress) throws java.rmi.RemoteException;
  void done(int id, RmtApp obj) throws java.rmi.RemoteException;
  void remove(int id, RmtApp obj) throws java.rmi.RemoteException;
  void barrier(int id) throws java.rmi.RemoteException;
  void barrier() throws java.rmi.RemoteException;
  int[] sortIPs(int id) throws java.rmi.RemoteException;
  java.util.Vector allgather(Object o) throws java.rmi.RemoteException;
  
//RMI Tests
  void startTests() throws java.rmi.RemoteException;  
  void call() throws java.rmi.RemoteException;  
  void sendByte(byte[] array) throws java.rmi.RemoteException;
  byte[] receiveByte(byte size) throws java.rmi.RemoteException;
  void sendInt(int[] array) throws java.rmi.RemoteException;
  int[] receiveInt(byte size) throws java.rmi.RemoteException;  
  void sendObject(MiscTests.SerializedClass obj) throws java.rmi.RemoteException;
  long sum(int[] array) throws java.rmi.RemoteException;
  long sum(byte[] array) throws java.rmi.RemoteException;
}
