/** Initialise an control module bean which has been loaded from a jar file
 */

package neosim.util;

import neosim.kernel.*;
import neosim.util.*;
import neosim.iface.*;
import java.util.*;
import java.beans.*;

/**
 * Load a java bean from a .jar file
 *
 * @author Fred Howell      
 *
 * @version 1.0, 18 Octobre 2000     
 *                 
 */
public class ControlModuleBean implements DoOnBean {
    Hashtable params;
    ControlModule ec;
    public ControlModuleBean(Hashtable params) {
	
        this.params = params;
    }
    public void action(JarInfo ji, BeanInfo bi, String beanName) {
        System.out.println("Running template "+beanName);
        //ec = (ControlModule)ji.getInstance(beanName);
	
	Object o = (Object)ji.getInstance(beanName);
	if (o instanceof neuroml.sim.run.RunnableControl) {
	    // make a converter
	    ec = NeuromlConverter.convertControlModule((neuroml.sim.run.RunnableControl)o);

	    ec.init(params); 
	}
	else {
	    ec = (ControlModule)o;

	    ec.init(params); 
	}

    }

    public ControlModule getControlModule() { return ec; }
    public void error(String msg) {
        System.out.println("Start bean error "+msg);
    }
    public void error(String msg, Exception ex) {
        System.out.println("Start bean exception "+msg);
   }
}
