

package neosim.util;
 
import java.awt.*;
import java.util.EventObject;

/**
 * File event object
 * This stores a single line of a file.
 */
 
public class FileEventObject extends EventObject implements Filecmds { 

  String line;
  int cmd;

  /** Creates a file event object with a string */
  public FileEventObject(Object o, String line) {
    super(o);
    set(line);
  }

  /** Creates a file event object from another */
  public FileEventObject(Object o, FileEventObject t) {
    super(o);
    set(t);
  }

  /** Creates a file event command 
   */
  public FileEventObject(Object o, int cmd) {
    super(o);
    set(cmd);
  }
  
  /** Sets this command to a  string */
  public void set(String line) {
    this.line = line;
    cmd = LINE;
  }

  /** Sets this command to a file object */
  public void set(FileEventObject t) {
    this.line = t.line;
    this.cmd = t.cmd;
  }

  /** Sets this command to one of the file commands */
  public void set(int cmd) {
    this.line = "null";
    this.cmd = cmd;
  }

  /** Returns the file line */
  public String getLine() { return line; }

  /** Returns the command */
  public int    getCmd()  { return cmd; }
}
