package neosim.util;

import neosim.neuroml.*;
import neosim.iface.*;
import neuroml.sim.run.*;


// Why is this in the util package???

/**
 * Neuroml converter
 * utility functions that allows Neosim to communicate with NeuroML modules
 *
 * @author Paul Rogister
 * @date Aug 2001
 */
public class NeuromlConverter {

    /** Converts RunnableCellFactory
     */
    public static EntityClass convertEntityClass(RunnableCellFactory rFactory) {
	NeosimEntityClassImpl convertedClass = new NeosimEntityClassImpl(rFactory);
	return convertedClass;
    }

    /** Converts SourceMethod
     */
    public static neosim.iface.SourceMethod convertSourceMethod(neuroml.sim.run.SourceMethod sMethod) {
	NeosimSourceMethodImpl convertedClass = new NeosimSourceMethodImpl(sMethod);
	return convertedClass;
    }

    /** Converts DestMethod
     */
    public static neosim.iface.DestMethod convertDestMethod(neuroml.sim.run.DestMethod sMethod) {
	NeosimDestMethodImpl convertedClass = new NeosimDestMethodImpl(sMethod);
	return convertedClass;
    }

    /** Converts RunnableControl
     */
    public static ControlModule convertControlModule(RunnableControl rControl) {
	NeosimControlModuleImpl convertedClass = new NeosimControlModuleImpl(rControl);
	return convertedClass;
    }
}
