package neosim.util;

import neosim.iface.*;
import neosim.implementation.*;
import java.io.Serializable;
import java.util.Hashtable;

/**
 * PopulationJar is used to get and initialize a PopulationBuilderImpl from a jar file
 */
public interface PopulationJar extends java.io.Serializable {
   
    /**
     * init allows passing the hashtable of parameters to the constructor
     */
    public void init(String name,  PopulationNode parent, int size, EntityClass ec, 
		     EntityInit ei, Hashtable params);

    /**
     * getProjection returns the GeneralProjectionImpl from the jar file
     */
    public Population getPopulation();
}
