
package neosim.util;

import neosim.kernel.*;
import neosim.util.*;
import neosim.iface.*;
import java.util.*;
import java.beans.*;


/**
 * Load a java bean from a .jar file
 *
 * @author Fred Howell      
 *
 * @version 1.0, 18 Octobre 2000     
 *                 
 */
public class ProjJarBean implements DoOnBean {
    String name;
    Hashtable params;
    String srcPop;
    short outPort;//PortID
    String destPop;
    short inPort;//PortID
    Time delay;

    ProjectionJar pj;
    public ProjJarBean(String name, String srcPop, short outPort, String destPop, short inPort, //PortID outPort //PortID inPort
		       Time delay,Hashtable params) {
	this.name = name;
        this.params = params;
	this.srcPop = srcPop;
	this.outPort = outPort;
	this.destPop = destPop;
	this.inPort = inPort;
	this.delay = delay;
    }
    public void action(JarInfo ji, BeanInfo bi, String beanName) {
        System.out.println("Running template "+beanName);
        pj = (ProjectionJar)ji.getInstance(beanName);
	pj.init(name, srcPop, outPort, destPop, inPort, delay, params); 
    }

    public ProjectionJar getProjectionJar() { return pj; }
    public void error(String msg) {
        System.out.println("Start bean error "+msg);
    }
    public void error(String msg, Exception ex) {
        System.out.println("Start bean exception "+msg);
   }
}
