package neosim.util;

import neosim.iface.*;
import neosim.implementation.*;
import java.io.Serializable;
import java.util.Hashtable;

/**
 * ProjectionJar is used to get and initialize a GeneralProjectionImpl from a jar file
 */
public interface ProjectionJar extends java.io.Serializable {
   
    /**
     * init allows passing the hashtable parameters to the GeneralProjectionImpl constructor
     */
    public void init(String name, 
		     String srcPop, short outPort, String destPop, short inPort, //PortID outPort//PortID inPort
		     Time delay, Hashtable params);
    /**
     * getProjection returns the GeneralProjectionImpl from the jar file
     */
    public ProjectionImpl getProjection();
}
