/*
 * LinkedListSrcPort.java
 *
 * Created on 11 February 2005, 17:10
 */

package neosim.util.SmallLists;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class LinkedListSrcPort_Out extends LinkedList {
    LinkedListSrcPort_Out next=null;  
    LinkedListDestPort_Out Array[];
    
    short srcPortID;   
    
    /** Creates a new instance of LinkedListSrcPort */
    public LinkedListSrcPort_Out(short srcPortID) {
        this.srcPortID=srcPortID;
        Array=new LinkedListDestPort_Out[this.ListSize];        
        LinkedList.TotalMemoryLinkedLists+=this.getSize();        
    }
    
    public synchronized void compress() {
        for(int i=0;i<RealIndex_read;i++){
	    if(Array[i]!=null)
            	Array[i].compress();
        }
        if(next!=null)
            next.compress();        
    }
    
    public synchronized int addOutConnection(short destPort, int srcID){
        for(int i=0;i<RealIndex_read;i++){
              if(Array[i]!=null&&Array[i].getID()==destPort){
                  return Array[i].addOutConnection(srcID);
              }
          }
          if(RealIndex_read==this.ListSize){
              if(next==null)
                next=new LinkedListSrcPort_Out(srcPortID);
              return next.addOutConnection(destPort, srcID); 
          }
          else{
              Array[RealIndex_read]=new LinkedListDestPort_Out(destPort);
              return Array[RealIndex_read++].addOutConnection(srcID);
          }                
    }      
    
    public short getID(){
        return srcPortID;
    }     
    
    public int getSize() {
        return 28+Array.length<<2;
    }
    
    public void compress_final() {
        LinkedListSrcPort_Out stuff=this;
        short MaxPortIn=-1;
        short current;
        int TotalLength=0;
        do{
            for(int i=0;i<stuff.RealIndex_read;i++){
                if(stuff.Array[i]!=null){
                    current=stuff.Array[i].getID();
                    if(current>MaxPortIn)
                        MaxPortIn=current;
                }
            }
            TotalLength+=stuff.getSize();
            stuff=stuff.next;
        }while(stuff!=null);
        
        LinkedListDestPort_Out[] NewArray=new LinkedListDestPort_Out[MaxPortIn+1];
        
        stuff=this;
        do{
            for(int i=0;i<stuff.RealIndex_read;i++){
		if(stuff.Array[i]!=null)
	                NewArray[stuff.Array[i].getID()]=stuff.Array[i];
            }
            stuff=stuff.next;
        }while(stuff!=null);
        
        
        Array=NewArray;
        this.ListSize=MaxPortIn+1;
        LinkedList.TotalMemoryLinkedLists=getSize()+LinkedList.TotalMemoryLinkedLists-TotalLength;
        next=null;
        this.RealIndex_read=ListSize;

        for(int i=0;i<RealIndex_read;i++){
            if(Array[i]!=null)
                Array[i].compress_final();
        }        
    }
    
    public int NumberPerPort(short inport) {//dont care about the port
        int k=0;
        LinkedListSrcPort_Out stuff=this;
        do{
            for(int i=0;i<stuff.Array.length;i++ ){
                if(stuff.Array[i]!=null)
                    k+=stuff.Array[i].NumberPerPort();
            }
            stuff=stuff.next;
        }while(stuff!=null);
        return k;
    }  
    
    public void  deleteInConnection(short destPortID, int srcID) {//ConnectionID cid
         //neosim.kernel.Deadlock_Message ecp=new neosim.kernel.Deadlock_Message();
         //neosim.kernel.DeadlockTracker.LockDeadlockTracker(this,ecp);  
         Array[destPortID].deleteInConnection(srcID);
         //neosim.kernel.DeadlockTracker.UnLockDeadlockTracker(ecp);
    }    
    
    public synchronized int[][] getOutConnection(short destPortID){//don't care about the port
        int [][]TempArray=new int[Array.length][];
        for(int i=0;i<Array.length;i++){
            if(Array[i]!=null)
                TempArray[i]=Array[i].getOutConnection();
        }
        return TempArray;
    }
}
