/**
 * Basic JAR loader - no entities, just a script reader
 */

package neosim.util.loaders.jarload;

import neosim.iface.*;
import neosim.implementation.*; 
import neosim.util.*; 
 
/** Loads a script reader from a JAR file
 */
public final class Jarload extends BasicApp {
    static boolean debug = false;

    /** Remove 1st string from array */
    static String[] trunc(String[] a1) {
        int newlength = a1.length-1; if (newlength<0) return null;
        String[] answer = new String[newlength];
        for (int i=0; i<newlength; i++) { answer[i] = a1[i+1]; }
        return answer;
    }
 
    /** Get and run script reader from URL 
     */
    public static void getScriptReader(String args[]) {
        try {      
            ScriptBean sb = new ScriptBean(trunc(args));
            if (debug) System.out.println("Getting script from ... "+args[0]);
            JarLoader.loadJarDoOnBean(args[0], sb);
            if (debug) System.out.println("Script completed OK");
        } catch (Exception e) {
            System.out.println("Jarloader exception: "+e);
	    e.printStackTrace();
        }      
    }

    public static void main(String args[]) {
	System.out.println("=== NEOSIM - testing jar loader === " + args[0]);
	String[] others = trunc(args);
	for (int i=0; i<others.length; i++) { 
	    System.out.println(" arg "+i+": "+others[i]);
	}
        getScriptReader(args); 
    }
}

