package neuroml.core;


/**
 * Interface for collections and references to implement if
 * they have a default class.
 * @see neuroml.core.Set, neuroml.core.Ref
 */
public interface ContentRestricted {

    /** Returns the class name.  Elements of the 
     * set must be instances or subclasses of this.
     * @return the class name (fully qualified unless the system knows the path)
     */
    public String getContentClassName();

    /** Sets the class name of elements in this set
     * @param s the class name (fully qualified unless the system knows the path)
     */
    public void setContentClassName(String s);
}
