package neuroml.core;

/**
 * A numeric double value with specified units.
 */
public class DValue {
    String name="";

    public double value;
    public Ref unit;

    public DValue() { 
	this(0.0, "null"); 
    }

    /** Constructor for double values, e.g.<b>
     * DValue length = new DValue(1.2,"m");
     */
    public DValue(double v, String unitName) { 
	value = v;
	unit = new Ref("Unit");
	unit.setTargetName( unitName );
    }

    public String getName() { return name; }
    public void setName(String n) { name = n; }    

    public double getValue() { return value; }
    public void setValue(double v) { value=v; }    

    public Ref getUnitRef() { return unit; }
}
