
package neuroml.core;

/**
 * A probability density function for a gamma distribution
 * with parameters location, scale and shape .
 *<P>
 * see eg 
 *<a href="http://www.itl.nist.gov/div898/handbook/eda/section3/eda366b.htm">
 *www.itl.nist.gov</a>   
 */
public class GammaPDF extends PDF {
    public double location;
    public double scale;
    public double shape;

    public GammaPDF() {
	this("gamma",0,1,1);
    }
    public GammaPDF(String rngName, double location, double scale, 
		    double shape) { 
	super(rngName);
	this.location = location;
	this.scale = scale;
	this.shape = shape;
    }

}
