package neuroml.core;

/** A reference to a module, 
 * with parameters.
 */
public class ModuleRef extends NamedObject {

//MODULE--JAG    public Ref module = new Ref("Module");

    /** The parameters can now be extracted by making a
     * copy of the module's "moduleObject"
     */
    public Object parameters = null;
       
    /*
     * Must be specified in order to get the interfaces/superclass to be implemented
     * So to speak Classes such as neurom.model.cell.ModuleNeuron which contain a field ModuleRef module must include explicity:
     *
     *     module.setName(getClass().getName()+"."+"module");
     *     where module is the name of the field.
     *
     */
    private String Name;
    public void setName(String str){Name=str;}
    public String getName(){return Name;}

    public ModuleRef() {
        super("Module");//JAG
//MODULE--JAG        module = new Ref("Module");
    }

    public ModuleRef(String name) {
	super(name);
//MODULE--JAG        module = new Ref("Module");
        Name=new String(getClass().getName());
    }
    public ModuleRef(String name, String moduleType) { 
	super(name);
//MODULE--JAG	module = new Ref(moduleType);
        Name=new String(getClass().getName());
    }
    public ModuleRef(String name, String moduleType, String target) { 
	super(name);
//MODULE--JAG	module = new Ref(moduleType,target);
        Name=new String(getClass().getName());
    }
}
