/*
 * NeuromlArray.java
 *
 * Created on 09 July 2004, 11:44
 */

package neuroml.core;
import java.util.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class NeuromlArray extends neuroml.core.Set {
    static public final int BOOLEAN=0;
    static public final int STRING=1;
    static public final int INTEGER=2;
    static public final int UNKNOWN_TYPE=-1;
    static public final int FLOAT=3;
    static public final int DOUBLE=4;
        
    public int NbColumns=0;
    public int NbLines=0;
    protected Object defaultValue;
    protected int type;

    /** Creates a new instance of NeuromlArray */
    public NeuromlArray() {
     
    }
    
    public NeuromlArray(int NbColumns, int NbLines, Object defaultValue) {
        this.NbColumns=NbColumns;
        this.NbLines=NbLines;
        setDefaultValue(defaultValue);
        if(defaultValue instanceof String)
            type=this.STRING;
        else if(defaultValue instanceof Boolean)
            type=this.BOOLEAN;
        else if(defaultValue instanceof Integer)
            type=this.INTEGER;
         else if(defaultValue instanceof Double)
            type=this.DOUBLE;
         else if(defaultValue instanceof Float)
            type=this.FLOAT;
        else
            type=this.UNKNOWN_TYPE;
        if(type==this.STRING||type==this.UNKNOWN_TYPE){    
            try {
                for(int j=0;j<NbLines;j++){
                    for(int i=0;i<NbColumns;i++){
                        elements.addElement(defaultValue.getClass().newInstance());
                    }
                }
            }
            catch(Exception exp){
                exp.printStackTrace();
            }
        }
        else if(type==this.BOOLEAN){  
            for(int j=0;j<NbLines;j++){
               for(int i=0;i<NbColumns;i++){
                    elements.addElement(new Boolean(((Boolean)defaultValue).booleanValue()));
                }
            }
        }
        else if(type==this.INTEGER){  
            for(int j=0;j<NbLines;j++){
               for(int i=0;i<NbColumns;i++){
                    elements.addElement(new Integer(((Integer)defaultValue).intValue()));
                }
            }
        }
        else if(type==this.DOUBLE){  
            for(int j=0;j<NbLines;j++){
               for(int i=0;i<NbColumns;i++){
                    elements.addElement(new Double(((Double)defaultValue).doubleValue()));
                }
            }
        }
        else if(type==this.FLOAT){  
            for(int j=0;j<NbLines;j++){
               for(int i=0;i<NbColumns;i++){
                    elements.addElement(new Float(((Float)defaultValue).floatValue()));
                }
            }
        }
    }
    public final Object getValue(int NbLines,int NbColumns){
        return elements.elementAt(NbLines*this.NbColumns+NbColumns);
    }
    public final void setValue(int NbLines,int NbColumns,Object muche){
        elements.setElementAt(muche, NbLines*this.NbColumns+NbColumns);
    }
    
    public final void setNbColumn(int NbColumns){
        try {
            int m=NbColumns;
            Vector<Object> v2=new Vector<Object>();
            for(int j=0;j<NbLines;j++){
                for(int i=0;i<m;i++){
                    if(i<this.NbColumns){
                        v2.addElement(this.elementAt(this.NbColumns*j+i));
                    }
                    else{
                        if(type==this.BOOLEAN){                         
                            v2.addElement(new Boolean(((Boolean)defaultValue).booleanValue()));
                        }
                        else if(type==this.INTEGER){  
                            v2.addElement(new Integer(((Integer)defaultValue).intValue()));
                        }
                        else if(type==this.DOUBLE){  
                            v2.addElement(new Double(((Double)defaultValue).doubleValue()));
                        }
                         else if(type==this.FLOAT){  
                            v2.addElement(new Float(((Float)defaultValue).floatValue()));
                        }
                        else if(type==this.STRING||type==this.UNKNOWN_TYPE){
                            v2.addElement(defaultValue.getClass().newInstance());
                        }
                    }
                }
            }
            elements=v2;
            this.NbColumns=NbColumns;
        }
        catch(Exception exp){
            exp.printStackTrace();
        }    
    }
    
    public final void setNbLines(int NbLines){
         int n,m;
         
         if(NbLines<this.NbLines){
             m=this.NbLines*NbColumns-NbLines*NbColumns;
             for(n=0;n<m;n++)
                 elements.remove(elements.size()-1);
         }
         else{
             try{
                m=NbLines*NbColumns-this.NbLines*NbColumns;
                for(n=0;n<m;n++)
                    if(type==this.BOOLEAN){                         
                        elements.addElement(new Boolean(((Boolean)defaultValue).booleanValue()));
                    }
                    else if(type==this.INTEGER){  
                        elements.addElement(new Integer(((Integer)defaultValue).intValue()));
                    }
                    else if(type==this.DOUBLE){  
                         elements.addElement(new Double(((Double)defaultValue).doubleValue()));
                    }
                    else if(type==this.FLOAT){  
                         elements.addElement(new Float(((Float)defaultValue).floatValue()));
                    }
                    else if(type==this.STRING||type==this.UNKNOWN_TYPE){
                        elements.addElement(defaultValue.getClass().newInstance());
                    }
             }
             catch(Exception exp){
                exp.printStackTrace();
             } 
         }
         this.NbLines=NbLines;
    }

    public final void setDefaultValue(Object defaultValue){
        this.defaultValue=defaultValue;
         if(defaultValue instanceof String)
            type=this.STRING;
        else if(defaultValue instanceof Boolean)
            type=this.BOOLEAN;
        else if(defaultValue instanceof Integer || defaultValue instanceof Short)
            type=this.INTEGER;
        else if(defaultValue instanceof Float)
            type=this.FLOAT;
        else if(defaultValue instanceof Double)
            type=this.DOUBLE;
        else
            type=this.UNKNOWN_TYPE;
    }
    
    public final int getNbColumn(){
        return NbColumns;
    }
    public final int getNbLines(){
        return NbLines;
    }
    
    public String getTitleColumn(int i){
        return new String(""+i);
    }
    public String getTitleLines(int i){
            return new String(""+i);
    }
    public boolean getEditNbColumns(){
        return true;
    }
    public boolean getEditNbLines(){
        return true;
    }
    public Object getDefaultValue(){
        return defaultValue;
    }
    
}
