package neuroml.core;

/**
 * An orientation
 */
public class Orientation extends NamedObject {

    public DValue rho   = new DValue(0,"radians");
    public DValue theta = new DValue(0,"radians");
    public DValue phi   = new DValue(0,"radians");

    public Orientation() { 
	this(0.0, 0.0, 0.0); 
    }

    /** Constructor for orientation, given rho,theta, phi
     */
    public Orientation(double rho, double theta, double phi) { 
	this.rho.setValue( rho );
	this.theta.setValue( theta );
	this.phi.setValue( phi );
    }
}
