package neuroml.environment.schedule;
 
import neuroml.core.*;
 
/** Top level class for NeuroML Environment definition<br>
 * The environment defines the inputs and outputs applied 
 * to the simulated model as well as the simulation schedule<p>
 *
 */
public class SchedulePkg extends Pkg {
 
    /** The simulation schedule
     */
    public Schedule schedule = new Schedule();

    /** A list of classes defined here
     * Used by the Namespace
     * @see neuroml.util.Namespace
     */
    public static String[] getClassList() { 
	String[] ret = { 
	    "SchedulePkg",
	    "ControlModule",
	    "Schedule",
	    "ControlledSchedule"
	};
	return ret;
    }
}





