/*
 * ChannelMeasurement.java
 *
 * Created on 12 October 2004, 18:02
 */

package neuroml.model.MeasurementTool;
import neuroml.model.MeasurementTool.*;
import neuroml.util.module.*;
import neuroml.sim.run.*;
import neuroml.core.*;
import neuroml.model.ions_channel.*;
import neuroml.model.cell.*;
import neuroml.util.*;


/**
 *
 * @author  Jean-Alain Grunchec
 */
public class ChannelIntensityMeasurement extends MeasurementTool implements Clonable {
    public int IndexChannel=0;
    public Ref NeuronRef=null;
    /** Creates a new instance of ChannelMeasurement */
 
    public ChannelIntensityMeasurement() {
        super();   
        NeuronRef = new Ref("AbstractNeuron");
    }

    public ChannelIntensityMeasurement(String str){
        super();
        NeuronRef = new Ref("AbstractNeuron");
	NeuronRef.setTargetName(str);
    }

    public double getValue(RunnableCell obj, double t){
       BasicChannelCell bscc=((BasicChannelCell)obj);
       return bscc.getChannel(IndexChannel).getChannelCurrent(bscc.getVoltage(t)); //getChannelIntensity(IndexChannel);
    }
    public String toString(){
        String toAdd=new String();
        if(this.ToBeSent)
            toAdd=new String("");
        else
            toAdd=new String("NOT_");
            
        try{
            AbstractNeuron obj=(AbstractNeuron)NeuromlSys.getNewestNamespace().deRef(NeuronRef);          
            BasicChannelCellFactory factory=(BasicChannelCellFactory)((ModuleNeuron)obj).module.parameters;
            Object o=factory.Channels.elementAt(IndexChannel);
            Object obj2=((ModuleChannel)o).module.parameters;
            String str=obj2.getClass().getName();
            int i=str.lastIndexOf('.');
            if(i>0) 
                 str=str.substring(i+1);
            return toAdd+str;
        }
        catch(Exception e){
        }
        String str=this.getClass().getName();
        int i=str.lastIndexOf('.');
        if(i>0) 
            str=str.substring(i+1);
        return toAdd+str+"_"+IndexChannel;               
    }
    public String getXUnit(){
        return "Time(s)";
    }
    public String getYUnit(){
        return "Intensity(A)";
    }    
    
    public Object Clone() {
        ChannelIntensityMeasurement truc=new ChannelIntensityMeasurement();
        truc.IndexChannel=this.IndexChannel;
        truc.NeuronRef=this.NeuronRef;
        return truc;
    }        
}
