package neuroml.model.cell;

import neuroml.core.*;
import neuroml.model.channel.*;

/** Top level compartmental neuron
 */
public class CableNeuron extends AbstractNeuron {
 
    public NeuronStructure structure = new NeuronStructure();

    /** Masks define greyscale masks for labelling parts of the neuronstructure 
     */
    public Set masks = new Set("Mask");

    /** Channel assignments associate channels with the mask densities
     */
    public List channelAssignments = new List("ChannelAssignment");

    public CableNeuron() {
    }

    public CableNeuron(String name) { 
	super(name);
    }
}

