package neuroml.model.cell;

import neuroml.core.*;
import neuroml.model.channel.*;

/** An oriented substructure.<p>
 * Has a NeuronStructure, an orientation and an attachment point
 */
public class OrientedSubstructure extends NamedObject {
    
    /*
     * A reference to the subtree
     */
    public Ref structureRef = new Ref("NeuronStructure");

    /*
     * The attachment to the parent, in the range 0-1
     */
    public DValue attachmentPoint = new DValue(0.0, "ratio");

    /*
     * Orientation of this substructure in relation to the
     * parent orientation
     */
    public Orientation orientation = new Orientation();

    public OrientedSubstructure() {
    }

    public OrientedSubstructure(String name) { 
	super(name);
    }

}
