package neuroml.model.channel;

import neuroml.core.*;

/** Used by ionic concentration pools to provide information about
  * the object providing an ionic current.
  * @author David Beeman, University of Colorado, Boulder
  */
public class CurrentSource extends NamedObject {

    /** The source of the ionic current, normally a subclass of Channel.
     */
    public Ref source = new Ref("Channel");

    /** The fraction of the ionic current that is provided to the pool.
	(default value = 1.0)
	 */
    public double fraction = 1.0;

    public CurrentSource() {
    }

    public CurrentSource(String name) {
        super(name);
    }
}
