package neuroml.model.network;

import neuroml.core.*;

/** 
 * A specification of a connection to make between
 * two elements
 */
public class Connection extends Projection {

    public Connection(){
	setName("");
    }
 
    /** Name of the source output
     * ?? the best way to do it ??
     */
    public String sourcePort = new String();    

    /** Name of the dest input
     * ?? the best way to do it ??
     */    
    public String destPort = new String();

    /** Delay on this connection
     */
    public DValue delay  = new DValue(1.0,"ms");

    /** Weight of this connection
     */
    public DValue weight = new DValue(1.0,"");
    
    public void copy(Connector pr){
        Connection prt=(Connection) pr;
        this.destPort=new String(prt.destPort);
        this.sourcePort=new String(prt.sourcePort);
        this.delay=new DValue(prt.delay.value,prt.delay.unit.getTargetName());
        this.weight=new DValue(prt.weight.value,prt.weight.unit.getTargetName());
    }
    public String TypeName(){
        return new String("Connection_del_"+delay.value+"_weight_"+weight.value);
    }
}
