package neuroml.model.network;

import neuroml.core.*;


/** An element reference can be put into a network's list of elements
 * (a population or reference to single element)
 */
public class ElementRef extends Model  {

    /** The class of objects to make. This 
     * is typically a reference to a cell description,
     * but can also be a Network
     */
    public Ref elementClass=new Ref("Element");

    public ElementRef() {}
    public ElementRef(String name) {super(name); }
    public ElementRef(String name, String elementClass) {
	super(name); 
	this.elementClass.setTargetName(elementClass);
    }
}
