package neuroml.model.network;

import neuroml.core.*;

/** A specification of a projection between two populations,
 * defined as a sourceMethod to run on each of the source elements and generate requests,
 * and a destMethod to run on wach of the target elements and consider requests.
 *
 * See also ModuleProjection which defines the projection in a single module
 * (rather than the combination of two)
 */
public class GeneralProjection extends Projection {
   
    /** The method to run on source population elements
     */
    public SourceMethod sourceMethod = new SourceMethod();

    /** The method to run on target elements
     */
    public DestMethod destMethod = new DestMethod();
    
    public GeneralProjection() {
        sourceMethod.setName(getClass().getName()+"."+"sourceMethod");        
        destMethod.setName(getClass().getName()+"."+"destMethod");
    }

    public GeneralProjection(String name) {
        super(name); 
        //not sure necessary here
        sourceMethod.setName(getClass().getName()+"."+"sourceMethod");        
        destMethod.setName(getClass().getName()+"."+"destMethod");
    }

    /** A utility constructor
     */
    public GeneralProjection(String name, 
			     String source, String dest) { //MODULE--JAG,String srcMethod, String dstMethod
	super(name,source,dest); 
//MODULE--JAG	setSourceMethodTargetName(srcMethod);
//MODULE--JAG	setDestMethodTargetName(dstMethod);
        //not sure necessary here
        sourceMethod.setName(getClass().getName()+"."+"sourceMethod");        
        destMethod.setName(getClass().getName()+"."+"destMethod");
    }

//MODULE--JAG    public void setSourceMethodTargetName(String s) {
//MODULE--JAG	sourceMethod.module.setTargetName(s);
//MODULE--JAG    }

//MODULE--JAG    public void setDestMethodTargetName(String s) {
//MODULE--JAG	destMethod.module.setTargetName(s);
//MODULE--JAG    }
    
     public void copy(Connector pr){
         GeneralProjection prt=(GeneralProjection)pr;
//MODULE--JAG         destMethod.module=new Ref(prt.destMethod.module.getContentClassName(),prt.destMethod.module.getTargetName());
         try{
            destMethod.parameters=prt.destMethod.parameters.getClass().newInstance();
         }
         catch(Exception e1){}
//MODULE--JAG         sourceMethod.module=new Ref(prt.sourceMethod.module.getContentClassName(),prt.sourceMethod.module.getTargetName());
         try{
            sourceMethod.parameters=prt.sourceMethod.parameters.getClass().newInstance();
         }
         catch(Exception e2){}
         
         //this.sourceMethod=((GeneralProjection)pr).sourceMethod;
     }
     
      public boolean IsEquivalent(Connector pr){
        if(pr.getClass()==this.getClass()){
            boolean toreturn=true;
            GeneralProjection prt=(GeneralProjection)pr;
/*MODULE--JAG            if(destMethod.module!=null&&prt.destMethod.module!=null){
                if(destMethod.module.getTargetName().compareTo(prt.destMethod.module.getTargetName())!=0)
                    toreturn=false;
                if(destMethod.module.getContentClassName().compareTo(prt.destMethod.module.getContentClassName())!=0)
                    toreturn=false;
            }
            else 
                return true;
            if(sourceMethod.module!=null&&prt.sourceMethod.module!=null){
                if(sourceMethod.module.getTargetName().compareTo(prt.sourceMethod.module.getTargetName())!=0)
                    toreturn=false;
                if(sourceMethod.module.getContentClassName().compareTo(prt.sourceMethod.module.getContentClassName())!=0)
                    toreturn=false;
            }
            else 
                return true;MODULE--JAG*/
            if(destMethod.parameters!=null&&prt.destMethod.parameters!=null){
                if(destMethod.parameters.getClass()!=prt.destMethod.parameters.getClass())
                    toreturn=false;
            }
            else 
                return true;          
            if(sourceMethod.parameters!=null&&prt.sourceMethod.parameters!=null){
                if(sourceMethod.parameters.getClass()!=prt.sourceMethod.parameters.getClass())
                    toreturn=false;
            }
            else 
                return true;             
            return toreturn;    
        }
        else if(destMethod.parameters==null||destMethod.parameters==null) //MODULE--JAG||sourceMethod.module==null||sourceMethod.parameters==null||
            return true;
        else
            return false;
    }
    /*public String TypeName(){
        /*String str1=sourceMethod.parameters.getClass().getName();
        str1=str1.substring(str1.lastIndexOf('.')+1);        
        String str2=destMethod.parameters.getClass().getName();
        str2=str2.substring(str2.lastIndexOf('.')+1);                
        return new String("GenPrj_"+str1+"_"+str2);
      
    }     */
}
