package neuroml.model.network;

import neuroml.core.*;

/** A specification of a projection between two populations
 * of <em>networks</em>.<p>
 * This needs two levels of projections:
 * <ul>
 * <li> a high level mapping - which subnetworks to connect
 * <li> a link type - how to connect two subnetworks
 * </ul>
 * The high level mapping IS this projection - 
 * the linktype is a member.
 */
public class HighLevelProjection extends Projection {
    
    /** The projection which defines connections
     * between two sub-networks. Should this be a Ref?
     */
    public Projection linktype = new Projection();

    public HighLevelProjection() {}
    public HighLevelProjection(String name) {super(name); }
}
