package neuroml.model.network;
 
import neuroml.core.*;
import neuroml.model.network.*;//put DestMethod in core...
/** Specification of a probe attachment
 *
 */
public class ModuleAttachment extends Attachment  {
    
    /** The method to run on target elements
     *  NB This used to be a ref to a dest method.
     * This runs of the thing being probed - and either 
     * adds an input or an output.
     */
    //public MethodRef method = new MethodRef();
    public DestMethod destMethod = new DestMethod();   
    public SourceMethod sourceMethod = new SourceMethod();
    
    public ModuleAttachment() {
        super();
        destMethod.setName(getClass().getName()+"."+"destMethod");
        sourceMethod.setName(getClass().getName()+"."+"sourceMethod");
    }
    public ModuleAttachment(String name) { 
        super(name); 
        destMethod.setName(getClass().getName()+"."+"destMethod");
        sourceMethod.setName(getClass().getName()+"."+"sourceMethod");
    }

    public ModuleAttachment(String name, 
			     String source) { //MODULE--JAG , String srcMethod
	super(name,source); 
//MODULE--JAG	setSourceMethodTargetName(srcMethod);
	
        //not sure necessary here
        sourceMethod.setName(getClass().getName()+"."+"sourceMethod");        
        destMethod.setName(getClass().getName()+"."+"destMethod");
    }
//MODULE--JAG   public void setSourceMethodTargetName(String s) {
//MODULE--JAG	sourceMethod.module.setTargetName(s);
//MODULE--JAG    }
   
    public void copy(Connector pr){
         ModuleAttachment prt=(ModuleAttachment)pr;
 //MODULE--JAG        destMethod.module=new Ref(prt.destMethod.module.getContentClassName(),prt.destMethod.module.getTargetName());
         try{
            destMethod.parameters=prt.destMethod.parameters.getClass().newInstance();
         }
         catch(Exception e1){}
 //MODULE--JAG        sourceMethod.module=new Ref(prt.sourceMethod.module.getContentClassName(),prt.sourceMethod.module.getTargetName());
         try{
            sourceMethod.parameters=prt.sourceMethod.parameters.getClass().newInstance();
         }
         catch(Exception e2){}
         
         //this.sourceMethod=((GeneralProjection)pr).sourceMethod;
     }
     
      public boolean IsEquivalent(Connector pr){
        if(pr.getClass()==this.getClass()){
            boolean toreturn=true;
            ModuleAttachment prt=(ModuleAttachment)pr;
/*MODULE--JAG             if(destMethod.module!=null&&prt.destMethod.module!=null){
                if(destMethod.module.getTargetName().compareTo(prt.destMethod.module.getTargetName())!=0)
                    toreturn=false;
                if(destMethod.module.getContentClassName().compareTo(prt.destMethod.module.getContentClassName())!=0)
                    toreturn=false;
            }
            else 
                return true;
            if(sourceMethod.module!=null&&prt.sourceMethod.module!=null){
                if(sourceMethod.module.getTargetName().compareTo(prt.sourceMethod.module.getTargetName())!=0)
                    toreturn=false;
                if(sourceMethod.module.getContentClassName().compareTo(prt.sourceMethod.module.getContentClassName())!=0)
                    toreturn=false;
            }
            else 
                return true;MODULE--JAG*/
            if(destMethod.parameters!=null&&prt.destMethod.parameters!=null){
                if(destMethod.parameters.getClass()!=prt.destMethod.parameters.getClass())
                    toreturn=false;
            }
            else 
                return true;          
            if(sourceMethod.parameters!=null&&prt.sourceMethod.parameters!=null){
                if(sourceMethod.parameters.getClass()!=prt.sourceMethod.parameters.getClass())
                    toreturn=false;
            }
            else 
                return true;             
            return toreturn;    
        }
        else if(sourceMethod.parameters==null||destMethod.parameters==null)//MODULE--JAG sourceMethod.module==null||||destMethod.module==null
            return true;
        else
            return false;
    }
  /*  public String TypeName(){
        String str1=sourceMethod.parameters.getClass().getName();
        str1=str1.substring(str1.lastIndexOf('.')+1);        
        String str2=destMethod.parameters.getClass().getName();
        str2=str2.substring(str2.lastIndexOf('.')+1);                
        return new String("ModAtta_"+str1+"_"+str2);
    }     */
}





