package neuroml.model.network;

import neuroml.core.*;

/** A projection specified in a module
 * See also GeneralProjection, which combines Source/Dest method modules
 */
public class ModuleProjection extends Projection {
    public ModuleRef module = new ModuleRef();//JAG "ProjectionModule"

    public ModuleProjection() { 
        module.setName(getClass().getName()+".module");
    }
    public ModuleProjection(String name) { 
        super(name); 
        module.setName(getClass().getName()+".module");
    } 
    
    public void copy(Connector pr){
         ModuleProjection prt=(ModuleProjection)pr;
//MODULE--JAG          module.module=new Ref(prt.module.module.getContentClassName(),prt.module.module.getTargetName());
         try{
            module.parameters=prt.module.parameters.getClass().newInstance();
         }
         catch(Exception e1){}
    }
    
    public boolean IsEquivalent(Connector pr){
        if(pr.getClass()==this.getClass()){
            boolean toreturn=true;
            ModuleProjection prt=(ModuleProjection)pr;
            
/*MODULE--JAG 
            if(module.module!=null&&prt.module.module!=null){
                if(module.module.getTargetName().compareTo(prt.module.module.getTargetName())!=0)
                    toreturn=false;
                if(module.module.getContentClassName().compareTo(prt.module.module.getContentClassName())!=0)
                    toreturn=false;
            }
            else 
                return true;MODULE--JAG */
           
            if(module.parameters!=null&&prt.module.parameters!=null){
                if(module.parameters.getClass()!=prt.module.parameters.getClass())
                    toreturn=false;
            }
            else 
                return true;          
                       
            return toreturn;    
        }
        else if(module.parameters==null) //MODULE--JAG  module.module==null||
            return true;
        else
            return false;
    }
    public String TypeName(){
        String str=module.parameters.getClass().getName();
        str=str.substring(str.lastIndexOf('.')+1);
        return new String("ModPrj_"+str);
    }         
}
