package neuroml.model.network;

import neuroml.core.*;


/** A network is a set of populations and a set of 
 * projections.
 */
public class Network extends ElementNetwork{ //Element {

    /** A network has a set of elements - can be populations or individual cells
     */
    public Set elements = new Set("Population");
    
    /** A network also defines a set of projections between elements
     */
    public Set projections = new Set("Projection");

    
        /** The set of probe definitions
     */
    public Set probes = new Set("Probe");

    /** The set of probe attachments
     */
    public Set attachments = new Set("Attachment");
    
    public Network() {this("");}
    public Network(String name) {
        super(name); 
        //JAG: some stuff dealing with the GUI
        elements.setName("elements");
        projections.setName("projections");
        probes.setName("probes");
        attachments.setName("attachments");
    }
}
