package neuroml.model.network;

import neuroml.core.*;

/** Top level class for networks
 */
public class NetworkPkg extends Pkg {
    public Ref MainNetwork=new Ref("Network",null);
    public NetworkPkg(){
    }
    public NetworkPkg(String name){
	super(name);
    }
    /** A set of networks in the package
     */
    public Set networks = new Set("Network");

    /** A set of cells in the package
     * Moved to list of models in parent package
     */
    //    public Set cells = new Set("CellElement");
 
    /** A set of source methods in the package
     * moved to list of Modules in NeuromlPkg
     */
    //   public Set sourceMethods = new Set("SourceMethod");

    /** A set of dest methods in the package
     */
    //    public Set destMethods = new Set("DestMethod");


    /** A list of classes defined here
     * Used by the Namespace
     * The order classes appear here can be important for C++ generation
     * @see neuroml.util.Namespace
     */
    public static String[] getClassList() { 
	String[] ret = { 
            "Connection",
            "DestMethod",
	    "DestMethodModule",
	    "Element",
	    "ElementRef",
            "EnumeratedDimension",
            "GeneralProjection",
            "Grid1DStructure",
	    "Grid3DStructure",
            "HighLevelProjection",
            "IndexedDimension",
            "IndexedStructure",
            "ModuleProjection",
	    "Network",
            "NetworkPkg",
            "Population",
            "PopulationStructure",
	    "Projection",
            "ProjectionModule",
	    "RawProjection",
            "RealPopulation",
	    "SourceMethod",
            "SubNetwork",
	    "SourceMethodModule",
            "Attachment",
            "ModuleAttachment",
            "ModuleProbe",
	    "Probe",
            "ProbeConnection",
            "ProbModule",
            "RawAttachment",
            "ModulePosition",
            "PositionModule"
	};
	return ret;
    }
}
