package neuroml.sim.run;

import neuroml.sim.state.*;

/** The interface a self-contained projection module implements.
 * An alternative is to specify a GeneralProjection with SourceMethod/
 * DestMethod Modules.
 *
 * See ModuleProjection.
 */
public interface BuildableProjection {
    /** Returns the source method
     */
    public SourceMethod getSourceMethod();

    /** Returns the dest method
     */
    public DestMethod getDestMethod(); 
}
