package neuroml.sim.run;

/** This is used by a SourceMethod as an interface to the system 
 * to send a connection request.
 */
public interface ConnectionRequestSender {

    /** Interface used by sendMethod to send a connection request,
     * @param cr connection request object (can include sourceData object)
     * @param dstID id of destination entity
     */
    public void sendRequest(ConnectionRequest cr, int dstID, boolean BuildingConnection); 

    /** Alternative form of sendRequest
     * @param cr connection request object
     * @param srcID id of source entity
     * @param srcPortID id of source port
     * @param dstID id of destination entity
     * @param dm method to run at receiving end
     */
    public void sendRequest(int srcID, short srcPortID, int dstID, DestMethod dm, boolean BuildingConnection); 
}
