package neuroml.sim.run;

import neuroml.sim.state.*;
import java.awt.Graphics2D;

/** The part of a general projection which runs on
 * a destination entity and decides to fulfill/deny
 * connection requests.
 */
public interface DestMethod  extends java.io.Serializable { 
    /** The considerRequest method checks the source entity's request
     * against the dest entity's details, and returns True or False
     * depending on whether or not the connection will be made. 
     *
     * @param cm the simulator's connection maker. Call this to actualle make a connection.
     * @param dstState the destination entity's state
     * @param cr the connection request from the source entity
     * @return true if a connection made, false otherwise.
     */
    public boolean considerRequest( ConnectionMaker cm, 
				    ElementState dstState, 
				    ConnectionRequest cr, boolean BuildingConnection );  

    /** Return the destination input port ID
     * @return the destination input port ID
     */
    public short getDstPortID();
    public void Draw(Graphics2D g, double x, double y);
}
