package neuroml.sim.run;  

/** An interface an object implements if it can respond to a NamedQuery
 * @see NamedQuery, Queryable
 */
public interface NamedQueryable {
    /** Returns the results of running a named query q on this object.
     * Usually implemented as something like 'if ("getsize".equals(q)) { return size(); }'
     *
     * @param q the query to run on this object
     * @param p any parameters of the query
     * @return the result of the query
     */
    public Object queryByName(String q, Object p);
}
