package neuroml.sim.run;  

/** An interface for cells with synapses to implement.
 * Derived projections can call this to set the synapse 
 * weight for a cell's connection.
 */
public interface SynapseWeightSettable {
    /** Set the weight for synapse corresponding to connection cid
     * @param cid the connection ID
     * @param w the weight
     */
    public void setSynapseWeight( int cid, double w );
}
