/** Load a java class from a jar file
 */

package neuroml.util;

import java.util.*;
import java.beans.*;

/**
 * Load a java class from a .jar file
 *
 * @author Fred Howell      
 *
 * @version 1.0, 18 October 2000     
 *                 
 */
public class ClassBean implements DoOnBean {
    String name;
    Class c;
    static boolean debug = true;
    public ClassBean(String name) {
	this.name = name;
    }
    public void action(JarInfo ji, BeanInfo bi, String beanName) {
        if (debug) { System.out.println("NeuroML Module Loader Loading Class "+beanName); }
        c = ji.getBeanClass(beanName);
    }
    public Class getBeanClass() { return c; }
    public void error(String msg) {
        System.out.println("NeuroML Module Loader error "+msg);
    }
    public void error(String msg, Exception ex) {
        System.out.println("NeuroML Module Loader exception "+msg);
   }
}
