package neuroml.util;

/** A class for static display hints
 * e.g. min/max
 *
 * to add hints to a field "public int myfield" to say the default range should be 32-1024,
 * add a static field:
 *    public static DisplayHints myfieldHints = new DisplayHints(32,1024);
 *
 * This is typically used by a GUI to present a slider
 */
public class DisplayHints {
    double min, max;
    boolean rangeFixed;

    public DisplayHints() {
	this(0,100);
    }

    public DisplayHints( double min, double max, boolean fixed ) { 
	this.min = min; 
	this.max = max;
	this.rangeFixed = fixed;
    }

    public DisplayHints( double min, double max ) { 
	this( min,max,false);
    }

    public double getMin() { return min; }
    public double getMax() { return max; }

    public boolean isRangeFixed() { return rangeFixed; }
}
