/** Load a java bean from a jar file
 */

package neuroml.util;

import neuroml.sim.run.*;
import java.util.*;
import java.beans.*;

/**
 * Load a java bean from a .jar file
 *
 * @author Fred Howell      
 *
 * @version 1.0, 18 October 2000     
 *                 
 */
public class SimulatorBean implements DoOnBean {
    String name;
    String beanName;
    Simulator o;
    static boolean debug = true;
    public SimulatorBean(String name) {
	this.name = name;
    }
    public void action(JarInfo ji, BeanInfo bi, String beanName) {
        if (debug) { System.out.println("NeuroML Module Loader Loading "+beanName); }
        Object obj = ji.getInstance(beanName);
        if (debug) { System.out.println("NeuroML Module Loaded "+obj); }
	if (obj instanceof neuroml.sim.run.Simulator) {
	    o = (neuroml.sim.run.Simulator)obj;
	} else System.out.println("NeuroML Module not a Simulator "+obj);
	this.beanName = beanName;
    }
    public Simulator getSimulator() { return o; }
    public String getBeanName() { return beanName; }
    public void error(String msg) {
        System.out.println("NeuroML Module Loader error "+msg);
    }
    public void error(String msg, Exception ex) {
        System.out.println("NeuroML Module Loader exception "+msg);
   }
}
