package neuroml.util.axiope;

/** 
 * A generic interface to find an ObjectAccessor given the
 * class/form name. This is a generalisation of Class.forName
 * which will work on other implementations of Object trees.
 */
public interface AccessorFinder {

    /** Return an ObjectAccessor given a type.
     * A sample implementation could wrap up class Class
     * @param o the object whose accessor needs finding
     */
    public ObjectAccessor getAccessor(Object o);
}

