package neuroml.util.axiope;

/** 
 * An interface a Field provides to extract a field value out of
 * an object.
 */
public interface ValueAccessor {

    /** Return the name of this field
     */
    public String getName();

    /** Return the declared type of this field
     * e.g. "URLString" or "[String" for list of String
     */
    public String getType();

    /** If this field type is a list, return the element type
     */
    public String getElementType();

    /** Return the value of this field
     * @param o the object to extract the value from
     */
    public Object getValue(Object o);
}

