/**
 * Neuroml dest method - fulfill all
 */

package neuroml.util.module;

import neuroml.sim.run.*;
import neuroml.sim.state.*;

 
/** Fulfills all requests, makes basic connection
 * Note that this class goes in a module, so the public fields are parameters
 * in the NeuroML file.
 */
public class BasicDestMethod implements DestMethod, Cloneable {

    /** Fixed dstPort (module parameter)
     */
    public short dstPort=1;

    /** Fixed connection delay (module parameter)
     */
    public double delay=1.0;
   
    static private boolean debug = true;

    /** There has to be a null constructor, as this class
     * will go in a loadable module
     */
    public BasicDestMethod() {	
    }

    public double getDelay() { return delay; }

    public short getDstPortID() { return dstPort; }
    
    public boolean considerRequest( ConnectionMaker cm, 
				    ElementState target, 
				    ConnectionRequest cr, boolean BuildingConnection ) {	

	/** Here we could compare source info to target info to
	 * decide on parameters of connection
	 */

	/** The connection maker returns a unique ID for this connection
	 * which can be used to store any extra info on the connection 
	 * (e.g. weight)
	 */
	int cid = cm.makeConnection(dstPort, delay,BuildingConnection);
	
	/** Call method on target cell to set any extra parameters
	 * *********************** FIXME ********************
	 */
	if (target instanceof RunnableCell) {
	    ((RunnableCell)target).setInputConnectionParameters( cid, this, cr );
	}  
	
	// If >0 connections made
	return true;
    }      
    
    public void Draw(java.awt.Graphics2D g, double x, double y) {
    }
    
}
