package neuroml.util.module;

import neuroml.core.NamedObject;
import neuroml.sim.run.*;
import neuroml.sim.state.*; 
 
import java.util.*;

/**
 * A basic implementation of a PopulationState as a list of element IDs
 */
public class BasicPopulationState extends BasicElementState implements PopulationState {     

    java.util.List<Integer> eids; // List of IDs
    java.util.List<String> enames; // List of elem names

    public BasicPopulationState() { 
	super();
	eids = new ArrayList<Integer>();
    }
    public int getNumElements() { return eids.size(); }
    public int getIndex(int elementID) { return eids.indexOf( new Integer(elementID) ); }
    public int getElementID(int index) { return ((eids.get(index))).intValue(); }
    public boolean isMember(int elementID) {
	return getIndex(elementID) != -1; // Check this.
    }
    public java.util.List<Integer> getElementIDs() { return eids; }
    public java.util.List<String> getElementNames() { return enames; }; 

    public void addElement(int elementID, String name) {
	eids.add(new Integer(elementID));
	enames.add(name);
    }
    
    
}
