package neuroml.util.schema;

import neuroml.core.*; 
import neuroml.util.*; 

import neuroml.util.axiope.*;

/** 
 * NeuromlSchema version of a "Class"
 * Updated Aug 2002 to implement axiope object accessor
 */
public class NeuromlClass extends NamedObject implements ObjectAccessor {

    /** base is equivalent to "extends" for derived classes */
    public String base = null;

    /** desc is an optional comment */
    public String desc = null;

    /** The set of fields in this class */
    public Set fields = new Set("neuroml.util.schema.NeuromlField");
    
    public NeuromlClass() {}
    public NeuromlClass( String n ) { name = n; }

    public NeuromlClass deepCopy() {
	NeuromlClass ret = new NeuromlClass(name);
	for (int i=0; i<fields.size(); i++) {
	    ret.fields.add( ((NeuromlField)fields.getElements().elementAt(i)).deepCopy() );	
	}
	return ret;
    }

    ValueAccessor[] vax = null;

    /** Implementation of ObjectAccessor - returns array of ValueAccessor 
     * (i.e. NeuromlField)
     */
    public ValueAccessor[] getValueAccessors() {
	if (vax==null) {
	    vax = new ValueAccessor[fields.size()];
	    for (int i=0; i<fields.size(); i++) {
		NeuromlField nf = (NeuromlField) fields.getElements().get(i);
		nf.setIndex(i);
		vax[i] = nf;
	    }
	}
	return vax;
    }    
}

