/*
 * NMLPlay_2.java
 *
 * Created on 28 May 2004, 12:20
 */
package nmlplay;

import guikit.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import javax.swing.plaf.BorderUIResource.*;
import java.io.*;

import neuroml.*;
import neuroml.util.*;
import neuroml.core.*;
import neuroml.environment.io.*;
import neuroml.model.network.*;
import neuroml.sim.run.*;

import java.net.URL;
import guikit.*;
import neosim.implementation.*;
import neosim.util.loaders.nmllauncher.XML_Reader;
import java.net.*;

/**
 * @author  Jean-Alain Grunchec
 */
public class NMLPlay_2 extends guikit.NetworkDesigner implements PlayerCallBack {
    //NMLPlay Code>
    private Object id = null;
    static final byte STOPPED = 0;
    static final byte RUNNING = 1;
    static final byte PAUSED  = 2;
    private static final String VERSION = "v1.00, June 2004";
    private static final String AUTHOR  = "Holger Bringmann (hcb@lambdabase.de) Fred Howell (fwh@anc.ad.ac.uk) Jean-Alain Grunchec (jgrunche@informatics.ed.ac.uk) ";
    protected String      filename="(no file specified)";
    protected boolean     modelModified = false; 
    protected boolean     needsSaving = false;
    protected Simulator   simulator;
    protected double      t; 
    protected JScrollPane mainView;
    protected JTextArea console;
    protected JProgressBar progress;
    protected Byte state=new Byte(STOPPED);    
   // protected neosim.kernel.Semaphore Simulsem=new neosim.kernel.Semaphore();
    protected RunSim myRunSim=null;
    
    static ResourceBundle resources_NML;
    static {
    try {
            resources_NML = ResourceBundle.getBundle("nmlplay.resources/NMLPlay",  Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("nmlplay.resources/NMLPlay.properties not found");
        }
    }
    //<NMLPlay Code
    JPanel NetworkConsole=new JPanel(new BorderLayout());
    JPanel NMLPlayConsole=new JPanel();
    RunnableControl Rendering3D;
    
    protected boolean Edition=true;
    
    public NMLPlay_2(String frameName,String str) {
        super();
        neosim.util.loaders.nmllauncher.NeosimNeuroMLLauncher.Player=this;
        this.setName(frameName);
        this.setTitle(frameName);
        init();

        //NMLPlay Code>
        needsSaving = false;
        /*Object machin = ModuleLoader.getObject( resources_NML.getString("launcherURL"), "");
        if (machin instanceof Simulator) simulator = (Simulator) machin;
        else { System.out.println("Object from module is of class "+machin.getClass()); }  */
        //<NMLPlay Code
        
        try{
            URL[] urlsToLoadFrom = new URL[]{new URL(resources_NML.getString("launcherURL"))};// "C:\\GuiKit\\MyCVS\\guikit\\guikit\\ReshapeNetwork\\"
            URLClassLoader loader1 = new URLClassLoader(urlsToLoadFrom); 
            Class cls1 = Class.forName(resources_NML.getString("MainClass"), true, loader1); 
            neosim.util.loaders.nmllauncher.XML_Reader stuff=(neosim.util.loaders.nmllauncher.XML_Reader)(cls1.newInstance());
            simulator = stuff;
        }
        catch(Exception except){
            System.out.println("No class");
        }
        try{
                java.net.URL truc=NMLPlay_2.class.getResource(resources.getString("Neuron"));
                ImageIcon chose=new ImageIcon(truc);
                this.setIconImage(chose.getImage());
        }
        catch(Exception except){
            System.out.println("No icon");
        }
        createMenu();
	getContentPane().setLayout(new BorderLayout());
        getContentPane().add(NMLPlayConsole,BorderLayout.NORTH);
        getContentPane().add(NetworkConsole,BorderLayout.CENTER);
        NMLPlayConsole.setBorder(BorderFactory.createTitledBorder("Simulation controls"));
        String BasicModel;
        if(str!=null){
            BasicModel=str;
            System.out.println("trying to load "+str);
        }
        else
            BasicModel=System.getProperty("user.dir")+"/BasicModel.xml";
        Object o = NeuromlSys.loadXML(BasicModel);
	System.out.println("Loaded "+o);
        println("Loaded "+o);

	if(o!=null){
		if (o instanceof NeuromlPkg){
                    Namespace truv=NeuromlSys.getNamespace(BasicModel);
                    truv.setModuleRef(((NeuromlPkg)o).ImplementionModules.getElements());
                    ((NeuromlPkg)o).ImplementionModules.setElements(truv.getModuleRef());
                    Environment env = new Environment(truv , (NeuromlPkg)o, null );
                    SpecialEditors.setEnvironment(env);		
		}				    
		editObject( NeuromlSys.getNamespace(BasicModel), o );
	}
        
        //NMLPlay Code>
        if (topObject != null) {
            modelModified = true;
            //simulator.initKernel(NEOSIMSettings.kernelParms);
// INIT-RESET
//            simulator.initKernel(NEOSIMSettings.mySchedule.command.split(" "));
//            simulator.reset();

            t = 0;
            needsSaving = false;
        }
        //<NMLPlay Code 
    }

    public JMenuItem addCheckBoxMenuItem( JMenu parent, String name, String IconName, String desc, int m, boolean bool) {
        JCheckBoxMenuItem mi;
        if(IconName==null)
            mi = new JCheckBoxMenuItem(name,bool);
        else{
            java.net.URL myURL=getClass().getResource(resources.getString(IconName));
            ImageIcon myIcon=new ImageIcon(myURL);
            mi = new JCheckBoxMenuItem(name,myIcon,bool);
        }
	if (m!=-1) 
	    mi.setAccelerator(KeyStroke.getKeyStroke(m, ActionEvent.ALT_MASK)); 
        mi.getAccessibleContext().setAccessibleDescription(desc); 
	mi.addActionListener(this);
	parent.add(mi);
	return mi;
    }
       
    //NMLPlay Code>    
    private void addButton(JToolBar tb, JButton btn, String toolTip)
    {
        btn.setToolTipText(toolTip);
        btn.addActionListener(this);
        btn.setActionCommand(toolTip);
        btn.setBorderPainted(false);
        btn.setRolloverEnabled(true);
        btn.setFocusPainted(true);
        tb.add(btn);
    }  
    //<NMLPlay Code

    public void editObject( Namespace ns, Object o ) { 
         if(o instanceof NeuromlPkg){
            topObject = o;
            this.ns = ns;
            NeuromlPkg np=(NeuromlPkg)o;
            Object obj=null;
            for(int i=0;i<np.models.size()&&obj==null;i++){
                obj=np.models.elementAt(i);
                if(!(obj instanceof NetworkPkg))
                    obj=null;
            }
            NetworkPkg netPkg;
            if(obj==null){
                netPkg = new NetworkPkg("pkg1");
                np.models.addElement( netPkg );
                ns.addRef("models.pkg1", netPkg); 
            }
            else
               netPkg=(NetworkPkg) obj;
            ObjectNode on = new ObjectNode(netPkg);
            on.setPath( "models."+netPkg.getName() );
            Object thing=null;
            try{
                thing=NetworkConsole.getComponent(0);
            }
            catch(Exception e){
                // pack();
                GraphicsConfiguration gc = getGraphicsConfiguration();
                Rectangle r = gc.getBounds();
                thing=new JPanel();
                ((JPanel)thing).setSize(r.width,r.height-85-NMLPlayConsole.getPreferredSize().height);//-18 for state bar below//r.height-62
        //<NMLPlay Code 
            }
            if(Edition) {
                stuff=new SubnetsEditor_StandAlone(netPkg,(NeuromlPkg)o,on.getPath(),null);//GuiKit
                if(thing!=null && thing instanceof JPanel)
                    stuff.setPreferredSize(((JPanel)thing).getSize());
            }
            else{
                stuff=new SubnetsEditor_Animation(netPkg,on.getPath(),null,this);
                if(thing!=null && thing instanceof JPanel)
                    stuff.setPreferredSize(((JPanel)thing).getSize());                
            }
            NEOSIMSettings.mySchedule.runtime=np.environment.schedule.runtime;
            NEOSIMSettings.mySchedule.stepping=np.environment.schedule.stepping;
            NEOSIMSettings.mySchedule.command=np.environment.schedule.command;
            NEOSIMSettings.mySchedule.visudelay=np.environment.schedule.visudelay;
            NEOSIMSettings.mySchedule.ViewOnOff=np.environment.schedule.ViewOnOff;
            NEOSIMSettings.mySchedule.DebugOnOff=np.environment.schedule.DebugOnOff;
            neosim.renderer.NetvisCtrl.setRefreshVisualization(np.environment.schedule.visudelay,NEOSIMSettings.mySchedule.ViewOnOff);
            
            NetworkConsole.removeAll();
            NetworkConsole.add(stuff,BorderLayout.CENTER);
            //((SubnetsEditor_StandAlone)stuff).BuildOthers((NeuromlPkg)o);

            pack();
            setVisible(true);
            obj=null;
            if(Edition){
                String str=netPkg.MainNetwork.getTargetName();
                if(str==null){
                    for(int i=0;i<netPkg.networks.size()&&obj==null;i++){
                        obj=netPkg.networks.elementAt(i);
                        if(!(obj instanceof Network))
                            obj=null;
                    }
                }
                else{ 
                    Hashtable chose=(Hashtable)ns.getReferences().get("Network");
                    if(chose!=null){
                        obj=chose.get(str);
                    }
                }
                if(obj!=null)
                    ((SubnetsEditor_StandAlone)stuff).ChangeCurrentNetwork((Network)obj);
            }
            else{
                //simulator.initKernel(NEOSIMSettings.kernelParms);
// INIT-RESET                
//                simulator.initKernel(NEOSIMSettings.mySchedule.command.split(" "));
//                simulator.reset();
            }
            NEOSIMSettings.mySchedule=((NeuromlPkg)o).environment.schedule;
            stuff.validate();   
         }
    }    

    public void createMenu() {
        menuBar = new JMenuBar();
        setJMenuBar(menuBar);
	fileMenu = addMenu( menuBar, "File", "File", KeyEvent.VK_F);
	addMenuItem(fileMenu, "Open", "Open", "Open NeuroML Model", -1);
	addMenuItem(fileMenu, "Save", "Save", "Save Model", -1);
        addCheckBoxMenuItem(fileMenu, "Running", null, "Design networks or play demo ?", -1,Edition);
	fileMenu.addSeparator();
	addMenuItem(fileMenu, "Exit", null, "Exit", -1);
	
	menuBar.add(Box.createHorizontalGlue());
	JMenu helpMenu = addMenu(menuBar,"Help",  "Help about Basic Application", KeyEvent.VK_H);
	JMenuItem about = addMenuItem(helpMenu, "About", null, "About this program", -1);
        
        //NMLPlay Code>  
        
        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.BOTH;
        NMLPlayConsole.setLayout(gbl);
    
        JButton logo = new JButton(new ImageIcon(this.getClass().getResource(resources_NML.getString("logo"))));
        logo.setBorderPainted(false);
        logo.addActionListener(this);
        logo.setActionCommand("about");
    
        gbc.gridwidth = 1;
        gbc.gridheight = 1;
    
        gbc.gridx=0;
        gbc.weightx = 2;
        
        gbl.setConstraints(logo, gbc);
        NMLPlayConsole.add(logo);

        JToolBar playTools = new JToolBar();
        JButton stopBtn, stepBtn, playBtn, pauseBtn, configBtn,three3DBtn;
    
        addButton(playTools, stopBtn = new JButton(new ImageIcon(this.getClass().getResource(resources_NML.getString("stop")))), "Stop and reset simulation");
        addButton(playTools, playBtn = new JButton(new ImageIcon(this.getClass().getResource(resources_NML.getString("play")))), "Run simulation");
        addButton(playTools, pauseBtn = new JButton(new ImageIcon(this.getClass().getResource(resources_NML.getString("pause")))), "Pause simulation");
        addButton(playTools, stepBtn = new JButton(new ImageIcon(this.getClass().getResource(resources_NML.getString("step")))), "Advance single timestep");
        addButton(playTools, three3DBtn = new JButton("3D"), "Refresh 3D");
        addButton(playTools, three3DBtn = new JButton("IP"), "Get local IP address");
        playTools.setFloatable(false);
        try{
                progress = new JProgressBar(0, (int)NEOSIMSettings.mySchedule.runtime);
              //  System.out.println((int)NEOSIMSettings.mySchedule.runtime);
        }
        catch(Exception excp1){
            progress = new JProgressBar(0, 10);
        }
        progress.setValue((int)t);
        progress.setStringPainted(true);
        progress.setString("t="+t);
        progress.setBorderPainted(true);
        JToolBar dummyTool = new JToolBar();
        dummyTool.setFloatable(false);
        dummyTool.add(progress);

        gbc.gridx=2;
        gbc.weightx = 2;
        
        gbl.setConstraints(playTools, gbc);
        NMLPlayConsole.add(playTools);

        gbc.gridx=4;
        gbc.weightx = 4;        
        
        gbl.setConstraints(dummyTool, gbc);
        NMLPlayConsole.add(dummyTool);
    
        JToolBar jtb = new JToolBar();
        jtb.setFloatable(false);
        jtb.addSeparator();
        addButton(jtb, configBtn = new JButton(new ImageIcon(this.getClass().getResource(resources_NML.getString("settings")))), "Settings...");
        configBtn.setBorderPainted(true);

        gbc.gridx=8;
        gbc.weightx = 1;        
        
        gbl.setConstraints(jtb, gbc);
        NMLPlayConsole.add(jtb);

        console = new JTextArea();
        console.setLineWrap(true);
        console.setWrapStyleWord(true);
        console.setEditable(false);
        console.setRows(3);//5
        mainView = new JScrollPane(console);
         mainView.setVerticalScrollBarPolicy(JScrollPane. VERTICAL_SCROLLBAR_ALWAYS);
        mainView.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        println("Welcome to NMLPlay "+VERSION+".");
        gbc.fill = GridBagConstraints.BOTH;

        gbc.gridx=9;
        gbc.weightx = 7; 

        gbl.setConstraints(mainView, gbc);
        NMLPlayConsole.add(mainView);
    
       // pack();
        //GraphicsConfiguration gc = getGraphicsConfiguration();
        //Rectangle r = gc.getBounds();
        //this.setSize(r.width,r.height);
        //setLocation((r.width-getWidth())/2, (r.height-getHeight())/2);
        //setVisible(true);
        //<NMLPlay Code       

    }    
    
    //NMLPlay Code>  
    public void runFinished(double nt) {
        t = nt;
        println("finished.");
    }
  
    public void showProgress(double t) {
        progress.setValue((int)t);
        progress.setString("t="+t);
    }

    public void pause(double p) {         
        println("paused at t="+p);
        state = new Byte(PAUSED);
        t = p;
    }
  
    public void stop() {
        state = new Byte(STOPPED);
        modelModified = true;
        simulator.reset();
        t = 0;
        progress.setValue(0);
        progress.setString("t=0");
        println("Simulation has been reset to t=0.\n");
        
    }
    
     public void println(String s) {
        console.append(s+"\n");
        console.setCaretPosition(console.getText().length()-1);
        console.revalidate();
        console.repaint();
        validate();
        repaint();
    }

  
    protected void print(String s) {
        console.append(s);
        console.setCaretPosition(console.getText().length()-1);
    }
     //<NMLPlay Code  
    protected void Save(){
        File machin=fileChooser("xml","Save NeuroML file");
        String fname=(machin!=null)?machin.getPath():null;
	if (fname!=null) {
            println("Saving "+fname);
            
            if(topObject instanceof NeuromlPkg){
                ((NeuromlPkg)topObject).environment.schedule.runtime=NEOSIMSettings.mySchedule.runtime;
                ((NeuromlPkg)topObject).environment.schedule.stepping=NEOSIMSettings.mySchedule.stepping;            
                ((NeuromlPkg)topObject).environment.schedule.command=NEOSIMSettings.mySchedule.command;
                ((NeuromlPkg)topObject).environment.schedule.visudelay=NEOSIMSettings.mySchedule.visudelay;
                ((NeuromlPkg)topObject).environment.schedule.ViewOnOff=NEOSIMSettings.mySchedule.ViewOnOff;
                ((NeuromlPkg)topObject).environment.schedule.DebugOnOff=NEOSIMSettings.mySchedule.DebugOnOff;
            }
            NeuromlSys.toFile(topObject,fname);//filename
            println("Writen model to "+fname);//filename
            needsSaving = false;
        }
    }
    
    public void actionPerformed(ActionEvent e) {
        
        synchronized(state){
        if (e.getActionCommand().equals("Running")) {
            
            
            if (state.byteValue()!=STOPPED){
                JOptionPane.showMessageDialog(this, "Simulation is still running.", "Oh no!",JOptionPane.WARNING_MESSAGE);
            }
            else {
                Edition=!Edition;
                if (topObject==null) {
                    JOptionPane.showMessageDialog(this, "You have to create or load a model first.",
                                        "Unable to edit",JOptionPane.WARNING_MESSAGE);
                } else {
                     if(Edition){ 
                        needsSaving = true;
                        modelModified = true;
                    }
                    editObject(ns,topObject);
                }
            }  
        }
        else if (e.getActionCommand().equals("Save")) {
            if (state.byteValue()!=STOPPED) 
                JOptionPane.showMessageDialog(this, "Simulation is still running.", "Oh no!",JOptionPane.WARNING_MESSAGE);
            else {
                if (topObject==null) {
                    JOptionPane.showMessageDialog(this, "There is no data to be saved.",
                                      "Unable to save",JOptionPane.WARNING_MESSAGE);
                } else {                    
                    Save();
                }
            }            
        } else if (e.getActionCommand().equals("Exit")) {
            System.exit(0);
        } else if (e.getActionCommand().equals("Open")) { 
            if (state.byteValue()!=STOPPED) 
                JOptionPane.showMessageDialog(this, "Simulation is still running.", "Oh no!",JOptionPane.WARNING_MESSAGE);
            else {

                if (needsSaving) {
		    int userResponse=JOptionPane.showConfirmDialog(this, "Do you want to save the current model before loading a new one ?");
                    if(userResponse==JOptionPane.YES_OPTION)
                        Save();
                    else if(userResponse==JOptionPane.CANCEL_OPTION||userResponse==JOptionPane.CLOSED_OPTION)
                        return;
                }
            
                File machin=fileChooser("xml","Open NeuroML file");
                String fname=(machin!=null)?machin.getPath():null;
                if (fname!=null) {
                    println("Opening "+fname);
                    Object o = NeuromlSys.loadXML(fname);
                    println("Loaded "+o);
                    this.setName(o.toString());
                    setTitle("NeuroML Player (" + fname + ")");
                
                    if (o!=null) {
                        if (o instanceof NeuromlPkg){
                            Namespace truv=NeuromlSys.getNamespace(fname);
                            truv.setModuleRef(((NeuromlPkg)o).ImplementionModules.getElements());
                            ((NeuromlPkg)o).ImplementionModules.setElements(truv.getModuleRef());
                            Environment env = new Environment(truv , (NeuromlPkg)o, null );
                            SpecialEditors.setEnvironment(env);		
                        }	
                        t = 0;
                        if(Edition){ 
                            needsSaving = true;
                            modelModified = true;
                        }
                        else{
                            needsSaving = false;
                            modelModified = true;
                        }
                        editObject( NeuromlSys.getNamespace(fname), o );
                        /*if(!Edition) {
                            simulator.buildModel(topObject, ns);
                        }*/
                    }
                }
	    }	  	   
	} else  if (e.getActionCommand().equals("About")) { 
            System.out.println("");
 	    System.out.println("Network Designer Tool");
            System.out.println("---------------------");
            System.out.println("University of Edinburgh");
            System.out.println("Jean-Alain Grunchec, 2004");
            System.out.println("");
            
            JOptionPane.showMessageDialog(this, "NeuroML/NEOSIM (c) University of Edinburgh,\nNMLPlay "+VERSION+" by\n"+AUTHOR, "About NMLPlay",
                                    JOptionPane.INFORMATION_MESSAGE,
                                    new ImageIcon(this.getClass().getResource(resources.getString("about"))));
            
	} else  if (e.getActionCommand().equals("Run simulation")) {
            if (topObject==null) {
                 JOptionPane.showMessageDialog(this, "You have to create or load a model first.",
                                      "Unable to build",JOptionPane.WARNING_MESSAGE);
            } else if (Edition) {
                 JOptionPane.showMessageDialog(this, "You must exit the editing mode first \n in order to display the results in the simulation mode.",
                                      "Unable to launch the simulation",JOptionPane.WARNING_MESSAGE);
            }else{ 
                    println("Updating the progress bar");
                    progress.setMaximum((int)NEOSIMSettings.mySchedule.runtime);
                    if(state.byteValue() ==PAUSED && myRunSim !=null){
                        state = new Byte(RUNNING);
                        myRunSim.updateParameters(NEOSIMSettings.mySchedule.runtime, NEOSIMSettings.mySchedule.stepping);
                    } else {
                        if (modelModified||t<NEOSIMSettings.mySchedule.stepping) {
                    //simulator.initKernel(NEOSIMSettings.kernelParms);
                            simulator.initKernel(NEOSIMSettings.mySchedule.command.split(" "));
                            simulator.buildModel(topObject, ns);
                            modelModified = false;
                        }
                        
                        Rendering3D.run(simulator);                 
                        if (t>=NEOSIMSettings.mySchedule.runtime) JOptionPane.showMessageDialog(this, "Simulation has already been finished.\nAdjust runtime settings or reset NEOSIM.",
                                   "Simulation finished",JOptionPane.WARNING_MESSAGE);
                        else {
                            if(state.byteValue()==STOPPED){
                                System.out.println("Running simulation to t="+NEOSIMSettings.mySchedule.runtime+"...");
                                myRunSim = new RunSim(simulator, t, NEOSIMSettings.mySchedule.runtime, NEOSIMSettings.mySchedule.stepping, this);
                                state = new Byte(RUNNING);
                                needsSaving = true;
                                myRunSim.start();
                            }
                        }
                    }
                
            }
        }
        else  if (e.getActionCommand().equals("Pause simulation")) {
                if (!(state.byteValue() == RUNNING)) {
                    JOptionPane.showMessageDialog(this, "Simulation is not running.",
                                      "Guess what?",JOptionPane.WARNING_MESSAGE);
                } else {
                    state = new Byte(PAUSED);
                }
        }  
        else  if (e.getActionCommand().equals("Refresh 3D")) {
            
             if (topObject==null) {
                JOptionPane.showMessageDialog(this, "You have to create or load a model first.",
                                      "Unable to build",JOptionPane.WARNING_MESSAGE);
            } else if (Edition) {
                JOptionPane.showMessageDialog(this, "You must exit the editing mode first \n in order to display the results in the simulation mode.",
                                      "Unable to launch the simulation",JOptionPane.WARNING_MESSAGE);
            } else {
                if(stuff instanceof SubnetsEditor_Animation)
                    ((SubnetsEditor_Animation)stuff).setActiveWindow(1);
                if (state.byteValue()!=RUNNING) {
                    this.Refresh3D();
                } else {
                    Rendering3D.run(simulator);
                }
            }
        }  
        else  if (e.getActionCommand().equals("Get local IP address")) {  
            try{
                java.net.InetAddress i = java.net.InetAddress.getLocalHost();                 
                System.out.println("Local IP : "+i.getHostAddress()); 
                println("Local IP : "+i.getHostAddress());
            }
            catch(java.net.UnknownHostException exc){
                println("Could not get the IP :( ");
            }
        } 
        else if (e.getActionCommand().equals("Stop and reset simulation")) {
            if ((state.byteValue() == STOPPED) || topObject==null) {
                JOptionPane.showMessageDialog(this, "Simulation is not running.",
                                      "Guess what?",JOptionPane.WARNING_MESSAGE);
            } else stop();
        } else if (e.getActionCommand().equals("Advance single timestep")) {
            if (topObject==null) {
                JOptionPane.showMessageDialog(this, "You have to create or load a model first.",
                                      "Unable to build",JOptionPane.WARNING_MESSAGE);
            } else {
                if (modelModified) {
                    //simulator.initKernel(NEOSIMSettings.kernelParms);
                    simulator.initKernel(NEOSIMSettings.mySchedule.command.split(" "));
                    simulator.buildModel(topObject, ns);
                    modelModified = false;
                }
                t += NEOSIMSettings.mySchedule.stepping;
                println("Stepping simulation to t="+t+".");
                simulator.runSim(NEOSIMSettings.mySchedule.stepping);
                if (t >= NEOSIMSettings.mySchedule.runtime) {
                    NEOSIMSettings.mySchedule.runtime=t;
                    progress.setMaximum((int)NEOSIMSettings.mySchedule.runtime);
                }
                progress.setValue((int)t);
                progress.setString("t="+t);
                needsSaving = true;
            }
        } else if (e.getActionCommand().equals("Settings...")) {
            NEOSIMSettings.configure(this);
            progress.setMaximum((int)NEOSIMSettings.mySchedule.runtime);
        } else {
            println("Warning: command not yet implemented."+e.paramString()+e.getID());    
        }
        id = e; 
        }
    }
    
    
    public static void main(String[] args) {
	System.out.println("Starting Basic Applet");
        System.out.println("Starting Network Editor Applet");
        SpecialEditors.put("neuroml.model.network.NetworkPkg","guikit.SubnetsEditor_GuiKit");
        SpecialEditors.put("neuroml.util.RefInterfaces","guikit.EditRefInterfaces");
        SpecialEditors.put("neuroml.core.Module","guikit.ModuleEditor");
        SpecialEditors.put("guikit.RGBColour", "guikit.ColourEditor" );
        EditTreeRefPanel.put("SubNetwork", "guikit.SubNetNode");
        for(int i=0;i<args.length;i++)
            System.out.println(args[i]);
        String str=null;
        if(args.length>0)
            str=args[0];
        JFrame frame = new NMLPlay_2("NEOSIM",str);

       /* System.out.println("JAVA: Compiler "+System.getProperty("java.compiler")+" Home "+System.getProperty("java.home")+" Class.Version "+System.getProperty("java.class.version"));
        System.out.println("USER: UserDir "+System.getProperty("user.dir")+" UserHome " + System.getProperty("user.home") +" UserName "+ System.getProperty("user.name"));
        System.out.println("OPERATING SYSTEM: Architecture "+System.getProperty("os.arch")+" Name " + System.getProperty("os.name") +" Version "+ System.getProperty("os.version"));*/
        
	
	frame.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }
	});
    }  
    
    public boolean isPaused() {
      return (state.byteValue()==PAUSED);
    }
  
    public boolean isRunning() {
      return (state.byteValue()==RUNNING);
    }
  
    public boolean isStopped() {
      return (state.byteValue()==STOPPED);
    }
    
    public JPanel buildProbeRendering(String str) {
        GUI_Maker_Population stuff=new GUI_Maker_Population(simulator,str);
        return GUI_Maker_Population.getLast();
    }
    
    public void SetRendering(RunnableControl path) {
        Rendering3D=path;
    }
    
    public RunnableControl getRendering() {
        return Rendering3D;
    }
    
    protected void Refresh3D(){
        if (modelModified) {
            //simulator.initKernel(NEOSIMSettings.kernelParms);
            simulator.initKernel(NEOSIMSettings.mySchedule.command.split(" "));
            simulator.buildModel(topObject, ns);
            modelModified = false;
        }
        Rendering3D.run(simulator);
        simulator.run(NEOSIMSettings.mySchedule.visudelay+0.00001);
    }
}