package guikit;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.text.NumberFormat;

public class DisplayListener implements DocumentListener, ActionListener, ItemListener {
    DisplayPanel disp;
    String title;
    JTextField paramField;
    String type;
    JSlider slider;
    int index; // for list listening

    public DisplayListener(DisplayPanel dp, String ptitle, String ptype){
	disp = dp;
	title = ptitle;
	paramField = new JTextField();
	type = ptype;	
    }

    public DisplayListener(DisplayPanel dp, String ptitle, JTextField pField, String ptype){
	disp = dp;
	title = ptitle;
	paramField = pField;
	type = ptype;	
    }

    public DisplayListener(DisplayPanel dp, String ptitle, JTextField pField, String ptype, int i){
	disp = dp;
	title = ptitle;
	paramField = pField;
	type = ptype;
	index = i;
    }

    public DisplayListener(DisplayPanel dp, String ptitle, String ptype, int i){
	disp = dp;
	title = ptitle;
	paramField = new JTextField();
	type = ptype;
	index = i;
    }

    public DisplayListener(DisplayPanel dp, String ptitle, JTextField pField, String ptype, JSlider sder){
	disp = dp;
	title = ptitle;
	paramField = pField;
	type = ptype;
	slider = sder;	
    }

    public void insertUpdate(DocumentEvent e) {
	updateDisplayValue(e);
    }

    public void removeUpdate(DocumentEvent e) {
	updateDisplayValue(e);
    }

    public void changedUpdate(DocumentEvent e) {
	//Plain text components don't fire these events
    }

    public void updateDisplayValue(DocumentEvent e) {
	if(type.equals("Text")){
	    //System.out.println(e.getActionCommand()+" "+e.paramString() ); 
	    //System.out.println("scroll offset = "+paramField.getScrollOffset());
	    disp.setParam(title,paramField.getText(),paramField.getScrollOffset()+1); // get the value
	    disp.refresh(); 
	    // disp.updateUI();
	}
	else if(type.equals("Button")){
	    //System.out.println(e.getActionCommand()+" "+e.paramString() ); 
	    if(paramField!=null)
		disp.setParam(title,paramField.getText()); // get the value
	    else disp.setParam(title,"");
	    disp.refresh(); 
	    // disp.updateUI();
	}
	else if(type.equals("List")){
	    //System.out.println(e.getActionCommand()+" "+e.paramString() );
	    disp.setParam(title,paramField.getText(),paramField.getScrollOffset()+1,index); 
	    disp.refresh(); 
	    // disp.updateUI();
	}
	else if(type.equals("Digit")){
	    //System.out.println(e.getActionCommand()+" "+e.paramString() ); 
	    disp.setParam(title,((DecimalField)paramField).getValue()); // get the value
	    disp.refresh(); 
	    // disp.updateUI();
	    
	}
	else if( type.equals("CheckBox")){
	}  
	else if( type.equals("ComboBox")){
	}  
	else  System.err.println("DisplayListener Error "+type);
    }

    public void actionPerformed(ActionEvent e) {
	if(type.equals("Text")){
	    //System.out.println(e.getActionCommand()+" "+e.paramString() ); 
	    //System.out.println("scroll offset = "+paramField.getScrollOffset());
	    disp.setParam(title,paramField.getText(),paramField.getScrollOffset()+1); // get the value
	    disp.refresh(); 
	    // disp.updateUI();
	}
	else if(type.equals("Button")){
	    //System.out.println(e.getActionCommand()+" "+e.paramString() ); 
	    if(paramField!=null)
		disp.setParam(title,paramField.getText()); // get the value
	    else disp.setParam(title,"");
	    disp.refresh(); 
	    // disp.updateUI();
	}
	else if(type.equals("List")){
	    //System.out.println(e.getActionCommand()+" "+e.paramString() ); 
	    disp.setParam(title,paramField.getText(),paramField.getScrollOffset()+1,index); 
	    disp.refresh(); 
	    // disp.updateUI();
	}
	else if(type.equals("Digit")){
	    //System.out.println(e.getActionCommand()+" "+e.paramString() ); 
	    disp.setParam(title,((DecimalField)paramField).getValue()); // get the value
	    disp.refresh(); 
	    // disp.updateUI();	    
	}
	else if(type.equals("Browse")){
	    disp.setParam(title,"");
	    //setChosenChoice(title);
	    disp.refresh(); 
	    // disp.updateUI();	   
	}
	else if( type.equals("CheckBox")){
	}  
	else if( type.equals("ComboBox")){
	    JComboBox cb = (JComboBox)e.getSource();
	    String selectName = (String)cb.getSelectedItem();
	    disp.setParam(title,selectName);
	}
	else  System.err.println("DisplayListener Error "+type);
    }
    
    public void itemStateChanged(ItemEvent e) {
	if( type.equals("CheckBox")){  
	    if (e.getStateChange() == ItemEvent.DESELECTED)
		disp.setParam(title,"deselected");
	    else disp.setParam(title,"selected");
	}	
    }        
}
