// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 11/12/2003 15:38:30
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Rastergram.java

package Holger_modules.module.rastergram;

import Holger_modules.datatypes.Spiketrain;
import Holger_modules.module.multiprobe.*;
import java.awt.Color;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.*;
import java.util.Hashtable;
import java.util.Random;
import javax.swing.*;
import neuroml.core.List;
import neuroml.sim.run.*;
//import neuroml.sim.state.ConnectionState;
import neuroml.sim.state.ElementState;
import neuroml.util.NeuromlSys;
import Holger_modules.ptolemy.plot.Plot;
import Holger_modules.ptolemy.plot.PlotFormatter;

import java.awt.*;
import java.awt.geom.*;
import neuroml.sim.run.*;

public final class Rastergram
    implements PluggableProbe, DestMethod
{

    public Rastergram()
    {
        fromAll = true;
        label = "none";
        panelNdx = 0;
        height = 100;
        tempRes = 0.10000000000000001D;
        title = "Untitled rastergram";
        xLabel = "";
        xRangeStart = 0.0D;
        xRangeEnd = 1.0D;
        yLabel = "";
        yRangeStart = 0.0D;
        yRangeEnd = 1.0D;
        impulses = false;
        style = "points";
        grid = true;
        color = true;
        numSpiketrains = 0;
        spiketrains = new List("java.lang.Double");
        data = new List("java.lang.Double");
        registerToCtrl = true;
    }

    public void reset()
    {
        registerToCtrl = true;
        numSpiketrains = 0;
    }

    public void build()
    {
        data = spiketrains;
        spiketrains = new List("java.lang.Double");
        cid2ndx = new Hashtable();
        plot = new Plot();
        plot.setBackground(Color.lightGray);
        plot.setForeground(Color.black);
        plot.addYTick((new Integer((int)yRangeStart)).toString(), (int)yRangeStart);
        plot.addYTick((new Integer((int)yRangeEnd)).toString(), (int)yRangeEnd);
        plot.setVisible(true);
        plot.setConnected(false);
        plot.setTitle(title);
        plot.setImpulses(impulses);
        plot.setMarksStyle(style);
        plot.setXRange(xRangeStart, xRangeEnd);
        plot.setYRange(yRangeStart, yRangeEnd);
        plot.setGrid(grid);
        plot.setColor(color);
        plot.setXLabel(xLabel);
        plot.setYLabel(yLabel);
        for(int i = 0; i < numSpiketrains; i++)
        {
            Spiketrain spiketrain = (Spiketrain)data.elementAt(i);
            for(int j = 0; j < spiketrain.numSpikes; j++)
                if(impulses)
                    plot.addPoint(0, ((Double)spiketrain.spikes.elementAt(j)).doubleValue(), 0.69999999999999996D, false);
                else
                    plot.addPoint(0, ((Double)spiketrain.spikes.elementAt(j)).doubleValue(), (double)i / (double)numSpiketrains, false);

        }

    }

    protected void setConnectionParameters(String s, int i, int j, boolean flag, double d)
    {
        build();
        title = s;
        plot.setTitle(s);
        height = i;
        panelNdx = j;
        impulses = !flag;
        if(impulses)
        {
            plot.setImpulses(true);
            plot.setMarksStyle("none");
            impulses = true;
            style = "none";
        } else
        {
            plot.setImpulses(false);
            plot.setMarksStyle("points");
            impulses = false;
            style = "points";
        }
        tempRes = d;
    }

    public void handleSpike(int i, double d)
    {
        d -= tempRes;
        if(d > plot.getXRange()[0])
        {
            plot.setXRange(xRangeStart, d);
            xRangeEnd = d;
            plot.repaint();
        }
        Integer integer = (Integer)cid2ndx.get(new Integer(i));
        if(integer != null)
        {
            if(impulses)
                plot.addPoint(0, d, 0.69999999999999996D, false);
            else
                plot.addPoint(0, d, (double)integer.intValue() / (double)numSpiketrains, false);
            ((Spiketrain)data.elementAt(integer.intValue())).spikes.addElement(new Double(d));
            ((Spiketrain)data.elementAt(integer.intValue())).numSpikes++;
        }
    }

    public void handle(Object obj, int i, double d)
    {
    }

    protected void registerConnection(int i)
    {
        data.addElement(new Spiketrain());
        cid2ndx.put(new Integer(i), new Integer(numSpiketrains));
        numSpiketrains++;
    }

    protected void updatePlotConfig()
    {
        title = plot.getTitle();
        impulses = plot.getImpulses();
        style = plot.getMarksStyle();
        double ad[] = plot.getXRange();
        xRangeStart = ad[0];
        xRangeEnd = ad[1];
        double ad1[] = plot.getYRange();
        yRangeStart = ad1[0];
        yRangeEnd = ad1[1];
        grid = plot.getGrid();
        color = plot.getColor();
        xLabel = plot.getXLabel();
        yLabel = plot.getYLabel();
    }

    public void configure()
    {
        PlotFormatter plotformatter = new PlotFormatter(plot);
        plotformatter.openModal();
        updatePlotConfig();
    }

    public JComponent getPanel()
    {
        return plot;
    }

    public int getRelativePanelSize()
    {
        return height;
    }

    public int getPanelIndex()
    {
        return panelNdx;
    }

    public void exportEPS(OutputStream outputstream)
        throws IOException
    {
        plot.export(outputstream);
    }

    public void hideXMLData()
    {
        spiketrains = new List("java.lang.Double");
    }

    public void discloseXMLData()
    {
        spiketrains = data;
    }

    public void exportXML(OutputStream outputstream)
        throws IOException
    {
        discloseXMLData();
        byte abyte0[] = NeuromlSys.toString(this).getBytes();
        outputstream.write(abyte0);
        hideXMLData();
    }

    public void setXRange(double ad[])
    {
        plot.setXRange(ad[0], ad[1]);
        updatePlotConfig();
        plot.repaint();
    }

    public void setYRange(double ad[])
    {
        plot.setYRange(ad[0], ad[1]);
        updatePlotConfig();
        plot.repaint();
    }

    public double[] getXRange()
    {
        return plot.getXRange();
    }

    public double[] getYRange()
    {
        return plot.getYRange();
    }

    public void fitData()
    {
        plot.fillPlot();
        plot.setYRange(yRangeStart, yRangeEnd);
        updatePlotConfig();
        plot.repaint();
    }

    public void init(String s, Hashtable hashtable)
    {
        System.out.println(this + " not supported :init/2 called");
    }

    public boolean considerRequest(ConnectionMaker connectionmaker, ElementState elementstate, ConnectionRequest connectionrequest, boolean BuildingConnection)
    {
        short i = (short)1;
        boolean flag = false;
       // ConnectionStateImpl connectionstateimpl = null;
        int j = 0;
        if(fromAll)
        {
            flag = true;
        } else
        {
            int k = Integer.valueOf(label).intValue();
            //if(k == connectionrequest.sourceIndex) JAG
            if(k == connectionrequest.getSrcID())
                flag = true;
        }
        if(flag)
            if(elementstate instanceof ProbeCtrlAdapter)
            {
               //JAG connectionstateimpl = new ConnectionStateImpl(connectionrequest.sourceID, connectionrequest.sourceOutputID, elementstate.getID(), i, tempRes);
                try
                {
                    //JAG j = connectionmaker.makeConnection(connectionstateimpl);
                    j=connectionmaker.makeConnection(connectionrequest.getSrcID(), connectionrequest.getSrcPortID(), elementstate.getID(), i, tempRes, BuildingConnection);
                    ((RunnableCell)elementstate).setMeasured(connectionrequest.getSrcID(),null);
                }
                catch(Exception exception) { }
                if(BuildingConnection){
                    ProbeCtrlAdapter probectrladapter = (ProbeCtrlAdapter)elementstate;
                    if(registerToCtrl)
                    {
                        setConnectionParameters(title, height, panelNdx, fromAll, tempRes);
                        probectrladapter.registerProbe(this);
                    }
                    registerToCtrl = false;
                    registerConnection(j);
                }
                return true;
            } else
            {
                System.out.println(this + " considerRequest/3 error : cellstate " + elementstate);
                return false;
            }
        return false;
        //JAGreturn connectionstateimpl;
    }

    public static void main(String args[])
    {
        System.out.println("\nPackage:  de.lambdabase.neuroml.module.rastergram, v1.0, January 2002");
        System.out.println("Author :  Holger Bringmann (hcb@lambdabase.de)");
        System.out.println("Usage  :  java -classpath \"...\" -jar Rastergram.jar [input NeuroML] [output EPS]\n");
        JFrame jframe = new JFrame();
        jframe.addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent windowevent)
            {
                System.exit(0);
            }

        });
        Rastergram rastergram;
        if(args.length > 0)
        {
            jframe.setTitle("Loaded from " + args[0]);
            rastergram = (Rastergram)NeuromlSys.loadXML(args[0]);
            rastergram.build();
        } else
        {
            jframe.setTitle("Generated example");
            rastergram = new Rastergram();
            rastergram.title = "Population 01";
            rastergram.xLabel = "time [s]";
            rastergram.yLabel = "n";
            rastergram.build();
            Random random = new Random();
            for(int i = 0; i < 1500; i++)
                rastergram.plot.addPoint(0, Math.abs(Math.sin((double)i / 2D) * 0.69999999999999996D + 0.29999999999999999D * random.nextDouble()), (double)(i % 25) / 25D, false);

        }
        jframe.pack();
        jframe.setSize(400, 250);
        jframe.getContentPane().add(rastergram.getPanel());
        jframe.setVisible(true);
        if(args.length > 1)
            try
            {
                FileOutputStream fileoutputstream = new FileOutputStream(args[1], false);
                rastergram.exportEPS(fileoutputstream);
                fileoutputstream.close();
                System.out.println("Exported EPS data to file " + args[1]);
            }
            catch(IOException ioexception)
            {
                System.out.println("Filestram exception on file " + args[1] + ": \n" + ioexception.getMessage());
            }
    }

    public short getDstPortID() {
        return (short)2; //Measurements on port 2 exclusively JAG
    }
    
    public void Draw(Graphics2D g, double x, double y) {
        g.setColor(Color.blue);
        g.fill(new Rectangle2D.Double(x-16,y-12, 32, 24));
        g.setStroke(new java.awt.BasicStroke(2));
        g.setColor(Color.white);
        g.fill(new Ellipse2D.Double(x-8,y-3,2,2));
        g.fill(new Ellipse2D.Double(x+8,y-1,2,2));
        g.fill(new Ellipse2D.Double(x-4,y-5,2,2));
        g.fill(new Ellipse2D.Double(x+12,y-8,2,2));
        g.fill(new Ellipse2D.Double(x+11,y+8,2,2));
        g.fill(new Ellipse2D.Double(x-2,y+4,2,2));
        g.fill(new Ellipse2D.Double(x+3,y+9,2,2));
        g.fill(new Ellipse2D.Double(x-10,y+1,2,2));
        g.setStroke(new java.awt.BasicStroke(1));
        g.setColor(Color.blue.darker());
        g.draw(new Rectangle2D.Double(x-16,y-12, 32, 24));
    }
    
    private static final String VERSION = "1.0, January 2002";
    private static final String AUTHOR = "Holger Bringmann (hcb@lambdabase.de)";
    public boolean fromAll;
    public String label;
    public int panelNdx;
    public int height;
    public double tempRes;
    public String title;
    public String xLabel;
    public double xRangeStart;
    public double xRangeEnd;
    public String yLabel;
    public double yRangeStart;
    public double yRangeEnd;
    public boolean impulses;
    public String style;
    public boolean grid;
    public boolean color;
    protected Plot plot;
    protected int numSpiketrains;
    protected List spiketrains;
    protected List data;
    protected Hashtable cid2ndx;
    private boolean registerToCtrl;
}