// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:01:00
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   JTextAreaExec.java

package Holger_modules.ptolemy.gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.AbstractButton;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.text.JTextComponent;

// Referenced classes of package ptolemy.gui:
//            SwingWorker

public class JTextAreaExec extends JPanel
{

    public JTextAreaExec(String name, boolean showButtons)
    {
        _interruptListener = new ActionListener() {

            public void actionPerformed(ActionEvent event)
            {
                _cancelButton.setEnabled(false);
                appendJTextArea("Cancel button was pressed");
                _worker.interrupt();
                _process.destroy();
                _enableStartButton();
            }

        };
        _startListener = new ActionListener() {

            public void actionPerformed(ActionEvent event)
            {
                _startButton.setEnabled(false);
                _cancelButton.setEnabled(true);
                _statusBar.setText("Working...");
                _worker = new SwingWorker() {

                    public Object construct()
                    {
                        return _executeCommands();
                    }

                    public void finished()
                    {
                        _enableStartButton();
                        _cancelButton.setEnabled(false);
                        _statusBar.setText(get().toString());
                    }

                };
                _worker.start();
            }

        };
        _commands = null;
        setLayout(new BoxLayout(this, 1));
        _jTextArea = new JTextArea("", 20, 100);
        _jTextArea.setEditable(false);
        JScrollPane scrollPane = new JScrollPane(_jTextArea);
        add(scrollPane);
        setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), name));
        _progressBar = new JProgressBar();
        _startButton = new JButton("Start");
        _startButton.addActionListener(_startListener);
        _enableStartButton();
        _cancelButton = new JButton("Cancel");
        _cancelButton.addActionListener(_interruptListener);
        _cancelButton.setEnabled(false);
        javax.swing.border.Border spaceBelow = BorderFactory.createEmptyBorder(0, 0, 5, 0);
        if(showButtons)
        {
            JComponent buttonBox = new JPanel();
            buttonBox.add(_startButton);
            buttonBox.add(_cancelButton);
            setLayout(new BoxLayout(this, 1));
            add(buttonBox);
            buttonBox.setBorder(spaceBelow);
            _statusBar = new JLabel("Click Start to begin", 0);
        } else
        {
            _statusBar = new JLabel("", 0);
        }
        add(_progressBar);
        add(_statusBar);
        _statusBar.setAlignmentX(0.5F);
        javax.swing.border.Border progressBarBorder = _progressBar.getBorder();
        _progressBar.setBorder(BorderFactory.createCompoundBorder(spaceBelow, progressBarBorder));
    }

    private void _enableStartButton()
    {
        if(_commands != null && _commands.size() > 0)
            _startButton.setEnabled(true);
        else
            _startButton.setEnabled(false);
    }

    private Object _executeCommands()
    {
        try
        {
            Runtime runtime = Runtime.getRuntime();
            try
            {
                if(_process != null)
                    _process.destroy();
                _progressBar.setMaximum(_commands.size());
                int commandCount = 0;
                for(Iterator commands = _commands.iterator(); commands.hasNext();)
                {
                    _updateProgressBar(++commandCount);
                    if(Thread.interrupted())
                        throw new InterruptedException();
                    String command = (String)commands.next();
                    appendJTextArea("Executing: " + command);
                    if(command.length() < 50)
                        _statusBar.setText("Executing: " + command);
                    else
                        _statusBar.setText("Executing: " + command.substring(0, 50) + " . . .");
                    _process = runtime.exec(command);
                    try
                    {
                        java.io.InputStream processStream = _process.getErrorStream();
                        BufferedReader reader = new BufferedReader(new InputStreamReader(processStream));
                        String line;
                        while((line = reader.readLine()) != null) 
                            appendJTextArea(line);
                        reader.close();
                        processStream = _process.getInputStream();
                        reader = new BufferedReader(new InputStreamReader(processStream));
                        while((line = reader.readLine()) != null) 
                            appendJTextArea(line);
                        reader.close();
                    }
                    catch(IOException io)
                    {
                        appendJTextArea("IOException: " + io);
                    }
                    try
                    {
                        int processReturnCode = _process.waitFor();
                        synchronized(this)
                        {
                            _process = null;
                        }
                        if(processReturnCode != 0)
                            break;
                    }
                    catch(InterruptedException interrupted)
                    {
                        appendJTextArea("InterruptedException: " + interrupted);
                        throw interrupted;
                    }
                }

                appendJTextArea("All Done.");
            }
            catch(IOException io)
            {
                appendJTextArea("IOException: " + io);
            }
        }
        catch(InterruptedException _ex)
        {
            _process.destroy();
            _updateProgressBar(0);
            return "Interrupted";
        }
        return "All Done";
    }

    private void _updateProgressBar(final int i)
    {
        Runnable doSetProgressBarValue = new Runnable() {

            public void run()
            {
                _progressBar.setValue(i);
            }

        };
        SwingUtilities.invokeLater(doSetProgressBarValue);
    }

    public void appendJTextArea(final String text)
    {
        Runnable doAppendJTextArea = new Runnable() {

            public void run()
            {
                _jTextArea.append(text + '\n');
            }

        };
        SwingUtilities.invokeLater(doAppendJTextArea);
    }

    public void cancel()
    {
        _cancelButton.doClick();
    }

    public JButton getStartButton()
    {
        return _startButton;
    }

    public static void main(String args[])
    {
        JFrame jFrame = new JFrame("JTextAreaExec Example");
        java.awt.event.WindowListener windowListener = new WindowAdapter() {

            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }

        };
        jFrame.addWindowListener(windowListener);
        java.util.List execCommands = new LinkedList();
        execCommands.add("date");
        execCommands.add("sleep 5");
        execCommands.add("date");
        final JTextAreaExec exec = new JTextAreaExec("JTextAreaExec Tester", true);
        exec.setCommands(execCommands);
        jFrame.getContentPane().add(exec);
        jFrame.pack();
        jFrame.setVisible(true);
        SwingUtilities.invokeLater(new Runnable() {

            public void run()
            {
                exec.getStartButton().requestFocus();
                exec.start();
            }

        });
    }

    public void setCommands(java.util.List commands)
    {
        _commands = commands;
        _enableStartButton();
    }

    public void start()
    {
        _startButton.doClick();
    }

    public void updateStatusBar(final String text)
    {
        Runnable doUpdateStatusBar = new Runnable() {

            public void run()
            {
                _statusBar.setText(text);
            }

        };
        SwingUtilities.invokeLater(doUpdateStatusBar);
    }

    private ActionListener _interruptListener;
    private ActionListener _startListener;
    private JButton _cancelButton;
    private java.util.List _commands;
    private JTextArea _jTextArea;
    private Process _process;
    private JProgressBar _progressBar;
    private JLabel _statusBar;
    private JButton _startButton;
    private SwingWorker _worker;










}