// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:01:03
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Query.java

package Holger_modules.ptolemy.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.text.JTextComponent;

// Referenced classes of package ptolemy.gui:
//            QueryListener

public class Query extends JPanel
{
    class QueryActionListener
        implements ActionListener
    {

        public void actionPerformed(ActionEvent e)
        {
            _notifyListeners(_name);
        }

        private String _name;

        public QueryActionListener(String name)
        {
            _name = name;
        }
    }

    class QueryFocusListener
        implements FocusListener
    {

        public void focusGained(FocusEvent focusevent)
        {
        }

        public void focusLost(FocusEvent e)
        {
            _notifyListeners(_name);
        }

        private String _name;

        public QueryFocusListener(String name)
        {
            _name = name;
        }
    }

    class QueryItemListener
        implements ItemListener
    {

        public void itemStateChanged(ItemEvent e)
        {
            _notifyListeners(_name);
        }

        private String _name;

        public QueryItemListener(String name)
        {
            _name = name;
        }
    }

    class SliderListener
        implements ChangeListener
    {

        public void stateChanged(ChangeEvent event)
        {
            _notifyListeners(_name);
        }

        private String _name;

        public SliderListener(String name)
        {
            _name = name;
        }
    }


    public Query()
    {
        _background = null;
        _entries = new HashMap();
        _entryPanel = new JPanel();
        _labels = new HashMap();
        _messageArea = null;
        _messagePanel = new JPanel();
        _previous = new HashMap();
        _width = 20;
        _grid = new GridBagLayout();
        _constraints = new GridBagConstraints();
        _constraints.fill = 2;
        _constraints.weightx = 1.0D;
        _constraints.anchor = 18;
        _entryPanel.setLayout(_grid);
        setLayout(new BoxLayout(this, 1));
        _entryPanel.setAlignmentX(0.0F);
        _messagePanel.setAlignmentX(0.0F);
        add(_messagePanel);
        add(_entryPanel);
        _entryPanel.setBackground(null);
        _messagePanel.setBackground(null);
    }

    protected void _addPair(String name, JLabel label, Component widget, Object entry)
    {
        _constraints.gridwidth = 1;
        _grid.setConstraints(label, _constraints);
        _entryPanel.add(label);
        _constraints.gridwidth = 0;
        _grid.setConstraints(widget, _constraints);
        _entryPanel.add(widget);
        _entries.put(name, entry);
        _labels.put(name, label);
        _previous.put(name, stringValue(name));
    }

    void _notifyListeners(String name)
    {
        if(_listeners != null)
        {
            String previous = (String)_previous.get(name);
            String newValue = stringValue(name);
            if(newValue.equals(previous))
                return;
            _previous.put(name, newValue);
            QueryListener queryListener;
            for(Enumeration listeners = _listeners.elements(); listeners.hasMoreElements(); queryListener.changed(name))
                queryListener = (QueryListener)listeners.nextElement();

        }
    }

    public void addCheckBox(String name, String label, boolean defaultValue)
    {
        JLabel lbl = new JLabel(label + ": ");
        lbl.setBackground(_background);
        JRadioButton checkbox = new JRadioButton();
        checkbox.setBackground(_background);
        checkbox.setOpaque(false);
        checkbox.setSelected(defaultValue);
        _addPair(name, lbl, checkbox, checkbox);
        checkbox.addItemListener(new QueryItemListener(name));
    }

    public void addChoice(String name, String label, String values[], String defaultChoice)
    {
        addChoice(name, label, values, defaultChoice, false);
    }

    public void addChoice(String name, String label, String values[], String defaultChoice, boolean editable)
    {
        JLabel lbl = new JLabel(label + ": ");
        lbl.setBackground(_background);
        JComboBox combobox = new JComboBox(values);
        combobox.setEditable(editable);
        combobox.setBackground(Color.white);
        combobox.setSelectedItem(defaultChoice);
        _addPair(name, lbl, combobox, combobox);
        combobox.addItemListener(new QueryItemListener(name));
    }

    public void addDisplay(String name, String label, String theValue)
    {
        JLabel lbl = new JLabel(label + ": ");
        lbl.setBackground(_background);
        JTextArea displayField = new JTextArea(theValue, 1, 10);
        displayField.setEditable(false);
        displayField.setBackground(_background);
        _addPair(name, lbl, displayField, displayField);
    }

    public void addLine(String name, String label, String defaultValue)
    {
        JLabel lbl = new JLabel(label + ": ");
        lbl.setBackground(_background);
        JTextField entryBox = new JTextField(defaultValue, _width);
        entryBox.setBackground(Color.white);
        _addPair(name, lbl, entryBox, entryBox);
        entryBox.addActionListener(new QueryActionListener(name));
        entryBox.addFocusListener(new QueryFocusListener(name));
    }

    public void addQueryListener(QueryListener listener)
    {
        if(_listeners == null)
            _listeners = new Vector();
        if(_listeners.contains(listener))
        {
            return;
        } else
        {
            _listeners.add(listener);
            return;
        }
    }

    public void addRadioButtons(String name, String label, String values[], String defaultValue)
    {
        JLabel lbl = new JLabel(label + ": ");
        lbl.setBackground(_background);
        FlowLayout flow = new FlowLayout();
        flow.setAlignment(0);
        Panel buttonPanel = new Panel(flow);
        ButtonGroup group = new ButtonGroup();
        QueryActionListener listener = new QueryActionListener(name);
        JRadioButton buttons[] = new JRadioButton[values.length];
        for(int i = 0; i < values.length; i++)
        {
            JRadioButton checkbox = new JRadioButton(values[i]);
            buttons[i] = checkbox;
            checkbox.setBackground(_background);
            checkbox.setOpaque(false);
            if(values[i].equals(defaultValue))
                checkbox.setSelected(true);
            group.add(checkbox);
            buttonPanel.add(checkbox);
            checkbox.addActionListener(listener);
        }

        _addPair(name, lbl, buttonPanel, buttons);
    }

    public void addSelectButtons(String name, String label, String values[], Set initiallySelected)
    {
        JLabel lbl = new JLabel(label + ": ");
        lbl.setBackground(_background);
        FlowLayout flow = new FlowLayout();
        flow.setAlignment(0);
        Panel buttonPanel = new Panel(flow);
        QueryActionListener listener = new QueryActionListener(name);
        if(initiallySelected == null)
            initiallySelected = new HashSet();
        JRadioButton buttons[] = new JRadioButton[values.length];
        for(int i = 0; i < values.length; i++)
        {
            JRadioButton checkbox = new JRadioButton(values[i]);
            buttons[i] = checkbox;
            checkbox.setBackground(_background);
            checkbox.setOpaque(false);
            if(initiallySelected.contains(values[i]))
                checkbox.setSelected(true);
            buttonPanel.add(checkbox);
            checkbox.addActionListener(listener);
        }

        _addPair(name, lbl, buttonPanel, buttons);
    }

    public void addSlider(String name, String label, int defaultValue, int minimum, int maximum)
        throws IllegalArgumentException
    {
        JLabel lbl = new JLabel(label + ": ");
        if(minimum > maximum)
        {
            int temp = minimum;
            minimum = maximum;
            maximum = temp;
        }
        if(defaultValue > maximum || defaultValue < minimum)
        {
            throw new IllegalArgumentException("Desired default value \"" + defaultValue + "\" does not fall " + "between the minimum and maximum.");
        } else
        {
            JSlider slider = new JSlider(minimum, maximum, defaultValue);
            _addPair(name, lbl, slider, slider);
            slider.addChangeListener(new SliderListener(name));
            return;
        }
    }

    public boolean booleanValue(String name)
        throws NoSuchElementException, IllegalArgumentException
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + "\" in the query box.");
        if(result instanceof JRadioButton)
            return ((JRadioButton)result).isSelected();
        else
            throw new IllegalArgumentException("Item named \"" + name + "\" is not a radio button, and hence does not have " + "a boolean value.");
    }

    public double doubleValue(String name)
        throws IllegalArgumentException, NoSuchElementException, NumberFormatException
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + " \" in the query box.");
        if(result instanceof JTextField)
            return (new Double(((JTextField)result).getText())).doubleValue();
        else
            throw new IllegalArgumentException("Item named \"" + name + "\" is not a text line, and hence cannot be converted to " + "a double value.");
    }

    public Dimension getMaximumSize()
    {
        return getPreferredSize();
    }

    public int getTextWidth()
    {
        return _width;
    }

    public int intValue(String name)
        throws IllegalArgumentException, NoSuchElementException, NumberFormatException
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + " \" in the query box.");
        if(result instanceof JTextField)
            return (new Integer(((JTextField)result).getText())).intValue();
        if(result instanceof JSlider)
            return ((JSlider)result).getValue();
        if(result instanceof JComboBox)
            return ((JComboBox)result).getSelectedIndex();
        if(result instanceof JRadioButton[])
        {
            JRadioButton buttons[] = (JRadioButton[])result;
            for(int i = 0; i < buttons.length; i++)
                if(buttons[i].isSelected())
                    return i;

            return -1;
        } else
        {
            throw new IllegalArgumentException("Item named \"" + name + "\" is not a text line or slider, and hence " + "cannot be converted to " + "an integer value.");
        }
    }

    public void notifyListeners()
    {
        String name;
        for(Iterator names = _entries.keySet().iterator(); names.hasNext(); _notifyListeners(name))
            name = (String)names.next();

    }

    public void removeQueryListener(QueryListener listener)
    {
        if(_listeners == null)
        {
            return;
        } else
        {
            _listeners.remove(listener);
            return;
        }
    }

    public void set(String name, String value)
        throws NoSuchElementException, IllegalArgumentException
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + " \" in the query box.");
        if(result instanceof JTextField)
            ((JTextField)result).setText(value);
        else
        if(result instanceof JTextArea)
            ((JTextArea)result).setText(value);
        else
        if(result instanceof JRadioButton)
        {
            Boolean flag = new Boolean(value);
            setBoolean(name, flag.booleanValue());
        } else
        if(result instanceof JSlider)
        {
            Integer parsed = new Integer(value);
            ((JSlider)result).setValue(parsed.intValue());
        } else
        if(result instanceof JComboBox)
            ((JComboBox)result).setSelectedItem(value);
        else
        if(result instanceof JRadioButton[])
        {
            Set selectedValues = new HashSet();
            for(StringTokenizer tokenizer = new StringTokenizer(value, ","); tokenizer.hasMoreTokens(); selectedValues.add(tokenizer.nextToken().trim()));
            JRadioButton buttons[] = (JRadioButton[])result;
            for(int i = 0; i < buttons.length; i++)
                if(selectedValues.contains(buttons[i].getText()))
                    buttons[i].setSelected(true);
                else
                    buttons[i].setSelected(false);

        } else
        {
            throw new IllegalArgumentException("Query class cannot set a string representation for entries of type " + result.getClass());
        }
        _previous.put(name, value);
    }

    public void setAndNotify(String name, String value)
        throws NoSuchElementException, IllegalArgumentException
    {
        set(name, value);
        _notifyListeners(name);
    }

    public void setBackground(Color color)
    {
        super.setBackground(color);
        _background = color;
        Component components[] = getComponents();
        for(int i = 0; i < components.length; i++)
            if(!(components[i] instanceof JTextField))
                components[i].setBackground(_background);

    }

    public void setBoolean(String name, boolean value)
        throws NoSuchElementException, IllegalArgumentException
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + "\" in the query box.");
        if(result instanceof JRadioButton)
            ((JRadioButton)result).setSelected(value);
        else
            throw new IllegalArgumentException("Item named \"" + name + "\" is not a radio button, and hence does not have " + "a boolean value.");
        _notifyListeners(name);
    }

    public void setDisplay(String name, String value)
        throws NoSuchElementException, IllegalArgumentException
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + " \" in the query box.");
        if(result instanceof JTextArea)
        {
            JTextArea label = (JTextArea)result;
            label.setText(value);
        } else
        {
            throw new IllegalArgumentException("Item named \"" + name + "\" is not a display, and hence cannot be set using " + "setDisplay().");
        }
        _notifyListeners(name);
    }

    public void setEnabled(String name, boolean value)
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + " \" in the query box.");
        if(result instanceof JComponent)
            ((JComponent)result).setEnabled(value);
        else
        if(result instanceof JRadioButton[])
        {
            JRadioButton buttons[] = (JRadioButton[])result;
            for(int i = 0; i < buttons.length; i++)
                buttons[i].setEnabled(value);

        }
    }

    public void setLine(String name, String value)
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + " \" in the query box.");
        if(result instanceof JTextField)
        {
            JTextField line = (JTextField)result;
            line.setText(value);
        } else
        {
            throw new IllegalArgumentException("Item named \"" + name + "\" is not a line, and hence cannot be set using " + "setLine().");
        }
        _notifyListeners(name);
    }

    public void setMessage(String message)
    {
        if(_messageArea == null)
        {
            _messageArea = new JTextArea(message);
            _messageArea.setFont(new Font("SansSerif", 0, 12));
            _messageArea.setEditable(false);
            _messageArea.setLineWrap(true);
            _messageArea.setWrapStyleWord(true);
            _messageArea.setBackground(getBackground());
            _messageArea.setAlignmentX(0.0F);
            _messagePanel.setLayout(new BoxLayout(_messagePanel, 1));
            _messagePanel.add(_messageArea);
            _messagePanel.add(Box.createRigidArea(new Dimension(0, 10)));
        } else
        {
            _messageArea.setText(message);
        }
        validate();
    }

    public void setSlider(String name, int value)
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + " \" in the query box.");
        if(result instanceof JSlider)
        {
            JSlider theSlider = (JSlider)result;
            theSlider.setValue(value);
        } else
        {
            throw new IllegalArgumentException("Item named \"" + name + "\" is not a slider, and hence cannot be set using " + "setSlider().");
        }
        _notifyListeners(name);
    }

    public void setTextWidth(int characters)
    {
        _width = characters;
    }

    public void setToolTip(String name, String tip)
    {
        JLabel label = (JLabel)_labels.get(name);
        if(label != null)
            label.setToolTipText(tip);
    }

    public String stringValue(String name)
        throws NoSuchElementException, IllegalArgumentException
    {
        Object result = _entries.get(name);
        if(result == null)
            throw new NoSuchElementException("No item named \"" + name + " \" in the query box.");
        if(result instanceof JTextField)
            return ((JTextField)result).getText();
        if(result instanceof JTextArea)
            return ((JTextArea)result).getText();
        if(result instanceof JRadioButton)
        {
            JRadioButton radioButton = (JRadioButton)result;
            if(radioButton.isSelected())
                return "true";
            else
                return "false";
        }
        if(result instanceof JSlider)
            return String.valueOf(((JSlider)result).getValue());
        if(result instanceof JComboBox)
            return (String)((JComboBox)result).getSelectedItem();
        if(result instanceof JRadioButton[])
        {
            JRadioButton buttons[] = (JRadioButton[])result;
            String toReturn = null;
            for(int i = 0; i < buttons.length; i++)
                if(buttons[i].isSelected())
                    if(toReturn == null)
                        toReturn = buttons[i].getText();
                    else
                        toReturn = toReturn + ", " + buttons[i].getText();

            if(toReturn == null)
                toReturn = "";
            return toReturn;
        } else
        {
            throw new IllegalArgumentException("Query class cannot generate a string representation for entries of type " + result.getClass());
        }
    }

    public static final int DEFAULT_ENTRY_WIDTH = 20;
    protected Color _background;
    protected GridBagLayout _grid;
    protected GridBagConstraints _constraints;
    protected Vector _listeners;
    private Map _entries;
    private JPanel _entryPanel;
    private Map _labels;
    private JTextArea _messageArea;
    private JPanel _messagePanel;
    private Map _previous;
    private int _width;
}