// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:01:08
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Top.java

package Holger_modules.ptolemy.gui;

import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.EventObject;
import javax.swing.*;

// Referenced classes of package ptolemy.gui:
//            ComponentDialog, MessageHandler, Query, StatusBar

public abstract class Top extends JFrame
{
    
    protected static File _directory = null;
    protected JMenu _fileMenu;
    protected JMenuItem _fileMenuItems[] = {
        new JMenuItem("Open File", 79), new JMenuItem("Open URL", 85), new JMenu("New"), new JMenuItem("Save", 83), new JMenuItem("SaveAs", 65), new JMenuItem("Print", 80), new JMenuItem("Close", 67), new JMenuItem("Exit", 88)
    };
    protected JMenu _helpMenu;
    protected JMenuItem _helpMenuItems[] = {
        new JMenuItem("About", 65), new JMenuItem("Help", 72)
    };
    protected JMenuBar _menubar;
    protected StatusBar _statusBar;
    private File _file;
    private String _lastURL;
    private boolean _modified;
    private boolean _menuPopulated;
    
    class FileMenuListener
        implements ActionListener
    {

        public void actionPerformed(ActionEvent e)
        {
            JMenuItem target = (JMenuItem)e.getSource();
            String actionCommand = target.getActionCommand();
            if(actionCommand.equals("Open File"))
                _open();
            else
            if(actionCommand.equals("Open URL"))
                _openURL();
            else
            if(actionCommand.equals("Save"))
                _save();
            else
            if(actionCommand.equals("SaveAs"))
                _saveAs();
            else
            if(actionCommand.equals("Print"))
                _print();
            else
            if(actionCommand.equals("Close"))
                _close();
            else
            if(actionCommand.equals("Exit"))
                _exit();
            repaint();
        }

        FileMenuListener()
        {
        }
    }

    class HelpMenuListener
        implements ActionListener
    {

        public void actionPerformed(ActionEvent e)
        {
            JMenuItem target = (JMenuItem)e.getSource();
            String actionCommand = target.getActionCommand();
            if(actionCommand.equals("About"))
                _about();
            else
            if(actionCommand.equals("Help"))
                _help();
            repaint();
        }

        HelpMenuListener()
        {
        }
    }


    public Top()
    {
        _fileMenu = new JMenu("File");
        _helpMenu = new JMenu("Help");
        _menubar = new JMenuBar();
        _statusBar = new StatusBar();
        _file = null;
        _lastURL = "http://ptolemy.eecs.berkeley.edu/xml/models/";
        _modified = false;
        _menuPopulated = false;
        setDefaultCloseOperation(0);
        addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent e)
            {
                _close();
            }

        });
        getContentPane().setLayout(new BorderLayout());
    }

    protected void _about()
    {
        JOptionPane.showMessageDialog(this, "Ptolemy II " + getClass().getName() + "\n" + "By: Claudius Ptolemaeus, ptolemy@eecs.berkeley.edu\n" + "For more information, see\n" + "http://ptolemy.eecs.berkeley.edu/ptolemyII\n\n" + "Copyright (c) 1997-2000, " + "The Regents of the University of California.", "About Ptolemy II", 1);
    }

    protected void _addMenus()
    {
    }

    protected boolean _clear()
    {
        return _queryForSave();
    }

    protected boolean _close()
    {
        if(isModified())
        {
            if(_queryForSave())
            {
                dispose();
                return true;
            } else
            {
                return false;
            }
        } else
        {
            dispose();
            return true;
        }
    }

    protected void _exit()
    {
        if(isModified())
        {
            if(_queryForSave())
                System.exit(0);
        } else
        {
            System.exit(0);
        }
    }

    protected String _getName()
    {
        if(_file == null)
            return "Unnamed";
        else
            return _file.getName();
    }

    protected void _help()
    {
        _about();
    }

    protected void _open()
    {
        JFileChooser fileDialog = new JFileChooser();
        fileDialog.setDialogTitle("Select a model file.");
        if(_directory != null)
        {
            fileDialog.setCurrentDirectory(_directory);
        } else
        {
            String cwd = System.getProperty("user.dir");
            if(cwd != null)
                fileDialog.setCurrentDirectory(new File(cwd));
        }
        int returnVal = fileDialog.showOpenDialog(this);
        if(returnVal == 0)
        {
            _directory = fileDialog.getCurrentDirectory();
            try
            {
                File file = fileDialog.getSelectedFile().getCanonicalFile();
                _read(file.toURL());
            }
            catch(Exception ex)
            {
                report("Error reading input", ex);
            }
        }
    }

    protected void _openURL()
    {
        Query query = new Query();
        query.setTextWidth(60);
        query.addLine("url", "URL", _lastURL);
        ComponentDialog dialog = new ComponentDialog(this, "Open URL", query);
        if(dialog.buttonPressed().equals("OK"))
        {
            _lastURL = query.stringValue("url");
            try
            {
                URL url = new URL(_lastURL);
                _read(url);
            }
            catch(Exception ex)
            {
                report("Error reading URL:\n" + _lastURL, ex);
            }
        }
    }

    protected void _print()
    {
        PrinterJob job = PrinterJob.getPrinterJob();
        if(this instanceof Pageable)
            job.setPageable((Pageable)this);
        else
        if(this instanceof Printable)
        {
            java.awt.print.PageFormat format = job.pageDialog(job.defaultPage());
            job.setPrintable((Printable)this, format);
        } else
        {
            return;
        }
        if(job.printDialog())
            try
            {
                job.print();
            }
            catch(Exception ex)
            {
                MessageHandler.error("Printing Failed", ex);
            }
    }

    private boolean _queryForSave()
    {
        Object options[] = {
            "Save", "Discard changes", "Cancel"
        };
        String query = "Save changes to " + _getName() + "?";
        int selected = JOptionPane.showOptionDialog(this, query, "Save Changes?", 1, 3, null, options, options[0]);
        if(selected == 0)
            return _save();
        return selected == 1;
    }

    protected abstract void _read(URL url)
        throws Exception;

    protected boolean _save()
    {
        if(_file != null)
        {
            try
            {
                _writeFile(_file);
                setModified(false);
                return true;
            }
            catch(IOException ex)
            {
                report("Error writing file", ex);
            }
            return false;
        } else
        {
            return _saveAs();
        }
    }

    protected boolean _saveAs()
    {
        JFileChooser fileDialog = new JFileChooser();
        fileDialog.setDialogTitle("Save as...");
        if(_directory != null)
        {
            fileDialog.setCurrentDirectory(_directory);
        } else
        {
            String cwd = System.getProperty("user.dir");
            if(cwd != null)
                fileDialog.setCurrentDirectory(new File(cwd));
        }
        int returnVal = fileDialog.showSaveDialog(this);
        if(returnVal == 0)
        {
            _file = fileDialog.getSelectedFile();
            if(_file.exists())
            {
                String query = "Overwrite " + _file.getName() + "?";
                int selected = JOptionPane.showOptionDialog(this, query, "Save Changes?", 0, 3, null, null, null);
                if(selected == 1)
                    return false;
            }
            setTitle(_getName());
            _directory = fileDialog.getCurrentDirectory();
            return _save();
        } else
        {
            return false;
        }
    }

    protected abstract void _writeFile(File file)
        throws IOException;

    public void centerOnScreen()
    {
        Toolkit tk = Toolkit.getDefaultToolkit();
        setLocation((tk.getScreenSize().width - getSize().width) / 2, (tk.getScreenSize().height - getSize().height) / 2);
    }

    public boolean isModified()
    {
        return _modified;
    }

    public void pack()
    {
        if(!_menuPopulated)
        {
            _menuPopulated = true;
            _fileMenu.setMnemonic(70);
            _helpMenu.setMnemonic(72);
            _fileMenuItems[0].setAccelerator(KeyStroke.getKeyStroke(79, 2));
            _fileMenuItems[2].setMnemonic(78);
            _fileMenuItems[2].setEnabled(false);
            _fileMenuItems[3].setAccelerator(KeyStroke.getKeyStroke(83, 2));
            _fileMenuItems[5].setAccelerator(KeyStroke.getKeyStroke(80, 2));
            if((this instanceof Printable) || (this instanceof Pageable))
                _fileMenuItems[5].setEnabled(true);
            else
                _fileMenuItems[5].setEnabled(false);
            _fileMenuItems[6].setAccelerator(KeyStroke.getKeyStroke(87, 2));
            FileMenuListener fml = new FileMenuListener();
            for(int i = 0; i < _fileMenuItems.length; i++)
            {
                _fileMenuItems[i].setActionCommand(_fileMenuItems[i].getText());
                _fileMenuItems[i].addActionListener(fml);
                _fileMenu.add(_fileMenuItems[i]);
            }

            _menubar.add(_fileMenu);
            HelpMenuListener sml = new HelpMenuListener();
            for(int i = 0; i < _helpMenuItems.length; i++)
            {
                _helpMenuItems[i].setActionCommand(_helpMenuItems[i].getText());
                _helpMenuItems[i].addActionListener(sml);
                _helpMenu.add(_helpMenuItems[i]);
            }

            _addMenus();
            _menubar.add(_helpMenu);
            setJMenuBar(_menubar);
            getContentPane().add(_statusBar, "South");
        }
        super.pack();
    }

    public void report(Exception ex)
    {
        report("", ex);
    }

    public void report(String message)
    {
        _statusBar.setMessage(message);
    }

    public void report(String message, Exception ex)
    {
        _statusBar.setMessage("Exception. " + message);
        MessageHandler.error(message, ex);
    }

    public void setBackground(Color background)
    {
        super.setBackground(background);
        if(_statusBar != null)
            _statusBar.setBackground(background);
    }

    public void setModified(boolean modified)
    {
        _modified = modified;
    }
}