// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:02:07
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Histogram.java

package Holger_modules.ptolemy.plot;

import java.awt.Component;
import java.awt.Graphics;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.*;
import javax.swing.JComponent;

// Referenced classes of package ptolemy.plot:
//            PlotBox

public class Histogram extends PlotBox
{

    public Histogram()
    {
        _currentdataset = -1;
        _points = new Vector();
        _histogram = new Vector();
        _barwidth = 0.5D;
        _baroffset = 0.14999999999999999D;
        _binWidth = 1.0D;
        _binOffset = 0.5D;
        _filename = null;
        _showing = false;
    }

    private void _addPoint(int dataset, double value)
    {
        _checkDatasetIndex(dataset);
        int bin = (int)Math.round((value - _binOffset) / _binWidth);
        Integer binobj = new Integer(bin);
        Hashtable bins = (Hashtable)_histogram.elementAt(dataset);
        int count;
        if(bins.containsKey(binobj))
        {
            count = 1 + ((Integer)bins.get(binobj)).intValue();
            bins.put(binobj, new Integer(count));
        } else
        {
            count = 1;
            bins.put(binobj, new Integer(count));
        }
        double x = (double)bin * _binWidth + _binOffset;
        if(x < super._xBottom)
            super._xBottom = x;
        double xtop = x + _binWidth / 2D;
        if(xtop > super._xTop)
            super._xTop = xtop;
        if((double)count > super._yTop)
            super._yTop = count;
        super._yBottom = 0.0D;
        Vector pts = (Vector)_points.elementAt(dataset);
        pts.addElement(new Double(value));
        Graphics graphics = getGraphics();
        if(_showing && graphics != null)
        {
            int pendingDataset = dataset;
            int pendingBin = bin;
            int pendingCount = count;
            _drawPlotPoint(graphics, pendingDataset, pendingBin, pendingCount);
        }
    }

    protected void _checkDatasetIndex(int dataset)
    {
        if(dataset < 0)
            throw new IllegalArgumentException("Plot._checkDatasetIndex: Cannot give a negative number for the data set index.");
        for(; dataset >= _points.size(); _histogram.addElement(new Hashtable()))
            _points.addElement(new Vector());

    }

    private void _clear(boolean format)
    {
        super.clear(format);
        _currentdataset = -1;
        _points = new Vector();
        _histogram = new Vector();
        _filename = null;
        _showing = false;
        if(format)
        {
            _barwidth = 0.5D;
            _baroffset = 0.14999999999999999D;
            _binWidth = 1.0D;
            _binOffset = 0.5D;
        }
    }

    protected void _drawBar(Graphics graphics, int dataset, long xpos, long ypos, boolean clip)
    {
        if(clip)
        {
            if(ypos < (long)super._uly)
                ypos = super._uly;
            if(ypos > (long)super._lry)
                ypos = super._lry;
        }
        if(ypos <= (long)super._lry && xpos <= (long)super._lrx && xpos >= (long)super._ulx)
        {
            int barlx = (int)(((double)xpos - (_barwidth * _binWidth * super._xscale) / 2D) + (double)dataset * _baroffset * _binWidth * super._xscale);
            int barrx = (int)((double)barlx + _barwidth * _binWidth * super._xscale);
            if(barlx < super._ulx)
                barlx = super._ulx;
            if(barrx > super._lrx)
                barrx = super._lrx;
            if(barlx >= barrx)
                barrx = barlx + 1;
            long zeroypos = (long)super._lry - (long)((0.0D - super._yMin) * super._yscale);
            if((long)super._lry < zeroypos)
                zeroypos = super._lry;
            if((long)super._uly > zeroypos)
                zeroypos = super._uly;
            if(super._yMin >= 0.0D || ypos <= zeroypos)
                graphics.fillRect(barlx, (int)ypos, barrx - barlx, (int)(zeroypos - ypos));
            else
                graphics.fillRect(barlx, (int)zeroypos, barrx - barlx, (int)(ypos - zeroypos));
        }
    }

    protected synchronized void _drawPlot(Graphics graphics, boolean clearfirst)
    {
        super._drawPlot(graphics, clearfirst);
        _showing = true;
        for(int dataset = _points.size() - 1; dataset >= 0; dataset--)
        {
            Hashtable data = (Hashtable)_histogram.elementAt(dataset);
            Integer bin;
            Integer count;
            for(Enumeration keys = data.keys(); keys.hasMoreElements(); _drawPlotPoint(graphics, dataset, bin.intValue(), count.intValue()))
            {
                bin = (Integer)keys.nextElement();
                count = (Integer)data.get(bin);
            }

        }

    }

    private void _drawPlotPoint(Graphics graphics, int dataset, int bin, int count)
    {
        if(super._usecolor)
        {
            int color = dataset % PlotBox._colors.length;
            graphics.setColor(PlotBox._colors[color]);
        } else
        {
            graphics.setColor(super._foreground);
        }
        double y = count;
        double x = _binWidth * (double)bin + _binOffset;
        if(super._xlog)
        {
            if(x <= 0.0D)
            {
                System.err.println("Can't plot non-positive X values when the logarithmic X axis value is specified: " + x);
                return;
            }
            x = Math.log(x) * PlotBox._LOG10SCALE;
        }
        if(super._ylog)
        {
            if(y <= 0.0D)
            {
                System.err.println("Can't plot non-positive Y values when the logarithmic Y axis value is specified: " + y);
                return;
            }
            y = Math.log(y) * PlotBox._LOG10SCALE;
        }
        long ypos = (long)super._lry - (long)((y - super._yMin) * super._yscale);
        long xpos = (long)super._ulx + (long)((x - super._xMin) * super._xscale);
        _drawBar(graphics, dataset, xpos, ypos, true);
        graphics.setColor(super._foreground);
    }

    private void _fillPlot()
    {
        super.fillPlot();
    }

    protected boolean _parseLine(String line)
    {
        if(super._parseLine(line))
            return true;
        String lcLine = new String(line.toLowerCase());
        if(lcLine.startsWith("dataset:"))
        {
            _currentdataset++;
            if(lcLine.length() > 0)
            {
                String legend = line.substring(8).trim();
                if(legend != null && legend.length() > 0)
                    addLegend(_currentdataset, legend);
            }
            return true;
        }
        if(lcLine.startsWith("bars:") || lcLine.startsWith("bargraph:"))
        {
            int comma = line.indexOf(",", 5);
            String baroffset = null;
            String barwidth;
            if(comma > 0)
            {
                barwidth = line.substring(5, comma).trim();
                baroffset = line.substring(comma + 1).trim();
            } else
            {
                barwidth = line.substring(5).trim();
            }
            try
            {
                Double bwidth = new Double(barwidth);
                double boffset = _baroffset;
                if(baroffset != null)
                    boffset = (new Double(baroffset)).doubleValue();
                setBars(bwidth.doubleValue(), boffset);
            }
            catch(NumberFormatException _ex) { }
            return true;
        }
        if(lcLine.startsWith("binwidth:"))
        {
            String binwidth = line.substring(9).trim();
            try
            {
                Double bwidth = new Double(binwidth);
                setBinWidth(bwidth.doubleValue());
            }
            catch(NumberFormatException _ex) { }
            return true;
        }
        if(lcLine.startsWith("binoffset:"))
        {
            String binoffset = line.substring(10).trim();
            try
            {
                Double boffset = new Double(binoffset);
                setBinOffset(boffset.doubleValue());
            }
            catch(NumberFormatException _ex) { }
            return true;
        }
        if(lcLine.startsWith("numsets:"))
            return true;
        if(line.startsWith("move:"))
            line = line.substring(5, line.length()).trim();
        else
        if(line.startsWith("move"))
            line = line.substring(4, line.length()).trim();
        else
        if(line.startsWith("draw:"))
            line = line.substring(5, line.length()).trim();
        else
        if(line.startsWith("draw"))
            line = line.substring(4, line.length()).trim();
        line = line.trim();
        int fieldsplit = line.indexOf(",");
        if(fieldsplit == -1)
            fieldsplit = line.indexOf(" ");
        if(fieldsplit == -1)
            fieldsplit = line.indexOf("\t");
        if(fieldsplit == -1)
        {
            try
            {
                Double xpt = new Double(line);
                addPoint(_currentdataset, xpt.doubleValue());
                return true;
            }
            catch(NumberFormatException _ex) { }
        } else
        {
            String y = line.substring(fieldsplit + 1).trim();
            try
            {
                Double ypt = new Double(y);
                addPoint(_currentdataset, ypt.doubleValue());
                return true;
            }
            catch(NumberFormatException _ex) { }
        }
        return false;
    }

    public void addLegend(int dataset, String legend)
    {
        _checkDatasetIndex(dataset);
        super.addLegend(dataset, legend);
    }

    public synchronized void addPoint(final int dataset, final double value)
    {
       // Runnable doAddPoint = value. new Runnable() {
            Runnable doAddPoint = new Runnable() {
            public void run()
            {
                _addPoint(dataset, value);
            }

        };
        _deferIfNecessary(doAddPoint);
    }

    public synchronized void addPoint(int dataset, double x, double y, boolean connected)
    {
        addPoint(dataset, y);
    }

    public synchronized void clear(final boolean format)
    {
        Runnable doClear = new Runnable() {

            public void run()
            {
                _clear(format);
            }

        };
        _deferIfNecessary(doClear);
    }

    public synchronized void fillPlot()
    {
        Runnable doFill = new Runnable() {

            public void run()
            {
                _fillPlot();
            }

        };
        _deferIfNecessary(doFill);
    }

    public synchronized void samplePlot()
    {
        clear(true);
        setTitle("Sample histogram");
        setXLabel("values");
        setYLabel("count");
        Random random = new Random();
        for(int i = 0; i <= 1000; i++)
        {
            addPoint(0, 5D * Math.cos((3.1415926535897931D * (double)i) / 500D));
            addPoint(1, 10D * random.nextDouble() - 5D);
            addPoint(2, 2D * random.nextGaussian());
        }

        repaint();
    }

    public synchronized void setBars(double width, double offset)
    {
        _barwidth = width;
        _baroffset = offset;
    }

    public synchronized void setBinOffset(double offset)
    {
        _binOffset = offset;
    }

    public void setBinWidth(double width)
    {
        _binWidth = width;
    }

    public synchronized void writeData(PrintWriter output)
    {
        super.writeData(output);
        for(int dataset = 0; dataset < _points.size(); dataset++)
        {
            String legend = getLegend(dataset);
            if(legend != null)
                output.println("<dataset name=\"" + legend + "\">");
            else
                output.println("<dataset>");
            Vector pts = (Vector)_points.elementAt(dataset);
            for(int pointnum = 0; pointnum < pts.size(); pointnum++)
            {
                Double pt = (Double)pts.elementAt(pointnum);
                output.println("<p y=\"" + pt.doubleValue() + "\"/");
            }

            output.println("</dataset>");
        }

    }

    public synchronized void writeFormat(PrintWriter output)
    {
        super.writeFormat(output);
        output.println("<barGraph width=\"" + _barwidth + "\" offset=\"" + _baroffset + "\"/>");
        output.println("<bin width=\"" + _binWidth + "\" offset=\"" + _binOffset + "\"/>");
    }

    protected int _currentdataset;
    protected Vector _points;
    protected Vector _histogram;
    private double _barwidth;
    private double _baroffset;
    private double _binWidth;
    private double _binOffset;
    private String _filename;
    private boolean _showing;



}