// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:02:12
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   Plot.java

package Holger_modules.ptolemy.plot;

import java.awt.*;
import java.io.*;
import java.net.URL;
import java.util.Vector;
import javax.swing.JComponent;

// Referenced classes of package ptolemy.plot:
//            PlotBox, EPSGraphics, PlotPoint

public class Plot extends PlotBox
{
    private class Format
        implements Serializable
    {

        public boolean connected;
        public boolean connectedUseDefault;
        public boolean impulses;
        public boolean impulsesUseDefault;
        public int marks;
        public boolean marksUseDefault;

        Format()
        {
            connectedUseDefault = true;
            impulsesUseDefault = true;
            marksUseDefault = true;
        }
    }


    public Plot()
    {
        _currentdataset = -1;
        _points = new Vector();
        _pointsPersistence = 0;
        _xPersistence = 0.0D;
        _bars = false;
        _barwidth = 0.5D;
        _baroffset = 0.050000000000000003D;
        _connected = true;
        _impulses = false;
        _maxdataset = -1;
        _reusedatasets = false;
        _firstinset = true;
        _sawfirstdataset = false;
        _radius = 3;
        _diameter = 6;
        _prevx = new Vector();
        _prevy = new Vector();
        _xyInvalid = true;
        _filename = null;
        _showing = false;
        _formats = new Vector();
    }

    private boolean _addLegendIfNecessary(boolean connected)
    {
        if((!_sawfirstdataset || _currentdataset < 0) && !_reusedatasets)
        {
            _sawfirstdataset = true;
            _currentdataset++;
        }
        if(!_sawfirstdataset && getLegend(_currentdataset) == null)
        {
            _firstinset = true;
            _sawfirstdataset = true;
            addLegend(_currentdataset, new String("Set " + _currentdataset));
        }
        if(_firstinset && !_reusedatasets)
        {
            connected = false;
            _firstinset = false;
        }
        return connected;
    }

    private void _addPoint(int dataset, double x, double y, double yLowEB, 
            double yHighEB, boolean connected, boolean errorBar)
    {
        _checkDatasetIndex(dataset);
        if(super._xlog)
        {
            if(x <= 0.0D)
            {
                System.err.println("Can't plot non-positive X values when the logarithmic X axis value is specified: " + x);
                return;
            }
            x = Math.log(x) * PlotBox._LOG10SCALE;
        }
        if(super._ylog)
        {
            if(y <= 0.0D)
            {
                System.err.println("Can't plot non-positive Y values when the logarithmic Y axis value is specified: " + y);
                return;
            }
            y = Math.log(y) * PlotBox._LOG10SCALE;
            if(errorBar)
            {
                if(yLowEB <= 0.0D || yHighEB <= 0.0D)
                {
                    System.err.println("Can't plot non-positive Y values when the logarithmic Y axis value is specified: " + y);
                    return;
                }
                yLowEB = Math.log(yLowEB) * PlotBox._LOG10SCALE;
                yHighEB = Math.log(yHighEB) * PlotBox._LOG10SCALE;
            }
        }
        Vector pts = (Vector)_points.elementAt(dataset);
        if(_xPersistence > 0.0D)
        {
            int numToDelete;
            for(numToDelete = 0; numToDelete < pts.size(); numToDelete++)
            {
                PlotPoint old = (PlotPoint)pts.elementAt(numToDelete);
                if(x - old.originalx <= _xPersistence)
                    break;
            }

            for(int i = 0; i < numToDelete; i++)
                erasePoint(dataset, 0);

        }
        int size = pts.size();
        PlotPoint pt = new PlotPoint();
        pt.originalx = x;
        if(super._wrap)
        {
            double width = super._wrapHigh - super._wrapLow;
            if(x < super._wrapLow)
                x += width * Math.floor(1.0D + (super._wrapLow - x) / width);
            else
            if(x > super._wrapHigh)
            {
                x -= width * Math.floor(1.0D + (x - super._wrapHigh) / width);
                if(x == super._wrapLow)
                    x = super._wrapHigh;
            }
        }
        if(x < super._xBottom)
            super._xBottom = x;
        if(x > super._xTop)
            super._xTop = x;
        if(y < super._yBottom)
            super._yBottom = y;
        if(y > super._yTop)
            super._yTop = y;
        pt.x = x;
        pt.y = y;
        pt.connected = connected && _isConnected(dataset);
        if(errorBar)
        {
            if(yLowEB < super._yBottom)
                super._yBottom = yLowEB;
            if(yLowEB > super._yTop)
                super._yTop = yLowEB;
            if(yHighEB < super._yBottom)
                super._yBottom = yHighEB;
            if(yHighEB > super._yTop)
                super._yTop = yHighEB;
            pt.yLowEB = yLowEB;
            pt.yHighEB = yHighEB;
            pt.errorBar = true;
        }
        if(size == 0)
            pt.connected = false;
        else
        if(super._wrap)
        {
            PlotPoint old = (PlotPoint)pts.elementAt(size - 1);
            if(old.x > x)
                pt.connected = false;
        }
        pts.addElement(pt);
        if(_pointsPersistence > 0 && size > _pointsPersistence)
            erasePoint(dataset, 0);
        Graphics graphics = getGraphics();
        if(_showing && graphics != null)
        {
            if((_pointsPersistence > 0 || _xPersistence > 0.0D) && isDoubleBuffered())
            {
                setDoubleBuffered(false);
                for(Component parent = getParent(); parent != null; parent = parent.getParent())
                    if(parent instanceof JComponent)
                        ((JComponent)parent).setDoubleBuffered(false);

            }
            _drawPlotPoint(graphics, dataset, pts.size() - 1);
        }
        if(super._wrap && x == super._wrapHigh)
            _addPoint(dataset, super._wrapLow, y, yLowEB, yHighEB, false, errorBar);
    }

    protected synchronized void _checkDatasetIndex(int dataset)
    {
        if(dataset < 0)
            throw new IllegalArgumentException("Plot._checkDatasetIndex: Cannot give a negative number for the data set index.");
        for(; dataset >= _points.size(); _prevy.addElement(new Long(0L)))
        {
            _points.addElement(new Vector());
            _formats.addElement(new Format());
            _prevx.addElement(new Long(0L));
        }

    }

    private void _clear(int dataset)
    {
        _checkDatasetIndex(dataset);
        _xyInvalid = true;
        Vector points = (Vector)_points.elementAt(dataset);
        _points.setElementAt(new Vector(), dataset);
        repaint();
    }

    private void _clear(boolean format)
    {
        super.clear(format);
        _currentdataset = -1;
        int size = _points.size();
        _points = new Vector();
        _prevx = new Vector();
        _prevy = new Vector();
        _maxdataset = -1;
        _firstinset = true;
        _sawfirstdataset = false;
        _xyInvalid = true;
        _filename = null;
        if(format)
        {
            _showing = false;
            _formats = new Vector();
            _marks = 0;
            _pointsPersistence = 0;
            _xPersistence = 0.0D;
            _bars = false;
            _barwidth = 0.5D;
            _baroffset = 0.050000000000000003D;
            _connected = true;
            _impulses = false;
            _reusedatasets = false;
        }
    }

    protected void _drawBar(Graphics graphics, int dataset, long xpos, long ypos, boolean clip)
    {
        if(clip)
        {
            if(ypos < (long)super._uly)
                ypos = super._uly;
            if(ypos > (long)super._lry)
                ypos = super._lry;
        }
        if(ypos <= (long)super._lry && xpos <= (long)super._lrx && xpos >= (long)super._ulx)
        {
            int barlx = (int)(((double)xpos - (_barwidth * super._xscale) / 2D) + (double)dataset * _baroffset * super._xscale);
            int barrx = (int)((double)barlx + _barwidth * super._xscale);
            if(barlx < super._ulx)
                barlx = super._ulx;
            if(barrx > super._lrx)
                barrx = super._lrx;
            if(barlx >= barrx)
                barrx = barlx + 1;
            long zeroypos = (long)super._lry - (long)((0.0D - super._yMin) * super._yscale);
            if((long)super._lry < zeroypos)
                zeroypos = super._lry;
            if((long)super._uly > zeroypos)
                zeroypos = super._uly;
            if(super._yMin >= 0.0D || ypos <= zeroypos)
                graphics.fillRect(barlx, (int)ypos, barrx - barlx, (int)(zeroypos - ypos));
            else
                graphics.fillRect(barlx, (int)zeroypos, barrx - barlx, (int)(ypos - zeroypos));
        }
    }

    protected void _drawErrorBar(Graphics graphics, int dataset, long xpos, long yLowEBPos, long yHighEBPos, boolean clip)
    {
        _drawLine(graphics, dataset, xpos - 5L, yHighEBPos, xpos + 5L, yHighEBPos, clip);
        _drawLine(graphics, dataset, xpos, yLowEBPos, xpos, yHighEBPos, clip);
        _drawLine(graphics, dataset, xpos - 5L, yLowEBPos, xpos + 5L, yLowEBPos, clip);
    }

    protected void _drawImpulse(Graphics graphics, long xpos, long ypos, boolean clip)
    {
        if(clip)
        {
            if(ypos < (long)super._uly)
                ypos = super._uly;
            if(ypos > (long)super._lry)
                ypos = super._lry;
        }
        if(ypos <= (long)super._lry && xpos <= (long)super._lrx && xpos >= (long)super._ulx)
        {
            double zeroypos = (long)super._lry - (long)((0.0D - super._yMin) * super._yscale);
            if((double)super._lry < zeroypos)
                zeroypos = super._lry;
            if((double)super._uly > zeroypos)
                zeroypos = super._uly;
            graphics.drawLine((int)xpos, (int)ypos, (int)xpos, (int)zeroypos);
        }
    }

    protected void _drawLine(Graphics graphics, int dataset, long startx, long starty, long endx, long endy, boolean clip)
    {
        if(clip)
        {
            if((endx > (long)super._ulx || startx > (long)super._ulx) && (endx < (long)super._lrx || startx < (long)super._lrx) && (endy > (long)super._uly || starty > (long)super._uly) && (endy < (long)super._lry || starty < (long)super._lry))
            {
                if(startx != endx)
                    if(endx < (long)super._ulx)
                    {
                        endy = (int)(endy + ((starty - endy) * ((long)super._ulx - endx)) / (startx - endx));
                        endx = super._ulx;
                    } else
                    if(endx > (long)super._lrx)
                    {
                        endy = (int)(endy + ((starty - endy) * ((long)super._lrx - endx)) / (startx - endx));
                        endx = super._lrx;
                    }
                if(starty != endy)
                    if(endy < (long)super._uly)
                    {
                        endx = (int)(endx + ((startx - endx) * ((long)super._uly - endy)) / (starty - endy));
                        endy = super._uly;
                    } else
                    if(endy > (long)super._lry)
                    {
                        endx = (int)(endx + ((startx - endx) * ((long)super._lry - endy)) / (starty - endy));
                        endy = super._lry;
                    }
                if(startx != endx)
                    if(startx < (long)super._ulx)
                    {
                        starty = (int)(starty + ((endy - starty) * ((long)super._ulx - startx)) / (endx - startx));
                        startx = super._ulx;
                    } else
                    if(startx > (long)super._lrx)
                    {
                        starty = (int)(starty + ((endy - starty) * ((long)super._lrx - startx)) / (endx - startx));
                        startx = super._lrx;
                    }
                if(starty != endy)
                    if(starty < (long)super._uly)
                    {
                        startx = (int)(startx + ((endx - startx) * ((long)super._uly - starty)) / (endy - starty));
                        starty = super._uly;
                    } else
                    if(starty > (long)super._lry)
                    {
                        startx = (int)(startx + ((endx - startx) * ((long)super._lry - starty)) / (endy - starty));
                        starty = super._lry;
                    }
            }
            if(endx >= (long)super._ulx && endx <= (long)super._lrx && endy >= (long)super._uly && endy <= (long)super._lry && startx >= (long)super._ulx && startx <= (long)super._lrx && starty >= (long)super._uly && starty <= (long)super._lry)
                graphics.drawLine((int)startx, (int)starty, (int)endx, (int)endy);
        } else
        {
            graphics.drawLine((int)startx, (int)starty, (int)endx, (int)endy);
        }
    }

    protected synchronized void _drawPlot(Graphics graphics, boolean clearfirst, Rectangle drawRectangle)
    {
        super._drawPlot(graphics, clearfirst, drawRectangle);
        for(int dataset = _points.size() - 1; dataset >= 0; dataset--)
        {
            Vector data = (Vector)_points.elementAt(dataset);
            for(int pointnum = 0; pointnum < data.size(); pointnum++)
                _drawPlotPoint(graphics, dataset, pointnum);

        }

        _showing = true;
    }

    private void _drawPlotPoint(Graphics graphics, int dataset, int index)
    {
        if(_pointsPersistence > 0 || _xPersistence > 0.0D)
            if(super._background == null)
                graphics.setXORMode(getBackground());
            else
                graphics.setXORMode(super._background);
        if(super._usecolor)
        {
            int color = dataset % PlotBox._colors.length;
            graphics.setColor(PlotBox._colors[color]);
        } else
        {
            graphics.setColor(super._foreground);
        }
        Vector pts = (Vector)_points.elementAt(dataset);
        PlotPoint pt = (PlotPoint)pts.elementAt(index);
        long ypos = (long)super._lry - (long)((pt.y - super._yMin) * super._yscale);
        long xpos = (long)super._ulx + (long)((pt.x - super._xMin) * super._xscale);
        long prevx = ((Long)_prevx.elementAt(dataset)).longValue();
        long prevy = ((Long)_prevy.elementAt(dataset)).longValue();
        if(pt.connected)
            _drawLine(graphics, dataset, xpos, ypos, prevx, prevy, true);
        _prevx.setElementAt(new Long(xpos), dataset);
        _prevy.setElementAt(new Long(ypos), dataset);
        Format fmt = (Format)_formats.elementAt(dataset);
        if(fmt.impulsesUseDefault)
        {
            if(_impulses)
                _drawImpulse(graphics, xpos, ypos, true);
        } else
        if(fmt.impulses)
            _drawImpulse(graphics, xpos, ypos, true);
        int marks = _marks;
        if(!fmt.marksUseDefault)
            marks = fmt.marks;
        if(marks != 0)
            _drawPoint(graphics, dataset, xpos, ypos, true);
        if(_bars)
            _drawBar(graphics, dataset, xpos, ypos, true);
        if(pt.errorBar)
            _drawErrorBar(graphics, dataset, xpos, (long)super._lry - (long)((pt.yLowEB - super._yMin) * super._yscale), (long)super._lry - (long)((pt.yHighEB - super._yMin) * super._yscale), true);
        graphics.setColor(super._foreground);
        if(_pointsPersistence > 0 || _xPersistence > 0.0D)
            graphics.setPaintMode();
    }

    protected void _drawPoint(Graphics graphics, int dataset, long xpos, long ypos, boolean clip)
    {
        boolean pointinside = ypos <= (long)super._lry && ypos >= (long)super._uly && xpos <= (long)super._lrx && xpos >= (long)super._ulx;
        if(!clip || pointinside)
        {
            int xposi = (int)xpos;
            int yposi = (int)ypos;
            Format fmt = (Format)_formats.elementAt(dataset);
            int marks = _marks;
            if(!fmt.marksUseDefault)
                marks = fmt.marks;
            if(!pointinside && marks != 3 && _isConnected(dataset) && (graphics instanceof EPSGraphics))
                graphics.drawLine(xposi - 6, yposi, xposi + 6, yposi);
            else
                switch(marks)
                {
                default:
                    break;

                case 0: // '\0'
                    graphics.fillRect(xposi - 6, yposi - 6, 6, 6);
                    break;

                case 1: // '\001'
                    graphics.fillOval(xposi - 1, yposi - 1, 3, 3);
                    break;

                case 2: // '\002'
                    graphics.fillOval(xposi - _radius, yposi - _radius, _diameter, _diameter);
                    break;

                case 3: // '\003'
                    int mark = dataset % 10;
                    switch(mark)
                    {
                    case 0: // '\0'
                    {
                        graphics.fillOval(xposi - _radius, yposi - _radius, _diameter, _diameter);
                        break;
                    }

                    case 1: // '\001'
                    {
                        graphics.drawLine(xposi - _radius, yposi - _radius, xposi + _radius, yposi + _radius);
                        graphics.drawLine(xposi + _radius, yposi - _radius, xposi - _radius, yposi + _radius);
                        break;
                    }

                    case 2: // '\002'
                    {
                        graphics.drawRect(xposi - _radius, yposi - _radius, _diameter, _diameter);
                        break;
                    }

                    case 3: // '\003'
                    {
                        int xpoints[] = new int[4];
                        int ypoints[] = new int[4];
                        xpoints[0] = xposi;
                        ypoints[0] = yposi - _radius;
                        xpoints[1] = xposi + _radius;
                        ypoints[1] = yposi + _radius;
                        xpoints[2] = xposi - _radius;
                        ypoints[2] = yposi + _radius;
                        xpoints[3] = xposi;
                        ypoints[3] = yposi - _radius;
                        graphics.fillPolygon(xpoints, ypoints, 4);
                        break;
                    }

                    case 4: // '\004'
                    {
                        int xpoints[] = new int[5];
                        int ypoints[] = new int[5];
                        xpoints[0] = xposi;
                        ypoints[0] = yposi - _radius;
                        xpoints[1] = xposi + _radius;
                        ypoints[1] = yposi;
                        xpoints[2] = xposi;
                        ypoints[2] = yposi + _radius;
                        xpoints[3] = xposi - _radius;
                        ypoints[3] = yposi;
                        xpoints[4] = xposi;
                        ypoints[4] = yposi - _radius;
                        graphics.drawPolygon(xpoints, ypoints, 5);
                        break;
                    }

                    case 5: // '\005'
                    {
                        graphics.drawOval(xposi - _radius, yposi - _radius, _diameter, _diameter);
                        break;
                    }

                    case 6: // '\006'
                    {
                        graphics.drawLine(xposi, yposi - _radius, xposi, yposi + _radius);
                        graphics.drawLine(xposi - _radius, yposi, xposi + _radius, yposi);
                        break;
                    }

                    case 7: // '\007'
                    {
                        graphics.fillRect(xposi - _radius, yposi - _radius, _diameter, _diameter);
                        break;
                    }

                    case 8: // '\b'
                    {
                        int xpoints[] = new int[4];
                        int ypoints[] = new int[4];
                        xpoints[0] = xposi;
                        ypoints[0] = yposi - _radius;
                        xpoints[1] = xposi + _radius;
                        ypoints[1] = yposi + _radius;
                        xpoints[2] = xposi - _radius;
                        ypoints[2] = yposi + _radius;
                        xpoints[3] = xposi;
                        ypoints[3] = yposi - _radius;
                        graphics.drawPolygon(xpoints, ypoints, 4);
                        break;
                    }

                    case 9: // '\t'
                    {
                        int xpoints[] = new int[5];
                        int ypoints[] = new int[5];
                        xpoints[0] = xposi;
                        ypoints[0] = yposi - _radius;
                        xpoints[1] = xposi + _radius;
                        ypoints[1] = yposi;
                        xpoints[2] = xposi;
                        ypoints[2] = yposi + _radius;
                        xpoints[3] = xposi - _radius;
                        ypoints[3] = yposi;
                        xpoints[4] = xposi;
                        ypoints[4] = yposi - _radius;
                        graphics.fillPolygon(xpoints, ypoints, 5);
                        break;
                    }
                    }
                    break;

                case 4: // '\004'
                    graphics.fillRect(xposi, yposi, 1, 1);
                    break;
                }
        }
    }

    private void _erasePoint(int dataset, int index)
    {
        _checkDatasetIndex(dataset);
        Graphics graphics = getGraphics();
        if(_showing && graphics != null)
        {
            if(_pointsPersistence > 0 || _xPersistence > 0.0D)
                if(super._background == null)
                    graphics.setXORMode(getBackground());
                else
                    graphics.setXORMode(super._background);
            if(super._usecolor)
            {
                int color = dataset % PlotBox._colors.length;
                graphics.setColor(PlotBox._colors[color]);
            } else
            {
                graphics.setColor(super._foreground);
            }
            Vector pts = (Vector)_points.elementAt(dataset);
            PlotPoint pt = (PlotPoint)pts.elementAt(index);
            long ypos = (long)super._lry - (long)((pt.y - super._yMin) * super._yscale);
            long xpos = (long)super._ulx + (long)((pt.x - super._xMin) * super._xscale);
            if(index < pts.size() - 1)
            {
                PlotPoint nextp = (PlotPoint)pts.elementAt(index + 1);
                int nextx = super._ulx + (int)((nextp.x - super._xMin) * super._xscale);
                int nexty = super._lry - (int)((nextp.y - super._yMin) * super._yscale);
                if(nextp.connected)
                    _drawLine(graphics, dataset, nextx, nexty, xpos, ypos, true);
                nextp.connected = false;
            }
            Format fmt = (Format)_formats.elementAt(dataset);
            if(fmt.impulsesUseDefault)
            {
                if(_impulses)
                    _drawImpulse(graphics, xpos, ypos, true);
            } else
            if(fmt.impulses)
                _drawImpulse(graphics, xpos, ypos, true);
            int marks = _marks;
            if(!fmt.marksUseDefault)
                marks = fmt.marks;
            if(marks != 0)
                _drawPoint(graphics, dataset, xpos, ypos, true);
            if(_bars)
                _drawBar(graphics, dataset, xpos, ypos, true);
            if(pt.errorBar)
                _drawErrorBar(graphics, dataset, xpos, (long)super._lry - (long)((pt.yLowEB - super._yMin) * super._yscale), (long)super._lry - (long)((pt.yHighEB - super._yMin) * super._yscale), true);
            graphics.setColor(super._foreground);
            if(_pointsPersistence > 0 || _xPersistence > 0.0D)
                graphics.setPaintMode();
        }
        Vector points = (Vector)_points.elementAt(dataset);
        if(points != null)
        {
            PlotPoint pt = (PlotPoint)points.elementAt(index);
            if(pt != null)
            {
                if(pt.x == super._xBottom || pt.x == super._xTop || pt.y == super._yBottom || pt.y == super._yTop)
                    _xyInvalid = true;
                points.removeElementAt(index);
            }
        }
    }

    private void _fillPlot()
    {
        if(_xyInvalid)
        {
            super._xBottom = 1.7976931348623157E+308D;
            super._xTop = -1.7976931348623157E+308D;
            super._yBottom = 1.7976931348623157E+308D;
            super._yTop = -1.7976931348623157E+308D;
            for(int dataset = 0; dataset < _points.size(); dataset++)
            {
                Vector points = (Vector)_points.elementAt(dataset);
                for(int index = 0; index < points.size(); index++)
                {
                    PlotPoint pt = (PlotPoint)points.elementAt(index);
                    if(pt.x < super._xBottom)
                        super._xBottom = pt.x;
                    if(pt.x > super._xTop)
                        super._xTop = pt.x;
                    if(pt.y < super._yBottom)
                        super._yBottom = pt.y;
                    if(pt.y > super._yTop)
                        super._yTop = pt.y;
                }

            }

        }
        _xyInvalid = false;
        if(_bars)
        {
            if(super._yBottom > 0.0D)
                super._yBottom = 0.0D;
            if(super._yTop < 0.0D)
                super._yTop = 0.0D;
        }
        super.fillPlot();
    }

    private boolean _isConnected(int dataset)
    {
        if(dataset < 0)
            return _connected;
        _checkDatasetIndex(dataset);
        Format fmt = (Format)_formats.elementAt(dataset);
        if(fmt.connectedUseDefault)
            return _connected;
        else
            return fmt.connected;
    }

    protected boolean _parseLine(String line)
    {
        boolean connected = false;
        if(_isConnected(_currentdataset))
            connected = true;
        if(super._parseLine(line))
            return true;
        String lcLine = new String(line.toLowerCase());
        if(lcLine.startsWith("marks:"))
        {
            String style = line.substring(6).trim();
            if(_sawfirstdataset)
                setMarksStyle(style, _currentdataset);
            else
                setMarksStyle(style);
            return true;
        }
        if(lcLine.startsWith("numsets:"))
            return true;
        if(lcLine.startsWith("reusedatasets:"))
        {
            if(lcLine.indexOf("off", 16) >= 0)
                setReuseDatasets(false);
            else
                setReuseDatasets(true);
            return true;
        }
        if(lcLine.startsWith("dataset:"))
        {
            if(_reusedatasets && lcLine.length() > 0)
            {
                String tlegend = line.substring(8).trim();
                _currentdataset = -1;
                for(int i = 0; i <= _maxdataset; i++)
                    if(getLegend(i).compareTo(tlegend) == 0)
                        _currentdataset = i;

                if(_currentdataset != -1)
                    return true;
                _currentdataset = _maxdataset;
            }
            _firstinset = true;
            _sawfirstdataset = true;
            _currentdataset++;
            if(lcLine.length() > 0)
            {
                String legend = line.substring(8).trim();
                if(legend != null && legend.length() > 0)
                    addLegend(_currentdataset, legend);
            }
            _maxdataset = _currentdataset;
            return true;
        }
        if(lcLine.startsWith("lines:"))
        {
            if(lcLine.indexOf("off", 6) >= 0)
                setConnected(false);
            else
                setConnected(true);
            return true;
        }
        if(lcLine.startsWith("impulses:"))
        {
            if(_sawfirstdataset)
            {
                if(lcLine.indexOf("off", 9) >= 0)
                    setImpulses(false, _currentdataset);
                else
                    setImpulses(true, _currentdataset);
            } else
            if(lcLine.indexOf("off", 9) >= 0)
                setImpulses(false);
            else
                setImpulses(true);
            return true;
        }
        if(lcLine.startsWith("bars:"))
        {
            if(lcLine.indexOf("off", 5) >= 0)
            {
                setBars(false);
            } else
            {
                setBars(true);
                int comma = line.indexOf(",", 5);
                String baroffset = null;
                String barwidth;
                if(comma > 0)
                {
                    barwidth = line.substring(5, comma).trim();
                    baroffset = line.substring(comma + 1).trim();
                } else
                {
                    barwidth = line.substring(5).trim();
                }
                try
                {
                    Double bwidth = new Double(barwidth);
                    double boffset = _baroffset;
                    if(baroffset != null)
                        boffset = (new Double(baroffset)).doubleValue();
                    setBars(bwidth.doubleValue(), boffset);
                }
                catch(NumberFormatException _ex) { }
            }
            return true;
        }
        if(line.startsWith("move:"))
        {
            connected = false;
            line = line.substring(5, line.length()).trim();
        } else
        if(line.startsWith("move"))
        {
            connected = false;
            line = line.substring(4, line.length()).trim();
        } else
        if(line.startsWith("draw:"))
            line = line.substring(5, line.length()).trim();
        else
        if(line.startsWith("draw"))
            line = line.substring(4, line.length()).trim();
        line = line.trim();
        int fieldsplit = line.indexOf(",");
        if(fieldsplit == -1)
            fieldsplit = line.indexOf(" ");
        if(fieldsplit == -1)
            fieldsplit = line.indexOf("\t");
        if(fieldsplit > 0)
        {
            String x = line.substring(0, fieldsplit).trim();
            String y = line.substring(fieldsplit + 1).trim();
            int fieldsplit2 = y.indexOf(",");
            if(fieldsplit2 == -1)
                fieldsplit2 = y.indexOf(" ");
            if(fieldsplit2 == -1)
                fieldsplit2 = y.indexOf("\t");
            if(fieldsplit2 > 0)
            {
                line = y.substring(fieldsplit2 + 1).trim();
                y = y.substring(0, fieldsplit2).trim();
            }
            try
            {
                Double xpt = new Double(x);
                Double ypt = new Double(y);
                if(fieldsplit2 > 0)
                {
                    int fieldsplit3 = line.indexOf(",");
                    if(fieldsplit3 == -1)
                        fieldsplit3 = line.indexOf(" ");
                    if(fieldsplit3 == -1)
                        fieldsplit2 = line.indexOf("\t");
                    if(fieldsplit3 > 0)
                    {
                        String yl = line.substring(0, fieldsplit3).trim();
                        String yh = line.substring(fieldsplit3 + 1).trim();
                        Double yLowEB = new Double(yl);
                        Double yHighEB = new Double(yh);
                        connected = _addLegendIfNecessary(connected);
                        addPointWithErrorBars(_currentdataset, xpt.doubleValue(), ypt.doubleValue(), yLowEB.doubleValue(), yHighEB.doubleValue(), connected);
                        return true;
                    } else
                    {
                        connected = _addLegendIfNecessary(connected);
                        addPoint(_currentdataset, xpt.doubleValue(), ypt.doubleValue(), connected);
                        return true;
                    }
                } else
                {
                    connected = _addLegendIfNecessary(connected);
                    addPoint(_currentdataset, xpt.doubleValue(), ypt.doubleValue(), connected);
                    return true;
                }
            }
            catch(NumberFormatException _ex) { }
        }
        return false;
    }

    /**
     * @deprecated Method _writeOldSyntax is deprecated
     */

    protected void _writeOldSyntax(PrintWriter output)
    {
        super._writeOldSyntax(output);
        if(_reusedatasets)
            output.println("ReuseDatasets: on");
        if(!_connected)
            output.println("Lines: off");
        if(_bars)
            output.println("Bars: " + _barwidth + ", " + _baroffset);
        if(_impulses)
            output.println("Impulses: on");
        int dataset;
        switch(_marks)
        {
        case 1: // '\001'
            output.println("Marks: points");
            // fall through

        case 2: // '\002'
            output.println("Marks: dots");
            // fall through

        case 3: // '\003'
            output.println("Marks: various");
            // fall through

        case 4: // '\004'
            output.println("Marks: pixels");
            // fall through

        default:
            dataset = 0;
            break;
        }
        for(; dataset < _points.size(); dataset++)
        {
            String legend = getLegend(dataset);
            if(legend != null)
                output.println("DataSet: " + getLegend(dataset));
            else
                output.println("DataSet:");
            Format fmt = (Format)_formats.elementAt(dataset);
            if(!fmt.impulsesUseDefault)
                if(fmt.impulses)
                    output.println("Impulses: on");
                else
                    output.println("Impulses: off");
            if(!fmt.marksUseDefault)
                switch(fmt.marks)
                {
                case 0: // '\0'
                    output.println("Marks: none");
                    // fall through

                case 1: // '\001'
                    output.println("Marks: points");
                    // fall through

                case 2: // '\002'
                    output.println("Marks: dots");
                    // fall through

                case 3: // '\003'
                    output.println("Marks: various");
                    // fall through

                case 4: // '\004'
                    output.println("Marks: pixels");
                    break;
                }
            Vector pts = (Vector)_points.elementAt(dataset);
            for(int pointnum = 0; pointnum < pts.size(); pointnum++)
            {
                PlotPoint pt = (PlotPoint)pts.elementAt(pointnum);
                if(!pt.connected)
                    output.print("move: ");
                if(pt.errorBar)
                    output.println(pt.x + ", " + pt.y + ", " + pt.yLowEB + ", " + pt.yHighEB);
                else
                    output.println(pt.x + ", " + pt.y);
            }

        }

    }

    public synchronized void addLegend(int dataset, String legend)
    {
        _checkDatasetIndex(dataset);
        super.addLegend(dataset, legend);
    }

    public synchronized void addPoint(final int dataset, final double x, final double y, final boolean connected)
    {
   //     Runnable doAddPoint = y. new Runnable() {
             Runnable doAddPoint = new Runnable() {

            public void run()
            {
                _addPoint(dataset, x, y, 0.0D, 0.0D, connected, false);
            }

        };
        _deferIfNecessary(doAddPoint);
    }

    public synchronized void addPointWithErrorBars(final int dataset, final double x, final double y, final double yLowEB, 
            final double yHighEB, final boolean connected)
    {
       // Runnable doAddPoint = yLowEB. new Runnable() {
        Runnable doAddPoint = new Runnable() {
            public void run()
            {
                _addPoint(dataset, x, y, yLowEB, yHighEB, connected, true);
            }

        };
        _deferIfNecessary(doAddPoint);
    }

    public synchronized void clear(final int dataset)
    {
        Runnable doClear = new Runnable() {

            public void run()
            {
                _clear(dataset);
            }

        };
        _deferIfNecessary(doClear);
    }

    public synchronized void clear(final boolean format)
    {
        Runnable doClear = new Runnable() {

            public void run()
            {
                _clear(format);
            }

        };
        _deferIfNecessary(doClear);
    }

    public synchronized void erasePoint(final int dataset, final int index)
    {
        Runnable doErasePoint = new Runnable() {

            public void run()
            {
                _erasePoint(dataset, index);
            }

        };
        _deferIfNecessary(doErasePoint);
    }

    public synchronized void fillPlot()
    {
        Runnable doFill = new Runnable() {

            public void run()
            {
                _fillPlot();
            }

        };
        _deferIfNecessary(doFill);
    }

    public boolean getConnected()
    {
        return _connected;
    }

    public boolean getImpulses()
    {
        return _impulses;
    }

    public synchronized String getMarksStyle()
    {
        if(_marks == 0)
            return "none";
        if(_marks == 1)
            return "points";
        if(_marks == 2)
            return "dots";
        if(_marks == 3)
            return "various";
        else
            return "pixels";
    }

    /**
     * @deprecated Method getMaxDataSets is deprecated
     */

    public int getMaxDataSets()
    {
        return 0x7fffffff;
    }

    public synchronized int getNumDataSets()
    {
        return _points.size();
    }

    /**
     * @deprecated Method parseFile is deprecated
     */

    public void parseFile(String filespec, URL documentBase)
    {
        _firstinset = true;
        _sawfirstdataset = false;
        super.parseFile(filespec, documentBase);
    }

    public synchronized void read(InputStream in)
        throws IOException
    {
        super.read(in);
        _firstinset = true;
        _sawfirstdataset = false;
    }

    public synchronized void samplePlot()
    {
        Runnable sample = new Runnable() {

            public void run()
            {
                synchronized(Plot.this)
                {
                    clear(true);
                    setTitle("Sample plot");
                    setYRange(-4D, 4D);
                    setXRange(0.0D, 100D);
                    setXLabel("time");
                    setYLabel("value");
                    addYTick("-PI", -3.1415926535897931D);
                    addYTick("-PI/2", -1.5707963267948966D);
                    addYTick("0", 0.0D);
                    addYTick("PI/2", 1.5707963267948966D);
                    addYTick("PI", 3.1415926535897931D);
                    setMarksStyle("none");
                    setImpulses(true);
                    boolean first = true;
                    for(int i = 0; i <= 100; i++)
                    {
                        double xvalue = i;
                        addPoint(0, xvalue, 5D * Math.cos((3.1415926535897931D * (double)i) / 20D), first ^ true);
                        addPoint(1, xvalue, 4.5D * Math.cos((3.1415926535897931D * (double)i) / 25D), first ^ true);
                        addPoint(2, xvalue, 4D * Math.cos((3.1415926535897931D * (double)i) / 30D), first ^ true);
                        addPoint(3, xvalue, 3.5D * Math.cos((3.1415926535897931D * (double)i) / 35D), first ^ true);
                        addPoint(4, xvalue, 3D * Math.cos((3.1415926535897931D * (double)i) / 40D), first ^ true);
                        addPoint(5, xvalue, 2.5D * Math.cos((3.1415926535897931D * (double)i) / 45D), first ^ true);
                        addPoint(6, xvalue, 2D * Math.cos((3.1415926535897931D * (double)i) / 50D), first ^ true);
                        addPoint(7, xvalue, 1.5D * Math.cos((3.1415926535897931D * (double)i) / 55D), first ^ true);
                        addPoint(8, xvalue, Math.cos((3.1415926535897931D * (double)i) / 60D), first ^ true);
                        addPoint(9, xvalue, 0.5D * Math.cos((3.1415926535897931D * (double)i) / 65D), first ^ true);
                        first = false;
                    }

                }
                repaint();
            }

        };
        _deferIfNecessary(sample);
    }

    public synchronized void setBars(double width, double offset)
    {
        _barwidth = width;
        _baroffset = offset;
        _bars = true;
    }

    public void setBars(boolean on)
    {
        _bars = on;
    }

    public void setConnected(boolean on)
    {
        _connected = on;
    }

    public synchronized void setConnected(boolean on, int dataset)
    {
        _checkDatasetIndex(dataset);
        Format fmt = (Format)_formats.elementAt(dataset);
        fmt.connected = on;
        fmt.connectedUseDefault = false;
    }

    public synchronized void setImpulses(boolean on)
    {
        _impulses = on;
    }

    public synchronized void setImpulses(boolean on, int dataset)
    {
        _checkDatasetIndex(dataset);
        Format fmt = (Format)_formats.elementAt(dataset);
        fmt.impulses = on;
        fmt.impulsesUseDefault = false;
    }

    public synchronized void setMarksStyle(String style)
    {
        if(style.equalsIgnoreCase("none"))
            _marks = 0;
        else
        if(style.equalsIgnoreCase("points"))
            _marks = 1;
        else
        if(style.equalsIgnoreCase("dots"))
            _marks = 2;
        else
        if(style.equalsIgnoreCase("various"))
            _marks = 3;
        else
        if(style.equalsIgnoreCase("pixels"))
            _marks = 4;
    }

    public synchronized void setMarksStyle(String style, int dataset)
    {
        _checkDatasetIndex(dataset);
        Format fmt = (Format)_formats.elementAt(dataset);
        if(style.equalsIgnoreCase("none"))
            fmt.marks = 0;
        else
        if(style.equalsIgnoreCase("points"))
            fmt.marks = 1;
        else
        if(style.equalsIgnoreCase("dots"))
            fmt.marks = 2;
        else
        if(style.equalsIgnoreCase("various"))
            fmt.marks = 3;
        else
        if(style.equalsIgnoreCase("pixels"))
            fmt.marks = 4;
        fmt.marksUseDefault = false;
    }

    /**
     * @deprecated Method setNumSets is deprecated
     */

    public void setNumSets(int numsets)
    {
        if(numsets < 1)
            throw new IllegalArgumentException("Number of data sets (" + numsets + ") must be greater than 0.");
        _currentdataset = -1;
        _points.removeAllElements();
        _formats.removeAllElements();
        _prevx.removeAllElements();
        _prevy.removeAllElements();
        for(int i = 0; i < numsets; i++)
        {
            _points.addElement(new Vector());
            _formats.addElement(new Format());
            _prevx.addElement(new Long(0L));
            _prevy.addElement(new Long(0L));
        }

    }

    public void setPointsPersistence(int persistence)
    {
        _pointsPersistence = persistence;
    }

    public void setReuseDatasets(boolean on)
    {
        _reusedatasets = on;
    }

    public void setXPersistence(double persistence)
    {
        _xPersistence = persistence;
    }

    public synchronized void writeData(PrintWriter output)
    {
        super.writeData(output);
        for(int dataset = 0; dataset < _points.size(); dataset++)
        {
            StringBuffer options = new StringBuffer();
            Format fmt = (Format)_formats.elementAt(dataset);
            if(!fmt.connectedUseDefault)
                if(_isConnected(dataset))
                    options.append(" connected=\"yes\"");
                else
                    options.append(" connected=\"no\"");
            if(!fmt.impulsesUseDefault)
                if(fmt.impulses)
                    options.append(" stems=\"yes\"");
                else
                    output.println(" stems=\"no\"");
            if(!fmt.marksUseDefault)
                switch(fmt.marks)
                {
                case 0: // '\0'
                    options.append(" marks=\"none\"");
                    // fall through

                case 1: // '\001'
                    options.append(" marks=\"points\"");
                    // fall through

                case 2: // '\002'
                    options.append(" marks=\"dots\"");
                    // fall through

                case 3: // '\003'
                    options.append(" marks=\"various\"");
                    // fall through

                case 4: // '\004'
                    options.append(" marks=\"pixels\"");
                    break;
                }
            String legend = getLegend(dataset);
            if(legend != null)
                options.append(" name=\"" + getLegend(dataset) + "\"");
            output.println("<dataset" + options.toString() + ">");
            Vector pts = (Vector)_points.elementAt(dataset);
            for(int pointnum = 0; pointnum < pts.size(); pointnum++)
            {
                PlotPoint pt = (PlotPoint)pts.elementAt(pointnum);
                if(!pt.connected)
                    output.print("<m ");
                else
                    output.print("<p ");
                output.print("x=\"" + pt.x + "\" y=\"" + pt.y + "\"");
                if(pt.errorBar)
                    output.print(" lowErrorBar=\"" + pt.yLowEB + "\" highErrorBar=\"" + pt.yHighEB + "\"");
                output.println("/>");
            }

            output.println("</dataset>");
        }

    }

    public synchronized void writeFormat(PrintWriter output)
    {
        super.writeFormat(output);
        if(_reusedatasets)
            output.println("<reuseDatasets/>");
        StringBuffer defaults = new StringBuffer();
        if(!_connected)
            defaults.append(" connected=\"no\"");
        switch(_marks)
        {
        case 1: // '\001'
            defaults.append(" marks=\"points\"");
            break;

        case 2: // '\002'
            defaults.append(" marks=\"dots\"");
            break;

        case 3: // '\003'
            defaults.append(" marks=\"various\"");
            break;

        case 4: // '\004'
            defaults.append(" marks=\"pixels\"");
            break;
        }
        if(_impulses)
            defaults.append(" stems=\"yes\"");
        if(defaults.length() > 0)
            output.println("<default" + defaults.toString() + "/>");
        if(_bars)
            output.println("<barGraph width=\"" + _barwidth + "\" offset=\"" + _baroffset + "\"/>");
    }

    protected int _currentdataset;
    protected Vector _points;
    protected int _marks;
    private int _pointsPersistence;
    private double _xPersistence;
    private boolean _bars;
    private double _barwidth;
    private double _baroffset;
    private boolean _connected;
    private boolean _impulses;
    private int _maxdataset;
    private boolean _reusedatasets;
    private boolean _firstinset;
    private boolean _sawfirstdataset;
    private int _radius;
    private int _diameter;
    private Vector _prevx;
    private Vector _prevy;
    private static final int _ERRORBAR_LEG_LENGTH = 5;
    private static final int _MAX_MARKS = 10;
    private boolean _xyInvalid;
    private String _filename;
    private boolean _showing;
    private Vector _formats;





}