// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 15:02:15
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   PlotApplication.java

package Holger_modules.ptolemy.plot;

import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;
import javax.swing.JOptionPane;
import javax.swing.UIManager;

// Referenced classes of package ptolemy.plot:
//            PlotFrame, CmdLineArgException, Plot, PlotBox

public class PlotApplication extends PlotFrame
{

    public PlotApplication()
        throws Exception
    {
        this(new String[0]);
    }

    public PlotApplication(PlotBox plot)
    {
        super("PlotApplication", plot);
        addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }

        });
        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch(Exception _ex) { }
        setVisible(true);
    }

    public PlotApplication(PlotBox plot, String args[])
        throws Exception
    {
        super("PlotApplication", plot);
        addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }

        });
        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch(Exception _ex) { }
        _parseArgs(args);
        if(args == null || args.length == 0)
            samplePlot();
        setVisible(true);
    }

    public PlotApplication(String args[])
        throws Exception
    {
        this(((PlotBox) (new Plot())), args);
    }

    protected void _about()
    {
        JOptionPane.showMessageDialog(this, "PlotApplication class\nBy: Edward A. Lee, eal@eecs.berkeley.edu and Christopher Hylands, cxh@eecs.berkeley.edu\nVersion 5.1p2, Build: $Id: PlotApplication.java,v 1.1.1.1 2005/07/07 14:31:48 jag Exp $\n\nFor more information, see\nhttp://ptolemy.eecs.berkeley.edu/java/ptplot\n\nCopyright (c) 1997-2001, The Regents of the University of California.", "About Ptolemy Plot", 1);
    }

    protected void _close()
    {
        System.exit(0);
    }

    protected void _help()
    {
        JOptionPane.showMessageDialog(this, "PlotApplication is a standalone plot  application.\n  File formats understood: Ptplot ASCII.\n  Left mouse button: Zooming.\n\n" + _usage(), "About Ptolemy Plot", 1);
    }

    protected int _parseArgs(String args[])
        throws CmdLineArgException, FileNotFoundException, IOException
    {
        int i = 0;
        String title = "Ptolemy plot";
        int width = 500;
        int height = 300;
        while(args != null && i < args.length) 
        {
            String arg = args[i++];
            if(arg.equals("-height"))
            {
                if(i > args.length - 1)
                    throw new CmdLineArgException(_usage());
                height = Integer.valueOf(args[i++]).intValue();
            } else
            if(arg.equals("-help"))
            {
                System.out.println(_usage());
                System.exit(0);
            } else
            if(arg.equals("-test"))
                _test = true;
            else
            if(arg.equals("-version"))
            {
                System.out.println("Version 5.1p2, Build $Id: PlotApplication.java,v 1.1.1.1 2005/07/07 14:31:48 jag Exp $");
                System.exit(0);
            } else
            if(arg.equals("-width"))
            {
                if(i > args.length - 1)
                    throw new CmdLineArgException("-width requires an integer argument");
                width = Integer.valueOf(args[i++]).intValue();
            } else
            if(!arg.equals(""))
                if(!arg.startsWith("-"))
                {
                    java.io.InputStream instream;
                    URL base;
                    try
                    {
                        URL inurl = new URL(null, arg);
                        base = inurl;
                        instream = inurl.openStream();
                    }
                    catch(MalformedURLException _ex)
                    {
                        File file = new File(arg);
                        instream = new FileInputStream(file);
                        super._file = new File(file.getAbsolutePath());
                        title = super._file.getName();
                        super._directory = super._file.getParentFile();
                        base = new URL("file", null, super._directory.getAbsolutePath());
                    }
                    _read(base, instream);
                } else
                {
                    throw new CmdLineArgException("Unrecognized option: " + arg);
                }
        }
        setSize(width, height);
        setTitle(title);
        int argumentsRead = i;
        return argumentsRead;
    }

    protected String _usage()
    {
        String commandOptions[][] = {
            {
                "-height", "<pixels>"
            }, {
                "-width", "<pixels>"
            }
        };
        String commandFlags[] = {
            "-help", "-test", "-version"
        };
        String result = "Usage: ptplot [ options ] [file ...]\n\nOptions that take values:\n";
        for(int i = 0; i < commandOptions.length; i++)
            result = result + " " + commandOptions[i][0] + " " + commandOptions[i][1] + "\n";

        result = result + "\nBoolean flags:\n";
        for(int i = 0; i < commandFlags.length; i++)
            result = result + " " + commandFlags[i];

        return result;
    }

    public static void main(String args[])
    {
        PlotApplication plot;
        try
        {
            plot = new PlotApplication(new Plot(), args);
        }
        catch(Exception ex)
        {
            System.err.println(ex.toString());
            ex.printStackTrace();
        }
        if(_test)
        {
            try
            {
                Thread.currentThread();
                Thread.sleep(2000L);
            }
            catch(InterruptedException _ex) { }
            System.exit(0);
        }
    }

    protected static boolean _test = false;

}