// Decompiled by DJ v3.5.5.77 Copyright 2003 Atanas Neshkov  Date: 12/12/2003 16:07:26
// Home Page : http://members.fortunecity.com/neshkov/dj.html  - Check often for new version!
// Decompiler options: packimports(3) fieldsfirst 
// Source File Name:   PlotBox.java

package Holger_modules.ptolemy.plot;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Enumeration;
import java.util.EventObject;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;
import javax.swing.AbstractButton;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

// Referenced classes of package ptolemy.plot:
//            EPSGraphics, PlotFormatter

public class PlotBox extends JPanel
    implements Printable
{
    class ButtonListener
        implements ActionListener, java.io.Serializable
    {

        public void actionPerformed(ActionEvent event)
        {
            if(event.getSource() == _fillButton)
                fillPlot();
            else
            if(event.getSource() == _printButton)
            {
                PrinterJob job = PrinterJob.getPrinterJob();
                job.setPrintable(PlotBox.this);
                if(job.printDialog())
                    try
                    {
                        job.print();
                    }
                    catch(Exception ex)
                    {
                        Component ancestor = getTopLevelAncestor();
                        JOptionPane.showMessageDialog(ancestor, "Printing failed:\n" + ex.toString(), "Print Error", 2);
                    }
            } else
            if(event.getSource() == _resetButton)
                resetAxes();
            else
            if(event.getSource() == _formatButton)
            {
                PlotFormatter fmt = new PlotFormatter(PlotBox.this);
                fmt.openModal();
            }
        }

        ButtonListener()
        {
        }
    }

    public class ZoomListener
        implements MouseListener, java.io.Serializable
    {

        public void mouseClicked(MouseEvent event)
        {
            requestFocus();
        }

        public void mouseEntered(MouseEvent mouseevent)
        {
        }

        public void mouseExited(MouseEvent mouseevent)
        {
        }

        public void mousePressed(MouseEvent event)
        {
            if((event.getModifiers() & 0x10) != 0 || event.getModifiers() == 0)
                _zoomStart(event.getX(), event.getY());
        }

        public void mouseReleased(MouseEvent event)
        {
            if((event.getModifiers() & 0x10) != 0 || event.getModifiers() == 0)
                _zoom(event.getX(), event.getY());
        }

        public ZoomListener()
        {
        }
    }

    public class DragListener
        implements MouseMotionListener, java.io.Serializable
    {

        public void mouseDragged(MouseEvent event)
        {
            _zoomBox(event.getX(), event.getY());
        }

        public void mouseMoved(MouseEvent mouseevent)
        {
        }

        public DragListener()
        {
        }
    }

    class CommandListener
        implements KeyListener, java.io.Serializable
    {

        private boolean _control;
        private boolean _shift;

        public void keyPressed(KeyEvent e)
        {
            int keycode = e.getKeyCode();
            switch(keycode)
            {
            default:
                break;

            case 17: // '\021'
                _control = true;
                break;

            case 16: // '\020'
                _shift = true;
                break;

            case 67: // 'C'
                if(_control)
                {
                    export(null);
                    String message = "Encapsulated PostScript (EPS) exported to clipboard.";
                    JOptionPane.showMessageDialog(PlotBox.this, message, "Ptolemy Plot Message", 1);
                }
                break;

            case 68: // 'D'
                if(!_control && _shift)
                {
                    write(System.out);
                    String message = "Plot data sent to standard out.";
                    JOptionPane.showMessageDialog(PlotBox.this, message, "Ptolemy Plot Message", 1);
                }
                if(_control)
                    System.exit(1);
                break;

            case 69: // 'E'
                if(!_control && _shift)
                {
                    export(System.out);
                    String message = "Encapsulated PostScript (EPS) exported to standard out.";
                    JOptionPane.showMessageDialog(PlotBox.this, message, "Ptolemy Plot Message", 1);
                }
                break;

            case 70: // 'F'
                if(!_control && _shift)
                    fillPlot();
                break;

            case 72: // 'H'
                if(!_control && _shift)
                    _help();
                break;

            case 81: // 'Q'
                if(!_control)
                    System.exit(1);
                break;

            case 47: // '/'
                if(_shift)
                    _help();
                break;
            }
        }

        public void keyReleased(KeyEvent e)
        {
            int keycode = e.getKeyCode();
            switch(keycode)
            {
            case 17: // '\021'
                _control = false;
                break;

            case 16: // '\020'
                _shift = false;
                break;
            }
        }

        public void keyTyped(KeyEvent keyevent)
        {
        }

        CommandListener()
        {
            _control = false;
            _shift = false;
        }
    }


    public static final String PTPLOT_RELEASE = "5.1p2";
    protected transient double _yMax;
    protected transient double _yMin;
    protected transient double _xMax;
    protected transient double _xMin;
    protected double _padding;
    protected transient boolean _xRangeGiven;
    protected transient boolean _yRangeGiven;
    protected transient boolean _rangesGivenByZooming;
    protected double _xlowgiven;
    protected double _xhighgiven;
    protected double _ylowgiven;
    protected double _yhighgiven;
    protected double _xBottom;
    protected double _xTop;
    protected double _yBottom;
    protected double _yTop;
    protected boolean _xlog;
    protected boolean _ylog;
    protected static final double _LOG10SCALE = 1.0D / Math.log(10D);
    protected boolean _grid;
    protected boolean _wrap;
    protected double _wrapHigh;
    protected double _wrapLow;
    protected Color _background;
    protected Color _foreground;
    protected int _topPadding;
    protected int _bottomPadding;
    protected int _rightPadding;
    protected int _leftPadding;
    protected int _ulx;
    protected int _uly;
    protected int _lrx;
    protected int _lry;
    protected double _yscale;
    protected double _xscale;
    protected boolean _usecolor;
    protected static Color _colors[] = {
        new Color(0xff0000), new Color(255), new Color(43690), new Color(0), new Color(0xffa500), new Color(0x53868b), new Color(0xff7f50), new Color(0x45ab1f), new Color(0x90422d), new Color(0xa0a0a0), 
        new Color(0x14ff14)
    };
    protected int _width;
    protected int _height;
    protected int _preferredWidth;
    protected int _preferredHeight;
    protected boolean _sizeHasBeenSet;
    public URL _documentBase;
    private boolean _actionsDeferred;
    private java.util.List _deferredActions;
    private String _filespec;
    private static final Color _boxColor;
    private double _ytickMax;
    private double _ytickMin;
    private double _xtickMax;
    private double _xtickMin;
    private int _yExp;
    private int _xExp;
    private double _ytickscale;
    private double _xtickscale;
    private Font _labelFont;
    private Font _superscriptFont;
    private Font _titleFont;
    private FontMetrics _labelFontMetrics;
    private FontMetrics _superscriptFontMetrics;
    private FontMetrics _titleFontMetrics;
    private transient int _gridCurJuke;
    private transient double _gridBase;
    private transient String _errorMsg[];
    private String _xlabel;
    private String _ylabel;
    private String _title;
    private Vector _legendStrings;
    private Vector _legendDatasets;
    private Vector _xticks;
    private Vector _xticklabels;
    private Vector _yticks;
    private Vector _yticklabels;
    private transient JButton _fillButton;
    private transient JButton _formatButton;
    boolean _originalXRangeGiven;
    boolean _originalYRangeGiven;
    double _originalXlow;
    double _originalXhigh;
    double _originalYlow;
    double _originalYhigh;
    private transient JButton _printButton;
    private transient JButton _resetButton;
    private transient int _zoomx;
    private transient int _zoomy;
    private transient int _zoomxn;
    private transient int _zoomyn;
    private transient boolean _zoomin;
    private transient boolean _zoomout;
    private transient boolean _drawn;
    private transient boolean _zooming;
    private static final String _DTD = "<!-- PlotML DTD, created by Edward A. Lee, eal@eecs.berkeley.edu.\n   See http://ptolemy.eecs.berkeley.edu/java/ptplot -->\n<!ELEMENT plot (barGraph | bin | dataset | default | noColor | \n\tnoGrid | title | wrap | xLabel | xLog | xRange | xTicks | yLabel | \n yLog | yRange | yTicks)*>\n  <!ELEMENT barGraph EMPTY>\n    <!ATTLIST barGraph width CDATA #IMPLIED>\n    <!ATTLIST barGraph offset CDATA #IMPLIED>\n  <!ELEMENT bin EMPTY>\n    <!ATTLIST bin width CDATA #IMPLIED>\n    <!ATTLIST bin offset CDATA #IMPLIED>\n  <!ELEMENT dataset (m | move | p | point)*>\n    <!ATTLIST dataset connected (yes | no) #IMPLIED>\n    <!ATTLIST dataset marks (none | dots | points | various) #IMPLIED>\n    <!ATTLIST dataset name CDATA #IMPLIED>\n    <!ATTLIST dataset stems (yes | no) #IMPLIED>\n  <!ELEMENT default EMPTY>\n    <!ATTLIST default connected (yes | no) \"yes\">\n    <!ATTLIST default marks (none | dots | points | various) \"none\">\n    <!ATTLIST default stems (yes | no) \"no\">\n  <!ELEMENT noColor EMPTY>\n  <!ELEMENT noGrid EMPTY>\n  <!ELEMENT title (#PCDATA)>\n  <!ELEMENT wrap EMPTY>\n  <!ELEMENT xLabel (#PCDATA)>\n  <!ELEMENT xLog EMPTY>\n  <!ELEMENT xRange EMPTY>\n    <!ATTLIST xRange min CDATA #REQUIRED>\n    <!ATTLIST xRange max CDATA #REQUIRED>\n  <!ELEMENT xTicks (tick)+>\n  <!ELEMENT yLabel (#PCDATA)>\n  <!ELEMENT yLog EMPTY>\n  <!ELEMENT yRange EMPTY>\n    <!ATTLIST yRange min CDATA #REQUIRED>\n    <!ATTLIST yRange max CDATA #REQUIRED>\n  <!ELEMENT yTicks (tick)+>\n    <!ELEMENT tick EMPTY>\n      <!ATTLIST tick label CDATA #REQUIRED>\n      <!ATTLIST tick position CDATA #REQUIRED>\n    <!ELEMENT m EMPTY>\n      <!ATTLIST m x CDATA #IMPLIED>\n      <!ATTLIST m x CDATA #REQUIRED>\n      <!ATTLIST m lowErrorBar CDATA #IMPLIED>\n      <!ATTLIST m highErrorBar CDATA #IMPLIED>\n    <!ELEMENT move EMPTY>\n      <!ATTLIST move x CDATA #IMPLIED>\n      <!ATTLIST move x CDATA #REQUIRED>\n      <!ATTLIST move lowErrorBar CDATA #IMPLIED>\n      <!ATTLIST move highErrorBar CDATA #IMPLIED>\n    <!ELEMENT p EMPTY>\n      <!ATTLIST p x CDATA #IMPLIED>\n      <!ATTLIST p x CDATA #REQUIRED>\n      <!ATTLIST p lowErrorBar CDATA #IMPLIED>\n      <!ATTLIST p highErrorBar CDATA #IMPLIED>\n    <!ELEMENT point EMPTY>\n      <!ATTLIST point x CDATA #IMPLIED>\n      <!ATTLIST point x CDATA #REQUIRED>\n      <!ATTLIST point lowErrorBar CDATA #IMPLIED>\n      <!ATTLIST point highErrorBar CDATA #IMPLIED>";

    public PlotBox()
    {
        _yMax = 0.0D;
        _yMin = 0.0D;
        _xMax = 0.0D;
        _xMin = 0.0D;
        _padding = 0.050000000000000003D;
        _xRangeGiven = false;
        _yRangeGiven = false;
        _rangesGivenByZooming = false;
        _xBottom = 1.7976931348623157E+308D;
        _xTop = -1.7976931348623157E+308D;
        _yBottom = 1.7976931348623157E+308D;
        _yTop = -1.7976931348623157E+308D;
        _xlog = false;
        _ylog = false;
        _grid = true;
        _wrap = false;
        _background = Color.white;
        _foreground = Color.black;
        _topPadding = 10;
        _bottomPadding = 5;
        _rightPadding = 10;
        _leftPadding = 10;
        _ulx = 1;
        _uly = 1;
        _lrx = 100;
        _lry = 100;
        _yscale = 1.0D;
        _xscale = 1.0D;
        _usecolor = true;
        _width = 500;
        _height = 300;
        _preferredWidth = 500;
        _preferredHeight = 300;
        _sizeHasBeenSet = false;
        _documentBase = null;
        _actionsDeferred = false;
        _filespec = null;
        _ytickMax = 0.0D;
        _ytickMin = 0.0D;
        _xtickMax = 0.0D;
        _xtickMin = 0.0D;
        _yExp = 0;
        _xExp = 0;
        _ytickscale = 0.0D;
        _xtickscale = 0.0D;
        _labelFont = null;
        _superscriptFont = null;
        _titleFont = null;
        _labelFontMetrics = null;
        _superscriptFontMetrics = null;
        _titleFontMetrics = null;
        _gridCurJuke = 0;
        _gridBase = 0.0D;
        _legendStrings = new Vector();
        _legendDatasets = new Vector();
        _xticks = null;
        _xticklabels = null;
        _yticks = null;
        _yticklabels = null;
        _fillButton = null;
        _formatButton = null;
        _originalXRangeGiven = false;
        _originalYRangeGiven = false;
        _originalXlow = 0.0D;
        _originalXhigh = 0.0D;
        _originalYlow = 0.0D;
        _originalYhigh = 0.0D;
        _printButton = null;
        _resetButton = null;
        _zoomx = -1;
        _zoomy = -1;
        _zoomxn = -1;
        _zoomyn = -1;
        _zoomin = false;
        _zoomout = false;
        _drawn = false;
        _zooming = false;
        setOpaque(true);
        setLayout(new FlowLayout(2, 2, 2));
        addMouseListener(new ZoomListener());
        addKeyListener(new CommandListener());
        addMouseMotionListener(new DragListener());
        _measureFonts();
    }

    private RenderingHints _defaultImageRenderingHints()
    {
        RenderingHints hints = new RenderingHints(null);
        hints.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        return hints;
    }

    protected void _deferIfNecessary(Runnable action)
    {
        if(EventQueue.isDispatchThread())
        {
            action.run();
        } else
        {
            if(_deferredActions == null)
                _deferredActions = new LinkedList();
            _deferredActions.add(action);
            if(!_actionsDeferred)
            {
                Runnable doActions = new Runnable() {

                    public void run()
                    {
                        _executeDeferredActions();
                    }

                };
                try
                {
                    SwingUtilities.invokeLater(doActions);
                }
                catch(Exception _ex) { }
                _actionsDeferred = true;
            }
        }
    }

    private int _drawLegend(Graphics graphics, int urx, int ury)
    {
        if(graphics == null)
            return 0;
        Font previousFont = graphics.getFont();
        graphics.setFont(_labelFont);
        int spacing = _labelFontMetrics.getHeight();
        Enumeration v = _legendStrings.elements();
        Enumeration i = _legendDatasets.elements();
        int ypos = ury + spacing;
        int maxwidth = 0;
        while(v.hasMoreElements()) 
        {
            String legend = (String)v.nextElement();
            int dataset = ((Integer)i.nextElement()).intValue();
            if(dataset >= 0)
            {
                if(_usecolor)
                {
                    int color = dataset % _colors.length;
                    graphics.setColor(_colors[color]);
                }
                _drawPoint(graphics, dataset, urx - 3, ypos - 3, false);
                graphics.setColor(_foreground);
                int width = _labelFontMetrics.stringWidth(legend);
                if(width > maxwidth)
                    maxwidth = width;
                graphics.drawString(legend, urx - 15 - width, ypos);
                ypos += spacing;
            }
        }
        graphics.setFont(previousFont);
        return 22 + maxwidth;
    }

    protected synchronized void _drawPlot(Graphics graphics, boolean clearfirst)
    {
        Rectangle bounds = getBounds();
        _drawPlot(graphics, clearfirst, bounds);
    }

    protected synchronized void _drawPlot(Graphics graphics, boolean clearfirst, Rectangle drawRect)
    {
        if(graphics == null)
            return;
        graphics.setPaintMode();
        if(_errorMsg != null)
        {
            int fheight = _labelFontMetrics.getHeight() + 2;
            int msgy = fheight;
            graphics.setColor(Color.black);
            for(int i = 0; i < _errorMsg.length; i++)
            {
                graphics.drawString(_errorMsg[i], 10, msgy);
                msgy += fheight;
                System.err.println(_errorMsg[i]);
            }

            return;
        }
        if(!_xRangeGiven)
            if(_xBottom > _xTop)
                _setXRange(0.0D, 0.0D);
            else
                _setXRange(_xBottom, _xTop);
        if(!_yRangeGiven)
            if(_yBottom > _yTop)
                _setYRange(0.0D, 0.0D);
            else
                _setYRange(_yBottom, _yTop);
        int titley = 0;
        int titlefontheight = _titleFontMetrics.getHeight();
        if(_title == null)
            _title = "";
        if(_title != null || _yExp != 0)
            titley = titlefontheight + _topPadding;
        Font previousFont = graphics.getFont();
        graphics.setFont(_labelFont);
        graphics.setColor(_foreground);
        int labelheight = _labelFontMetrics.getHeight();
        int halflabelheight = labelheight / 2;
        int ySPos = drawRect.height - 5;
        int xSPos = drawRect.width - _rightPadding;
        if(_xlog)
            _xExp = (int)Math.floor(_xtickMin);
        if(_xExp != 0 && _xticks == null)
        {
            String superscript = Integer.toString(_xExp);
            xSPos -= _superscriptFontMetrics.stringWidth(superscript);
            graphics.setFont(_superscriptFont);
            if(!_xlog)
            {
                graphics.drawString(superscript, xSPos, ySPos - halflabelheight);
                xSPos -= _labelFontMetrics.stringWidth("x10");
                graphics.setFont(_labelFont);
                graphics.drawString("x10", xSPos, ySPos);
            }
            _bottomPadding = (3 * labelheight) / 2 + 5;
        }
        if(_xlabel != null && _bottomPadding < labelheight + 5)
            _bottomPadding = labelheight + 5;
        _uly = titley + 5;
        _lry = drawRect.height - labelheight - _bottomPadding - 3;
        int height = _lry - _uly;
        _yscale = (double)height / (_yMax - _yMin);
        _ytickscale = (double)height / (_ytickMax - _ytickMin);
        int ny = 2 + height / (labelheight + 10);
        double yStep = _roundUp((_ytickMax - _ytickMin) / (double)ny);
        double yStart = yStep * Math.ceil(_ytickMin / yStep);
        int widesty = 0;
        String ylabels[] = new String[ny];
        int ylabwidth[] = new int[ny];
        int ind = 0;
        if(_yticks == null)
        {
            Vector ygrid = null;
            if(_ylog)
                ygrid = _gridInit(yStart, yStep, true, null);
            int numfracdigits = _numFracDigits(yStep);
            double yTmpStart = yStart;
            if(_ylog)
                yTmpStart = _gridStep(ygrid, yStart, yStep, _ylog);
            for(double ypos = yTmpStart; ypos <= _ytickMax; ypos = _gridStep(ygrid, ypos, yStep, _ylog))
            {
                if(ind >= ny)
                    break;
                String yticklabel;
                if(_ylog)
                    yticklabel = _formatLogNum(ypos, numfracdigits);
                else
                    yticklabel = _formatNum(ypos, numfracdigits);
                ylabels[ind] = yticklabel;
                int lw = _labelFontMetrics.stringWidth(yticklabel);
                ylabwidth[ind++] = lw;
                if(lw > widesty)
                    widesty = lw;
            }

        } else
        {
            for(Enumeration nl = _yticklabels.elements(); nl.hasMoreElements();)
            {
                String label = (String)nl.nextElement();
                int lw = _labelFontMetrics.stringWidth(label);
                if(lw > widesty)
                    widesty = lw;
            }

        }
        if(_ylabel != null)
            _ulx = widesty + _labelFontMetrics.stringWidth("W") + _leftPadding;
        else
            _ulx = widesty + _leftPadding;
        int legendwidth = _drawLegend(graphics, drawRect.width - _rightPadding, _uly);
        _lrx = drawRect.width - legendwidth - _rightPadding;
        int width = _lrx - _ulx;
        _xscale = (double)width / (_xMax - _xMin);
        _xtickscale = (double)width / (_xtickMax - _xtickMin);
        graphics.setColor(Color.white);
        graphics.fillRect(_ulx, _uly, width, height);
        graphics.setColor(_foreground);
        graphics.drawRect(_ulx, _uly, width, height);
        int tickLength = 5;
        int xCoord1 = _ulx + tickLength;
        int xCoord2 = _lrx - tickLength;
        if(_yticks == null)
        {
            Vector ygrid = null;
            double yTmpStart = yStart;
            if(_ylog)
            {
                ygrid = _gridInit(yStart, yStep, true, null);
                yTmpStart = _gridStep(ygrid, yStart, yStep, _ylog);
                ny = ind;
            }
            ind = 0;
            boolean needExponent = _ylog;
            for(double ypos = yTmpStart; ypos <= _ytickMax; ypos = _gridStep(ygrid, ypos, yStep, _ylog))
            {
                if(ind >= ny)
                    break;
                int yCoord1 = _lry - (int)((ypos - _ytickMin) * _ytickscale);
                int offset = 0;
                if(ind > 0 && !_ylog)
                    offset = halflabelheight;
                graphics.drawLine(_ulx, yCoord1, xCoord1, yCoord1);
                graphics.drawLine(_lrx, yCoord1, xCoord2, yCoord1);
                if(_grid && yCoord1 != _uly && yCoord1 != _lry)
                {
                    graphics.setColor(Color.lightGray);
                    graphics.drawLine(xCoord1, yCoord1, xCoord2, yCoord1);
                    graphics.setColor(_foreground);
                }
                if(_ylog && ylabels[ind].indexOf('e') != -1)
                    needExponent = false;
                graphics.drawString(ylabels[ind], _ulx - ylabwidth[ind++] - 4, yCoord1 + offset);
            }

            if(_ylog)
            {
                Vector unlabeledgrid = _gridInit(yStart, yStep, false, ygrid);
                if(unlabeledgrid.size() > 0)
                {
                    double tmpStep = yStep <= 1.0D ? yStep : 1.0D;
                    for(double ypos = _gridStep(unlabeledgrid, yStart, tmpStep, _ylog); ypos <= _ytickMax; ypos = _gridStep(unlabeledgrid, ypos, tmpStep, _ylog))
                    {
                        int yCoord1 = _lry - (int)((ypos - _ytickMin) * _ytickscale);
                        if(_grid && yCoord1 != _uly && yCoord1 != _lry)
                        {
                            graphics.setColor(Color.lightGray);
                            graphics.drawLine(_ulx + 1, yCoord1, _lrx - 1, yCoord1);
                            graphics.setColor(_foreground);
                        }
                    }

                }
                if(needExponent)
                    _yExp = (int)Math.floor(yTmpStart);
                else
                    _yExp = 0;
            }
            if(_yExp != 0)
            {
                graphics.drawString("x10", 2, titley);
                graphics.setFont(_superscriptFont);
                graphics.drawString(Integer.toString(_yExp), _labelFontMetrics.stringWidth("x10") + 2, titley - halflabelheight);
                graphics.setFont(_labelFont);
            }
        } else
        {
            Enumeration nt = _yticks.elements();
            for(Enumeration nl = _yticklabels.elements(); nl.hasMoreElements();)
            {
                String label = (String)nl.nextElement();
                double ypos = ((Double)nt.nextElement()).doubleValue();
                if(ypos <= _yMax && ypos >= _yMin)
                {
                    int yCoord1 = _lry - (int)((ypos - _yMin) * _yscale);
                    int offset = 0;
                    if(ypos < (double)(_lry - labelheight))
                        offset = halflabelheight;
                    graphics.drawLine(_ulx, yCoord1, xCoord1, yCoord1);
                    graphics.drawLine(_lrx, yCoord1, xCoord2, yCoord1);
                    if(_grid && yCoord1 != _uly && yCoord1 != _lry)
                    {
                        graphics.setColor(Color.lightGray);
                        graphics.drawLine(xCoord1, yCoord1, xCoord2, yCoord1);
                        graphics.setColor(_foreground);
                    }
                    graphics.drawString(label, _ulx - _labelFontMetrics.stringWidth(label) - 3, yCoord1 + offset);
                }
            }

        }
        int yCoord1 = _uly + tickLength;
        int yCoord2 = _lry - tickLength;
        if(_xticks == null)
        {
            int nx = 10;
            double xStep = 0.0D;
            int numfracdigits = 0;
            int charwidth = _labelFontMetrics.stringWidth("8");
            if(_xlog)
            {
                nx = 2 + width / (charwidth * 6 + 10);
            } else
            {
                for(int count = 0; count++ <= 10;)
                {
                    xStep = _roundUp((_xtickMax - _xtickMin) / (double)nx);
                    numfracdigits = _numFracDigits(xStep);
                    int intdigits = _numIntDigits(_xtickMax);
                    int inttemp = _numIntDigits(_xtickMin);
                    if(intdigits < inttemp)
                        intdigits = inttemp;
                    int maxlabelwidth = charwidth * (numfracdigits + 2 + intdigits);
                    int savenx = nx;
                    nx = 2 + width / (maxlabelwidth + 10);
                    if(nx - savenx <= 1 || savenx - nx <= 1)
                        break;
                }

            }
            xStep = _roundUp((_xtickMax - _xtickMin) / (double)nx);
            numfracdigits = _numFracDigits(xStep);
            double xStart = xStep * Math.ceil(_xtickMin / xStep);
            Vector xgrid = null;
            double xTmpStart = xStart;
            if(_xlog)
            {
                xgrid = _gridInit(xStart, xStep, true, null);
                xTmpStart = _gridRoundUp(xgrid, xStart);
            }
            boolean needExponent = _xlog;
            for(double xpos = xTmpStart; xpos <= _xtickMax; xpos = _gridStep(xgrid, xpos, xStep, _xlog))
            {
                String xticklabel;
                if(_xlog)
                {
                    xticklabel = _formatLogNum(xpos, numfracdigits);
                    if(xticklabel.indexOf('e') != -1)
                        needExponent = false;
                } else
                {
                    xticklabel = _formatNum(xpos, numfracdigits);
                }
                xCoord1 = _ulx + (int)((xpos - _xtickMin) * _xtickscale);
                graphics.drawLine(xCoord1, _uly, xCoord1, yCoord1);
                graphics.drawLine(xCoord1, _lry, xCoord1, yCoord2);
                if(_grid && xCoord1 != _ulx && xCoord1 != _lrx)
                {
                    graphics.setColor(Color.lightGray);
                    graphics.drawLine(xCoord1, yCoord1, xCoord1, yCoord2);
                    graphics.setColor(_foreground);
                }
                int labxpos = xCoord1 - _labelFontMetrics.stringWidth(xticklabel) / 2;
                graphics.drawString(xticklabel, labxpos, _lry + 3 + labelheight);
            }

            if(_xlog)
            {
                double tmpStep = xStep <= 1.0D ? xStep : 1.0D;
                xTmpStart = tmpStep * Math.ceil(_xtickMin / tmpStep);
                Vector unlabeledgrid = _gridInit(xTmpStart, tmpStep, false, xgrid);
                if(unlabeledgrid.size() > 0)
                {
                    for(double xpos = _gridStep(unlabeledgrid, xTmpStart, tmpStep, _xlog); xpos <= _xtickMax; xpos = _gridStep(unlabeledgrid, xpos, tmpStep, _xlog))
                    {
                        xCoord1 = _ulx + (int)((xpos - _xtickMin) * _xtickscale);
                        if(_grid && xCoord1 != _ulx && xCoord1 != _lrx)
                        {
                            graphics.setColor(Color.lightGray);
                            graphics.drawLine(xCoord1, _uly + 1, xCoord1, _lry - 1);
                            graphics.setColor(_foreground);
                        }
                    }

                }
                if(needExponent)
                {
                    _xExp = (int)Math.floor(xTmpStart);
                    graphics.setFont(_superscriptFont);
                    graphics.drawString(Integer.toString(_xExp), xSPos, ySPos - halflabelheight);
                    xSPos -= _labelFontMetrics.stringWidth("x10");
                    graphics.setFont(_labelFont);
                    graphics.drawString("x10", xSPos, ySPos);
                } else
                {
                    _xExp = 0;
                }
            }
        } else
        {
            Enumeration nt = _xticks.elements();
            Enumeration nl = _xticklabels.elements();
            double preLength = 0.0D;
            while(nl.hasMoreElements()) 
            {
                String label = (String)nl.nextElement();
                double xpos = ((Double)nt.nextElement()).doubleValue();
                if(xpos <= _xMax && xpos >= _xMin)
                {
                    xCoord1 = _ulx + (int)((xpos - _xMin) * _xscale);
                    int labxpos = xCoord1 - _labelFontMetrics.stringWidth(label) / 2;
                    if((double)labxpos > preLength)
                    {
                        preLength = xCoord1 + _labelFontMetrics.stringWidth(label) / 2 + 10;
                        graphics.drawString(label, labxpos, _lry + 3 + labelheight);
                        graphics.drawLine(xCoord1, _uly, xCoord1, yCoord1);
                        graphics.drawLine(xCoord1, _lry, xCoord1, yCoord2);
                        if(_grid && xCoord1 != _ulx && xCoord1 != _lrx)
                        {
                            graphics.setColor(Color.lightGray);
                            graphics.drawLine(xCoord1, yCoord1, xCoord1, yCoord2);
                            graphics.setColor(_foreground);
                        }
                    }
                }
            }
        }
        graphics.setColor(_foreground);
        if(_title != null)
        {
            graphics.setFont(_titleFont);
            int titlex = _ulx + (width - _titleFontMetrics.stringWidth(_title)) / 2;
            graphics.drawString(_title, titlex, titley);
        }
        graphics.setFont(_labelFont);
        if(_xlabel != null)
        {
            int labelx = _ulx + (width - _labelFontMetrics.stringWidth(_xlabel)) / 2;
            graphics.drawString(_xlabel, labelx, ySPos);
        }
        int charcenter = 2 + _labelFontMetrics.stringWidth("W") / 2;
        int charheight = labelheight;
        if(_ylabel != null)
        {
            int yl = _ylabel.length();
            int starty = ((_uly + (_lry - _uly) / 2) - (yl * charheight) / 2) + charheight;
            for(int i = 0; i < yl; i++)
            {
                String nchar = _ylabel.substring(i, i + 1);
                int cwidth = _labelFontMetrics.stringWidth(nchar);
                graphics.drawString(nchar, charcenter - cwidth / 2, starty);
                starty += charheight;
            }

        }
        graphics.setFont(previousFont);
    }

    protected void _drawPoint(Graphics graphics, int dataset, long xpos, long ypos, boolean clip)
    {
        if(graphics == null)
            return;
        boolean pointinside = ypos <= (long)_lry && ypos >= (long)_uly && xpos <= (long)_lrx && xpos >= (long)_ulx;
        if(!pointinside && clip)
        {
            return;
        } else
        {
            graphics.fillRect((int)xpos - 6, (int)ypos - 6, 6, 6);
            return;
        }
    }

    private synchronized void _executeDeferredActions()
    {
        try
        {
            Runnable action;
            for(Iterator actions = _deferredActions.iterator(); actions.hasNext(); action.run())
                action = (Runnable)actions.next();

        }
        finally
        {
            _actionsDeferred = false;
            _deferredActions.clear();
        }
    }

    private String _formatLogNum(double num, int numfracdigits)
    {
        int exponent = (int)num;
        String results;
        if(exponent >= 0 && exponent < 10)
            results = "0" + exponent;
        else
        if(exponent < 0 && exponent > -10)
            results = "-0" + -exponent;
        else
            results = Integer.toString(exponent);
        if(num >= 0.0D)
        {
            if(num - (double)(int)num < 0.001D)
                results = "1e" + results;
            else
                results = _formatNum(Math.pow(10D, num - (double)(int)num), numfracdigits);
        } else
        if(-num - (double)(int)(-num) < 0.001D)
            results = "1e" + results;
        else
            results = _formatNum(Math.pow(10D, num - (double)(int)num) * 10D, numfracdigits);
        return results;
    }

    private String _formatNum(double num, int numfracdigits)
    {
        double fudge = 0.5D;
        if(num < 0.0D)
            fudge = -0.5D;
        String numString = Double.toString(num + fudge * Math.pow(10D, -numfracdigits));
        int dpt = numString.lastIndexOf(".");
        StringBuffer result = new StringBuffer();
        if(dpt < 0)
        {
            if(numfracdigits <= 0)
            {
                result.append(numString);
                return result.toString();
            }
            result.append(".");
            for(int i = 0; i < numfracdigits; i++)
                result.append("0");

            return result.toString();
        }
        int shortby = numfracdigits - (numString.length() - dpt - 1);
        if(shortby <= 0)
        {
            int numtocopy = dpt + numfracdigits + 1;
            if(numfracdigits == 0)
                numtocopy--;
            result.append(numString.substring(0, numtocopy));
            return result.toString();
        }
        result.append(numString);
        for(int i = 0; i < shortby; i++)
            result.append("0");

        return result.toString();
    }

    private Vector _gridInit(double low, double step, boolean labeled, Vector oldgrid)
    {
        Vector grid = new Vector(10);
        double ratio = Math.pow(10D, step);
        int ngrid = 1;
        if(labeled)
        {
            if(ratio <= 3.5D)
                if(ratio > 2D)
                    ngrid = 2;
                else
                if(ratio > 1.26D)
                    ngrid = 5;
                else
                if(ratio > 1.125D)
                    ngrid = 10;
                else
                    ngrid = (int)Math.rint(1.0D / step);
        } else
        if(ratio > 10D)
            ngrid = 1;
        else
        if(ratio > 3D)
            ngrid = 2;
        else
        if(ratio > 2D)
            ngrid = 5;
        else
        if(ratio > 1.125D)
            ngrid = 10;
        else
            ngrid = 100;
        int oldgridi = 0;
        for(int i = 0; i < ngrid; i++)
        {
            double gridval = ((double)i / (double)ngrid) * 10D;
            double logval = _LOG10SCALE * Math.log(gridval);
            if(logval == (-1.0D / 0.0D))
                logval = 0.0D;
            if(oldgrid != null && oldgridi < oldgrid.size())
            {
                for(; oldgridi < oldgrid.size() && ((Double)oldgrid.elementAt(oldgridi)).doubleValue() < logval; oldgridi++);
                if(oldgridi < oldgrid.size())
                {
                    if(Math.abs(((Double)oldgrid.elementAt(oldgridi)).doubleValue() - logval) > 1.0000000000000001E-005D)
                        grid.addElement(new Double(logval));
                } else
                {
                    grid.addElement(new Double(logval));
                }
            } else
            {
                grid.addElement(new Double(logval));
            }
        }

        _gridCurJuke = 0;
        if(low == 0D)
            low = 0.0D;
        _gridBase = Math.floor(low);
        double x = low - _gridBase;
        for(_gridCurJuke = -1; _gridCurJuke + 1 < grid.size() && x >= ((Double)grid.elementAt(_gridCurJuke + 1)).doubleValue(); _gridCurJuke++);
        return grid;
    }

    private double _gridRoundUp(Vector grid, double pos)
    {
        double x = pos - Math.floor(pos);
        int i;
        for(i = 0; i < grid.size() && x >= ((Double)grid.elementAt(i)).doubleValue(); i++);
        if(i >= grid.size())
            return pos;
        else
            return Math.floor(pos) + ((Double)grid.elementAt(i)).doubleValue();
    }

    private double _gridStep(Vector grid, double pos, double step, boolean logflag)
    {
        if(logflag)
        {
            if(++_gridCurJuke >= grid.size())
            {
                _gridCurJuke = 0;
                _gridBase += Math.ceil(step);
            }
            if(_gridCurJuke >= grid.size())
                return pos + step;
            else
                return _gridBase + ((Double)grid.elementAt(_gridCurJuke)).doubleValue();
        } else
        {
            return pos + step;
        }
    }

    protected void _help()
    {
        String message = "Ptolemy plot package\nBy: Edward A. Lee, eal@eecs.berkeley.edu\nand Christopher Hylands, cxh@eecs.berkeley.edu\nVersion 5.1p2, Build: $Id: PlotBox.java,v 1.1.1.1 2005/07/07 14:31:48 jag Exp $\n\nKey bindings:\n   Cntr-c:  copy plot to clipboard (EPS format), if permitted\n   D: dump plot data to standard out\n   E: export plot to standard out (EPS format)\n   F: fill plot\n   H or ?: print help message (this message)\n   Cntr-D or Q: quit\nFor more information, see\nhttp://ptolemy.eecs.berkeley.edu/java/ptplot\n";
        JOptionPane.showMessageDialog(this, message, "Ptolemy Plot Help Window", 1);
    }

    private void _measureFonts()
    {
        if(_labelFont == null)
            _labelFont = new Font("Helvetica", 0, 12);
        if(_superscriptFont == null)
            _superscriptFont = new Font("Helvetica", 0, 9);
        if(_titleFont == null)
            _titleFont = new Font("Helvetica", 1, 14);
        _labelFontMetrics = getFontMetrics(_labelFont);
        _superscriptFontMetrics = getFontMetrics(_superscriptFont);
        _titleFontMetrics = getFontMetrics(_titleFont);
    }

    private int _numFracDigits(double num)
    {
        int numdigits;
        for(numdigits = 0; numdigits <= 15 && num != Math.floor(num); numdigits++)
            num *= 10D;

        return numdigits;
    }

    private int _numIntDigits(double num)
    {
        int numdigits;
        for(numdigits = 0; numdigits <= 15 && (double)(int)num != 0.0D; numdigits++)
            num /= 10D;

        return numdigits;
    }

    protected boolean _parseLine(String line)
    {
        String lcLine = new String(line.toLowerCase());
        if(lcLine.startsWith("#"))
            return true;
        if(lcLine.startsWith("titletext:"))
        {
            setTitle(line.substring(10).trim());
            return true;
        }
        if(lcLine.startsWith("title:"))
        {
            setTitle(line.substring(10).trim());
            return true;
        }
        if(lcLine.startsWith("xlabel:"))
        {
            setXLabel(line.substring(7).trim());
            return true;
        }
        if(lcLine.startsWith("ylabel:"))
        {
            setYLabel(line.substring(7).trim());
            return true;
        }
        if(lcLine.startsWith("xrange:"))
        {
            int comma = line.indexOf(",", 7);
            if(comma > 0)
            {
                String min = line.substring(7, comma).trim();
                String max = line.substring(comma + 1).trim();
                try
                {
                    Double dmin = new Double(min);
                    Double dmax = new Double(max);
                    setXRange(dmin.doubleValue(), dmax.doubleValue());
                }
                catch(NumberFormatException _ex) { }
            }
            return true;
        }
        if(lcLine.startsWith("yrange:"))
        {
            int comma = line.indexOf(",", 7);
            if(comma > 0)
            {
                String min = line.substring(7, comma).trim();
                String max = line.substring(comma + 1).trim();
                try
                {
                    Double dmin = new Double(min);
                    Double dmax = new Double(max);
                    setYRange(dmin.doubleValue(), dmax.doubleValue());
                }
                catch(NumberFormatException _ex) { }
            }
            return true;
        }
        if(lcLine.startsWith("xticks:"))
        {
            _parsePairs(line.substring(7), true);
            return true;
        }
        if(lcLine.startsWith("yticks:"))
        {
            _parsePairs(line.substring(7), false);
            return true;
        }
        if(lcLine.startsWith("xlog:"))
        {
            if(lcLine.indexOf("off", 5) >= 0)
                _xlog = false;
            else
                _xlog = true;
            return true;
        }
        if(lcLine.startsWith("ylog:"))
        {
            if(lcLine.indexOf("off", 5) >= 0)
                _ylog = false;
            else
                _ylog = true;
            return true;
        }
        if(lcLine.startsWith("grid:"))
        {
            if(lcLine.indexOf("off", 5) >= 0)
                _grid = false;
            else
                _grid = true;
            return true;
        }
        if(lcLine.startsWith("wrap:"))
        {
            if(lcLine.indexOf("off", 5) >= 0)
                _wrap = false;
            else
                _wrap = true;
            return true;
        }
        if(lcLine.startsWith("color:"))
        {
            if(lcLine.indexOf("off", 6) >= 0)
                _usecolor = false;
            else
                _usecolor = true;
            return true;
        } else
        {
            return false;
        }
    }

    private void _parsePairs(String line, boolean xtick)
    {
        if(xtick)
        {
            _xticks = null;
            _xticklabels = null;
        } else
        {
            _yticks = null;
            _yticklabels = null;
        }
        int start = 0;
        boolean cont = true;
        while(cont) 
        {
            int comma = line.indexOf(",", start);
            String pair = null;
            if(comma > start)
            {
                pair = line.substring(start, comma).trim();
            } else
            {
                pair = line.substring(start).trim();
                cont = false;
            }
            int close = -1;
            int open = 0;
            if(pair.startsWith("\""))
            {
                close = pair.indexOf("\"", 1);
                open = 1;
            } else
            {
                close = pair.indexOf(" ");
            }
            if(close > 0)
            {
                String label = pair.substring(open, close);
                String index = pair.substring(close + 1).trim();
                try
                {
                    double idx = Double.valueOf(index).doubleValue();
                    if(xtick)
                        addXTick(label, idx);
                    else
                        addYTick(label, idx);
                }
                catch(NumberFormatException e)
                {
                    System.err.println("Warning from PlotBox: Unable to parse ticks: " + e.getMessage());
                }
            }
            start = comma + 1;
            comma = line.indexOf(",", start);
        }
    }

    private double _roundUp(double val)
    {
        int exponent = (int)Math.floor(Math.log(val) * _LOG10SCALE);
        val *= Math.pow(10D, -exponent);
        if(val > 5D)
            val = 10D;
        else
        if(val > 2D)
            val = 5D;
        else
        if(val > 1.0D)
            val = 2D;
        val *= Math.pow(10D, exponent);
        return val;
    }

    /**
     * @deprecated Method _setButtonsVisibility is deprecated
     */

    protected void _setButtonsVisibility(boolean vis)
    {
        _printButton.setVisible(vis);
        _fillButton.setVisible(vis);
        _formatButton.setVisible(vis);
        _resetButton.setVisible(vis);
    }

    protected void _setPadding(double padding)
    {
        _padding = padding;
    }

    private void _setXRange(double min, double max)
    {
        if(min > max)
        {
            min = -1D;
            max = 1.0D;
        } else
        if(min == max)
        {
            min--;
            max++;
        }
        _xMin = min - (max - min) * _padding;
        _xMax = max + (max - min) * _padding;
        double largest = Math.max(Math.abs(_xMin), Math.abs(_xMax));
        _xExp = (int)Math.floor(Math.log(largest) * _LOG10SCALE);
        if(_xExp > 1 || _xExp < -1)
        {
            double xs = 1.0D / Math.pow(10D, _xExp);
            _xtickMin = _xMin * xs;
            _xtickMax = _xMax * xs;
        } else
        {
            _xtickMin = _xMin;
            _xtickMax = _xMax;
            _xExp = 0;
        }
    }

    private void _setYRange(double min, double max)
    {
        if(min > max)
        {
            min = -1D;
            max = 1.0D;
        } else
        if(min == max)
        {
            min -= 0.10000000000000001D;
            max += 0.10000000000000001D;
        }
        _yMin = min - (max - min) * _padding;
        _yMax = max + (max - min) * _padding;
        double largest = Math.max(Math.abs(_yMin), Math.abs(_yMax));
        _yExp = (int)Math.floor(Math.log(largest) * _LOG10SCALE);
        if(_yExp > 1 || _yExp < -1)
        {
            double ys = 1.0D / Math.pow(10D, _yExp);
            _ytickMin = _yMin * ys;
            _ytickMax = _yMax * ys;
        } else
        {
            _ytickMin = _yMin;
            _ytickMax = _yMax;
            _yExp = 0;
        }
    }

    /**
     * @deprecated Method _writeOldSyntax is deprecated
     */

    protected void _writeOldSyntax(PrintWriter output)
    {
        output.println("# Ptolemy plot, version 2.0");
        if(_title != null)
            output.println("TitleText: " + _title);
        if(_xlabel != null)
            output.println("XLabel: " + _xlabel);
        if(_ylabel != null)
            output.println("YLabel: " + _ylabel);
        if(_xRangeGiven)
            output.println("XRange: " + _xlowgiven + ", " + _xhighgiven);
        if(_yRangeGiven)
            output.println("YRange: " + _ylowgiven + ", " + _yhighgiven);
        if(_xticks != null && _xticks.size() > 0)
        {
            output.print("XTicks: ");
            int last = _xticks.size() - 1;
            for(int i = 0; i < last; i++)
                output.print("\"" + (String)_xticklabels.elementAt(i) + "\" " + (Double)_xticks.elementAt(i) + ", ");

            output.println("\"" + (String)_xticklabels.elementAt(last) + "\" " + (Double)_xticks.elementAt(last));
        }
        if(_yticks != null && _yticks.size() > 0)
        {
            output.print("YTicks: ");
            int last = _yticks.size() - 1;
            for(int i = 0; i < last; i++)
                output.print("\"" + (String)_yticklabels.elementAt(i) + "\" " + (Double)_yticks.elementAt(i) + ", ");

            output.println("\"" + (String)_yticklabels.elementAt(last) + "\" " + (Double)_yticks.elementAt(last));
        }
        if(_xlog)
            output.println("XLog: on");
        if(_ylog)
            output.println("YLog: on");
        if(!_grid)
            output.println("Grid: off");
        if(_wrap)
            output.println("Wrap: on");
        if(!_usecolor)
            output.println("Color: off");
    }

    void _zoom(int x, int y)
    {
        _zooming = false;
        Graphics graphics = getGraphics();
        if(graphics == null)
            return;
        boolean handled = false;
        if(_zoomin && _drawn)
        {
            if(_zoomxn != -1 || _zoomyn != -1)
            {
                int minx = Math.min(_zoomx, _zoomxn);
                int maxx = Math.max(_zoomx, _zoomxn);
                int miny = Math.min(_zoomy, _zoomyn);
                int maxy = Math.max(_zoomy, _zoomyn);
                graphics.setXORMode(_boxColor);
                graphics.drawRect(minx, miny, maxx - minx, maxy - miny);
                graphics.setPaintMode();
                if(y > _lry)
                    y = _lry;
                if(y < _uly)
                    y = _uly;
                if(x > _lrx)
                    x = _lrx;
                if(x < _ulx)
                    x = _ulx;
                if(Math.abs(_zoomx - x) > 5 && Math.abs(_zoomy - y) > 5)
                {
                    double a = _xMin + (double)(_zoomx - _ulx) / _xscale;
                    double b = _xMin + (double)(x - _ulx) / _xscale;
                    if(a < b)
                        setXRange(a, b);
                    else
                        setXRange(b, a);
                    a = _yMax - (double)(_zoomy - _uly) / _yscale;
                    b = _yMax - (double)(y - _uly) / _yscale;
                    if(a < b)
                        setYRange(a, b);
                    else
                        setYRange(b, a);
                }
                repaint();
                handled = true;
            }
        } else
        if(_zoomout && _drawn)
        {
            graphics.setXORMode(_boxColor);
            int x_diff = Math.abs(_zoomx - _zoomxn);
            int y_diff = Math.abs(_zoomy - _zoomyn);
            graphics.drawRect(_zoomx - 15 - x_diff, _zoomy - 15 - y_diff, 30 + x_diff * 2, 30 + y_diff * 2);
            graphics.setPaintMode();
            double a = (double)Math.abs(_zoomx - x) / 30D;
            double b = (double)Math.abs(_zoomy - y) / 30D;
            double newx1 = _xMax + (_xMax - _xMin) * a;
            double newx2 = _xMin - (_xMax - _xMin) * a;
            double newy1 = _yMax + (_yMax - _yMin) * b;
            double newy2 = _yMin - (_yMax - _yMin) * b;
            zoom(newx2, newy2, newx1, newy1);
            handled = true;
        } else
        if(!_drawn)
        {
            repaint();
            handled = true;
        }
        _drawn = false;
        _zoomin = _zoomout = false;
        _zoomxn = _zoomyn = _zoomx = _zoomy = -1;
    }

    void _zoomBox(int x, int y)
    {
        if(!_zooming)
            return;
        Graphics graphics = getGraphics();
        if(graphics == null)
            return;
        if(y > _lry)
            y = _lry;
        if(y < _uly)
            y = _uly;
        if(x > _lrx)
            x = _lrx;
        if(x < _ulx)
            x = _ulx;
        if(_zoomx != -1 || _zoomy != -1)
        {
            if(!_zoomin && !_zoomout)
                if(y < _zoomy)
                {
                    _zoomout = true;
                    graphics.setXORMode(_boxColor);
                    graphics.drawRect(_zoomx - 15, _zoomy - 15, 30, 30);
                } else
                if(y > _zoomy)
                    _zoomin = true;
            if(_zoomin)
            {
                if((_zoomxn != -1 || _zoomyn != -1) && _drawn)
                {
                    int minx = Math.min(_zoomx, _zoomxn);
                    int maxx = Math.max(_zoomx, _zoomxn);
                    int miny = Math.min(_zoomy, _zoomyn);
                    int maxy = Math.max(_zoomy, _zoomyn);
                    graphics.setXORMode(_boxColor);
                    graphics.drawRect(minx, miny, maxx - minx, maxy - miny);
                }
                if(y > _zoomy)
                {
                    _zoomxn = x;
                    _zoomyn = y;
                    int minx = Math.min(_zoomx, _zoomxn);
                    int maxx = Math.max(_zoomx, _zoomxn);
                    int miny = Math.min(_zoomy, _zoomyn);
                    int maxy = Math.max(_zoomy, _zoomyn);
                    graphics.setXORMode(_boxColor);
                    graphics.drawRect(minx, miny, maxx - minx, maxy - miny);
                    _drawn = true;
                    return;
                }
                _drawn = false;
            } else
            if(_zoomout)
            {
                if((_zoomxn != -1 || _zoomyn != -1) && _drawn)
                {
                    int x_diff = Math.abs(_zoomx - _zoomxn);
                    int y_diff = Math.abs(_zoomy - _zoomyn);
                    graphics.setXORMode(_boxColor);
                    graphics.drawRect(_zoomx - 15 - x_diff, _zoomy - 15 - y_diff, 30 + x_diff * 2, 30 + y_diff * 2);
                }
                if(y < _zoomy)
                {
                    _zoomxn = x;
                    _zoomyn = y;
                    int x_diff = Math.abs(_zoomx - _zoomxn);
                    int y_diff = Math.abs(_zoomy - _zoomyn);
                    graphics.setXORMode(_boxColor);
                    graphics.drawRect(_zoomx - 15 - x_diff, _zoomy - 15 - y_diff, 30 + x_diff * 2, 30 + y_diff * 2);
                    _drawn = true;
                    return;
                }
                _drawn = false;
            }
        }
        graphics.setPaintMode();
    }

    void _zoomStart(int x, int y)
    {
        if(y > _lry)
            y = _lry;
        if(y < _uly)
            y = _uly;
        if(x > _lrx)
            x = _lrx;
        if(x < _ulx)
            x = _ulx;
        _zoomx = x;
        _zoomy = y;
        _zooming = true;
    }

    public synchronized void addLegend(int dataset, String legend)
    {
        if(legend == null || legend.equals(""))
        {
            return;
        } else
        {
            _legendStrings.addElement(legend);
            _legendDatasets.addElement(new Integer(dataset));
            return;
        }
    }

    public synchronized void addXTick(String label, double position)
    {
        if(_xticks == null)
        {
            _xticks = new Vector();
            _xticklabels = new Vector();
        }
        _xticks.addElement(new Double(position));
        _xticklabels.addElement(label);
    }

    public synchronized void addYTick(String label, double position)
    {
        if(_yticks == null)
        {
            _yticks = new Vector();
            _yticklabels = new Vector();
        }
        _yticks.addElement(new Double(position));
        _yticklabels.addElement(label);
    }
    public void ResetYTick(){
            _yticks = new Vector();
            _yticklabels = new Vector();        
    }
    

    public synchronized void clear(boolean axes)
    {
        _xBottom = 1.7976931348623157E+308D;
        _xTop = -1.7976931348623157E+308D;
        _yBottom = 1.7976931348623157E+308D;
        _yTop = -1.7976931348623157E+308D;
        if(axes)
        {
            _yMax = 0.0D;
            _yMin = 0.0D;
            _xMax = 0.0D;
            _xMin = 0.0D;
            _xRangeGiven = false;
            _yRangeGiven = false;
            _originalXRangeGiven = false;
            _originalYRangeGiven = false;
            _rangesGivenByZooming = false;
            _xlog = false;
            _ylog = false;
            _grid = true;
            _wrap = false;
            _usecolor = true;
            _filespec = null;
            _xlabel = null;
            _ylabel = null;
            _title = null;
            _legendStrings = new Vector();
            _legendDatasets = new Vector();
            _xticks = null;
            _xticklabels = null;
            _yticks = null;
            _yticklabels = null;
        }
    }

    public synchronized void clearLegends()
    {
        _legendStrings = new Vector();
        _legendDatasets = new Vector();
    }

    public synchronized void export(OutputStream out)
    {
        try
        {
            EPSGraphics g = new EPSGraphics(out, _width, _height);
            _drawPlot(g, false);
            g.showpage();
        }
        catch(RuntimeException ex)
        {
            String message = "Export failed: " + ex.getMessage();
            JOptionPane.showMessageDialog(this, message, "Ptolemy Plot Message", 0);
            throw (RuntimeException)ex.fillInStackTrace();
        }
    }

    public synchronized BufferedImage exportImage()
    {
        Rectangle rectangle = new Rectangle(_preferredWidth, _preferredHeight);
        return exportImage(new BufferedImage(rectangle.width, rectangle.height, 2), rectangle, _defaultImageRenderingHints(), false);
    }

    public synchronized BufferedImage exportImage(Rectangle rectangle)
    {
        return exportImage(new BufferedImage(rectangle.width, rectangle.height, 2), rectangle, _defaultImageRenderingHints(), false);
    }

    public synchronized BufferedImage exportImage(BufferedImage bufferedImage)
    {
        return exportImage(bufferedImage, new Rectangle(bufferedImage.getWidth(), bufferedImage.getHeight()), _defaultImageRenderingHints(), true);
    }

    public synchronized BufferedImage exportImage(BufferedImage bufferedImage, Rectangle rectangle, RenderingHints hints, boolean transparent)
    {
        Graphics2D graphics = bufferedImage.createGraphics();
        graphics.addRenderingHints(_defaultImageRenderingHints());
        if(!transparent)
        {
            graphics.setColor(Color.white);
            graphics.fill(rectangle);
        }
        _drawPlot(graphics, false, rectangle);
        return bufferedImage;
    }

    public synchronized void fillPlot()
    {
        setXRange(_xBottom, _xTop);
        setYRange(_yBottom, _yTop);
        repaint();
    }

    public boolean getColor()
    {
        return _usecolor;
    }

    public static Color getColorByName(String name)
    {
        String names[][];
        try
        {
            if(name.startsWith("#"))
                name = name.substring(1);
            Color col = new Color(Integer.parseInt(name, 16));
            return col;
        }
        catch(NumberFormatException _ex)
        {
            names = (new String[][] {
                new String[] {
                    "black", "00000"
                }, new String[] {
                    "white", "ffffff"
                }, new String[] {
                    "red", "ff0000"
                }, new String[] {
                    "green", "00ff00"
                }, new String[] {
                    "blue", "0000ff"
                }
            });
        }
        for(int i = 0; i < names.length; i++)
            if(name.equals(names[i][0]))
                try
                {
                    Color col = new Color(Integer.parseInt(names[i][1], 16));
                    return col;
                }
                catch(NumberFormatException _ex) { }

        return null;
    }

    /**
     * @deprecated Method getDataurl is deprecated
     */

    public String getDataurl()
    {
        return _filespec;
    }

    /**
     * @deprecated Method getDocumentBase is deprecated
     */

    public URL getDocumentBase()
    {
        return _documentBase;
    }

    public boolean getGrid()
    {
        return _grid;
    }

    public synchronized String getLegend(int dataset)
    {
        int idx = _legendDatasets.indexOf(new Integer(dataset), 0);
        if(idx != -1)
            return (String)_legendStrings.elementAt(idx);
        else
            return null;
    }

    public synchronized Dimension getMaximumSize()
    {
        if(_sizeHasBeenSet)
            return new Dimension(_preferredWidth, _preferredHeight);
        else
            return super.getMaximumSize();
    }

    public synchronized Dimension getMinimumSize()
    {
        if(_sizeHasBeenSet)
            return new Dimension(_preferredWidth, _preferredHeight);
        else
            return super.getMinimumSize();
    }

    public synchronized Dimension getPreferredSize()
    {
        return new Dimension(_preferredWidth, _preferredHeight);
    }

    public synchronized String getTitle()
    {
        if(_title == null)
            return "";
        else
            return _title;
    }

    public synchronized String getXLabel()
    {
        return _xlabel;
    }

    public boolean getXLog()
    {
        return _xlog;
    }

    public synchronized double[] getXRange()
    {
        double result[] = new double[2];
        if(_xRangeGiven)
        {
            result[0] = _xlowgiven;
            result[1] = _xhighgiven;
        } else
        {
            result[0] = _xMin + (_xMax - _xMin) * _padding;
            result[1] = _xMax - (_xMax - _xMin) * _padding;
        }
        return result;
    }

    public synchronized Vector[] getXTicks()
    {
        if(_xticks == null)
        {
            return null;
        } else
        {
            Vector result[] = new Vector[2];
            result[0] = _xticks;
            result[1] = _xticklabels;
            return result;
        }
    }

    public String getYLabel()
    {
        return _ylabel;
    }

    public boolean getYLog()
    {
        return _ylog;
    }

    public synchronized double[] getYRange()
    {
        double result[] = new double[2];
        if(_yRangeGiven)
        {
            result[0] = _ylowgiven;
            result[1] = _yhighgiven;
        } else
        {
            result[0] = _yMin + (_yMax - _yMin) * _padding;
            result[1] = _yMax - (_yMax - _yMin) * _padding;
        }
        return result;
    }

    public synchronized Vector[] getYTicks()
    {
        if(_yticks == null)
        {
            return null;
        } else
        {
            Vector result[] = new Vector[2];
            result[0] = _yticks;
            result[1] = _yticklabels;
            return result;
        }
    }

    /**
     * @deprecated Method init is deprecated
     */

    public void init()
    {
        setButtons(true);
        if(_filespec != null)
            parseFile(_filespec, _documentBase);
    }

    public void paintComponent(Graphics graphics)
    {
        super.paintComponent(graphics);
        _drawPlot(graphics, true);
    }

    /**
     * @deprecated Method parseFile is deprecated
     */

    public void parseFile(String filespec)
    {
        parseFile(filespec, null);
    }

    /**
     * @deprecated Method parseFile is deprecated
     */

    public synchronized void parseFile(String filespec, URL documentBase)
    {
        DataInputStream in = null;
        if(filespec == null || filespec.length() == 0)
            in = new DataInputStream(System.in);
        else
            try
            {
                URL url = null;
                if(documentBase == null && _documentBase != null)
                    documentBase = _documentBase;
                if(documentBase == null)
                    url = new URL(filespec);
                else
                    try
                    {
                        url = new URL(documentBase, filespec);
                    }
                    catch(NullPointerException _ex)
                    {
                        url = new URL(filespec);
                    }
                in = new DataInputStream(url.openStream());
            }
            catch(MalformedURLException _ex)
            {
                try
                {
                    in = new DataInputStream(new FileInputStream(filespec));
                }
                catch(FileNotFoundException me)
                {
                    _errorMsg = new String[2];
                    _errorMsg[0] = "File not found: " + filespec;
                    _errorMsg[1] = me.getMessage();
                    return;
                }
                catch(SecurityException me)
                {
                    _errorMsg = new String[2];
                    _errorMsg[0] = "Security Exception: " + filespec;
                    _errorMsg[1] = me.getMessage();
                    return;
                }
            }
            catch(IOException ioe)
            {
                _errorMsg = new String[3];
                _errorMsg[0] = "Failure opening URL: ";
                _errorMsg[1] = " " + filespec;
                _errorMsg[2] = ioe.getMessage();
                return;
            }
        try
        {
            BufferedReader din = new BufferedReader(new InputStreamReader(in));
            for(String line = din.readLine(); line != null; line = din.readLine())
                _parseLine(line);

        }
        catch(MalformedURLException e)
        {
            _errorMsg = new String[2];
            _errorMsg[0] = "Malformed URL: " + filespec;
            _errorMsg[1] = e.getMessage();
            return;
        }
        catch(IOException e)
        {
            _errorMsg = new String[2];
            _errorMsg[0] = "Failure reading data: " + filespec;
            _errorMsg[1] = e.getMessage();
            _errorMsg[1] = e.getMessage();
        }
        finally
        {
            try
            {
                in.close();
            }
            catch(IOException _ex) { }
        }
    }

    public synchronized int print(Graphics graphics, PageFormat format, int index)
        throws PrinterException
    {
        if(graphics == null)
            return 1;
        if(index >= 1)
        {
            return 1;
        } else
        {
            graphics.translate((int)format.getImageableX(), (int)format.getImageableY());
            _drawPlot(graphics, true);
            return 0;
        }
    }

    public synchronized void read(InputStream in)
        throws IOException
    {
        try
        {
            BufferedReader din = new BufferedReader(new InputStreamReader(in));
            try
            {
                for(String line = din.readLine(); line != null; line = din.readLine())
                    _parseLine(line);

            }
            finally
            {
                din.close();
            }
        }
        catch(IOException e)
        {
            _errorMsg = new String[2];
            _errorMsg[0] = "Failure reading input data.";
            _errorMsg[1] = e.getMessage();
            throw e;
        }
    }

    public synchronized void read(String command)
    {
        _parseLine(command);
    }

    public synchronized void resetAxes()
    {
        setXRange(_originalXlow, _originalXhigh);
        setYRange(_originalYlow, _originalYhigh);
        repaint();
    }

    public void samplePlot()
    {
    }

    public void setBackground(Color background)
    {
        _background = background;
        super.setBackground(_background);
    }

    public synchronized void setBounds(int x, int y, int width, int height)
    {
        _width = width;
        _height = height;
        super.setBounds(x, y, _width, _height);
    }

    public synchronized void setButtons(boolean visible)
    {
        if(_printButton == null)
        {
            URL img = getClass().getResource("/ptolemy/plot/img/print.gif");
            if(img != null)
            {
                ImageIcon printIcon = new ImageIcon(img);
                _printButton = new JButton(printIcon);
                _printButton.setBorderPainted(false);
            } else
            {
                _printButton = new JButton("P");
            }
            _printButton.setPreferredSize(new Dimension(20, 20));
            _printButton.setToolTipText("Print the plot.");
            _printButton.addActionListener(new ButtonListener());
            add(_printButton);
        }
        _printButton.setVisible(visible);
        if(_resetButton == null)
        {
            URL img = getClass().getResource("/ptolemy/plot/img/reset.gif");
            if(img != null)
            {
                ImageIcon resetIcon = new ImageIcon(img);
                _resetButton = new JButton(resetIcon);
                _resetButton.setBorderPainted(false);
            } else
            {
                _resetButton = new JButton("R");
            }
            _resetButton.setPreferredSize(new Dimension(20, 20));
            _resetButton.setToolTipText("Reset X and Y ranges to their original values");
            _resetButton.addActionListener(new ButtonListener());
            add(_resetButton);
        }
        _resetButton.setVisible(visible);
        if(_formatButton == null)
        {
            URL img = getClass().getResource("/ptolemy/plot/img/format.gif");
            if(img != null)
            {
                ImageIcon formatIcon = new ImageIcon(img);
                _formatButton = new JButton(formatIcon);
                _formatButton.setBorderPainted(false);
            } else
            {
                _formatButton = new JButton("S");
            }
            _formatButton.setPreferredSize(new Dimension(20, 20));
            _formatButton.setToolTipText("Set the plot format");
            _formatButton.addActionListener(new ButtonListener());
            add(_formatButton);
        }
        _formatButton.setVisible(visible);
        if(_fillButton == null)
        {
            URL img = getClass().getResource("/ptolemy/plot/img/fill.gif");
            if(img != null)
            {
                ImageIcon fillIcon = new ImageIcon(img);
                _fillButton = new JButton(fillIcon);
                _fillButton.setBorderPainted(false);
            } else
            {
                _fillButton = new JButton("F");
            }
            _fillButton.setPreferredSize(new Dimension(20, 20));
            _fillButton.setToolTipText("Rescale the plot to fit the data");
            _fillButton.addActionListener(new ButtonListener());
            add(_fillButton);
        }
        _fillButton.setVisible(visible);
    }

    public void setColor(boolean useColor)
    {
        _usecolor = useColor;
    }

    /**
     * @deprecated Method setDataurl is deprecated
     */

    public void setDataurl(String filespec)
    {
        _filespec = filespec;
    }

    /**
     * @deprecated Method setDocumentBase is deprecated
     */

    public void setDocumentBase(URL documentBase)
    {
        _documentBase = documentBase;
    }

    public void setForeground(Color foreground)
    {
        _foreground = foreground;
        super.setForeground(_foreground);
    }

    public void setGrid(boolean grid)
    {
        _grid = grid;
    }

    public void setLabelFont(String name)
    {
        _labelFont = Font.decode(name);
        _labelFontMetrics = getFontMetrics(_labelFont);
    }

    public void setSize(int width, int height)
    {
        _width = width;
        _height = height;
        _preferredWidth = width;
        _preferredHeight = height;
        _sizeHasBeenSet = true;
        super.setSize(width, height);
    }

    public void setTitle(String title)
    {
        _title = title;
    }

    public void setTitleFont(String name)
    {
        _titleFont = Font.decode(name);
        _titleFontMetrics = getFontMetrics(_titleFont);
    }

    public void setWrap(boolean wrap)
    {
        _wrap = wrap;
        if(!_xRangeGiven)
            if(_xBottom > _xTop)
                setXRange(0.0D, 0.0D);
            else
                setXRange(_xBottom, _xTop);
        _wrapLow = _xlowgiven;
        _wrapHigh = _xhighgiven;
    }

    public void setXLabel(String label)
    {
        _xlabel = label;
    }

    public void setXLog(boolean xlog)
    {
        _xlog = xlog;
    }

    public synchronized void setXRange(double min, double max)
    {
        _xRangeGiven = true;
        _xlowgiven = min;
        _xhighgiven = max;
        if(!_originalXRangeGiven)
        {
            _originalXlow = min;
            _originalXhigh = max;
            _originalXRangeGiven = true;
        }
        _setXRange(min, max);
    }

    public void setYLabel(String label)
    {
        _ylabel = label;
    }

    public void setYLog(boolean ylog)
    {
        _ylog = ylog;
    }

    public synchronized void setYRange(double min, double max)
    {
        _yRangeGiven = true;
        _ylowgiven = min;
        _yhighgiven = max;
        if(!_originalYRangeGiven)
        {
            _originalYlow = min;
            _originalYhigh = max;
            _originalYRangeGiven = true;
        }
        _setYRange(min, max);
    }

    public void write(OutputStream out)
    {
        write(out, null);
    }

    public synchronized void write(OutputStream out, String dtd)
    {
        write(((Writer) (new OutputStreamWriter(out))), dtd);
    }

    public synchronized void write(Writer out, String dtd)
    {
        PrintWriter output = new PrintWriter(new BufferedWriter(out), false);
        if(dtd == null)
        {
            output.println("<?xml version=\"1.0\" standalone=\"yes\"?>");
            output.println("<!DOCTYPE plot PUBLIC \"-//UC Berkeley//DTD PlotML 1//EN\"");
            output.println("    \"http://ptolemy.eecs.berkeley.edu/xml/dtd/PlotML_1.dtd\">");
        } else
        {
            output.println("<?xml version=\"1.0\" standalone=\"no\"?>");
            output.println("<!DOCTYPE plot SYSTEM \"" + dtd + "\">");
        }
        output.println("<plot>");
        output.println("<!-- Ptolemy plot, version 5.1p2 , PlotML format. -->");
        writeFormat(output);
        writeData(output);
        output.println("</plot>");
        output.flush();
    }

    public synchronized void writeData(PrintWriter printwriter)
    {
    }

    public synchronized void writeFormat(PrintWriter output)
    {
        if(_title != null)
            output.println("<title>" + _title + "</title>");
        if(_xlabel != null)
            output.println("<xLabel>" + _xlabel + "</xLabel>");
        if(_ylabel != null)
            output.println("<yLabel>" + _ylabel + "</yLabel>");
        if(_xRangeGiven)
            output.println("<xRange min=\"" + _xlowgiven + "\" max=\"" + _xhighgiven + "\"/>");
        if(_yRangeGiven)
            output.println("<yRange min=\"" + _ylowgiven + "\" max=\"" + _yhighgiven + "\"/>");
        if(_xticks != null && _xticks.size() > 0)
        {
            output.println("<xTicks>");
            int last = _xticks.size() - 1;
            for(int i = 0; i <= last; i++)
                output.println("  <tick label=\"" + (String)_xticklabels.elementAt(i) + "\" position=\"" + (Double)_xticks.elementAt(i) + "\"/>");

            output.println("</xTicks>");
        }
        if(_yticks != null && _yticks.size() > 0)
        {
            output.println("<yTicks>");
            int last = _yticks.size() - 1;
            for(int i = 0; i <= last; i++)
                output.println("  <tick label=\"" + (String)_yticklabels.elementAt(i) + "\" position=\"" + (Double)_yticks.elementAt(i) + "\"/>");

            output.println("</yTicks>");
        }
        if(_xlog)
            output.println("<xLog/>");
        if(_ylog)
            output.println("<yLog/>");
        if(!_grid)
            output.println("<noGrid/>");
        if(_wrap)
            output.println("<wrap/>");
        if(!_usecolor)
            output.println("<noColor/>");
    }

    /**
     * @deprecated Method writeOldSyntax is deprecated
     */

    public synchronized void writeOldSyntax(OutputStream out)
    {
        PrintWriter output = new PrintWriter(new BufferedOutputStream(out), false);
        _writeOldSyntax(output);
        output.flush();
        if(out != System.out)
            output.close();
    }

    public synchronized void zoom(double lowx, double lowy, double highx, double highy)
    {
        _setXRange(lowx, highx);
        _setYRange(lowy, highy);
        repaint();
    }

    static 
    {
        _boxColor = Color.orange;
    }





}